/***********************************************************************
*
* ļ        MemoryManager.h
* ģĿģʵƽ̨عڴ
* ߼ڣ  wang_jin 2008-05-18
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#ifndef MemoryManager_H
#define MemoryManager_H

#include <assert.h>
#include "Common/Types.h"
#include "GDLock/GDLock.h"
#include "gd3_define/gd3_errcode.h"

#ifdef _WIN32
#	include <windows.h>
#else
#endif


typedef struct _shared_memory_data
{
	int nSize;
	int nOffset;
}	SharedMemoryData;

// ڴ:ڲݴȡ
class CSharedMemoryManager
{
public:
	CSharedMemoryManager();
	~CSharedMemoryManager();

public:
	long CreateMemory( long nKey, long nMaxSize, bool* pbOwner = NULL );	// 
	long CreateMemory( const char* sKey, long nMaxSize, bool* pbOwner = NULL );
	long ReleaseMemory();							// ͷ
	long CreateMemory( long nMaxSize );				// ()
	SharedMemoryData* GetBaseAddress()				// ȡ
	{
		return m_pSMData;
	}

private:
	long m_nMaxSize;
	char m_sInforGuardSharedMemoryId[GD_MAX_PATH];
#ifdef _WIN32
	long m_nSharedMemoryKey;
	HANDLE m_hFileMap;
	void* m_pMapView;
#else
	key_t m_nSharedMemoryKey;
	int m_nSharedMemoryID;
	void * m_pBaseAddress;
#endif

private:
	SharedMemoryData* m_pSMData;

};


#endif
