/***********************************************************************
*
* ļ        SharedBuffer.h
* ģĿģʵֹڴ
* ߼ڣ  wang_jin 2008-05-18
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#include "GDQue/SharedBuffer.h"
#include "MemoryManager.h"
#include "DataManager.h"


CSharedBuffer::CSharedBuffer()
:m_pDataMgr( new CSharedDataManager )
{
}

CSharedBuffer::~CSharedBuffer()
{
	if ( m_pDataMgr )
	{
		m_pDataMgr->ReleaseMemory();
		delete m_pDataMgr;
	}
}

long CSharedBuffer::CreateBuffer( long nKey, long nSize )
{
	long nRet = m_pDataMgr->CreateMemory( nKey, nSize );

	return nRet;
}

long CSharedBuffer::CreateBuffer( const char* sKey, long nSize )
{
	long nRet = m_pDataMgr->CreateMemory( sKey, nSize );
	
	return nRet;
}

long CSharedBuffer::ReleaseBuffer()
{
	return m_pDataMgr->ReleaseMemory();
}

long CSharedBuffer::SetData( void* pBuf, long nSize )
{
	return m_pDataMgr->SetData( pBuf, nSize );
}

long CSharedBuffer::GetData( void* pBuf, long& nSize )
{
	return m_pDataMgr->GetData( pBuf, nSize );
}

bool CSharedBuffer::IsOwner()
{
	return m_pDataMgr->IsOwner();
}

int CSharedBuffer::GetOffset( void* pBuf )					// Чڴַתƫ
{
    if( pBuf )
    {
	    return m_pDataMgr->GetOffset( pBuf );
    }

    return 0;
}

void* CSharedBuffer::GetRealAddress( int nOffset )				// ƫתЧڴַ
{
	if ( nOffset )
	{
		return m_pDataMgr->GetRealAddress( nOffset );
	}

	return NULL;
}

