/************************
 ȡɼϢ
 ************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include "gcps.h"
#include "z.h"
#include "zagent.h"
#include "zvar.h"

int f_onecfg(void)
{
    int   i, b, nEncry = 0;

    char *p, *pBody,
          szCfgDir[256],        /* Ŀ¼ */
          szCfgFile[256],       /* ļ */

          szNo[17],             /* ɼ */
          szBelong[9],          /* ֹ˾ */
          szPass1[64],          /* 1 */
          szPass2[64],          /* 2 */
          szText1[64],          /* 1 */
          szText2[64];          /* 2 */

    for( i = 0; i < MAXN_TAG; i++ )
    {
        if( u_TAGs[i].tag == 0 ) break;

        switch( u_TAGs[i].tag )
        {
        case TAG_BELONG:    /* ֹ˾ */

            strcpy(szBelong, u_TAGs[i].pv);
            break;

        case TAG_NO:        /* ɼ */

            strcpy(szNo, u_TAGs[i].pv);
            break;
        }
    }

/* ----------------------------------------------------------------------- */

    /* ȡĿ¼ */
    b = z_readini(CITYS_CFG, SEG_DIRCFG, szBelong, szCfgDir, sizeof(szCfgDir) - 1, 0);

    if( b )
    {
        z_logv(g_logfile, "b=%d, szBelong=%s", b, szBelong);
        GC_sendecode(E_LOGONDENY);
        return(1);
    }

    /* · */
    if( access(szCfgDir, R_OK) )
    {
        GC_sendecode(E_BELONG);
        return(2);
    }

    /* ȡļ */
    snprintf(szCfgFile, sizeof(szCfgFile), "%s/%s%s", szCfgDir, szNo, CFGSUFFIX);

    pBody = u_cinfo;
    *pBody = 0;

    for( i = 0; i < MAXN_TAG; i++ )
    {
        if( u_TAGs[i].tag == 0 ) break;
        if( u_TAGs[i].group != TAGGRP_ONE ) continue;

        z_getkeyv(szCfgFile, u_TAGs[i].key, u_TAGs[i].pv, u_TAGs[i].vlen);
        f_packTLV(&pBody, u_TAGs[i].pv, u_TAGs[i].tag);
    }

    /* Ƿ */
    i = f_seekTAG(TAG_ENCRYPTION);
    nEncry = u_TAGs[i].pv[0] == '1' ? 1 : 0;

    /*  */
    i = f_seekTAG(TAG_PASSWORD_PAIR);

    p = u_TAGs[i].pv;
    z_get_fieldv(&p, szPass1, NULL, sizeof(szPass1) - 1, SM_HYPHEN);
    z_get_fieldv(&p, szPass2, NULL, sizeof(szPass1) - 1, SM_HYPHEN);

    if( nEncry == 0 )
    {
        strcpy(szText1, szPass1);
        strcpy(szText2, szPass2);
    }
    else
    {
        memset(szText1, 0, sizeof(szText1));
        memset(szText2, 0, sizeof(szText2));

        f_pass_decry(szPass1, (unsigned char *)szText1);
        f_pass_decry(szPass2, (unsigned char *)szText2);
    }

    f_packTLV(&pBody, szText1, TAG_PASSWORD1);
    f_packTLV(&pBody, szText2, TAG_PASSWORD2);

    /* Ӧ */
    *p = 0;
    GC_setpheadn(g_okcode, 3);
    GC_sendtext(u_cinfo);

    return(0);
}
