/********
 ײ㺯
 ********/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "zvar.h"
#include "gcps.h"
#include "z.h"

static    char          *t_shmhead = NULL;    /* ڴûַ */
static    int            t_offs = 0;          /* ƽַ̨ƫ */

static    unsigned char  t_key[10] =          /* DES Կ */
    {0xbb, 0xf5, 0xc7, 0xd2, 0x8c, 0x76, 0x6b, 0x25, 0x0, 0x0};

/***************************************
 ΪʾתַеĿַ -> .
 ***************************************/
void f_all_print(char *s)
{
    while( *s )
    {
        if( iscntrl(*s) ) *s = '.';
        s++;
    }
}

/**********************************
 ƽ̨Զ干ڴ
 ڲkey_t key  -- ؼ
           int   lock -- ˢ?
 **********************************/
char * f_conn_zshm(key_t key, int lock)
{
    int len = 0;

    /* ûڴ */
    if( t_shmhead == NULL &&
        (t_shmhead = GC_conn_Ushm(key, &t_offs)) == NULL )
    {
        return(NULL);
    }

    u_paras = (ZPUBPARA *) (t_shmhead + len);
    len += ZPUB_LEN;

    u_cfgs = (ZCFG *) (t_shmhead + len);
    u_pcfgs = u_cfgs;

    len += (MAXN_Z * ZCFG_LEN);

    u_runs = (ZRUN *) (t_shmhead + len);
    u_pruns = u_runs;

    len += (MAXN_Z * ZRUN_LEN);

    u_wtms = (ZWARNTIME *) (t_shmhead + len);
    u_pwtms = u_wtms;

    if( lock && f_gpara_refresh(0) < 0 ) return(NULL);

    return(t_shmhead - t_offs);
}

/****************
 ƽ̨ڴ
 ****************/
void f_disconn_zshm(void)
{
    if( t_shmhead )
    {
        GC_disconn_shm(t_shmhead - t_offs);
        t_shmhead = NULL;
    }

    return;
}

/*************************************
 ʽĿ(󳤶256)
 ڲchar *s    ԭ
           char *fmt  ʽ
           char *t    Ŀ
           char *cdt  ļĲɼʱ
 ֵ  0   ɹ
           -1  ƫЧ
 *************************************/
int f_nametr(char *s, char *fmt, char *t, char *cdt)
{
    int    i, n, b,
           iOldNameLen,             /* ԭƳ */
           iOneChar,                /* һλ */
           iMin = -1,
           iMax = -1,
           iAdjust,
           iValLen,
           bFirst = 1,
           bOpen = 0,
           iSubsNum = 0;            /* 滻ӴĿ */

    char  *p, v[256], szBuf[256], s1[8], s2[8];

    static struct s_subs
    {
        char a[8];                  /* ʽӴ */
        char b[MAXL_FNAME + 1];     /* 滻Ӵ */
    } subs[64];

    /* Ʋ */
    if( fmt == NULL || *fmt == 0 )
    {
        strcpy(t, s);
        return(0);
    }

    strcpy(t, fmt);
    strcpy(szBuf, fmt);

    /* ӴλַΧ */
    s2[0] = SM_SEQHYPHEN; s2[1] = 0;
    iOldNameLen = strlen(s);

    if( strstr(fmt, s2) )
    {
        p = fmt;

        do
        {
            b = z_get_fieldv(&p, v, &n, sizeof(v) - 1, s2);
            iValLen = strlen(v);

            if( bOpen == 0 )
                iAdjust = iValLen - 3;
            else
                iAdjust = 0;

            if( iValLen < 3 || v[0 + iAdjust] != SM_NAME_REF1 ) return(-1);
            if( ! isdigit(v[1 + iAdjust]) ) return(-1);
            if( ! isdigit(v[2 + iAdjust]) ) return(-1);

            strncpy(s1, v + iAdjust + 1, 2);
            s1[2] = 0;

            if( bOpen == 0 )
            {
                iMin = atoi(s1);
                bOpen = 1;
            }
            else        /* open */
            {
                iMax = atoi(s1);
                if( iMin <= 0 || iMin > iOldNameLen || iMax <= 0 || iMax > iOldNameLen ) return(-1);

                sprintf(subs[iSubsNum].a, "%c%02d%c%c%02d", SM_NAME_REF1, iMin, SM_SEQHYPHEN, SM_NAME_REF1, iMax);
                strncpy(subs[iSubsNum].b, s + iMin - 1, iMax - iMin + 1);
                subs[iSubsNum++].b[iMax - iMin +1] = 0;

                if( iValLen == 3 )
                {
                    bOpen = 0;
                }
                else
                {
                    if( v[iValLen - 3] == SM_NAME_REF1 )
                    {
                        if( ! isdigit(v[iValLen - 2]) ) return(-1);
                        if( ! isdigit(v[iValLen - 1]) ) return(-1);

                        strncpy(s1, v + iValLen - 2, 2);
                        s1[2] = 0;
                        iMin = atoi(s1);
                        bOpen = 1;
                    }
                }
            }
        }
        while(b);
    }

    /* Ӵ1 λַ */
    s2[0] = SM_NAME_REF1; s2[1] = 0;

    if( strstr(fmt, s2) )
    {
        p = fmt;

        do
        {
            b = z_get_fieldv(&p, v, &n, sizeof(v) - 1, s2);

            if( bFirst == 0 )
            {
                iOneChar = 0;
                sscanf(v, "%2d", &iOneChar);

                if( iOneChar <= 0 || iOneChar > iOldNameLen ) return(-1);

                sprintf(subs[iSubsNum].a, "$%.2s", v);
                strncpy(subs[iSubsNum].b, s + iOneChar - 1, 1);
                subs[iSubsNum].b[1] = 0;

                iSubsNum++;
            }
            else bFirst = 0;
        }
        while( b );
    }

    for( i = 0; i < iSubsNum; i++ )
    {
        z_sswap(t, szBuf, subs[i].a, subs[i].b, 1);
        strcpy(szBuf, t);
    }

    /*  */
    if( strchr(fmt, SM_PATH_DATE) )
    {
        z_get_dt(t, CL - 1, szBuf, 0);
        strcpy(szBuf, t);
    }

    /* ļĲɼʱ */
    if( strchr(fmt, SM_PATH_CDATE) && cdt )
    {
        s2[0] = SM_PATH_CDATE; s2[1] = 0;
        z_sswap(t, szBuf, s2, cdt, 0);
        strcpy(szBuf, t);
    }

    /* Դļ */
    if( strchr(fmt, SM_NAME) )
    {
        s2[0] = SM_NAME; s2[1] = 0;
        z_sswap(t, szBuf, s2, s, 0);
    }

    return(0);
}

/**************************
 Ľ
 ڲchar *pass  
           char *text  
 **************************/
void f_pass_decry(char *pass, unsigned char *text)
{
    unsigned char buf1[129];

    z_2hexs((char *)buf1, pass);

    /*  */
    GC_en_code(buf1, text, t_key, strlen(pass) / 2, 0);
}

/****************
 ļת
 ****************/
void f_pass_encry(char *text, char *pass)
{
    int  dlen, len1;

    unsigned char out[129];

    /* ȡ8 ı */
    dlen = strlen(text);
    if( (len1 = dlen % 8) ) dlen += (8 - len1);

    /*  */
    memset(out, 0, sizeof(out));
    GC_en_code((unsigned char *)text, out, t_key, dlen, 1);

    z_s2hex(pass, (char *)out, dlen);
}

/**************************
 ȡſļ
 ֵ  -1  ļʧ
            0  ɹ
            1  δ
 **************************/
int f_fsn_read(char *file, int *seq)
{
    FILE *fp;

    int   r = 0;
    char  buf1[CL];

    if( (fp = fopen(file, "r")) == NULL ) return(-1);

    while( ! feof(fp) )
    {
        if( fgets(buf1, sizeof(buf1), fp) == NULL ) break;

        if( buf1[0] == '-' )    /* ʾδָ'Ը澯'ʱʹ */
        {
            r = 1;
            break;
        }
        else if( isdigit(buf1[0]) )
        {
            *seq = (int) strtol(buf1, (char **)NULL, 10);
            break;
        }
    }

    fclose(fp);
    return(r);
}

/**************************
 ſļ
 ڲint seq 
 **************************/
int f_fsn_write(char *file, int seq)
{
    FILE *fp;

    if( (fp = fopen(file, "w")) == NULL ) return(-1);

    fputs("! ļļ\n", fp);
    fputs("! ϸ޶ʽӶַ\n", fp);

    if( seq == -1 )
        fputs("-\n", fp);
    else
        fprintf(fp, "%0*d\n", u_zcfg.seq_length, seq);

    fclose(fp);
    return(0);
}

/**********************************************
 ˢȫֹ
 ڲint flag -- ˢ±־ 0ʼװ 1ˢ
 **********************************************/
int f_gpara_refresh(int flag)
{
    time_t t[8];

    int    b[8], nPort;
    char   value[16], busytime[12], prov_sms_nums[128],
           rzip[17], rzuser[17], rzpass[33];

    memset(t, 0, sizeof(t));
    memset(b, 0, sizeof(b));

    if( z_getkeyv(u_pcfgfile, "BUSYNOFILET", value, sizeof(value) - 1) == 0 )
        t[0] = (int) strtol(value, (char **)NULL, 10);

    if( z_getkeyv(u_pcfgfile, "FREENOFILET", value, sizeof(value) - 1) == 0 )
        t[1] = (int) strtol(value, (char **)NULL, 10);

    if( z_getkeyv(u_pcfgfile, "HDTIMELIMIT", value, sizeof(value) - 1) == 0 )
        t[2] = (int) strtol(value, (char **)NULL, 10);

    if( z_getkeyv(u_pcfgfile, "PROVINCE_WARNITV", value, sizeof(value) - 1) == 0 )
        t[3] = (int) strtol(value, (char **)NULL, 10);

    if( z_getkeyv(u_pcfgfile, "CITY_WARNITV", value, sizeof(value) - 1) == 0 )
        t[4] = (int) strtol(value, (char **)NULL, 10);

    if( z_getkeyv(u_pcfgfile, "STANDBY_TIMEOUT", value, sizeof(value) - 1) == 0 )
        t[5] = (int) strtol(value, (char **)NULL, 10);
    else
        t[5] = TMO_FTP_RZ;

    if( z_getkeyv(u_pcfgfile, "FTP_TIMEOUT", value, sizeof(value) - 1) == 0 )
        t[6] = (int) strtol(value, (char **)NULL, 10);
    else
        t[6] = TMO_FTP;

    if( z_getkeyv(u_pcfgfile, "FTPPORT", value, sizeof(value) - 1) == 0 )
        nPort = (int) strtol(value, (char **)NULL, 10);
    else
        nPort = FTPPORT;

    if( z_getkeyv(u_pcfgfile, "STANDBY_ENCRYPTION", value, sizeof(value) - 1) == 0 )
        b[0] = (int) strtol(value, (char **)NULL, 10);

    if( z_getkeyv(u_pcfgfile, "CONFIG_PLACE", value, sizeof(value) - 1) == 0 )
        b[1] = (int) strtol(value, (char **)NULL, 10);

    if( z_getkeyv(u_pcfgfile, "BUSY_TIME", busytime, sizeof(busytime) - 1) )
        strcpy(busytime, BUSYTIME);

    if( z_getkeyv(u_pcfgfile, "PROVINCE_SMS_NUMBERS", prov_sms_nums, sizeof(prov_sms_nums) - 1) )
        prov_sms_nums[0] = 0;

    if( z_getkeyv(u_pcfgfile, "STANDBY_HOST", rzip, sizeof(rzip) - 1) )
        rzip[0] = 0;

    if( z_getkeyv(u_pcfgfile, "STANDBY_USER", rzuser, sizeof(rzuser) - 1) )
        rzuser[0] = 0;

    if( z_getkeyv(u_pcfgfile, "STANDBY_PASS", rzpass, sizeof(rzpass) - 1) )
        rzpass[0] = 0;

    /*  */
    if( GC_semop(u_semid, SN_LOCATION, -1, 0) < 0 ) return(-1);

    if( flag == 1 || u_paras->loadok == 0 )
    {
        strcpy(u_paras->prov_sms_nums, prov_sms_nums);
        strcpy(u_paras->busytime, busytime);
        strcpy(u_paras->rz_host, rzip);
        strcpy(u_paras->rz_user, rzuser);
        strcpy(u_paras->rz_pass, rzpass);

        u_paras->busynofilet  = t[0];
        u_paras->freenofilet  = t[1];
        u_paras->hdtimelimit  = t[2];

        u_paras->prov_warnitv = t[3];
        u_paras->city_warnitv = t[4];
        u_paras->rz_timeout   = t[5];
        u_paras->ftp_timeout  = t[6];
        u_paras->ftpport      = nPort;

        u_paras->rz_encryption = b[0];
        u_paras->cfg_place = b[1];
        u_paras->loadok = 1;
    }

    /*  */
    if( GC_semop(u_semid, SN_LOCATION, 1, 0) < 0 ) return(-1);

    return(0);
}

/****************
 ȡò
 ****************/
int f_para_read(void)
{
    char szValue[16];

    /* ־ļ */
    u_logmsize = LOGMSIZE;

    if( z_getkeyv(u_pcfgfile, "LOGMAXSIZE", szValue, sizeof(szValue) - 1) == 0 )
    {
        z_lrtrim(szValue);
        u_logmsize = (int) strtol(szValue, (char **)NULL, 10);
    }

    /* ־ļѭĿ */
    u_logloops = 0;

    if( z_getkeyv(u_pcfgfile, "LOGLOOPS", szValue, sizeof(szValue) - 1) == 0 )
    {
        z_lrtrim(szValue);
        u_logloops = (int) strtol(szValue, (char **)NULL, 10);
    }

    /* ƽ̨KEY */
    u_zkey = 0;

    if( z_getkeyv(u_pcfgfile, "GCPSIPCKEY", szValue, sizeof(szValue) - 1) )
    {
        return(-1);
    }
    z_lrtrim(szValue);
    u_zkey = (int) strtol(szValue, (char **)NULL, 10);

    /* · */
    if( z_getkeyv(u_pcfgfile, "DIRPLUG", u_plugdir, sizeof(u_plugdir) - 1) )
        strcpy(u_plugdir, APLUGDIR);

    /* UDP ˿ */
    u_udpport = ANIDPORT;

    if( z_getkeyv(u_pcfgfile, "UDPPORT", szValue, sizeof(szValue) - 1) == 0 )
    {
        z_lrtrim(szValue);
        u_udpport = (int) strtol(szValue, (char **)NULL, 10);
    }

    return(0);
}

/************************************
 ȷæʱʱ
 ڲchar *pbusyt  æʱʱζ
 ************************************/
int f_isbusy(char *pbusyt)
{
    int  isbusy = 1;

    char busytime[16],
         busybt[8], busyet[8],  /* æʱֹʱ */
         ctvs[16];              /* ǰʱַʽ */

    memset(busytime, 0, sizeof(busytime));

    /* ȡæʱʱ */
    if( *pbusyt )
        strncpy(busytime, pbusyt, 15);
    else
        strcpy(busytime, u_zpara.busytime);

    strncpy(busybt, busytime, 5);
    busybt[5] = 0;
    strncpy(busyet, busytime + 6, 5);
    busyet[5] = 0;

    z_get_dt(ctvs, 8, "t", 0);

    /* жæʱʱ */
    if( strcmp(busyet, busybt) >= 0 )
    {
        if( strncmp(ctvs, busybt, 5) > 0 && strncmp(ctvs, busyet, 5) < 0 )
            isbusy = 1;
        else
            isbusy = 0;
    }
    else
    {
        if( strncmp(ctvs, busybt, 5) > 0 || strncmp(ctvs, busyet, 5) < 0 )
            isbusy = 1;
        else
            isbusy = 0;
    }

    return(isbusy);
}

/******************************
 
 ڲchar  *no   
           int    type 
           char  *val  ֵ
           ZCFG  *ocfg 
 ֵ  -1  ʧ
           -2  Ȩ޲
            0  Ų
            1  ok
 ******************************/
int f_search_set(char *no, int type, char *val, ZCFG *ocfg)
{
    int   i, found = 0;
    uid_t myuid;    /* ûuid */

    /*  */
    if( GC_semop(u_semid, SN_LOCATION, -1, 0) < 0 )
    {
        printf("󣺼ʧ\n");
        return(-1);
    }

    u_pcfgs = u_cfgs;
    u_pruns = u_runs;

    myuid = geteuid();

    for( i = 0; i < MAXN_Z; u_pcfgs++, u_pruns++, i++ )
    {
        if( u_pcfgs->no[0] == 0 ) continue;

        /* ״̬ */
        if( GC_getstat(NULL, u_pruns->pslot) == ST_RELEASED ) continue;

        if( strcmp(u_pcfgs->no, no) == 0 )
        {
            if( myuid && (myuid != GC_getuid(NULL, u_pruns->pslot)) )
                found = -2;
            else
                found = 1;

            break;
        }
    }

    if( found == 1 )
    {
        if( ocfg ) memcpy(ocfg, u_pcfgs, ZCFG_LEN);

        switch( type )
        {
        case OT_WARN:           /* 澯 */
            u_pcfgs->warn_mode[WF_ALL] = val[0];
            break;

        case OT_NEW_CFG:        /* ˢ */
            u_pcfgs->refresh = 1;
            break;

        case OT_NEW_SEQ:        /* Ÿ */
            u_pcfgs->seq_refresh = 1;
            u_pcfgs->seq_to_file = (int) strtol(val, (char **)NULL, 10);
            break;
        }
    }

    /*  */
    if( GC_semop(u_semid, SN_LOCATION, 1, 0) < 0 )
    {
        printf("󣺽ʧ\n");
        return(-1);
    }

    return(found);
}

/**********************
 ܸ֯澯Ϣ
 **********************/
void f_setnid(char *msg, char *pWId, char *pWType, int iWLevel)
{
    strncpy(u_pNidWarn->szWarnId, pWId, sizeof(u_pNidWarn->szWarnId) - 1);
    u_pNidWarn->szWarnId[sizeof(u_pNidWarn->szWarnId) - 1] = 0;

    if( pWType)
    {
        strncpy(u_pNidWarn->szWarnType, pWType, sizeof(u_pNidWarn->szWarnType) - 1);
        u_pNidWarn->szWarnType[sizeof(u_pNidWarn->szWarnType) - 1] = 0;
    }

    strncpy(u_pNidWarn->szWarnMsg, msg, sizeof(u_pNidWarn->szWarnMsg) - 1);
    u_pNidWarn->szWarnMsg[sizeof(u_pNidWarn->szWarnMsg) - 1] = 0;

    if( iWLevel > 0 ) u_pNidWarn->iWarnLevel = iWLevel;

    f_nidlog(&u_nid_warn);
}

/************
 ôϢ
 ************/
void f_seterr(char *msg, char *pWId, char *pWType, int iWLevel)
{
    int   i, len, slen,
          iFirstWarn = 0,    /* Ƿ澯IDĳθ澯 */
          iNotSameMsg = 0;   /* ǰ澯ϢϴϢǷͬ */

    char *pMsg;

    z_logv(u_logfile, msg);

    /* ¼ܸ澯 */
    if( pWId )
    {
        /* 澯 */
        for( i = 0; i < sizeof(u_lightwarn[u_careno]) / sizeof(LIGHTWARN); i++ )
        {
            if( u_lightwarn[u_careno][i].szWarnId[0] == 0 ) break;

            if( strcmp(pWId, u_lightwarn[u_careno][i].szWarnId) == 0 )    /* ƥ */
            {
                if( u_lightwarn[u_careno][i].iWarnTimes == 0 )            /* θ澯 */
                {
                    iFirstWarn = 1;
                    u_lightwarn[u_careno][i].iWarnTimes = 1;
                }
                else
                {
                    u_lightwarn[u_careno][i].iWarnTimes = 0;
                }
            }
            else
            {
                u_lightwarn[u_careno][i].iWarnTimes = 0;
            }
        }

        if( iFirstWarn == 1 ) return;
    }

    /*  */
    if( GC_semop(u_semid, SN_LOCATION, -1, 0) < 0 ) return;

    if( strcmp(msg, u_pruns->errmsg) )
    {
        iNotSameMsg = 1;
        u_pruns->errtime = time( (time_t *) 0 );

        /* Ϣ */
        slen = strlen(msg);
        len = slen < (EMSG_LEN - NIDW_LEN) ? slen : (EMSG_LEN - NIDW_LEN);

        strncpy(u_pruns->errmsg, msg, len);
        u_pruns->errmsg[len] = 0;

        /* ܸ澯Ϣ */
        pMsg = u_pruns->errmsg + (EMSG_LEN - NIDW_LEN) + 1;

        if( pWId )
        {
            strncpy(pMsg, u_pNidWarn->szWarnId, 8);     // 澯ID
            pMsg += 8;

            strncpy(pMsg, u_pNidWarn->szWarnType, 8);   // 澯
            pMsg += 8;

            *pMsg = u_pNidWarn->iWarnLevel + '0';       // 澯
        }
        else
        {
            *pMsg = 0;
        }

        u_pruns->e_report1 = 0;
        u_pruns->e_report2 = 0;
        u_pruns->e_report3 = 0;
    }

    /*  */
    if( GC_semop(u_semid, SN_LOCATION, 1, 0) < 0 ) return;

    /* ܸ澯 */
    if( pWId && iNotSameMsg )
    {
        f_setnid(msg, pWId, pWType, iWLevel);
    }
}

/******************************************
 ͨUDP Э鷢־¼
 ڲNID_PKT *pPkt   Ϣ
 ******************************************/
int f_nidlog(NID_PKT *pPkt)
{
    int   sktfd,
          iPktLen;          /* ĳ */

    struct sockaddr_in server;

    /* ĳ */
    switch( pPkt->cType  )
    {
    case NID_T_NORMAL:
        iPktLen = sizeof(NID_NORMAL);
        break;

    case NID_T_WARN:
        iPktLen = sizeof(NID_WARN);
        break;

    default:
        return(0);
    }

    /* ƫ */
    iPktLen += (long) (&((NID_PKT *)0)->uData);

    /* Create a datagram socket in the internet domain and use the default protocol(UDP). */
    if( (sktfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0 )
    {
        z_logv(u_logfile, "socket() failed");
        return(-1);
    }

    /* Set up the server name */
    server.sin_family      = AF_INET;               /* Internet Domain  */
    server.sin_port        = htons(u_udpport);      /* Server's Port    */
    server.sin_addr.s_addr = htonl(INADDR_LOOPBACK);/* Server's Address */

    /* Send the messages in buf to the server */
    if( sendto(sktfd, (char *)pPkt, iPktLen, 0, (struct sockaddr *)&server, sizeof(server)) < 0 )
    {
        z_logv(u_logfile, "sendto() failed");
        return(-2);
    }

    /* Deallocate the socket */
    close(sktfd);
    return(0);
}

/****************************************
 ûڸ澯ʱڴеĲλ
 ڲuid_t iUid    ûID
           int   bWrite  Ƿ׷Ӽ¼
 ****************************************/
int f_wtmslot(uid_t iUid, int bWrite)
{
    int i, iSlot = -1;

    /* rootû̶ʹõһλ */
    if( iUid == 0 ) return 0;

    /* ӵڶλʼ */
    for( i = 1, u_pwtms = u_wtms + 1; i < MAXN_USER; i++, u_pwtms++ )
    {
        if( u_pwtms->iUid == 0 )
        {
            if( bWrite ) iSlot = i;
            break;
        }
        else if( u_pwtms->iUid == iUid )
        {
            iSlot = i;
            break;
        }
    }

    return(iSlot);
}

