/**************
 FTP Э飬ɼ
 **************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>
#include <time.h>
#include <sys/stat.h>
#include "gcps.h"
#include "z.h"
#include "zvar.h"

/* ļƥģʽ */
char * f_pattern(char *pattern, int iseq);

/* ϸŲɼʱļеʱ */
int f_checknewer(char *latestfile, char *oldestfile);

/* ȡһļ */
int f_1file(FILE *fp, char *pLine, int nLineSize, char *latestfile);

/* ȡԶļС֤ */
long f_remotesize(int fd, char *file, char *zout);

/* ļĶ⿽ */
int f_extralink(FILINFO *fi);

/* ɾ/ƶԶļ */
int f_bakremote(int *fd, FILINFO *fi, char *zout);

/* ļ */
void f_updateseq(char *file, int *iseq);

/* get ɹ֮ĸ澯 */
int f_warnget(char *emsg, int fcount, int siz, char *oldestfile);

/*********************************
 ڲint *iseq  ϴļ
 ֵ  0    ɹ
           -1   ʧ
           -2   FTP ʧ
           -3   ʧ
 *********************************/
int f_get(int *iseq, FILINFO *fi)
{
    FILE  *fp;

    int    b = 0,
           f_err = R_SUCCESS,               /* ʧܱ־ */
           fcount = 0,                      /* ɼļĿ */
           ftpfd = -1;                      /* ftp  */

    char  *ppat, pattern[65],               /* Դļģʽ */

           oldestfile[CL],                  /* ͬļɵһ澯ʹ */
           latestfile[CL],                  /* ͬļµһ */

           filelist[CL],                    /* Զļб */
           zout[CL];                        /* FTP Ϣļ */

    static char     szLine[1024];
    static char     emsg[EMSG_LEN + 1];     /* ־Ϣ */

    /* ǰļģʽ */
    ppat = f_pattern(pattern, *iseq);
    z_logv(u_logfile, ppat);

    /* ȡļб */
    snprintf(filelist, sizeof(filelist), "%s/%s%s", u_logdir, FILELIST, u_zcfg.no);
    snprintf(zout, sizeof(zout), "%s/%s%s%s", u_logdir, OUTPREFIX, u_zcfg.no, OUTSUFFIX);

    u_pruns->leftfiles = 0;
    if( (ftpfd = f_conn_server(ppat, filelist, zout, t_ftpbuf1)) < 0 )
    {
        z_rtrim(t_ftpbuf1);
        return(R_LOGONFAIL);
    }

    /*  */
    if( ftpfd > 64 )
    {
        z_logv(u_logfile, "ftpfd > 64");
        return(R_RESTART);
    }

    fcount = u_pruns->leftfiles;
    z_logv(u_logfile, "fcount=%d", fcount);

    /* бļ */
    if( (fp = fopen(filelist, "r")) == NULL )
    {
        snprintf(emsg, sizeof(emsg), "бļʧ'%s'", filelist);
        f_seterr(emsg, "O007", "OS", 9);

        close(ftpfd);
        return(R_FILEFAIL);
    }

    /* жϵļ */
    if( f_oldnew(fp, latestfile, oldestfile) < 0 )
    {
        fclose(fp);
        close(ftpfd);
        return(R_FILEFAIL);
    }

    /* ϸŲɼʱļеʱ */
    if( f_checknewer(latestfile, oldestfile) < 0 )
    {
        fclose(fp);
        close(ftpfd);
        return(R_FILEFAIL);
    }

    /* һɼÿļ */
    for( rewind(fp); ! feof(fp); u_pruns->leftfiles -- )
    {
        f_err = R_SUCCESS;

        /* ȡһļ */
        b = f_1file(fp, szLine, sizeof(szLine), latestfile);

        if( b == 0 ) break;
        else if( b == 1 ) continue;
        else if( b == -1 )
        {
            f_err = R_FILEFAIL;
            break;
        }

        /* ĿƵϢ */
        strcpy(fi->fstr, szLine);
        fi->szCrtTime[0] = 0;

        if( f_name1a(fi) < 0 )
        {
            f_err = R_FILEFAIL;
            break;
        }

        /* ȡļС֤ */
        if( (fi->fsize = f_remotesize(ftpfd, fi->fstr, zout)) < 0 )
        {
            f_err = R_FTPFAIL;
            break;
        }

        /* ϴβɼʼʱ */
        u_pruns->begtime = time( (time_t *) 0 );

        gettimeofday(&(fi->tStartTv), NULL);
        u_pNidNormal->tStartTv = fi->tStartTv;

        z_logv(u_logfile, "Remote=%s", fi->fstr);
        z_logv(u_logfile, "Local=%s", fi->dstfile);
        z_logv(u_logfile, "Getting ...");

        /* ɼļ */
        if( GC_ftp_get(ftpfd, fi->fstr, fi->midpath, t_ftpbuf1) < 0 )
        {
            z_rtrim(t_ftpbuf1);
            z_logv(zout, t_ftpbuf1);
            f_seterr("ɼļʧ", "A008", "APP", 6);

            f_err = R_FTPFAIL;
            break;
        }
        z_logv(u_logfile, "done");

        gettimeofday(&(fi->tEndTv), NULL);
        u_pNidNormal->tEndTv = fi->tEndTv;

        /* ļСƥ֤ */
        if( (f_err = f_sizematch(ftpfd, fi, zout)) != R_SUCCESS ) break;

        /* ʱ */
        if( f_hdtime(fi, fi->midpath) < 0 )
        {
            f_err = R_FILEFAIL;
            break;
        }

        /* ļ */
        if( rename(fi->midpath, fi->localpath) < 0 )
        {
            z_logv(u_logfile, "'%s' -> '%s' ļʧ", fi->midpath, fi->localpath);
            f_seterr("ļʧ", "O003", "OS", 9);

            f_err = R_FILEFAIL;
            break;
        }

        /* ļĶ⿽ */
        if( f_extralink(fi) < 0 )
        {
            f_err = R_FILEFAIL;
            break;
        }

        /* ɾƶ */
        if( f_bakremote(&ftpfd, fi, zout) < 0 )
        {
            f_err = R_FTPFAIL;
            break;
        }

        /* ļ */
        f_updateseq(fi->fstr, iseq);

        /* дļ */
        if( u_zcfg.seq_ctrl == 1 || u_zcfg.warn_mode[WF_SEQBREAK] == '1' )
        {
            if( f_fsn_write(u_fsnfile, *iseq) < 0 )
            {
                f_seterr("дļʧ", "O001", "OS", 9);
                f_err = R_FILEFAIL;
                break;
            }
        }

        /* 澯Ϣ */
        emsg[0] = 0;
        f_warnget(emsg, fcount, fi->fsize, oldestfile);

        /* Իӳٵĸ澯 */
        f_delay_warn(fi->szCallTime, emsg[0] == 0 ? emsg : NULL);

        /* ɹ״̬ */
        if( f_set_ok(fi->dstfile, fi->szCallTime, emsg) < 0 )
        {
            f_seterr("ʧ");
            f_err = R_LOCKFAIL;
            break;
        }

        /* FTP  */
        if( u_zcfg.seq_ctrl == 1 || u_zcfg.warn_mode[WF_SEQBREAK] == '1' )
        {
            if( u_zcfg.seq_sync && f_fsn_rz(t_ftpbuf1) < 0 )
            {
                z_rtrim(t_ftpbuf1);
                z_logv(zout, t_ftpbuf1);
                z_logv(u_logfile, "ϵͳļʧ");
            }
        }

        /* óɹű */
        f_okshell(fi);

        /* ¼ܼ */
        strncpy(u_pNidNormal->szFileName, fi->dstfile, sizeof(u_pNidNormal->szFileName) - 1);
        u_pNidNormal->szFileName[sizeof(u_pNidNormal->szFileName) - 1] = 0;
        u_pNidNormal->iFileSize = fi->fsize;
        strcpy(u_pNidWarn->szFileName, u_pNidNormal->szFileName);

        f_nidlog(&u_nid_normal);

        z_logv(u_logfile, "Size=%ld", fi->fsize);
        z_logv(u_logfile, "Ok!");
    }
    fclose(fp);

    /* ر */
    close(ftpfd);
    ftpfd = -1;

    return(f_err);
}

/********************************
 ȡһļ
 ڲFILE *fp      бļ
           int   iseq    ǰ
 ֵ   0  
            1  
            2  ɹ
           -1  ʧ
 ********************************/
int f_1file(FILE *fp, char *pLine, int nLineSize, char *latestfile)
{
    static char fstr[1024];

    pLine[nLineSize - 2] = '\n';
    if( fgets(pLine, nLineSize, fp) == NULL ) return(0);

    /* ļй */
    if( pLine[nLineSize - 2] && pLine[nLineSize - 2] != '\n' )
    {
        z_logv(u_logfile, "бļй");
        return(-1);
    }

    z_lrtrim(pLine);
    if( pLine[0] == 0 || strcmp(pLine, ".") == 0 || strcmp(pLine, "..") == 0 ) return(1);

    if( latestfile && latestfile[0] )
    {
        if( strcmp(pLine, latestfile) == 0 )
        {
            /* ɼµһļ */
            if( strchr(u_zcfg.gather_mode, SM_NOLATEST) ) return(1);
        }
        else
        {
            /* ϸſʱֻɼµһ */
            if( u_zcfg.seq_ctrl == 1 ) return(1);
        }
    }

    /* ȡļ */
    strncpy(fstr, z_fnonly(pLine), sizeof(fstr) - 1);
    fstr[sizeof(fstr) - 1] = 0;

    if( strlen(fstr) > MAXL_FNAME ) return(1);

    /* ļƥģʽ */
    if( u_zcfg.src_regex[0] && z_regmatch(fstr, u_zcfg.src_regex) == 0 )
    {
        z_logv(u_logfile, "ģʽ '%s' ƥ", u_zcfg.src_regex);
        return(1);
    }

    return(2);
}

/********************************
 ļƥģʽ
 ڲchar *pattern ģʽ
           int   iseq    ǰ
 ֵ  char *  ƥģʽ
 ********************************/
char * f_pattern(char *pattern, int iseq)
{
    char  *ppat,                            /* Դļģʽ */
           seqstr[17];                      /* ǰŵַʾ */

    if( u_zcfg.seq_ctrl == 1 )              /* Ź */
    {
        sprintf(seqstr, "%0*d", u_zcfg.seq_length, iseq);
        f_seq2name(seqstr, pattern);
        ppat = pattern;
    }
    else if( u_zcfg.warn_mode[WF_SEQBREAK] == '1' )
    {
        f_seq2name(NULL, pattern);
        ppat = pattern;
    }
    else
        ppat = u_zcfg.src_fn_pattern;

    return ppat;
}

/**************************
 жϵļ
 **************************/
int f_oldnew(FILE *fp, char *latestfile, char *oldestfile)
{
    int  b = 0;
    static char szLine[1024];

    latestfile[0] = 0;
    oldestfile[0] = 0;

    /* ϸŲɼʱ .. */
    if( u_zcfg.seq_ctrl == 1 || strchr(u_zcfg.gather_mode, SM_NOLATEST) )
    {
        while( ! feof(fp) )
        {
            szLine[sizeof(szLine) - 2] = '\n';
            if( fgets(szLine, sizeof(szLine), fp) == NULL ) break;

            /* ļй */
            if( szLine[sizeof(szLine) - 2] && szLine[sizeof(szLine) - 2] != '\n' )
            {
                b = -1;
                break;
            }
            z_lrtrim(szLine);

            /* µļ */
            if( latestfile[0] == 0 || strcmp(szLine, latestfile) > 0 )
            {
                strncpy(latestfile, szLine, sizeof(latestfile) - 1);
                latestfile[sizeof(latestfile) - 1] = 0;
            }

            /* ɵļ */
            if( oldestfile[0] == 0 || strcmp(szLine, oldestfile) < 0 )
            {
                strncpy(oldestfile, szLine, sizeof(oldestfile) - 1);
                oldestfile[sizeof(oldestfile) - 1] = 0;
            }
        }

        if( b < 0 )
        {
            z_logv(u_logfile, "бļй");
            return(-1);
        }
    }

    return(0);
}

/************************************
 ϸŲɼʱļеʱ
 ************************************/
int f_checknewer(char *latestfile, char *oldestfile)
{
    int    b;
    char   hdftime[21], hdfttmp[21];

    static char szBuf[EMSG_LEN + 1];

    if( u_zcfg.seq_ctrl == 1 &&
        strchr(u_zcfg.file_analyzer, SM_NAME_REF1) &&
        latestfile[0] &&
        u_pruns->hdftime[0] )
    {
        /* ȡļеʱ */
        if( (b = f_nametr(latestfile, u_zcfg.file_analyzer, hdfttmp)) < 0 )
        {
            sprintf(szBuf, "'%s' ȡеʱʧ=%d", u_zcfg.file_analyzer, b);
            f_seterr(szBuf, "A010", "APP", 9);
            return(-1);
        }

        sprintf(hdftime, "%8.8s %2.2s:%2.2s:%2.2s", hdfttmp, hdfttmp + 8, hdfttmp + 10, hdfttmp + 12);
        if( strcmp(u_pruns->hdftime, hdftime) > 0 )
        {
            sprintf(szBuf, "棺ʷļ '%s'", oldestfile);
            f_seterr(szBuf, "A015", "APP", 9);
            return(-1);
        }
    }

    return(0);
}

/**************************************
 ȡԶļС֤
 ڲFILINFO *fi   ļϢ
 **************************************/
long f_remotesize(int fd, char *file, char *zout)
{
    long l;
    char szBuf[64];

    if( u_zcfg.size_col > 0 )
        l = f_size_one(fd, file, t_ftpbuf1);
    else
        l = GC_ftp_size(fd, file, t_ftpbuf1);

    if( l < 0 )
    {
        z_rtrim(t_ftpbuf1);
        z_logv(zout, t_ftpbuf1);
        f_seterr("ȡԶļСʧ", "A007", "APP", 6);

        return(-1);
    }

    if( u_zcfg.record_size > 0 && (l % u_zcfg.record_size) )
    {
        sprintf(szBuf, "Զļ%ld, ", l);
        z_logv(u_logfile, szBuf);

        /*
         * if( u_zcfg.warn_mode[WF_SIZEMIS] == '1' )
         *     f_seterr(emsg);
         * else
         *     z_logv(u_logfile, emsg);
         */

        return(-1);
    }

    return(l);
}

/********************************
 ļСƥ֤
 ڲFILINFO *fi   ļϢ
 ********************************/
int f_sizematch(int fd, FILINFO *fi, char *zout)
{
    FILE  *fp;

    long   l = -1L;
    char   szBuf[128], cmdstr[CL];

    struct stat st;

    /* ȡĿļС */
    switch( u_zcfg.optype )
    {
    case SM_FTPGET:

        if( stat(fi->midpath, &st) < 0 )
        {
            f_seterr("ȡļ״̬ʧ", "O004", "OS", 9);
            return(R_FILEFAIL);
        }

        l = (long) (st.st_size);
        break;

    case SM_FTPPUT:

        if( (l = f_remotesize(fd, fi->pPutName, zout)) < 0 ) return(R_FTPFAIL);
        break;

    case SM_SHELLPUT:

        if( u_zcfg.sizeshell[0] == 0 ) break;

        snprintf(cmdstr, sizeof(cmdstr), "%s/%s %s/%s", u_plugdir, u_zcfg.sizeshell, u_zcfg.dst_path, fi->pPutName);
        fp = popen(cmdstr, "r");

        if( fp == NULL || fscanf(fp, "%ld", &l) != 1 )
        {
            f_seterr("ȡԶļСʧ", "A007", "APP", 6);
            if( fp ) pclose(fp);
            return(R_FTPFAIL);
        }

        pclose(fp);
        break;
    }

    if( l != -1L && l != fi->fsize )
    {
        sprintf(szBuf, "Դ%ld. Ŀ%ld. Сһ", fi->fsize, l);

        if( l < fi->fsize )
        {
            strcat(szBuf, "ļϵͳռ");
            f_seterr(szBuf, "A009", "APP", 6);
        }
        else
            z_logv(u_logfile, szBuf);

        return(R_FTPFAIL);
    }

    return(R_SUCCESS);
}

/**********************************
 ʱ
 ڲchar    *file ļ
           FILINFO *fi   ļϢ
 **********************************/
int f_hdtime(FILINFO *fi, char *file)
{
    FILE *fp;

    int   b;
    char  hdfttmp[21];

    static char szCmd[1024], szTmp[1024];

    fi->szCallTime[0] = 0;
    if( strchr(u_zcfg.file_analyzer, SM_NAME_REF1) )
    {
        /* ȡļеʱ */
        if( (b = f_nametr(fi->fstr, u_zcfg.file_analyzer, hdfttmp)) < 0 )
        {
            sprintf(szTmp, "'%s' ȡеʱʧ=%d", u_zcfg.file_analyzer, b);
            f_seterr(szTmp, "A010", "APP", 9);
            return(-1);
        }
        sprintf(fi->szCallTime, "%8.8s %2.2s:%2.2s:%2.2s", hdfttmp, hdfttmp + 8, hdfttmp + 10, hdfttmp + 12);
    }
    else if( u_zcfg.file_analyzer[0] && fi->fsize )
    {
        z_logv(u_logfile, "Analyzing ...");
        snprintf(szCmd, sizeof(szCmd), "%s/%s %s", u_plugdir, u_zcfg.file_analyzer, file);

        if( (fp = popen(szCmd, "r")) )
        {
            fgets(fi->szCallTime, sizeof(fi->szCallTime), fp);
            pclose(fp);
        }
    }

    return(0);
}

/********************************
 ⿽ļ
 ڲFILINFO *fi   ļϢ
 ********************************/
int f_extralink(FILINFO *fi)
{
    int i;

    struct stat st;
    static char szTmp[1024];

    for( i = 0; i < u_zcfg.extracopy; i++ )
    {
        snprintf(szTmp, sizeof(szTmp), "%s/%s%d", fi->datedir, COPYPREFIX, i + 1);

        if( stat(szTmp, &st) < 0 && mkdir(szTmp, NEWDIRMODE) < 0 )
        {
            f_seterr("⿽·ʧ", "A011", "APP", 9);
            return(-1);
        }

        snprintf(szTmp, sizeof(szTmp), "%s/%s%d/%s", fi->datedir, COPYPREFIX, i + 1, fi->dstfile);
        unlink(szTmp);

        if( link(fi->localpath, szTmp) < 0 )
        {
            f_seterr("Ӷ⿽ļʧ", "A011", "APP", 9);
            return(-1);
        }
    }

    return(0);
}

/************
 ļ
 ************/
void f_updateseq(char *file, int *iseq)
{
    char szSeq[64];

    if( u_zcfg.seq_ctrl == 1 )
    {
        if( *iseq < u_zcfg.seq_max )
            (*iseq) ++;
        else
            *iseq = u_zcfg.seq_min;
    }
    else if( u_zcfg.warn_mode[WF_SEQBREAK] == '1' )
    {
        /* ļȡ */
        f_name2seq(file, szSeq);
        *iseq = (int) strtol(szSeq, (char **)NULL, 10);
    }
}

/*****************
 ɾ/ƶԶļ
 *****************/
int f_bakremote(int *fd, FILINFO *fi, char *zout)
{
    int  i, b = -1;

    for( i = 0; b < 0 && (u_zcfg.rmtbak_times == 0 || i < u_zcfg.rmtbak_times); i++ )
    {
        t_ftpbuf1[0] = 0;

        /* ӷ */
        if( i )
        {
            z_logv(u_logfile, "Sleeping %d ...", u_zcfg.ftp_timeout);
            sleep(u_zcfg.ftp_timeout);

            if( *fd >= 0 ) close(*fd);

            if( (*fd = f_conn_server(NULL, NULL, zout, t_ftpbuf1)) < 0 ||
                GC_ftp_cd(*fd, u_zcfg.src_path, t_ftpbuf1) < 0 )
            {
                z_rtrim(t_ftpbuf1);
                z_logv(zout, t_ftpbuf1);

                if( *fd >= 0 )
                {
                    close(*fd);
                    *fd = -1;
                }
                continue;
            }
        }

        switch( u_zcfg.src_bakflag )
        {
        case BF_DELETE:     /* ɾ */

            z_logv(u_logfile, "Deleting ...");
            b = GC_ftp_delete(*fd, fi->fstr, t_ftpbuf1);
            break;

        case BF_MOVE:       /* ƶ */

            if( (b = f_dtpath_remote(*fd, u_zcfg.src_path, u_zcfg.src_bpath, fi->datedir, t_ftpbuf1)) >= 0 )
            {
                z_logv(u_logfile, "Moving ...");
                snprintf(fi->midpath, sizeof(fi->midpath), "%s/%s", fi->datedir, fi->fstr);
                b = GC_ftp_move(*fd, fi->fstr, fi->midpath, t_ftpbuf1);
            }
            break;

        default:
            b = 0;
            break;
        }

        if( b < 0 )                         /* ʧܸ澯 */
        {
            f_seterr("Զɾƶʧ", "A013", "APP", 6);

            if( b == -10 )                  /* ʱ */
            {
                z_logv(u_logfile, "ʱ");
            }
            else
            {
                z_rtrim(t_ftpbuf1);
                z_logv(zout, t_ftpbuf1);

                if( t_ftpbuf1[0] == '5' )   /* ļڣٶϴѳɹ */
                {
                    z_logv(u_logfile, "ϴβʱ");
                    b = 0;
                }
            }
        }
    }

    if( *fd < 0 )
    {
        return(-1);
    }
    /* Դ */
    else if( u_zcfg.rmtbak_times && i >= u_zcfg.rmtbak_times )
    {
        z_logv(u_logfile, "ٶɹ");
    }

    return(0);
}

/**********************
 get ɹ֮ĸ澯
 **********************/
int f_warnget(char *emsg, int fcount, int siz, char *oldestfile)
{
    int  b;
    char szTmp[EMSG_LEN + 1];   /* ʱ־Ϣ */

    emsg[0] = 0;

    /* ظԼ */
    if( u_zcfg.seq_ctrl == 1 )
    {
        if( fcount > 1 )
        {
            sprintf(emsg, "棺ļͬĿ%dļ%s", fcount, oldestfile);
            z_logv(u_logfile, emsg);
            f_setnid(emsg, "A016", "APP", 9);
        }
    }
    /* Լ */
    else if( u_zcfg.warn_mode[WF_SEQBREAK] == '1' )
    {
        if( u_pruns->lastseq >= 0 )
        {
            b = u_pruns->seq - u_pruns->lastseq;

            if( b <= 0 )
            {
                b += (u_zcfg.seq_max - u_zcfg.seq_min + 1);
            }
            if( b != 1 )
            {
                sprintf(emsg, "棺ϴ%d", u_pruns->lastseq);
                z_logv(u_logfile, emsg);
                f_setnid(emsg, "A017", "APP", 9);
            }
        }

        u_pruns->lastseq = u_pruns->seq;
    }

    /* ļ澯 */
    if( siz )
    {
        u_pruns->num0 = 0;
    }
    else
    {
        u_pruns->num0 ++;

        if( u_zcfg.warn_mode[WF_ZERO] == '1' )
        {
            sprintf(szTmp, "棺ļСΪ0Ŀ%d", u_pruns->num0);
            if( emsg[0] == 0 ) strcpy(emsg, szTmp);

            z_logv(u_logfile, szTmp);
            f_setnid(szTmp, "A018", "APP", 9);
        }
    }

    return(0);
}

/**********************************
 ƻȡԶļС
 ڲchar *fname   ļ
 ֵ  -1  FTP ʧ
           -2  ļʧ
               ļС
 **********************************/
long f_size_one(int ftpfd, char *fname, char *outbuf)
{
    FILE  *rfp;

    int    i;
    long   fsize = -1;

    char   tfile[CL],              /* бļ */
           fmt1[65],               /* ȡʽ */
           slen[65];

    static char szLine[1024];

    snprintf(tfile, sizeof(tfile), "%s/%s%s.1", u_logdir, FILELIST, u_zcfg.no);
    unlink(tfile);

    /* Ŀ¼б */
    if( GC_ftp_list(ftpfd, fname, 1, tfile, outbuf) < 0 ) return(-1);

    if( (rfp = fopen(tfile, "r")) == NULL ) return(-2);

    /* ļСӦĸʽ */
    fmt1[0] = 0;

    for( i = 0; i < u_zcfg.size_col - 1; i++ ) strcat(fmt1, "%*s");
    strcat(fmt1, "%s");

    /* ȡļС */
    if( fgets(szLine, sizeof(szLine), rfp) )
    {
        z_lrtrim(szLine);
        sscanf(szLine, fmt1, slen);

        if( isdigit( slen[0] ) ) fsize = strtol(slen, (char **)NULL, 10);
    }

    fclose(rfp);
    unlink(tfile);

    return(fsize);
}
