

#ifndef __SPICE_DESKTOP_INTEGRATION_H__
#define __SPICE_DESKTOP_INTEGRATION_H__

#include "spice-client.h"

G_BEGIN_DECLS

#define SPICE_TYPE_DESKTOP_INTEGRATION            (spice_desktop_integration_get_type ())
#define SPICE_DESKTOP_INTEGRATION(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), SPICE_TYPE_DESKTOP_INTEGRATION, SpiceDesktopIntegration))
#define SPICE_DESKTOP_INTEGRATION_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), SPICE_TYPE_DESKTOP_INTEGRATION, SpiceDesktopIntegrationClass))
#define SPICE_IS_DESKTOP_INTEGRATION(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SPICE_TYPE_DESKTOP_INTEGRATION))
#define SPICE_IS_DESKTOP_INTEGRATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SPICE_TYPE_DESKTOP_INTEGRATION))
#define SPICE_DESKTOP_INTEGRATION_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), SPICE_TYPE_DESKTOP_INTEGRATION, SpiceDesktopIntegrationClass))

typedef struct _SpiceDesktopIntegration SpiceDesktopIntegration;
typedef struct _SpiceDesktopIntegrationClass SpiceDesktopIntegrationClass;
typedef struct _SpiceDesktopIntegrationPrivate SpiceDesktopIntegrationPrivate;


struct _SpiceDesktopIntegration
{
    GObject parent;

    SpiceDesktopIntegrationPrivate *priv;
};

struct _SpiceDesktopIntegrationClass
{
    GObjectClass parent_class;
};

GType spice_desktop_integration_get_type(void);
SpiceDesktopIntegration *spice_desktop_integration_get(SpiceSession *session);
void spice_desktop_integration_inhibit_automount(SpiceDesktopIntegration *self);
void spice_desktop_integration_uninhibit_automount(SpiceDesktopIntegration *self);

G_END_DECLS

#endif 

