/********************
 ͻ˵Ϣ
 ********************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "gcps.h"
#include "z.h"
#include "uap_agent.h"
#include "uap_stru.h"

int     f_update_cfg(const char *);         /*  */
int     f_exec_cmd(const char *);

static struct code_func
{
    char          *code;                    /* ״ */
    int          (*func)(const char *);     /*  */
} funcs[] =
{
    {TC_UPDATECFG, f_update_cfg    },       /* ļ */
    {TC_CMDEXEC,   f_exec_cmd      }        /* ִָ */
};

char    szUapExe[256],                      // UAP ִг
        szUapCfg[256];                      // UAP ļ

int f_dispense(const char *pno)
{
    int  i, r, n;
    char szTc[8];

    r = 0;
    n = sizeof(funcs) / sizeof(struct code_func);

    /* ¼ */
    z_logv(g_logfile, "<%-15s:%s", g_clientip, g_reqinfo);

    /*  */
    GC_getpheadn(szTc, 2);

    // ȡļUAP ִг
    if( szUapExe[0] == 0 )
    {
        if( z_getkeyv(g_cfgfile, SG_UAPEXE, szUapExe, sizeof(szUapExe) - 1) )
        {
            z_logv("ļûж %s", SG_UAPEXE);
            return(-1);
        }
    }

    // ȡļUAP ļ
    if( szUapCfg[0] == 0 )
    {
        if( z_getkeyv(g_cfgfile, SG_UAPCFG, szUapCfg, sizeof(szUapCfg) - 1) )
        {
            z_logv("ļûж %s", SG_UAPCFG);
            return(-1);
        }
    }

    /* ҵ룬ӦĴ */
    for( i = 0; i < n; i++ )
    {
        if( strcmp(szTc, funcs[i].code) == 0 )
        {
            r = (int) (funcs[i].func)(pno);
            break;
        }
    }

    /* ¼Ӧ */
    i = z_chi_nohalf(g_repinfo, 64);
    g_repinfo[i] = 0;

    z_logv(g_logfile, ">%-15s:|%s|", g_clientip, g_repinfo);

    return(r);
}
