/******************************************************************************
*
* ļ              ErrText.cpp
* ģĿģ      ϵͳ
* ߼ڣ        wang_jin 2008-06-19
* 汾                1.0
* ȨϢ            CVICSE Middleware
* ļ¼            
*
******************************************************************************/


#ifdef WIN32
#	include <windows.h>
#else
#	include <string.h>
#endif

#include "Common/Common.h"


struct error_text
{
	long nErrCode;
	char sErrText[ 256 ];
}	ErrTextList[] = {
	{    0, "ѳɹɡ" },
#ifdef WIN32
	{    1, "ĺ" },
	{    2, "ϵͳҲָļ" },
	{    3, "ϵͳҲָ·" },
	{    4, "ϵͳ޷ļ" },
	{    5, "ܾʡ" },
	{    6, "Ч" },
	{    7, "洢ƿ𻵡" },
	{    8, "õĴ洢㣬޷ִи" },
	{    9, "洢ƿַЧ" },
	{   10, "" },
	{   11, "ͼʹòȷĸʽس" },
	{   12, "ʴЧ" },
	{   13, "Ч" },
	{   14, "õĴ洢㣬޷ɸò" },
	{   15, "ϵͳҲָ" },
	{   16, "޷ɾĿ¼" },
	{   17, "ϵͳ޷ļƵϡ" },
	{   18, "ûļ" },
	{   19, "ýд" },
	{   20, "ϵͳҲָ豸" },
	{   21, "豸δ׼á" },
	{   22, "豸޷ʶ" },
	{   23, "ݴѭ飩" },
	{   24, "򷢳Ǹĳȴ" },
	{   25, "ڴ޷λָŵ" },
	{   26, "޷ָĴ̡̻" },
	{   27, "Ҳ" },
	{   28, "ӡȱֽ" },
	{   29, "ϵͳ޷дָ豸" },
	{   30, "ϵͳ޷ȡָ豸" },
	{   31, "ϵͳӵ豸ת" },
	{   32, "ʹøļ޷ʡ" },
	{   33, "һļĳһ֣޷ʡ" },
	{   34, "е̲ȷ" },
	{   36, "򿪹ļ̫ࡣ" },
	{   38, "ѵļβ" },
	{   39, "" },
	{   50, "ִ֧" },
	{   51, "Զ̼޷ʹá" },
	{   52, "д" },
	{   53, "Ҳ·" },
	{   54, "æ" },
	{   55, "ָԴ豸Ѳá" },
	{   56, "Ѿﵽļޡ" },
	{   57, "ִ" },
	{   58, "ָķ޷ִĲ" },
	{   59, "" },
	{   60, "Զݡ" },
	{   61, "ӡ" },
	{   62, "ûд洢ȴӡļĿռ䡣" },
	{   63, "ѾɾȺӡļ" },
	{   64, "ָ޷ʹá" },
	{   65, "ܾ硣" },
	{   66, "Դʹ" },
	{   67, "Ҳ" },
	{   68, "ѳؼƼޡ" },
	{   69, "ѳ BIOS Ựļޡ" },
	{   70, "Զ̷ѾͣС" },
	{   71, "ڸüĿѴﵽޣʱ޷ӵԶ̼" },
	{   72, "ָĴӡ豸Ѿͣ" },
	{   80, "ļڡ" },
	{   82, "޷Ŀ¼ļ" },
	{   83, "INT 24 ʧܡ" },
	{   84, "Ĵ洢á" },
	{   85, "ʹøñ豸" },
	{   86, "ָ벻ȷ" },
	{   87, "" },
	{   88, "д" },
	{   89, "ʱϵͳ޷̡" },
	{  100, "޷ϵͳ־" },
	{  101, "̵רñ־" },
	{  102, "־Ѿã޷رա" },
	{  103, "޷ٴøñ־" },
	{  104, "жʱ޷רñ־" },
	{  105, "˱־ǰȨֹ" },
	{  106, "뽫̲ %1" },
	{  107, "δ룬ֹͣ" },
	{  108, "ʹû" },
	{  109, "ܵѾ" },
	{  110, "ϵͳ޷ָ豸ļ" },
	{  111, "ļ̫" },
	{  112, "̿ռ䲻㡣" },
	{  113, "ûõڲļʶ" },
	{  114, "Ŀڲļʶȷ" },
	{  117, "Ӧóе IOCTL òȷ" },
	{  118, "УдĿزֵȷ" },
	{  119, "ϵͳ֧" },
	{  120, "ϵͳϲִ֧˹ܡ" },
	{  121, "ѳʱ" },
	{  123, "ļĿ¼﷨" },
	{  124, "ϵͳò㲻ȷ" },
	{  125, "ûоꡣ" },
	{  126, "Ҳָģ顣" },
	{  127, "ҲָĹ̡" },
	{  128, "ûҪȺӽ̡" },
	{  129, "ģʽС" },
	{  130, "ͼʹò(ԭʼI/O)Ѵ򿪴̷ļ" },
	{  131, "ͼļָļͷ֮ǰ" },
	{  132, "޷ָ豸ļļָ롣" },
	{  133, "ڰʹ JOIN  SUBST " },
	{  134, "ͼѾӵʹ JOIN  SUBST " },
	{  135, "ͼѾ滻ʹ JOIN  SUBST " },
	{  136, "ϵͳͼɾδӵ JOIN" },
	{  137, "ϵͳͼɾδ滻滻" },
	{  138, "ϵͳͼӵӵµĿ¼" },
	{  139, "ϵͳͼ滻滻µĿ¼" },
	{  140, "ϵͳͼӵ滻һĿ¼С" },
	{  141, "ϵͳͼ滻ɵӵµĿ¼" },
	{  142, "ʱϵͳ޷ JOIN  SUBST" },
	{  143, "ϵͳ޷ӵ滻ͬһµĿ¼" },
	{  144, "Ŀ¼ǸøĿ¼Ŀ¼" },
	{  145, "Ŀ¼δա" },
	{  146, "ָ·Ѿ滻ʹá" },
	{  147, "Դ㣬޷ִи" },
	{  148, "ʱ޷ʹָ·" },
	{  149, "ͼӻ滻ĳĿ¼ϵĳĿ¼һ滻ĿĿ¼" },
	{  150, "CONFIG.SYS ļδָϵͳϢֹ١" },
	{  151, "DosMuxSemWait ָź¼Ŀȷ" },
	{  152, "DosMuxSemWait ûУѾ̫ı־" },
	{  153, "DosMuxSemWait бȷ" },
	{  154, "ľ곬Ŀļϵͳıַȼޡ" },
	{  155, "޷̡߳" },
	{  156, "սܾ̾źš" },
	{  157, "Ѿ޷" },
	{  158, "Ѿ" },
	{  159, "̱߳ʶĵַ" },
	{  160, " DosExecPgm Ĳַ" },
	{  161, "ָ·Ч" },
	{  162, "źѹ" },
	{  164, "ϵͳ޷̡߳" },
	{  167, "޷ļķΧ" },
	{  170, "ҪԴʹС" },
	{  173, "ṩȡҪ" },
	{  174, "ļϵͳֵ֧͵Զġ" },
	{  180, "ϵͳ⵽롣" },
	{  182, "ϵͳ޷ %1" },
	{  183, "ܴѾڵļ" },
	{  186, "͵ı־ȷ" },
	{  187, "Ҳָϵͳźơ" },
	{  188, "ϵͳ޷ %1" },
	{  189, "ϵͳ޷ %1" },
	{  190, "ϵͳ޷ %1" },
	{  191, "޷ Win32 ģʽ %1" },
	{  192, "ϵͳ޷ %1" },
	{  193, "%1 Ч Win32 Ӧó" },
	{  194, "ϵͳ޷ %1" },
	{  195, "ϵͳ޷ %1" },
	{  196, "ϵͳ޷дӦó" },
	{  197, "ǰ޷òϵͳдӦó" },
	{  198, "ϵͳ޷ %1" },
	{  199, "ϵͳ޷дӦó" },
	{  200, "ӦС 64K" },
	{  201, "ϵͳ޷ %1" },
	{  202, "ϵͳ޷ %1" },
	{  203, "ϵͳҲĻѡ" },
	{  205, " еĽûźž" },
	{  206, "ļչ̫" },
	{  207, " 2 ջʹС" },
	{  208, "ȫļַ *  ? ȷָȫļַ̫ࡣ" },
	{  209, "͵źŲȷ" },
	{  210, "޷źŴ" },
	{  212, "޷·䡣" },
	{  214, "ӵ˳̬ģĶ̬ģ̫ࡣ" },
	{  215, "޷Ƕ׵ LoadModule" },
	{  216, "ͼļ %1 Чڱ͡" },
	{  230, "ܵ״̬Ч" },
	{  231, "еĹܵʵæ״̬" },
	{  232, "ܵڹرա" },
	{  233, "ڹܵһûн̡" },
	{  234, "иõݡ" },
	{  240, "ȡỰ" },
	{  254, "ָչЧ" },
	{  255, "չԲһ¡" },
	{  258, "ȴʱ" },
	{  259, "ûݡ" },
	{  266, "޷ʹøƹܡ" },
	{  267, "Ŀ¼Ч" },
	{  275, "չԲƥ仺" },
	{  276, "װصļϵͳϵչļѱ𻵡" },
	{  277, "չԱļ" },
	{  278, "ָչԾЧ" },
	{  282, "װļϵͳ֧չԡ" },
	{  288, "ͼͷŲڵߵĶ·ͬźš" },
	{  298, "źͶݵĴ̫ࡣ" },
	{  299, "ɲ ReadProcessMemory  WriteProcessMemory " },
	{  300, "󱻾ܾ" },
	{  301, "ϵͳһЧĲȷϡ" },
	{  317, " %2 ϢļУϵͳ޷ҵϢΪ 0x%1 Ϣı" },
	{  487, "ͼЧַ" },
	{  534, " 32 λ" },
	{  535, "ùܵһһ̡" },
	{  536, "Ⱥ̴򿪹ܵһˡ" },
	{  994, "ܾչԵķʡ" },
	{  995, "߳˳ӦóҪI/O 쳣ֹ" },
	{  996, "ص I/O ¼ѱ״̬" },
	{  997, "ڴص I/O " },
	{  998, "ڴλõЧʡ" },
	{  999, "ִҳڲ" },
	{ 1001, "ݹ̫ջ" },
	{ 1002, "޷Ϣ" },
	{ 1003, "޷ɴܡ" },
	{ 1004, "־Ч" },
	{ 1005, "ʶļϵͳȷҪļϵͳѾأҾûκ𻵡" },
	{ 1006, "ĳļľⲿı䣬򿪵ļЧ" },
	{ 1007, "ҪĲ޷ȫĻģʽִС" },
	{ 1008, "ͼòڵķš" },
	{ 1009, "עݿ𻵡" },
	{ 1010, "עЧ" },
	{ 1011, "޷ע" },
	{ 1012, "޷ȡע" },
	{ 1013, "޷дע" },
	{ 1014, "ʹ־ļָעݿеĳļָɹ" },
	{ 1015, "ע𻵡һעļĽṹ𻵣Ҳڴиļϵͳӳ𻵣Ϊݸ־ڣ𻵣޷ָļ" },
	{ 1016, "ע I/O ˲ɻָĴעܶȡдˢ°עϵͳӳһļ" },
	{ 1017, "ϵͳͼļػԭעУǣָļעļʽ" },
	{ 1018, "ͼעѾΪɾɵĲǷ" },
	{ 1019, "ϵͳ޷ע־ļзĿռ䡣" },
	{ 1020, "޷ѾӼֵעдӡ" },
	{ 1021, "ʧĸ²̶ܴӼ" },
	{ 1022, "֪ͨĸѾɣҷϢûб͵ߵĻСҪоļҵĶݡ" },
	{ 1051, "ѽֹͣƷ͸зصķ" },
	{ 1052, "ҪĿƶԴ˷Ч" },
	{ 1053, "ûмʱӦ" },
	{ 1054, "޷Ϊ÷񴴽̡߳" },
	{ 1055, "ݿ" },
	{ 1056, "÷ʵС" },
	{ 1057, "ʻЧ߲ڣָʻЧ" },
	{ 1058, "޷ΪãҲΪûйĿ豸" },
	{ 1059, "ѾָѭĴϵ" },
	{ 1060, "ָķװķ" },
	{ 1061, "÷ʱ޷տϢ" },
	{ 1062, "δ" },
	{ 1063, "޷ӵƳ" },
	{ 1064, "ʱ" },
	{ 1065, "ָݿⲻڡ" },
	{ 1066, "񷵻طضĴ롣" },
	{ 1067, "ֹ" },
	{ 1068, "޷顣" },
	{ 1069, "ڵ¼ʧܣû" },
	{ 1070, "󣬷񱣳״̬" },
	{ 1071, "ָķݿЧ" },
	{ 1072, "ָķѾΪɾ" },
	{ 1073, "ָķѾڡ" },
	{ 1074, "ϵͳǰһгɹС" },
	{ 1075, "񲻴ڣѾΪɾ" },
	{ 1076, "ѽʹõǰΪЧá" },
	{ 1077, "ԴһԺûٴ÷" },
	{ 1078, "Ѿʾ" },
	{ 1079, "˷ʻͬͬһϵʻ" },
	{ 1080, "ֻΪ Win32 ʧܲΪá" },
	{ 1081, "еĽ̺ͷƹͬԣֹĻƹ޷κβ" },
	{ 1082, "ûûָ" },
	{ 1083, "óڸÿִгеִи÷" },
	{ 1100, "ѾŴͷ" },
	{ 1101, "Ŵʵļǡ" },
	{ 1102, "Ŵײ" },
	{ 1103, "Ŵʵļĩβ" },
	{ 1104, "Ŵûݡ" },
	{ 1105, "Ŵ޷" },
	{ 1106, "ʶؾ´ŴʱǰСȷ" },
	{ 1107, "شŴʱҲŴϢ" },
	{ 1108, "޷ý˳ܡ" },
	{ 1109, "޷жý塣" },
	{ 1110, "еýѸġ" },
	{ 1111, "Ѿλ I/O ߡ" },
	{ 1112, "ûý塣" },
	{ 1113, "ĿֽڴҳвڶԵַӳ䡣" },
	{ 1114, "̬ӿ (DLL) ʼʧܡ" },
	{ 1115, "ڹرϵͳ" },
	{ 1116, "޷ֹϵͳػΪûнеĹػ" },
	{ 1117, " I/O 豸ִ޷и" },
	{ 1118, "豸ʼʧܡжش" },
	{ 1119, "޷豸ж (IRQ) 豸һʹø IRQ 豸Ѿ򿪡" },
	{ 1120, "ٴд봮пڣ I/O ѽ(IOCTL_SERIAL_XOFF_COUNTER Ϊ㡣)" },
	{ 1121, "ڳʱ I/O ѽ(IOCTL_SERIAL_XOFF_COUNTER δﵽ㡣)" },
	{ 1122, "Ҳʶַǡ" },
	{ 1123, "ʶֶ̿ŵַƥ䡣" },
	{ 1124, "̿ʶĴ" },
	{ 1125, "̿صĽעĲһ¡" },
	{ 1126, "ӲʱУ׼ʧܣһκҲ޷" },
	{ 1127, "Ӳʱ̲ʧܣһκûá" },
	{ 1128, "ӲʱҪ̿δɹ" },
	{ 1129, "ŴѾͷ" },
	{ 1130, "õķ洢㣬޷ִи" },
	{ 1131, "⵽Ǳڵ" },
	{ 1132, "ָĻַļƫûȷ롣" },
	{ 1140, "ͼϵͳԴ״̬ĲһӦóֹ" },
	{ 1141, "ϵͳ BIOS ޷ϵͳԴ״̬" },
	{ 1142, "ͼһļϴϵͳӡ" },
	{ 1150, "ָĳҪµ Windows 汾" },
	{ 1151, "ָĳ Windows  MS-DOS " },
	{ 1152, "޷ָĶʵ" },
	{ 1153, "ָĳΪ Windows ڰ汾дġ" },
	{ 1154, "дӦóĳļ" },
	{ 1155, "ûӦóòָļ" },
	{ 1156, "͵Ӧóʱִ" },
	{ 1157, "ҲдӦóĳļ" },
	{ 1158, "ǰʹ Window ϵͳо" },
	{ 1159, "Ϣֻͬһʹá" },
	{ 1160, "ָԴԪûý塣" },
	{ 1161, "ָĿԪѰý塣" },
	{ 1162, "ָԪزڡ" },
	{ 1163, "ָԪδʾĴ洢Դһ֡" },
	{ 1164, "ָ豸Ҫ³ʼΪӲд" },
	{ 1165, "豸ʾڳԽһ֮ǰҪ" },
	{ 1166, "豸ʾǴ״̬" },
	{ 1167, "豸ûӡ" },
	{ 1168, "ҲԪء" },
	{ 1169, "ûָͬƥ" },
	{ 1170, "ڶϲָԼ" },
	{ 1171, "ݵ GetMouseMovePoints ĵ㲻ڻС" },
	{ 1172, "(վ)ûС" },
	{ 1173, "Ҳ ID" },
	{ 1175, "޷ɾҪ滻ļ" },
	{ 1176, "޷滻ļƵҪ滻ļҪ滻ļԭơ" },
	{ 1177, "޷滻ļƵҪ滻ļҪ滻ļѱΪơ" },
	{ 1178, "ļ¼ɾ" },
	{ 1179, "ļ¼񲻴ڻС" },
	{ 1180, "ҵһļǿܲȷļ" },
	{ 1181, "־Ѵ־ɾ" },
	{ 1200, "ָ豸Ч" },
	{ 1201, "豸ǰȻδӣǼӡ" },
	{ 1202, "ͼѾס豸" },
	{ 1203, "繩Ӧ̲ܸ·" },
	{ 1204, "ָ繩ӦЧ" },
	{ 1205, "޷ļ" },
	{ 1206, "ļ𻵡" },
	{ 1207, "޷оٷǰࡣ" },
	{ 1208, "չ" },
	{ 1209, "ָĸʽЧ" },
	{ 1210, "ָĸʽЧ" },
	{ 1211, "ָ¼ĸʽЧ" },
	{ 1212, "ָĸʽЧ" },
	{ 1213, "ָĸʽЧ" },
	{ 1214, "ָĸʽЧ" },
	{ 1215, "ָĸʽЧ" },
	{ 1216, "ָĸʽЧ" },
	{ 1217, "ָʼЧ" },
	{ 1218, "ָʼĿĵصĸʽЧ" },
	{ 1219, "ṩƾƾóͻ" },
	{ 1220, "ͼỰĿǰ÷ĻỰ̫ࡣ" },
	{ 1221, "ϵѾʹøù" },
	{ 1222, "粻ڻû" },
	{ 1223, "ûѾȡò" },
	{ 1224, "ҪĲ޷ѾûӳļС" },
	{ 1225, "Զϵͳܾӡ" },
	{ 1226, "Ѿرӡ" },
	{ 1227, "紫յѾһַ" },
	{ 1228, "յδַ" },
	{ 1229, "ͼڲڵв" },
	{ 1230, "ͼڻϽЧ" },
	{ 1231, "ܷλáйѽϢ Windows " },
	{ 1232, "ܷλáйѽϢ Windows " },
	{ 1233, "ܷλáйѽϢ Windows " },
	{ 1234, "ԶϵͳĿ˵ûκη" },
	{ 1235, "Ѿֹ" },
	{ 1236, "ϵͳѾֹӡ" },
	{ 1237, "޷ɲһΡ" },
	{ 1238, "޷÷ӣΪѾ˸ʻͬʱӵĿ" },
	{ 1239, "ͼڸʻδȨʱڵ¼" },
	{ 1240, "δȨʻӸվ¼硣" },
	{ 1241, "ַ޷ҪĲ" },
	{ 1242, "Ѿעᡣ" },
	{ 1243, "ָķ񲻴ڡ" },
	{ 1244, "δ֤ûݣ޷ִҪĲ" },
	{ 1245, "ûδ¼磬޷ҪĲָķ񲻴ڡ" },
	{ 1246, "" },
	{ 1247, "ɳʼͼٴгʼ" },
	{ 1248, "û豸" },
	{ 1249, "ָվ㲻ڡ" },
	{ 1250, "ָƵѾڡ" },
	{ 1251, "ֻӵʱָ֧ò" },
	{ 1252, "ʹûиĶԿҲӦõչ" },
	{ 1253, "ָûûһЧļ" },
	{ 1254, "Microsoft Small Business Server ִ֧˲" },
	{ 1300, "Ƕеĵ÷Ȩ" },
	{ 1301, "ʻ밲ȫʶ֮ӳδɡ" },
	{ 1302, "ûΪʻȷϵͳơ" },
	{ 1303, "ûпõԿ֪Կ" },
	{ 1304, "̫ӣ޷ת LAN Manager 롣ص LAN Manager ǿַ" },
	{ 1305, "޶δ֪" },
	{ 1306, "ʾ޶𲻼ݡ" },
	{ 1307, "޷˰ȫʶָΪöӵߡ" },
	{ 1308, "޷˰ȫʶָΪҪĶ顣" },
	{ 1309, "ǰδģͻ߳ͼģơ" },
	{ 1310, "Խø顣" },
	{ 1311, "Ŀǰûпõĵ¼¼" },
	{ 1312, "ָĵ¼ỰڡûỰֹ" },
	{ 1313, "ָȨ޲ڡ" },
	{ 1314, "ͻȨޡ" },
	{ 1315, "ṩƲȷʻƸʽ" },
	{ 1316, "ָûѾڡ" },
	{ 1317, "ָûڡ" },
	{ 1318, "ָѾڡ" },
	{ 1319, "ָ鲻ڡ" },
	{ 1320, "ָûʻѾĳضĳԱҲָǿնܱɾ" },
	{ 1321, "ָûʻָʻĳԱ" },
	{ 1322, "ϴαĹʻ޷رջɾ" },
	{ 1323, "޷롣벻ȷ" },
	{ 1324, "޷룬ṩֵ" },
	{ 1325, "޷롣ΪṩֵַĳȡԻʷҪ" },
	{ 1326, "¼ʧ: ûδ֪" },
	{ 1327, "¼ʧ: ûʻơ" },
	{ 1328, "¼ʧ: Υʻ¼ʱơ" },
	{ 1329, "¼ʧ: ֹû¼üϡ" },
	{ 1330, "¼ʧ: ָʻѹڡ" },
	{ 1331, "¼ʧ: ǰʻ" },
	{ 1332, "δʻ밲ȫԱʶ֮ӳ䡣" },
	{ 1333, "һıûʶ(LUID)̫ࡣ" },
	{ 1334, "ûõıûʶ(LUID)" },
	{ 1335, "ضʹ˵ȫʶӲЧġ" },
	{ 1336, "ʿ嵥(ACL)ṹЧ" },
	{ 1337, "ȫʶṹЧ" },
	{ 1338, "ȫṹЧ" },
	{ 1340, "޷̳еķʿб(ACL)ʿĿ(ACE)" },
	{ 1341, "ǰѽ÷" },
	{ 1342, "ǰ÷" },
	{ 1343, "ṩֵЧıʶȨֵ" },
	{ 1344, "ûиڴڸ°ȫϢ" },
	{ 1345, "ָЧָԲݡ" },
	{ 1346, "ûṩģ¼𣬻ṩģ¼Ч" },
	{ 1347, "޷ȫԷš" },
	{ 1348, "֤ϢЧ" },
	{ 1349, "ŲԵķʽʹá" },
	{ 1350, "޷ûذȫԵĶаȫ" },
	{ 1351, "δܴȡϢΪʹãǷʱܾ" },
	{ 1352, "ȫʻ(SAM)򱾵ذȫ䷢(LSA)״̬ȷ޷аȫ" },
	{ 1353, "ִаȫĴ״̬" },
	{ 1354, "òִֻС" },
	{ 1355, "ָ򲻴ڻϵϡ" },
	{ 1356, "ָѾڡ" },
	{ 1357, "ͼÿĿļޡ" },
	{ 1358, "صý̵ݽṹ𻵣޷Ĳ" },
	{ 1359, "ڲ" },
	{ 1360, "ͨõķͰڷУѾӳΪͨ͡" },
	{ 1361, "ȫĸʽ󣨾Իأ" },
	{ 1362, "Ĳֻ׼¼ʹáõù̲δ¼Ϊ¼̡" },
	{ 1363, "޷Ѿʹõıʶµĵ¼Ự" },
	{ 1364, "ָȷݰδ֪" },
	{ 1365, "¼Ự״̬Ĳһ¡" },
	{ 1366, "¼ỰʶʹС" },
	{ 1367, "¼Чĵ¼ֵ" },
	{ 1368, "ʹܵȡ֮ǰ޷ɸùܵģ⡣" },
	{ 1369, "ע״̬Ĳݡ" },
	{ 1370, "ͻڲȫݿϡ" },
	{ 1371, "޷ڲʻиò" },
	{ 1372, "޷ڸڲضиò" },
	{ 1373, "޷ڸڲضûиò" },
	{ 1374, "Ϊ鵱ǰûҪ飬ԲܴӴɾû" },
	{ 1375, "÷ΪҪʹá" },
	{ 1376, "ָı鲻ڡ" },
	{ 1377, "ָʻǱĳԱ" },
	{ 1378, "ָʻѾǱĳԱ" },
	{ 1379, "ָıѾڡ" },
	{ 1380, "¼ʧ: ûڱûбע͡" },
	{ 1381, "˿Դ洢ڵϵͳеơ" },
	{ 1382, "ܵĳȳֵ" },
	{ 1383, "ذȫȨݿڲһµĴ" },
	{ 1384, "¼ʱûİȫۻ̫İȫʶ" },
	{ 1385, "¼ʧ: ûڱûбע͡" },
	{ 1386, "ܵû롣" },
	{ 1387, "Աڣ޷ӵɾ" },
	{ 1388, "³Աʻ޷ӵ顣" },
	{ 1389, "ָİȫʶ̫ࡣ" },
	{ 1390, "ܵĸû롣" },
	{ 1391, "ʾ ACL ûпɼ̳е" },
	{ 1392, "ļĿ¼𻵣޷ȡݡ" },
	{ 1393, "̽ṹ𻵣޷ȡݡ" },
	{ 1394, "ָĵ¼ỰûûỰԿ" },
	{ 1395, "ڷʵķضĿӡΪӵĿѴﵽɽܵĿԴʱ޷µķӡ" },
	{ 1396, "¼ʧ: ĿʻƲȷ" },
	{ 1397, "໥֤ʧܡ÷ڡ" },
	{ 1398, "ڿͻͷ֮һʱ" },
	{ 1400, "ھЧ" },
	{ 1401, "˵Ч" },
	{ 1402, "Ч" },
	{ 1403, "ټľЧ" },
	{ 1404, "ҽӾЧ" },
	{ 1405, "شλýṹЧ" },
	{ 1406, "޷ϲӴڡ" },
	{ 1407, "Ҳࡣ" },
	{ 1408, "Ч̡߳" },
	{ 1409, "Ѿעȼ" },
	{ 1410, "Ѿڡ" },
	{ 1411, "಻ڡ" },
	{ 1412, "രԴš" },
	{ 1413, "Ч" },
	{ 1414, "ͼЧ" },
	{ 1415, "ʹ˽˶Ի򴰿֡" },
	{ 1416, "Ҳбʶ" },
	{ 1417, "Ҳκͨ" },
	{ 1418, "߳ûд򿪼塣" },
	{ 1419, "δעȼ" },
	{ 1420, "ôڲЧĶԻ򴰿ڡ" },
	{ 1421, "ҲƱʶ" },
	{ 1422, "ûб༭ƣ˸ϿϢЧ" },
	{ 1423, "ڲϿ" },
	{ 1424, "߶ȱС 256" },
	{ 1425, "豸(DC)Ч" },
	{ 1426, "ҽӹЧ" },
	{ 1427, "ҽӹЧ" },
	{ 1428, "ģ÷ǱصĹҽӡ" },
	{ 1429, "ֻȫøùҽӹ̡" },
	{ 1430, "Ѱװռǹҽӹ̡" },
	{ 1431, "δװҽӹ̡" },
	{ 1432, "ѡбϢЧ" },
	{ 1433, "LB_SETCOUNT ͵б" },
	{ 1434, "б֧Ʊ" },
	{ 1435, "޷ƻ߳Ķ" },
	{ 1436, "Ӵڲв˵" },
	{ 1437, "ûϵͳ˵" },
	{ 1438, "ϢʽЧ" },
	{ 1439, "ϵͳΧڵ(SPI_*)ĲЧ" },
	{ 1440, "ĻѾ" },
	{ 1441, "شλýṹдھͬĸڡ" },
	{ 1442, "ڲӴڡ" },
	{ 1443, "GW_* Ч" },
	{ 1444, "̱߳ʶЧ" },
	{ 1445, "޷Ƕĵӿ(MDI)ڵϢ" },
	{ 1446, "ʽ˵Ѽ" },
	{ 1447, "ûй" },
	{ 1448, "Χܴ MAXLONG" },
	{ 1449, "޷ָķʽʾرմڡ" },
	{ 1450, "ϵͳԴ㣬޷ķ" },
	{ 1451, "ϵͳԴ㣬޷ķ" },
	{ 1452, "ϵͳԴ㣬޷ķ" },
	{ 1453, "㣬޷ķ" },
	{ 1454, "㣬޷ķ" },
	{ 1455, "ҳ潻ļ̫С޷ɴ" },
	{ 1456, "Ҳ˵" },
	{ 1457, "̲־Ч" },
	{ 1458, "ʹùҹ͡" },
	{ 1459, "òҪʽڹվ" },
	{ 1460, "ڳʱʱѹòء" },
	{ 1461, "Ч" },
	{ 1500, "¼־ļ𻵡" },
	{ 1501, "޷¼־ļ޷¼¼" },
	{ 1502, "¼־ļ" },
	{ 1503, "¼־ļζȡѷ仯" },
	{ 1601, "޷ Windows װ뼼֧Աϵȷ Windows װǷעȷ" },
	{ 1602, "ûȡ˰װ" },
	{ 1603, "װʱش" },
	{ 1604, "װѹδɡ" },
	{ 1605, "ֻԵǰװĲƷЧ" },
	{ 1606, " ID δעᡣ" },
	{ 1607, " ID δעᡣ" },
	{ 1608, "δ֪ԡ" },
	{ 1609, "ڲȷ״̬" },
	{ 1610, "Ʒ𻵣뼼֧Աϵ" },
	{ 1611, "ﲻڡ" },
	{ 1612, "ƷİװԴ޷ʹá֤ԴǷڣǷԷʡ" },
	{ 1613, "Windows װ޷װװ밲װ Windows װ°汾 Windows Service Park" },
	{ 1614, "Ʒжء" },
	{ 1615, "SQL ѯ﷨ȷ򲻱֧֡" },
	{ 1616, "¼ַ򲻴ڡ" },
	{ 1617, "豸ѱɾ" },
	{ 1618, "ڽһװڼװ֮ǰǸ" },
	{ 1619, "δܴװ֤ǷڣǷԷʣӦóӦϵ֤ǷЧ Windows װ" },
	{ 1620, "δܴװӦóӦϵ֤ǷЧ Windows װ" },
	{ 1621, " Windows װûʱд뼼֧Աϵ" },
	{ 1622, "򿪰װ־ļʱָ֤־ļλǷڣǷд롣" },
	{ 1623, "װԲϵͳ֧֡" },
	{ 1624, "Ӧñ任ʱָ֤ı任·ǷЧ" },
	{ 1625, "ϵͳԽֹװϵͳԱϵ" },
	{ 1626, "޷ִк" },
	{ 1627, "ִڼ䣬⡣" },
	{ 1628, "ָЧĻδ֪ı" },
	{ 1629, "ṩͲԡ" },
	{ 1630, "͵ݲ֧֡" },
	{ 1631, "Windows װδ뼼֧Աϵ" },
	{ 1632, "ʱļ޷ʹá֤ʱļǷڣǷд롣" },
	{ 1633, "Ͳָ֧ðװƷӦϵ" },
	{ 1634, "ų̂ʹá" },
	{ 1635, "޷޲֤޲ǷڣǷԷʣӦóӦϵ֤ǷЧ Windows װ޲" },
	{ 1636, "޷޲ӦóӦϵ֤ǷЧ Windows װ޲" },
	{ 1637, "Windows װ޷޲밲װ Windows װ°汾 Windows Service Pack" },
	{ 1638, "ѰװƷһ汾汾İװ޷ҪûɾƷа汾á塱ϵġ/ɾ򡱡" },
	{ 1639, "Чвйϸа Windows װ SDK" },
	{ 1640, "ն˷Զ̻Ựڼ䣬ֻйԱӡɾ÷ȨޡҪڷϰװԱϵ" },
	{ 1641, "ҪĲѳɹҪʹĶЧϵͳ" },
	{ 1642, "Windows װ޷װ޲Ϊĳʧ޲򽫸´˳汾ȷҪĳļ޲ȷġ" },
	{ 1700, "Ч" },
	{ 1701, "󶨾ʹ" },
	{ 1702, "󶨾Ч" },
	{ 1703, "֧ RPC Э˳" },
	{ 1704, "RPC ЭЧ" },
	{ 1705, "ַȫΨһʶ(UUID)Ч" },
	{ 1706, "յĸʽЧ" },
	{ 1707, "ַЧ" },
	{ 1708, "δҵյ㡣" },
	{ 1709, "ʱֵЧ" },
	{ 1710, "ҲöȫΨһʶ(UUID)" },
	{ 1711, "öȫΨһʶ(UUID)Ѿעᡣ" },
	{ 1712, "һ͵ȫΨһʶ(UUID)Ѿעᡣ" },
	{ 1713, "RPC ڼ" },
	{ 1714, "δעЭ˳" },
	{ 1715, "RPC ڼ״̬" },
	{ 1716, "δ֪" },
	{ 1717, "ӿδ֪" },
	{ 1718, "ûа󶨡" },
	{ 1719, "ûЭС" },
	{ 1720, "޷յ㡣" },
	{ 1721, "Դ㣬޷ɸò" },
	{ 1722, "RPC ޷ʹá" },
	{ 1723, "RPC ̫æ޷ɴ" },
	{ 1724, "ѡЧ" },
	{ 1725, "߳вڻԶ̵̹á" },
	{ 1726, "Զ̵̹ʧܡ" },
	{ 1727, "Զ̵̹ʧܲ޷ִС" },
	{ 1728, "Զ̵̹(RPC)Эִ" },
	{ 1730, "RPC ִ֧﷨" },
	{ 1732, "֧͵ȫΨһʶ" },
	{ 1733, "ʶЧ" },
	{ 1734, "߽Ч" },
	{ 1735, "вĿ" },
	{ 1736, "﷨Ч" },
	{ 1737, "֧﷨" },
	{ 1739, "ûпõַ޷ȫΨһʶ(UUID)" },
	{ 1740, "սظ" },
	{ 1741, "֤δ֪" },
	{ 1742, "ô̫С" },
	{ 1743, "ַ̫" },
	{ 1744, "Ҳ RPC ЭС" },
	{ 1745, "̺ųΧ" },
	{ 1746, "˴ΰ󶨲κ֤Ϣ" },
	{ 1747, "֤δ֪" },
	{ 1748, "֤δ֪" },
	{ 1749, "ȫЧ" },
	{ 1750, "֤δ֪" },
	{ 1751, "ĿЧ" },
	{ 1752, "ս޷ִд" },
	{ 1753, "յӳûиյá" },
	{ 1754, "ûеκνӿڡ" },
	{ 1755, "Ŀ" },
	{ 1756, "汾ѡЧ" },
	{ 1757, "ûԱ" },
	{ 1758, "Եȫݡ" },
	{ 1759, "δҵӿڡ" },
	{ 1760, "ĿѾڡ" },
	{ 1761, "ĿҲ" },
	{ 1762, "Ʒ񲻿á" },
	{ 1763, "ַЧ" },
	{ 1764, "֧Ĳ" },
	{ 1765, "ûпɹðµİȫ" },
	{ 1766, "Զ̵̹(RPC)ڲ" },
	{ 1767, "RPC ͼ㡣" },
	{ 1768, "RPC Ѱַ" },
	{ 1769, "RPC еĸɱ" },
	{ 1770, "RPC ˸" },
	{ 1771, "RPC ˸" },
	{ 1772, "Զ󶨵 RPC бѾꡣ" },
	{ 1773, "޷ַתļ" },
	{ 1774, "ַתļС 512 ֽڡ" },
	{ 1775, "Զ̵̹Уͻһյ" },
	{ 1777, "Զ̵̹е仯" },
	{ 1778, "͵Զ̵̹õİ󶨾ƥ䡣" },
	{ 1779, "ռλ޷Զ̵̹õľ" },
	{ 1780, "յĲοָ뷢͸ռλ" },
	{ 1781, "оֵΧ" },
	{ 1782, "ֽĿ̫С" },
	{ 1783, "ռλյݡ" },
	{ 1784, "ṩûĲЧ" },
	{ 1785, "޷ʶý塣ܻδʽ" },
	{ 1786, "վû롣" },
	{ 1787, "ϵİȫݿûиùվιϵļʻ" },
	{ 1788, "ιϵʧܡ" },
	{ 1789, "վιϵʧܡ" },
	{ 1790, "¼ʧܡ" },
	{ 1791, "ִ߳йѾԶ̵̹á" },
	{ 1792, "ͼ¼磬¼δ" },
	{ 1793, "ûʻѵڡ" },
	{ 1794, "ضʹã޷жء" },
	{ 1795, "ѾװָĴӡ" },
	{ 1796, "ָĶ˿δ֪" },
	{ 1797, "ӡδ֪" },
	{ 1798, "ӡδ֪" },
	{ 1799, "ָķָļЧ" },
	{ 1800, "ָȼЧ" },
	{ 1801, "ӡЧ" },
	{ 1802, "ӡѾڡ" },
	{ 1803, "ӡЧ" },
	{ 1804, "ָЧ" },
	{ 1805, "ָĻЧ" },
	{ 1806, "û󶨡" },
	{ 1807, "ʹõʻǿʻʹȫûʻ򱾵ûʻʴ˷" },
	{ 1808, "ʹõʻǼʻʹȫûʻ򱾵ûʻʸ÷" },
	{ 1809, "ʹõʻǷʻʹȫûʻ򱾵ûʻʸ÷" },
	{ 1810, "ָȫʶϢһ¡" },
	{ 1811, "ʹУ޷жء" },
	{ 1812, "ָӳļԴ֡" },
	{ 1813, "ӳļҲָԴ͡" },
	{ 1814, "ӳļҲָԴơ" },
	{ 1815, "ӳļҲָԴ ID " },
	{ 1816, "õ㣬޷ִи" },
	{ 1817, "ûעĽӿڡ" },
	{ 1818, "Զ̵̹ñȡ" },
	{ 1819, "󶨾ҪϢ" },
	{ 1820, "Զ̵ùзͨѶʧܡ" },
	{ 1821, "֤𲻱֧֡" },
	{ 1822, "Ҫûעᡣ" },
	{ 1823, "ָĴЧ Windows RPC 롣" },
	{ 1824, "ѷڱЧ UUID" },
	{ 1825, "ضİȫ" },
	{ 1826, "ûȡ̡߳" },
	{ 1827, "ڱ/봦ʱĲЧ" },
	{ 1828, "лİ汾ݡ" },
	{ 1829, "RPC ռλİ汾ݡ" },
	{ 1830, "RPC ܵЧ𻵡" },
	{ 1831, "ͼ RPC ܵϽЧ" },
	{ 1832, "ֵ֧ RPC ܵ汾" },
	{ 1898, "ҲԱ" },
	{ 1899, "޷սӳݿĿ" },
	{ 1900, "ȫʶ(UUID)Ϊա" },
	{ 1901, "ָʱЧ" },
	{ 1902, "ָıЧ" },
	{ 1903, "ָıСЧ" },
	{ 1904, "ָĴӡڵȺ" },
	{ 1905, "ָĴӡѾɾ" },
	{ 1906, "ӡ״̬Ч" },
	{ 1907, "û״ε¼ǰȸ롣" },
	{ 1908, "Ҳ" },
	{ 1909, "õʻĿǰ޷¼" },
	{ 1910, "ûзָĴ˶󵼳ߡ" },
	{ 1911, "ûзָĶ" },
	{ 1912, "ûзָĶ" },
	{ 1913, "һЩͣ󻺳ڡ" },
	{ 1914, "Ч첽Զ̵̹þ" },
	{ 1915, "첽 RPC þȷ" },
	{ 1916, "RPC ܵѾرա" },
	{ 1917, "RPC ȫĹ֮ܵǰɡ" },
	{ 1918, "ûõ RPC ܵ" },
	{ 1919, "ûпõվ" },
	{ 1920, "ϵͳ޷ʴļ" },
	{ 1921, "ϵͳ޷ļ" },
	{ 1922, "ĿҪ͡" },
	{ 1923, "޷ж UUID ָ" },
	{ 1924, "޷ӿڵָ" },
	{ 1925, "޷ָļ" },
	{ 1926, "޷ָļԪء" },
	{ 1927, "޷ɾָļԪء" },
	{ 1928, "޷Ԫء" },
	{ 1929, "޷ɾԪء" },
	{ 2000, "ظʽЧ" },
	{ 2001, "ָЧ" },
	{ 2002, "òĴʽЧ" },
	{ 2003, "֧ͼԪļ" },
	{ 2004, "֧ת" },
	{ 2005, "֧ļ" },
	{ 2010, "ָɫģЧ" },
	{ 2011, "ָɫļЧ" },
	{ 2012, "Ҳָıʶ" },
	{ 2013, "ıʶڡ" },
	{ 2014, "ָıʶѾڡ" },
	{ 2015, "ָɫļκ豸ء" },
	{ 2016, "Ҳָɫļá" },
	{ 2017, "ָɫռЧ" },
	{ 2018, "ͼɫûá" },
	{ 2019, "ɾɫתʱһ" },
	{ 2020, "ָɫתЧ" },
	{ 2021, "ָתλͼɫռ䲻ƥ䡣" },
	{ 2022, "ָɫļвڡ" },
	{ 2108, "ѳɹҪʾûһͬԭʼָ롣" },
	{ 2202, "ָûЧ" },
	{ 2250, "Ӳڡ" },
	{ 2401, "Ѵڴ򿪵ļδ" },
	{ 2402, "Ȼڡ" },
	{ 2404, "豸ɻʹã޷Ͽӡ" },
	{ 3000, "ָĴӡӳδ֪" },
	{ 3001, "ָĴӡʹС" },
	{ 3002, "Ҳѻļ" },
	{ 3003, "ûз StartDocPrinter á" },
	{ 3004, "δ AddJob á" },
	{ 3005, "ָĴӡѾװ" },
	{ 3006, "ָĴӡӳѾװ" },
	{ 3007, "ָĴӡ߱ҪĹܡ" },
	{ 3008, "ָĴӡʹС" },
	{ 3009, "ӡҵųɶʱ˲ǲġ" },
	{ 3010, "ĲɹֻϵͳĲŻЧ" },
	{ 3011, "Ĳɹֻ񣬸ĲŻЧ" },
	{ 3012, "Ҳӡ" },
	{ 4000, "WINS ڴʱִд" },
	{ 4001, "޷ɾص WINS" },
	{ 4002, "ļʧܡ" },
	{ 4003, "ʧܡǰִйı?" },
	{ 4004, "ʧܡ鱸ݿĿĿ¼" },
	{ 4005, " WINS ݿвڡ" },
	{ 4006, "δòֵĸơ" },
	{ 4100, "DHCP ͻһѱʹõ IP ֱַ DHCP ͻԻµĵַǰؽӿڽá" },
	{ 4200, "WMI ṩʶ GUID ǷЧ" },
	{ 4201, "WMI ṩ޷ʶʵǷЧ" },
	{ 4202, "WMI ṩ޷ʶĿʶǷЧ" },
	{ 4203, "޷ WMI һΡ" },
	{ 4204, "Ҳ WMI ṩ" },
	{ 4205, "WMI ṩõһδעʵ顣" },
	{ 4206, "WMI ݿ¼֪ͨá" },
	{ 4207, "WMI ݿ鲻ٿá" },
	{ 4208, "WMI ݷ޷ʹá" },
	{ 4209, "WMI ṩ޷" },
	{ 4210, "WMI MOF ϢЧ" },
	{ 4211, "WMI עϢЧ" },
	{ 4212, "WMI ݿ¼֪ͨѽá" },
	{ 4213, "WMI ĿݿΪֻ" },
	{ 4214, "WMI Ŀݿ鲻ܸġ" },
	{ 6118, "ùķбǰá" },
	{ 6200, "ҪУƻñϵͳʻСԱóʻС" },
	{ 7001, "ָĻỰЧ" },
	{ 7002, "ָЭЧ" },
	{ 7003, "ϵͳ·ҲָЭ" },
	{ 7004, "ϵͳ·Ҳָն" },
	{ 7005, "ΪỰһ¼־ע" },
	{ 7006, "ͬһѾϵͳдڡ" },
	{ 7007, "ڻỰһرղ" },
	{ 7008, "ûпõ" },
	{ 7009, "Ҳ MODEM.INF ļ" },
	{ 7010, " MODEM.INF ûҵƽơ" },
	{ 7011, "ƽûнܷ͸ָ֤õĵƽӵĵƽǷƥ䡣 7012 ƽûӦ͸ָ֤õƽǷȷҴ˵Դء" },
	{ 7013, "ڶϿӣزʧܻزֹͣ" },
	{ 7014, "Ҫʱûзֲȷ绰ȷʹá" },
	{ 7015, "Զվؽʱ⵽ռźš" },
	{ 7016, "ڻؽʱԶվϼ⵽" },
	{ 7017, "" },
	{ 7022, "ҲָĻỰ" },
	{ 7023, "ָĻỰѴʹС" },
	{ 7024, "նĿǰæڴһӡϿӡλɾ޷ɸĲ" },
	{ 7025, "ͼӵƵģʽܵǰͻֵ֧ĻỰ" },
	{ 7035, "Ӧó DOS ͼģʽ֧ DOS ͼģʽ" },
	{ 7037, "Ľʽ¼ȨѱáĹԱϵ" },
	{ 7038, "Ĳֻϵͳִ̨Сͨһϵͳ DLL Ҫֱӿ̨ʵĽ" },
	{ 7040, "ͻδܶԷϢӦ" },
	{ 7041, "ֶ֧Ͽ̨Ự" },
	{ 7042, "֧½һϿĻỰӵ̨" },
	{ 7044, "Զ̿һỰ󱻾ܾ" },
	{ 7045, "ܾĻỰʡ" },
	{ 7049, "ָնЧ" },
	{ 7050, "Զ̿ĻỰҲڸûỰжϻĿǰûһû¼⣬ܴӸϵͳ̨Զ̿һỰԶ̿ϵͳ̨ңԶ̿ԼĵǰỰ" },
	{ 7051, "ĻỰûóԶ̿ơ" },
	{ 7052, "ӵն˷뱻ܾն˷ͻ֤ĿǰڱһûʹáϵͳԱϵȡһµն˷ͻ֤ЧġΨһġ" },
	{ 7053, "ӵն˷뱻ܾûΪն˷ͻն˷ͻ֤롣ϵͳԱϵΪն˷ͻһЧġΨһ֤롣" },
	{ 7054, "ϵͳѴﵽȨĵ¼ơԺһΡ" },
	{ 7055, "ʹõĿͻûʹøϵͳȨĵ¼󱻾ܾ" },
	{ 7056, "ϵͳ֤ѹڡĵ¼󱻾ܾ" },
#else
	{ 1, "" }, // EPERM	Operation not permitted
	{ 2, "޴ļĿ¼" }, // ENOENT	No such file or directory
	{ 3, "޴˹" }, // ESRCH	No such process
	{ 4, "ϵͳñֹ" }, // EINTR	Interrupted system call
	{ 5, "I/O " }, // EIO	I/O error
	{ 6, "޴ַ" }, // ENXIO	No such device or address
	{ 7, "Arg б̫" }, // E2BIG	Arg list too long
	{ 8, "Exec ʽ" }, // ENOEXEC	Exec format error
	{ 9, "ļЧ" }, // EBADF	Bad file number
	{ 10, "ӹ" }, // ECHILD	No child processes
	{ 11, "һ" }, // EAGAIN	Try again
	{ 12, "ڴ治" }, // ENOMEM	Out of memory
	{ 13, "ɾܾ" }, // EACCES	Permission denied
	{ 14, "ڴַ" }, // EFAULT	Bad address
	{ 15, "Ҫ豸" }, // ENOTBLK	Block device required
	{ 16, "豸Դæ" }, // EBUSY	Device or resource busy
	{ 17, "ļ" }, // EEXIST	File exists
	{ 18, "" }, // EXDEV	Cross-device link
	{ 19, "޴豸" }, // ENODEV	No such device
	{ 20, "һĿ¼" }, // ENOTDIR	Not a directory "·ĲĿ¼"
	{ 21, "һĿ¼" }, // EISDIR	Is a directory
	{ 22, "ЧĺԱ" }, // EINVAL	Invalid argument
	{ 23, "ļ" }, // ENFILE	File table overflow
	{ 24, "򿪵ļ̫" }, // EMFILE	Too many open files
	{ 25, "" }, // ENOTTY	Inappropriate ioctl for device
	{ 26, "ıļæ" }, // ETXTBSY	Text file busy
	{ 27, "ļ̫" }, // EFBIG	File too large
	{ 28, "̿ռ䲻" }, // ENOSPC	No space left on device
	{ 29, "ϷѰ" }, // ESPIPE	Illegal seek
	{ 30, "ֻļϵͳ" }, // EROFS	Read-only file system
	{ 31, "̫" }, // EMLINK	Too many links
	{ ELOOP, "򿪵ļй⣬Ϊ16" }, // 
	{ ENAMETOOLONG, "file_name·̫" }, // 
#endif
};

const char* GetErrText( long nErrCode )
{ 
	int nMax = sizeof( ErrTextList ) / sizeof( struct error_text ) - 1;
	int nMin = 0;
	int nMid = 0;
	do
	{
		nMid = nMin + ( nMax - nMin ) / 2;
		if ( ErrTextList[ nMid ].nErrCode == nErrCode ) 
		{
			return ErrTextList[ nMid ].sErrText;
		}
		else if ( ErrTextList[ nMid ].nErrCode < nErrCode )
		{
			nMin = nMid + 1;
		}
		else //if ( ErrTextList[ nMid ].nErrCode > nErrCode )
		{
			nMax = nMid - 1;
		}
	} while ( nMin < nMax );

	return strerror( nErrCode );
}
