/************
 UAP 
 ************/
#ifndef _UAP_FDECL_H
#define _UAP_FDECL_H

#include "uap_stru.h"
#include "uap_api.h"

/****************
 Χϵͳ־
 ****************/
void u_set_outsys(int nOut);

/***************************************
 ڴ桢źŵ
 ڲkey_t        --  KEY ֵ
           const char * --  ļ
           int          --  ڴ泤
 ֵ  -1ʧ  0ɹ
 ***************************************/
int u_init_ipc(key_t aKey, const char *pFile, int aLen);

/******************************
 ڴ桢źŵ
 ֵ  -1ʧ  0ɹ
 ******************************/
int u_clean_ipc(void);

/************************************
 װظϢ
 ڲconst char *   -- ļ
           UAP_CUTOVER *  -- 
           int *          -- ¼Ŀ
 ֵ  -1ʧ  0ɹ  1
 ************************************/
int u_load_cutover(const char *pFile, UAP_CUTOVER *pCut, int *nRows);

/**************************************
 ٽˢ
 ڲint io    --  1=  0=뿪
 ֵ  -1ʧ  0ɹ
 **************************************/
int u_Xzone_write(int io);

/****************************************
 ٽ
 ڲint io    --  1=  0=뿪
 ֵ  -1ʧ  0ɹ
 ****************************************/
int u_Xzone_read(int io);

/***********************************
 ˢָ
 ڲconst char * --  ļ
           int          --  
 ֵ  -1ʧ  0ɹ
 ***********************************/
int u_refresh_zone(const char *pFile, int aZone);

/************************************
 鿴ָ
 ڲint           --  
           const char *  --  ޶ID
 ֵ  -1ʧ  0ɹ
 ************************************/
int u_show_zone(int aZone, const char *pID);

/******************
 ¼ ORACLE ݿ
 ******************/
int u_conndb(const char *pTns, int nEncry, int *nCode);

/**********************************
 ˢ½ӵ㼰֤Ϣ
 ڲUAP_NODE * -- ڴַ
           int *      -- 
           int *      -- ¼Ŀ
 ֵ  -1ʧ  0ɹ  1
 **********************************/
int u_load_node(UAP_NODE *pNode, int *nCode, int *nRows);

/**********************************
 ˢЭϢ
 ڲUAP_PROT *   -- ڴַ
           const char * -- Эб
           int *        -- 
           int *        -- ¼Ŀ
 ֵ  -1ʧ  0ɹ  1
 **********************************/
int u_load_prot(UAP_PROT *pProt, const char *pProList, int *nCode, int *nRows);

/**********************************
 ˢIPϢ
 ڲUAP_IPAUTH * -- ڴַ
           int *        -- 
           int *        -- ¼Ŀ
 ֵ  -1ʧ  0ɹ  1
 **********************************/
int u_load_IP(UAP_IPAUTH *pIP, int *nCode, int *nRows);

/*************************************
 ˢûϢ
 ڲUAP_IUSERAUTH * -- ڴַ
           int *        -- 
           int *        -- ¼Ŀ
 ֵ  -1ʧ  0ɹ  1
 *************************************/
int u_load_user(UAP_USERAUTH *pUser, int *nCode, int *nRows);

/**********************************
 ˢҵϢ
 ڲUAP_BUSI *   -- ڴַ
           const char * -- Эб
           int *        -- 
           int *        -- ¼Ŀ
 ֵ  -1ʧ  0ɹ  1
 **********************************/
int u_load_busi(UAP_BUSI *pBusi, const char *pProList, int *nCode, int *nRows);

/**********************************
 ˢ½űϢ
 ڲUAP_FLOW *  --  ڴַ
           char *      --  ű
           int *       --  
           int *       --  ¼Ŀ
           int *       --  ۼƳ
 ֵ  -1ʧ  0ɹ  1
 **********************************/
int u_load_flow(UAP_FLOW *pFlow, char *pBuf, int *nCode, int *nRows, int *nTotalLen);

/**********************************
 ˢºŶϢ
 ڲUAP_H3 *  --  ڴַ
           int *     --  
           int *     --  ¼Ŀ
 ֵ  -1ʧ  0ɹ  1
 **********************************/
int u_load_h3(UAP_H3 *pH3, int *nCode, int *nRows);

/**********************************
 ˢ·Ϣ
 ڲUAP_RCODE * --  ڴַ
           int *       --  
           int *       --  ¼Ŀ
           int *       --  ¼Ŀ
           int *       --  ¼Ŀ
 ֵ  -1ʧ  0ɹ  1
 **********************************/
int u_load_rcode(UAP_RCODE *pRCode, int *nCode, int *nRows, int *nRows1, int *nRows2);

/**********************************
 ˢ²ƷӳϢ
 ڲUAP_PMAP *  --  ڴַ
           int *       --  
           int *       --  ¼Ŀ
           int *       --  ¼Ŀ
           int *       --  ¼Ŀ
 ֵ  -1ʧ  0ɹ  1
 **********************************/
int u_load_pmap(UAP_PMAP *pPMap, int *nCode, int *nRows);

/******************
 Ͽݿ
 ******************/
int u_disconnect_db(void);

/**************************************
 TLV
 ڲchar **      -- Ŀָ
           const char * -- Value
           const char * -- Tag
 ֵ  -1ʧ  >=0ݳ
 **************************************/
int u_packTLV(char **pBody, const char *pValue, const char *pTag);

#endif

