/****************************
 ѭCICS
 ****************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <errno.h>
#include <unistd.h>
#include <sys/msg.h>
#include "gcps.h"
#include "z.h"
#include "mvdef.h"
#include "mo15.h"

/* ţ1 λַñ */
void SendUdpLog(char *ip,int port);

// תһ
static int Fw1(const char *pTel, const char *pMsg, char *pErr, char *pErrDesc);

// 
static int FwActiveTest(void);

static    int      bTimeout = 0;    // Ϣճʱ־

/************
 ALRMź
 ************/
static void sk_do_alarm(int sig)
{
    bTimeout = 1;
}

int main(void)
{
    int   r = 0, i = 0,midret = 0, callret = 0,UpdServerPort=-1,
          mtype = 0;            /* Ϣ */

    char *p, buf[128], dblogon[128], all_region[8],
        downmsg[SM_MAXL + 1], retcode[32 + 1], ywformnum[32 + 1],
        retmsg[1024 +1], hungrep[256 +1], region_list[128],UdpServerAddr[32];

    //add by l00135279
    char nextRuleid[33];
    int  iSucceedSendSms=0;
    //end add

    int  dailylog=0;        /* Ƿ¼־ */

    MSQBUF15  msqbuf;       /* Ϣ */
    SMREQ    *msqc;         /* Ϣͨ */

    static SMRULE smrule;   /*  */

    sigset_t st;

    char   szValue[64],
           szError[8],
           szErrDesc[128];

    int    b, nCutOver;     // ǷѸ

    time_t tTv,
           tActiveTest;     // ʱ
/* ------------------------------------------------------------------------- */

    memset(&st, 0, sizeof(st));
    sigemptyset(&st);
    sigaddset(&st, SIGTERM);

    /* ʼ */
    memset(u_pno, 0, sizeof(u_pno));
    memset(region_list, 0, sizeof(region_list));
    memset(u_cfgfile, 0, sizeof(u_cfgfile));    /* ļ */

    //add by l00135279
    memset(nextRuleid, 0, sizeof(nextRuleid));
    //end add

    if( (r = GC_daemon_init(u_cfgfile, u_pno, NULL, &u_msqid, NULL)) ) {
        printf("󣺳ʼʧ%d", r);
        return(0);
    }

    /* Ƿÿһ־ļ */
    dailylog = 0;
    memset(buf, 0, sizeof(buf));
    if( z_getkeyv(u_cfgfile, "DAILYLOG", buf, sizeof(buf) - 1) == 0 )
        dailylog = (int) strtol(buf, (char **)NULL, 10);

    if( dailylog ) z_logsetday(1);

    /* 趨־ļ */
    u_logmsize = LOGMSIZE;
    memset(buf, 0, sizeof(buf));

    if( z_getkeyv(u_cfgfile, "LOGMAXSIZE", buf, 15) == 0 )
        u_logmsize = (unsigned int) strtoul(buf, (char **)NULL, 10);

    z_logsetsz(u_logmsize);

    /* 趨־Ƿ¼ */
    u_writelog = 0;
    memset(buf, 0, sizeof(buf));

    if( z_getkeyv(u_cfgfile, "ISWRITELOG", buf, 3) == 0 )
        u_writelog = (unsigned int) strtoul(buf, (char **)NULL, 3);
    /*ȡUDP־,˿ں*/

	memset(buf, 0, sizeof(buf));
	memset(UdpServerAddr,0,sizeof(UdpServerAddr));
	strcpy(UdpServerAddr,"127.0.0.1");

	if( z_getkeyv(u_cfgfile, "UDPLOGSADDR", buf, 32) == 0 )
	{
	   strncpy(UdpServerAddr ,buf,sizeof(UdpServerAddr)-1);
	}

	memset(buf, 0, sizeof(buf));
	if( z_getkeyv(u_cfgfile, "UPDLOGSPORT", buf, 10) == 0 )
	{
	    UpdServerPort = (unsigned int) strtoul(buf, (char **)NULL, 10);
	}
    if( z_getkeyv(u_cfgfile, "HUNGREP", hungrep, 256))
        strcpy(hungrep,"");

    /* ־ļ */
    sprintf(u_logfile, "../log/log%s", u_pno);

    z_logv(u_logfile, "ļ=%s", u_cfgfile);

/* ------------------------------------------------------------------------- */
    /* ̱Ϣ */
    memset(u_pnoinfo, 0, sizeof(u_pnoinfo));

    if( z_getkeyv(u_cfgfile, u_pno + 1, u_pnoinfo, 255) ) {
        z_logv(u_logfile, "ļ޽̱ %s !", u_pno + 1);
        return(-1);
    }
    z_lrtrim(u_pnoinfo);

    /* ··smnotify·ȼ· 20081220 */
    if( z_getkeyv(u_cfgfile, "SENDTAB", u_sendtab, 32) ) {
        strcpy(u_sendtab,"smnotify") ;
    }
    z_lrtrim(u_sendtab);

    if( z_getkeyv(u_cfgfile, "SENDTABPARA", u_sendtabpara, 32) ) {
        strcpy(u_sendtabpara,"smnotify_para") ;
    }
    z_lrtrim(u_sendtabpara);

    /* ֽ̱Ϣ */
    p = u_pnoinfo;

    /* Ϣ */
    if( z_get_fieldv(&p, buf, NULL, 10, "|") == 0 ) return(0);
    mtype = (int) strtol(buf, (char **)NULL, 10);

    /* ݿ¼Ϣ */
    memset(dblogon, 0, sizeof(dblogon));

    if( z_get_fieldv(&p, dblogon, NULL, 127, "|") == 0 ) return(1);
/* ------------------------------------------------------------------------- */

    /* ееıʾ */
    memset(all_region, 0, sizeof(all_region));

    if( z_getkeyv(u_cfgfile, "REGION_ALL", all_region, 7) )
        strcpy(all_region, "999");

    z_atrim(all_region);

    z_get_fieldv(&p, region_list, NULL, 127, "|");

    #ifdef __TUXEDO__

    z_get_fieldv(&p, TuxSvrAddr, NULL, 255, "|");
    z_get_fieldv(&p, TuxSvrName, NULL, 64, "|");
    z_atrim(TuxSvrAddr);
    z_atrim(TuxSvrName);

    #endif

    GC_loop_timeout(60);

    /* ݿ⣬׼ */
    GC_aloopb();
    r = u_dbpre(0, dblogon);
    GC_aloope();

    if( r < 0 ) return(r);
    else if( r > 0 )
    {
        z_logv(u_logfile, "޹Ͻ");
        return(0);
    }
/* ------------------------------------------------------------------------- */

    tActiveTest = time(0);

    // ALRMźŴ
    struct sigaction sa;

    memset(&sa, 0, sizeof(sa));
    sigemptyset(&sa.sa_mask);
    sa.sa_flags = 0;

    sa.sa_handler = sk_do_alarm;
    sigaction(SIGALRM, &sa, NULL);

    // ȡļ
    if( GC_read_cfg(u_cfgfile) < 0 )
    {
        z_logv(u_logfile, "GC_read_cfg ʧ");
        return(0);
    }

    // socket
    g_csktfd = -1;

    while( 1 )
    {
        bTimeout = 0;
        nCutOver = 0;
        b = 0;

        memset(&StatLog,0,sizeof(StatLog));


        //add by l00135279
        iSucceedSendSms = 0;
        if (0 == strlen(nextRuleid))
        {
            /* ΪϢṹֵ */
            memset(&msqbuf, 0, MSQBUF15_LEN);
            msqc = (SMREQ *) (msqbuf.mtext);

            /* ȡϢ */
            z_logv(u_logfile, "Read ...");

            alarm(10);
            b = msgrcv(u_msqid, &msqbuf, MSGSZ15, mtype, 0);
            alarm(0);
        }
        else
        {
            strncpy(msqc->rule_id, nextRuleid, sizeof(msqc->rule_id)-1);
            memset(nextRuleid, 0, sizeof(nextRuleid));
        }
        //end add

        // 
        tTv = time(0);

        if( tTv - tActiveTest > 10 )
        {
            if( FwActiveTest() < 0 )
            {
                if( g_csktfd >= 0 )
                {
                    close(g_csktfd);
                    g_csktfd = -1;
                }
            }

            tActiveTest = tTv;
        }

        if( b < 0 )
        {
            if( bTimeout == 0 )
            {
                z_logv(u_logfile, "DEALϢȡʧ=%.64s", strerror(errno));
                return(0);
            }
            else
                continue;
        }

/* ------------------------------------------------------------------------- */

        /* ĻϢ */
        memset(buf, 0, sizeof(buf));

        sprintf(buf, "R%d T%s P%s r%s t%d M",
            msqc->REGION, msqc->TELNUM, msqc->PORT, msqc->rule_id, msqc->timeout);

        r = z_chi_nohalf(msqc->MSG_TXT, 32);
        strncat(buf, msqc->MSG_TXT, r);

         /*UDP־Ϣɼ*/
        strncpy(StatLog.req_pkg, buf,sizeof(StatLog.req_pkg)-1);
        strncpy(StatLog.access_type,"IntSms",sizeof(StatLog.access_type));
        strncpy(StatLog.trade_org,"IntSms",sizeof(StatLog.trade_org)-1);
        strncpy(StatLog.telnum, msqc->TELNUM,sizeof(StatLog.telnum)-1);

        z_logsetonly1(1);
        z_logv(u_logfile, buf);

        all_print(buf);
        GC_setscr(buf);

        /* ʼTAG-VALUE */
        u_rset[0] = 0;

        for( i = 0; i < MAXTAGS && u_tagvalue[i].tag[0]; i++ )
        {
            u_tagvalue[i].tag[0] = 0;
        }

        /* ֵ'TAG-VALUE ' --ϵͳ */

        sprintf(buf, "%d", msqc->REGION);
        u_settag("REGION", buf, NULL, PARA_SYS);
        u_settag("TELNUM", msqc->TELNUM, NULL, PARA_SYS);
        u_settag("PORT", msqc->PORT, NULL, PARA_SYS);
        u_settag("MSGTXT", msqc->MSG_TXT, NULL, PARA_SYS);
        u_settag("BRAND", msqc->brand, NULL, PARA_SYS);
        u_settag("INTIME", msqc->INTIME, NULL, PARA_SYS);
        u_settag("-INTIME", msqc->INTIME, NULL, PARA_SYS);

        u_settag(NAME_SENDORN, "0", TEXT_T_NORMAL, PARA_RKEY);

        /* ȡ */
        smrule.sendornot = 0;
        smrule.f_result = 0;

        smrule.issendudplog = 0;
        smrule.region = msqc->REGION;
        strcpy(smrule.ruleid, msqc->rule_id);

        /*UDP־Ϣɼ*/
        sprintf(StatLog.region,"%d\0",smrule.region);
        strncpy(StatLog.trade_code, smrule.ruleid,sizeof(StatLog.trade_code)-1);
        strncpy(StatLog.req_time,msqc->INTIME,sizeof(StatLog.req_time)-1);

//----------
        // жϵǷѸ
        sprintf(buf, "CUTOVER_%d", smrule.region);

        if( z_getkeyv(u_cfgfile, buf, szValue, sizeof(szValue) - 1) == 0 )
            nCutOver = (int) strtol(szValue, (char **)NULL, 10);

        if( nCutOver == 0 )
        {
            // 
            if( Fw1(msqc->TELNUM, msqc->MSG_TXT, szError, szErrDesc) < 0 )
            {
                strcpy(szError, "9090");
                strcpy(szErrDesc, "Broken pipe");

                if( g_csktfd >= 0 )
                {
                    close(g_csktfd);
                    g_csktfd = -1;
                }
            }

            // UDP־Ϣ
            strcpy(StatLog.error_code, szError);
            strcpy(StatLog.realerrcode, szError);
            strcpy(StatLog.error_desc, szErrDesc);

            if( smrule.issendudplog ) SendUdpLog(UdpServerAddr, UpdServerPort);

            z_logv(u_logfile, "szError=%s, szErrDesc=%s", szError, szErrDesc);
            continue;
        }
//----------

        GC_aloopb();
        r = u_read_rule(&smrule, all_region);
        GC_aloope();
        //z_logv(u_logfile, "u_read_rule %d", r);
        if( r < 0 )
        {
            /*UDP־Ϣɼ*/
            snprintf(StatLog.error_code,sizeof(StatLog.error_code),"%d\0",r);
            snprintf(StatLog.realerrcode,sizeof(StatLog.realerrcode),"%d\0",r);
            snprintf(StatLog.error_desc,sizeof(StatLog.error_desc),"%sȡʧ\0",smrule.ruleid );

            if(smrule.issendudplog) SendUdpLog(UdpServerAddr,UpdServerPort);

            return(r);
        }
        else if( r > 0 )
        {
            /*UDP־Ϣɼ*/
            snprintf(StatLog.error_code,sizeof(StatLog.error_code),"%d\0",r);
            snprintf(StatLog.realerrcode,sizeof(StatLog.realerrcode),"%d\0",r);
            snprintf(StatLog.error_desc,sizeof(StatLog.error_desc),"%s޶\0",smrule.ruleid );

            if(smrule.issendudplog) SendUdpLog(UdpServerAddr,UpdServerPort);

            z_logv(u_logfile, "󣺹%s޶", smrule.ruleid);
            continue;
        }

        /* ȡ */
        GC_aloopb();
        r = u_read_para(&smrule);
        GC_aloope();
        if( r < 0 )
        {
            /*UDP־Ϣɼ*/
            snprintf(StatLog.error_code,sizeof(StatLog.error_code),"%d\0",r);
            snprintf(StatLog.realerrcode,sizeof(StatLog.realerrcode),"%d\0",r);
            snprintf(StatLog.error_desc,sizeof(StatLog.error_desc),"ȡ %s ʧ\0",smrule.ruleid );

            if(smrule.issendudplog) SendUdpLog(UdpServerAddr,UpdServerPort);

            return(-1);
        }
        /* 'TAG-VALUE ' */
        z_logv(u_logfile, "haspara=%d, isfixed=%d", smrule.haspara, smrule.isfixed);

        u_analy_in(&smrule, msqc->MSG_TXT);

        if( r < 0 ) return(-3);

        /* ȡм¼'TAG-VALUE ' */
        midret = 0;
        if( strcasecmp(smrule.ruletype, RULE_T_OUT) == 0 )
        {
            GC_aloopb();
            midret = u_read_mid(&smrule, msqc); /*1м飬-30ӦĶ*/
            GC_aloope();
            z_logv(u_logfile, "u_read_mid[%d],sendornot[%d]",midret,smrule.sendornot);

            if( midret < 0 )
            {
                /*UDP־Ϣɼ*/
               snprintf(StatLog.error_code,sizeof(StatLog.error_code),"%d\0",midret);
               snprintf(StatLog.realerrcode,sizeof(StatLog.realerrcode),"%d\0",midret);
               snprintf(StatLog.error_desc,sizeof(StatLog.error_desc),"u_read_mid[%d],sendornot[%d]\0",midret,smrule.sendornot);

               if(smrule.issendudplog) SendUdpLog(UdpServerAddr,UpdServerPort);
                return(-1);
            }
        }

        /* ֵ */
        r = u_cal_para(&smrule, PARA_IN);

        u_showtags();
        r=0;
        if(midret != 1)
        {
            /* Ŀ */
            u_settag(NAME_CHKCODE, CODE_CHECKOK, TEXT_T_NORMAL, PARA_RKEY);

            GC_aloopb();
            r = u_read_check(&smrule);
            GC_aloope();

            z_logv(u_logfile, "check=%d", r);
        }

        if( r < 0 )
        {
            /*UDP־Ϣɼ*/
            snprintf(StatLog.error_code,sizeof(StatLog.error_code),"%d\0",r);
            snprintf(StatLog.realerrcode,sizeof(StatLog.realerrcode),"%d\0",r);
            strncpy(StatLog.error_desc,"check fail \0",sizeof(StatLog.error_desc));

            if(smrule.issendudplog) SendUdpLog(UdpServerAddr,UpdServerPort);

            return(-1);
        }
        else if( r > 0 || midret == 1)                     /* ʧ */
        {
            /* ü */
            if( midret == 1 )
            {
                strcpy(smrule.retcode,"-30");
                smrule.f_result = 0;
            }
            else
            {
                i = u_gettag(NAME_CHKCODE, NULL, PARA_ALL);
                strcpy(smrule.retcode, u_tagvalue[i].value);
            }
        }
        else
        {
            u_settag(NAME_CHKCODE, CODE_CICSFAIL, TEXT_T_NORMAL, PARA_RKEY);

            /* TERMź */
            sigprocmask(SIG_BLOCK, &st, NULL);

            GC_aloopb();
            callret = call15(&smrule, msqc);
            GC_aloope();

            /* TERMź */
            sigprocmask(SIG_UNBLOCK, &st, NULL);

            z_logv(u_logfile, "call15=%d", callret);

            switch( callret )
            {
            case 0:                          /* ɹ */
                break;

            case -5:                         /* tuxû */
                smrule.f_result = 0;
                strcpy(smrule.retcode, CODE_CICSFAIL);
                break;
            case -4:                         /* tuxʧ */
                smrule.f_result = 0;
                strcpy(smrule.retcode, CODE_CICSFAIL);
                break;
            case -2:                         /* ݿ */
            case -3:                         /* ϵͳ */
                smrule.f_result = 0;
                strcpy(smrule.retcode, CODE_CICSFAIL);
                break;

            case -1:                         /* CICS쳣Żظ */
                smrule.f_result = 0;
                strcpy(smrule.retcode, CODE_CICSFAIL);
                break;
            case -6:                         /* CICS쳣Żظ */
                smrule.f_result = 0;
                strcpy(smrule.retcode, CODE_CICSFAIL);
                break;
            }
        }

        u_showtags();

        memset(retcode, 0, sizeof(retcode));
        memset(retmsg, 0, sizeof(retmsg));
        memset(ywformnum, 0, sizeof(ywformnum));
        u_gettag("RETCODE", retcode, PARA_ALL);
        u_gettag("RETMSG", retmsg, PARA_ALL);
        u_gettag("YWFORMNUM", ywformnum, PARA_ALL);

        if(u_gettag("REALRETCODE", StatLog.realerrcode, PARA_ALL)<0)
        {
            strncpy(StatLog.realerrcode,retcode,sizeof(StatLog.realerrcode)-1);
        }

        strncpy(StatLog.error_code,retcode,sizeof(StatLog.error_code)-1);
        strncpy(StatLog.error_desc,retmsg, sizeof(StatLog.error_desc)-1);
        strncpy(StatLog.req_oid,ywformnum,sizeof(StatLog.req_oid)-1);

        z_logv(u_logfile, "smrule.issendudplog%d UdpServerAddr %s UpdServerPort %d ", smrule.issendudplog,UdpServerAddr,UpdServerPort);

        if(smrule.issendudplog) SendUdpLog(UdpServerAddr,UpdServerPort);

        z_logv(u_logfile, "RETCODE=%s, RETMSG=%s, SENDORNOT=%d", retcode, retmsg, smrule.sendornot);

        //add by l00135279
        //ֻڱһҵɹ£ŻNEXTRULEID
        if (0 == strcmp(retcode, "100"))
        {
            u_gettag(NAME_NEXTRULE, nextRuleid, PARA_ALL);
            z_lrtrim(nextRuleid);
        }

        //ǷֻǳɹʱͶ
        int count = u_gettag(SUCCEEDSENDSMS, NULL, PARA_ALL);
        iSucceedSendSms = (int) strtol(u_tagvalue[count].value, (char **)NULL, 10);

        z_logv(u_logfile, "nextRuleid=%s, sendornot=%d, iSucceedSendSms=%d", nextRuleid, smrule.sendornot, iSucceedSendSms);

        //˲Ͷţҵɹʱŵҵʧʱ·
        if ( (1 == smrule.sendornot) || ((1 == iSucceedSendSms) && (0 != strcmp(retcode, "100"))) )
        {
            continue;
        }
        //end add

        /* ȡ */
        if( smrule.f_result == 0 )
        {
            GC_aloopb();
            r = u_read_rsfmt(&smrule);
            GC_aloope();

            if( r < 0 ) return(-1);
        }

        if( smrule.f_result == 2 )    /* ش޶壬ȱʡӦϢ */
        {
            if(strlen(hungrep)!=0)  //ļûþʹӱȡ55Ķ
            {
                strcpy(smrule.rstype, "NONE");
                strcpy(smrule.smformat, hungrep);
            }
            else
            {
                strcpy(smrule.retcode, CODE_NOFOUND);
                GC_aloopb();
                r = u_read_rsfmt(&smrule);
                GC_aloope();
            }
            strcat(retmsg,CODE_NOFOUND);
        }

        /* · */

        z_logv(u_logfile, "rstype=%s, startrow=%d", smrule.rstype, smrule.startrow);
        u_var_replace(smrule.smformat, downmsg);

        z_logv(u_logfile, "downmsg=%s", downmsg);

        /* · */
        GC_aloopb();

        r = u_to_send(msqc, downmsg, retcode, retmsg, ywformnum);
        GC_aloope();

        if ( callret == -6 )
        {
            sleep(30);
        }

        if ( callret == -5 || callret == -4 )
        {
            return (-1);
        }

    }

}
void 	 strnset(char *instr,char s,char t)
{
	for(int i=0;i<strlen(instr);i++)
	{
		if(*(instr+i)==s) *(instr+i)=t;
	}
}
//UDPֵ
void SendUdpLog(char *ip,int port)
{
   if(-1==port)
   {
       z_logv(u_logfile, " [UPDLOGSPORT] [UDPLOGSADDR]");
       return;
   }
	 //ʱ
   char udpinfo[1024];
   memset(udpinfo,0,sizeof(udpinfo));

	// z_logv(u_logfile, "StatLog.req_time [%s]",StatLog.req_time);

	 StatLog.duration=u_get_duration(StatLog.req_time,StatLog.resp_time);

	 strnset(StatLog.trade_org,'|',' ');
	 strnset(StatLog.error_desc,'|',' ');
	 strnset(StatLog.req_pkg,'|',' ');

	 if(0==strlen(StatLog.region))/*ȡϢİ999ĬϣҲֶ*/
     {
        strcpy(StatLog.region,"999");
     }

    snprintf(udpinfo,sizeof(udpinfo)-1,"sm%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%s|%d|%s|%s", StatLog.req_oid,StatLog.region ,StatLog.access_type ,StatLog.trade_org ,StatLog.telnum ,StatLog.trade_code ,StatLog.error_code,StatLog.error_desc ,
StatLog.realerrcode ,StatLog.req_oid ,StatLog.req_time ,StatLog.resp_time,StatLog.duration,StatLog.cli_ipaddr,StatLog.req_pkg  );

   z_logv(u_logfile, "udpinfo [%s]",udpinfo);

   GC_sendudp(ip, port, udpinfo,strlen(udpinfo)+1);
}

// תһ
static int Fw1(const char *pTel, const char *pMsg, char *pErr, char *pErrDesc)
{
    static int nSeq = 1;
    char *p, szInfo[256];

    // ʼͨ
    if( g_csktfd < 0 && GC_topencn(g_serverip, g_cport) < 0 ) return -1;

    sprintf(szInfo, "%04d", nSeq);
    if( nSeq < 9999 ) nSeq++;
    else nSeq = 1;

    GC_setpheadn("10001", 2);
    GC_setpheadn(szInfo, 3);
    GC_setpheadn("0", 4);
    GC_setpheadn(szInfo, 5);
    GC_setpheadn("0", 6);

    // 
    sprintf(szInfo, "%s~%s;", pTel, pMsg);
    if( GC_sendtextc(szInfo) < 0 ) return -1;

    // ȡͷ
    if( GC_lookpheadc(szInfo) != g_phlen ) return -1;

    // ȡ
    int nBodyLen = g_iplen - g_phlen;
    if( GC_recvinfoc(szInfo + g_phlen, nBodyLen) != nBodyLen ) return -1;
    szInfo[g_iplen] = 0;

    // Ӧ
    p = szInfo + g_phlen;
    z_get_fieldv(&p, pErr, NULL, 7, "~");
    z_get_fieldv(&p, pErrDesc, NULL, 127, ";");

    return(0);
}

// 
static int FwActiveTest(void)
{
    char szInfo[256];

    // ʼͨ
    if( g_csktfd < 0 && GC_topencn(g_serverip, g_cport) < 0 ) return -1;

    GC_setpheadn("10000", 2);
    GC_setpheadn("0", 4);
    GC_setpheadn("0", 6);

    // 
    if( GC_sendtextc("") < 0 ) return -1;

    // ȡͷ
    if( GC_lookpheadc(szInfo) != g_phlen ) return -1;

    return(0);
}

