/************
 ɼ
 ************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <time.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include "zvdef.h"
#include "zvar.h"
#include "gcps.h"
#include "z.h"

#define   EXPFILE_DEFAULT    "CPCFG.exp"    /* ȱʡĵļ */

/* ------------------------------------------------------------- */

/* ʾɼĸ澯״̬ */
void f_warn_list(void);

/* ø澯״̬ */
void f_warn_set(char *no, char *val);

/* Ϣ */
void f_cfg_exp(char *file);

/* ʾüϢ */
void f_cfg_show(char *no);

/* ˢϢ */
void f_cfg_refresh(char *no, int fn);

/* ޸ļ */
void f_seq_update(char *no, int fseq);

/* ------------------------------------------------------------- */

static void s_mlen_show(void)
{
    int len = 0;

    len += ZPUB_LEN;
    printf("\t=%d\n", len);

    len += (MAXN_Z * ZCFG_LEN);
    printf("Ϣ\t=%d\n", len);

    len += (MAXN_Z * ZRUN_LEN);
    printf("Ϣ\t=%d\n", (MAXN_Z * ZRUN_LEN));

    len += (MAXN_USER * ZWTM_LEN);
    printf("澯ʱ\t=%d\n", (MAXN_USER * ZWTM_LEN));

    printf("ܼ\t\t=%d\n", len);
}

/****************
 ʾʹð
 ****************/
static void s_help(char *pname)
{
    printf("*                                                           *\n");
    printf("* [-s] [-r r1 -f f1] [-p p1] [-m m1 -f f1]                *\n");
    printf("* -c c1 [-L | -E [-f f1] | -R | -n n1 [-w w1 | -R | -u s1]] *\n");
    printf("*                                                           *\n");
    printf("* -s          --  ʾڴ                              *\n");
    printf("*                                                           *\n");
    printf("* -L          --  ʾɼĸ澯״̬                      *\n");
    printf("* -E          --  ɼϢ                      *\n");
    printf("* -v          --  ʾɼüϢ                *\n");
    printf("* -R          --  ˢ²ɼϢ(ȫֲ)          *\n");
    printf("* -c c1       --  ָļ 'c1'                         *\n");
    printf("* -n n1       --  ָɼ 'n1'                       *\n");
    printf("* -w w1       --  л澯״̬(0ر  1)                *\n");
    printf("* -r r1       --  ָʽ 'r1'                       *\n");
    printf("* -f f1       --  ָļ 'f1'                         *\n");
    printf("* -m m1       --  ָĿתʽ 'm1'                 *\n");
    printf("* -p p1       --  ָ 'p1'                         *\n");
    printf("*                                                           *\n");
    printf("*************************************************************\n");

    printf("ʾ:\n");
    printf("%s -s                     # ʾڴ\n", pname);
    printf("%s -p p1                  # ʾp1Ӧ\n", pname);

    putchar('\n');
    printf("%s -r 'r1' -f b1.dat      # b1.datǷƥʽr1\n", pname);
    printf("%s -m 'm1' -f b1.dat      # ʾb1.datm1תĿ\n", pname);

    putchar('\n');
    printf("%s -c c1 -L               # ʾɼĸ澯״̬\n", pname);
    printf("%s -c c1 -n n1 -w 0       # رղɼn1ĸ澯\n", pname);
    printf("%s -c c1 -n n1 -w 1       # 򿪲ɼn1ĸ澯\n", pname);

    putchar('\n');
    printf("%s -c c1 -E [-f f1]       # ɼϢ\n", pname);
    printf("%s -c c1 -n n1 -v         # ʾɼn1üϢ\n", pname);
    printf("%s -c c1 -n n1 -R         # ˢ²ɼn1Ϣ\n", pname);
    printf("%s -c c1 -R               # ˢȫֲ\n", pname);
    printf("%s -c c1 -n n1 -u s1      # ޸Ĳɼn1ļ\n", pname);
    putchar('\n');
}

int main(int argc, char **argv)
{
    int   b, f_err,
          fseq,                               /* ļ */
          fc, fs, fp, fr, fm,
          fL, fR, fE, fv, fw, fu, fn, ff;

    char  zno[17],                            /* ɼ */
          warnval[8],                         /* 澯ȡֵ */
          regex[65],                          /* ʽ */
          modetr[65],                         /* תģʽ */
          fname[CL],                          /* ļ */
          dstfile[CL],                        /* Ŀļ */
          passwd[33];                         /* (Ļ) */

    unsigned char ptext[65];                  /* (Ļ) */

printf("*************************************************************\n");
printf("*           CPɼ for AIX  Version: 3.0            *\n");
printf("*************************************************************\n");

    fseq = -1;
    f_err = fc = fs = fp = fr = fm = 0;
    fL = fR = fE = fv = fw = fu = fn = ff = 0;

    memset(u_pcfgfile, 0, sizeof(u_pcfgfile));
    memset(zno,        0, sizeof(zno));
    memset(warnval,    0, sizeof(warnval));
    memset(regex,      0, sizeof(regex));
    memset(modetr,     0, sizeof(modetr));
    memset(fname,      0, sizeof(fname));
    memset(dstfile,    0, sizeof(dstfile));
    memset(passwd,     0, sizeof(passwd));

    while( (b = getopt(argc, argv, ":c:sp:r:m:LREvw:u:n:f:")) != -1 )
    {
        switch( b )
        {
        case 'c':                             /* ļ */
            fc ++;
            strncpy(u_pcfgfile, optarg, sizeof(u_pcfgfile) - 1);
            u_pcfgfile[sizeof(u_pcfgfile) - 1] = 0;
            break;

        case 's':                             /* ʾڴ */
            fs ++;
            break;

        case 'p':                             /* Ļ */
            fp ++;
            strncpy(passwd, optarg, sizeof(passwd) - 1);
            passwd[sizeof(passwd) - 1] = 0;
            break;

        case 'r':                             /* ʽ */
            fr ++;
            strncpy(regex, optarg, sizeof(regex) - 1);
            regex[sizeof(regex) - 1] = 0;
            break;

        case 'm':                             /* Ŀתʽ */
            fm ++;
            strncpy(modetr, optarg, sizeof(modetr) - 1);
            modetr[sizeof(modetr) - 1] = 0;
            break;

        case 'L':                             /* ʾɼĸ澯״̬ */
            fL ++;
            break;

        case 'R':                             /* ˢ²ɼϢ */
            fR ++;
            break;

        case 'E':                             /* ɼϢ */
            fE ++;
            break;

        case 'v':                             /* ʾɼϢ */
            fv ++;
            break;

        case 'w':                             /* 澯 */
            fw ++;
            warnval[0] = optarg[0];
            break;

        case 'u':                             /* ޸ļ */
            fu ++;
            fseq = (int) strtol(optarg, (char **)NULL, 10);
            break;

        case 'n':                             /* ɼ */
            fn ++;
            strncpy(zno, optarg, sizeof(zno) - 1);
            zno[sizeof(zno) - 1] = 0;
            break;

        case 'f':                             /* ļ */
            ff ++;
            strncpy(fname, optarg, sizeof(fname) - 1);
            fname[sizeof(fname) - 1] = 0;
            break;

        case ':':                             /* ȱѡ */
            f_err = -1;
            printf("Option -%c requires an argument\n", optopt);
            break;

        case '?':                             /* Ƿѡ */
            f_err = -1;
            printf("Unrecognized option: -%c\n", optopt);
            break;
        }

        if( f_err < 0 ) break;
    }

    if( fs )            /* ʾڴ */
    {
        s_mlen_show();
        return(0);
    }
    else if( fp )       /* ܽ */
    {
        if( fv )
        {
            memset(ptext, 0, sizeof(ptext));
            f_pass_decry(passwd, ptext);
            printf("=[%s]\n", ptext);
        }
        else
        {
            f_pass_encry(passwd, (char *)ptext);
            printf("=%s\n", (char *)ptext);
        }

        return(0);
    }
    else if( fr )       /* ʽƥ䣬f ѡָ */
    {
        if( ff == 0 )
        {
            printf("ʽƥԣָļ\n");
            return(0);
        }

        printf("ʽ%s\n", regex);
        printf("  %s\n", fname);

        if( z_regmatch(fname, regex) == 0 )
            printf("NOT\n");
        else
            printf("OK\n");
        return(0);
    }
    else if( fm )       /* Ŀļתf ѡָ */
    {
        if( ff == 0 )
        {
            printf("ĿתָԴļ\n");
            return(0);
        }

        printf("Դ  %s\n", fname);
        printf("תʽ%s\n", modetr);

        if( (b = f_nametr(fname, modetr, dstfile)) < 0 )
        {
            printf("'%s' Ŀתʧ=%d\n", modetr, b);
            return(0);
        }

        printf("Ŀƣ%s\n", dstfile);
        return(0);
    }

    if( f_err == 0 )                          /*  */
    {
        if( (fc != 1) ||                      /* ָc ѡ */

            /* ظѡ */
            (fn > 1 || ff > 1) ||

            /* ָһѡ */
            (fL + fR + fE + fv + fw + fu != 1) ||

            /* Ҫn ѡ */
            (fw && fn == 0) || (fv && fn == 0) || (fu && fn == 0) ||

            /* ҪE ѡ */
            (ff && fE == 0) )
        {
            f_err = -1;
        }
    }

    if( f_err == -1 )                         /* д */
    {
        s_help(argv[0]);
        return(1);
    }

    /* ---------------------------------------------------- */

    /* ȡò */
    if( f_para_read() < 0 ) return(2);

    /* ӹڴ */
    if( f_conn_zshm(u_zkey, 0) == NULL )
    {
        printf(": CPɼƽ̨û\n");
        return(3);
    }

    if( (u_semid = semget(u_zkey, 0, 0)) < 0 )
    {
        perror("semget");
        return(4);
    }

    if( fL )
    {
        f_warn_list();
    }
    else if( fR )
    {
        f_cfg_refresh(zno, fn);
    }
    else if( fE )
    {
        f_cfg_exp(ff ? fname : (char *)EXPFILE_DEFAULT);
    }
    else if( fv )
    {
        f_cfg_show(zno);
    }
    else if( fw )
    {
        f_warn_set(zno, warnval);
    }
    else if( fu )
    {
        f_seq_update(zno, fseq);
    }

    return(0);
}

/****************
 ø澯״̬
 ****************/
void f_warn_set(char *no, char *val)
{
    int b;

    if( strcmp(val, "0") && strcmp(val, "1") )
    {
        printf("Ч澯ȡֵ '%s'\n", val);
        return;
    }

    b = f_search_set(no, OT_WARN, val, NULL);

    if( b == 0 ) printf("󣺲ɼ '%s' \n", no);
    else if( b == -1 ) printf("ʧ\n");
    else if( b == -2 ) printf("Ȩ޲\n");
    else printf("Ok.\n");

    putchar('\n');
    return;
}

/************
 ˢϢ
 ************/
void f_cfg_refresh(char *no, int fn)
{
    int b;

    if( fn == 0 )
    {
        b = f_gpara_refresh(1);

        if( b < 0 ) printf("ʧ\n");
        else printf("Ok.\n");
    }
    else
    {
        b = f_search_set(no, OT_NEW_CFG, NULL, NULL);

        if( b == 0 ) printf("󣺲ɼ '%s' \n", no);
        else if( b == -1 ) printf("ʧ\n");
        else if( b == -2 ) printf("Ȩ޲\n");
        else printf("OK֪ͨɼ̣ò¸ɼڵˢ.\n");
    }

    putchar('\n');
    return;
}

/************
 ޸ļ
 ************/
void f_seq_update(char *no, int fseq)
{
    int  b;
    char val[16];

    /* Ϣ */
    b = f_search_set(no, -1, val, &u_zcfg);

    if( b != 1 )
    {
        if( b == 0 ) printf("󣺲ɼ '%s' \n", no);
        else if( b == -1 ) printf("ʧ\n");
        else if( b == -2 ) printf("Ȩ޲\n");

        return;
    }

    if( u_zcfg.seq_ctrl != 1 && u_zcfg.warn_mode[WF_SEQBREAK] != '1' )
    {
        printf("󣺲ɼ '%s' ļ\n", no);
        return;
    }

    if( fseq < u_zcfg.seq_min || fseq > u_zcfg.seq_max )
    {
        printf("ЧЧΧ[%d-%d]\n", u_zcfg.seq_min, u_zcfg.seq_max);
        return;
    }

    /* Ÿ */
    sprintf(val, "%d", fseq);

    b = f_search_set(no, OT_NEW_SEQ, val, NULL);

    if( b == 0 ) printf("󣺲ɼ '%s' \n", no);
    else if( b < 0 ) printf("ʧ\n");
    else printf("Ok֪ͨɼ̣ļ¸ɼڵԸ.\n");

    putchar('\n');
    return;
}

/************
 Ϣ
 ************/
void f_cfg_exp(char *file)
{
    FILE *fp;

    int   i, num = 0;
    uid_t myuid;    /* ûuid */

    if( (fp = fopen(file, "w")) == NULL ) return;

    u_pcfgs = u_cfgs;
    u_pruns = u_runs;

    myuid = geteuid();

    for( i = 0; i < MAXN_Z; u_pcfgs++, u_pruns++, i++ )
    {
        /*  */
        if( GC_semop(u_semid, SN_LOCATION, -1, 0) < 0 )
        {
            printf("󣺼ʧ\n");
            return;
        }

        memcpy(&u_zcfg, u_pcfgs, ZCFG_LEN);

        /*  */
        if( GC_semop(u_semid, SN_LOCATION, 1, 0) < 0 )
        {
            printf("󣺽ʧ\n");
            return;
        }

        if( u_zcfg.no[0]  == 0 ) continue;

        /* ״̬ */
        if( GC_getstat(NULL, u_pruns->pslot) == ST_RELEASED ) continue;

        if( myuid && (myuid != GC_getuid(NULL, u_pruns->pslot)) ) continue;

        fprintf(fp, "\n[%s]\n", u_zcfg.no);
        fprintf(fp, "DESCRIPTION=%s\n", u_zcfg.desc);
        fprintf(fp, "OPERATION_TYPE=%c\n", u_zcfg.optype);
        fprintf(fp, "GATHER_MODE=%s\n", u_zcfg.gather_mode);
        fprintf(fp, "HOSTIP_PAIR=%s,%s\n", u_zcfg.host[0], u_zcfg.host[1]);
        fprintf(fp, "USER_PAIR=%s,%s\n", u_zcfg.user[0], u_zcfg.user[1]);
        fprintf(fp, "PASSWORD_PAIR=%s,%s\n", u_zcfg.pass[0], u_zcfg.pass[1]);
        fprintf(fp, "ENCRYPTION=%d\n", u_zcfg.encryption);
        fprintf(fp, "FTPPORT=%d\n", u_zcfg.ftpport);
        fprintf(fp, "SOURCE_PATTERN=%s\n", u_zcfg.src_fn_pattern);
        fprintf(fp, "SOURCE_NAME_FILTER=%s\n", u_zcfg.src_regex);
        fprintf(fp, "SOURCE_MOVEDEL=%d\n", u_zcfg.src_bakflag);
        fprintf(fp, "SOURCE_PATH=%s\n", u_zcfg.src_path);
        fprintf(fp, "SOURCE_BACKUP_PATH=%s\n", u_zcfg.src_bpath);
        fprintf(fp, "DEST_PATH=%s\n", u_zcfg.dst_path);
        fprintf(fp, "DEST_NAME_FORMAT=%s\n", u_zcfg.dst_format);
        fprintf(fp, "BUSY_TIME=%s\n", u_zcfg.busytime);
        fprintf(fp, "BUSY_INTERVAL=%d\n", u_zcfg.busyitv);
        fprintf(fp, "FREE_INTERVAL=%d\n", u_zcfg.freeitv);
        fprintf(fp, "NOFILE_LIMIT=%d\n", u_zcfg.nofile_limit);
        fprintf(fp, "FILE_ANALYZER=%s\n", u_zcfg.file_analyzer);
        fprintf(fp, "SEQUENCE_CONTROL=%d\n", u_zcfg.seq_ctrl);
        fprintf(fp, "SEQUENCE_SCOPE=%0*d%c%0*d\n",
            u_zcfg.seq_length, u_zcfg.seq_min, SM_SEQHYPHEN, u_zcfg.seq_length, u_zcfg.seq_max);
        fprintf(fp, "SEQUENCE_SYNC=%d\n", u_zcfg.seq_sync);
        fprintf(fp, "WARN_MODE=%s\n", u_zcfg.warn_mode + 1);
        fprintf(fp, "RECORD_SIZE=%d\n", u_zcfg.record_size);
        fprintf(fp, "FTP_TIMEOUT=%d\n", u_zcfg.ftp_timeout);
        fprintf(fp, "FTP_RESUME=%d\n", u_zcfg.ftp_resume);
        fprintf(fp, "FTP_PASSIVE=%d\n", u_zcfg.ftp_passive);
        fprintf(fp, "SIZE_COL=%d\n", u_zcfg.size_col);
        fprintf(fp, "EXTRACOPY=%d\n", u_zcfg.extracopy);
        fprintf(fp, "RETRY_TIMES=%d\n", u_zcfg.retrytimes);
        fprintf(fp, "RETRY_INTERVAL=%d\n", u_zcfg.retryitv);
        fprintf(fp, "ATTACH_FILE=%s\n", u_zcfg.attachfile);
        fprintf(fp, "STATUS=%d\n", u_zcfg.status);

        /*
         * fprintf(fp, "ENABLE_TIME=%s\n", u_zcfg.enable_time);
         * fprintf(fp, "EXPIRE_TIME=%s\n", u_zcfg.expire_time);
         */

        num++;
    }

    fclose(fp);

    printf("ɼĿ%d\n\n", num);
    return;
}

/******************
 ʾüϢ
 ******************/
void f_cfg_show(char *no)
{
    int   i, found = 0;
    char  tmstr[16];

    uid_t myuid;    /* ûuid */

    printf("[ʡ˾澯룺%s]\n", u_paras->prov_sms_nums);
    printf("[ȱʡæʱʱ  %s]\n", u_paras->busytime);

    printf("[æʱļʱޣ%d]\n", u_paras->busynofilet);
    printf("[ʱļʱޣ%d]\n", u_paras->freenofilet);

    printf("[ʡ˾澯%d]\n", u_paras->prov_warnitv);
    printf("[ֹ˾澯%d]\n", u_paras->city_warnitv);

    printf("[ϵͳIP    %s]\n", u_paras->rz_host);
    printf("[ϵͳû  %s]\n", u_paras->rz_user);
    printf("[ϵͳ  %s]\n", u_paras->rz_pass);
    printf("[Կʽ  %s]\n", u_paras->rz_encryption == 1 ? "" : "");
    printf("[ִʱ  %d]\n", u_paras->rz_timeout);

    printf("[FTP ʱ  %d]\n", u_paras->ftp_timeout);
    printf("[FTP ˿      %d]\n", u_paras->ftpport);
    printf("[ʼװر־  %d]\n", u_paras->loadok);

    printf("------------------------------------------------------------------\n");

    u_pcfgs = u_cfgs;
    u_pruns = u_runs;

    myuid = geteuid();

    for( i = 0; i < MAXN_Z; i++, u_pcfgs++, u_pruns++ )
    {
        if( u_pcfgs->no[0]  == 0 ) continue;

        /* ״̬ **
         * if( GC_getstat(NULL, u_pruns->pslot) == ST_RELEASED ) continue;
         */

        if( myuid && (myuid != GC_getuid(NULL, u_pruns->pslot)) ) continue;

        if( strcmp(u_pcfgs->no, no) == 0 )
        {
            printf("[òλ      %d]\n", i);
            printf("[ע          %s]\n", u_pcfgs->desc);
            printf("[      ");

            switch( toupper(u_pcfgs->optype) )
            {
            case SM_FTPGET:
                printf("FTP ȡ");
                break;
            case SM_FTPPUT:
                printf("FTP ");
                break;
            case SM_FTPNOKIA:
                printf("FTP ȡŵ");
                break;
            case SM_FTAM:
                printf("FTAMȡ");
                break;
            case SM_SHELLPUT:
                printf("SHELL ");
                break;
            }
            printf("]\n");

            printf("[ɼģʽ      %s", u_pcfgs->gather_mode);

            if( strchr(u_pcfgs->gather_mode, SM_NOLATEST) )
                printf("(ļ)");
            if( strchr(u_pcfgs->gather_mode, SM_NOTMPNAME) )
                printf("(ϴʱʱ)");
            if( strchr(u_pcfgs->gather_mode, SM_TIMESUFFIX) )
                printf("(ϴʱʹʱ׺)");

            printf("]\n");

            printf("[IP            %s,%s]\n", u_pcfgs->host[0], u_pcfgs->host[1]);
            printf("[û          %s,%s]\n", u_pcfgs->user[0], u_pcfgs->user[1]);
            printf("[          %s,%s]\n", u_pcfgs->pass[0], u_pcfgs->pass[1]);
            printf("[Կʽ      %s]\n", u_pcfgs->encryption == 1 ? "" : "");
            printf("[FTP ˿      %d]\n", u_pcfgs->ftpport);
            printf("[Դģʽ    %s]\n", u_pcfgs->src_fn_pattern);
            printf("[ʽ    %s]\n", u_pcfgs->src_regex);

            if( toupper(u_pcfgs->optype) == SM_FTPNOKIA )
            {
                printf("[شļ  %s]\n", u_pcfgs->src_bakflag == BF_NONE ? "()" : "");
            }
            else
            {
                printf("[Դɾ־    ");
                switch( u_pcfgs->src_bakflag )
                {
                case BF_NONE:
                    printf("޲");
                    break;
                case BF_DELETE:
                    printf("ֱɾ");
                    break;
                case BF_MOVE:
                    printf("ƶ");
                    break;
                }
                printf("]\n");
            }

            printf("[Դ·        %s]\n", u_pcfgs->src_path);
            printf("[Դ·    %s]\n", u_pcfgs->src_bpath);
            printf("[Ŀ·      %s]\n", u_pcfgs->dst_path);
            printf("[Ŀת%s]\n", u_pcfgs->dst_format);
            printf("[æʱʱ      %s]\n", u_pcfgs->busytime);
            printf("[æʱɼ  %d]\n", u_pcfgs->busyitv);
            printf("[ʱɼ  %d]\n", u_pcfgs->freeitv);

            printf("[澯ģʽ      %s%s]\n",
                u_pcfgs->warn_mode + 1,
                u_pcfgs->warn_mode[WF_ALL] == '1' ? "" : "");

            printf("[ļ澯ʱޣ%d]\n", u_pcfgs->nofile_limit);
            printf("[ļ%s]\n", u_pcfgs->file_analyzer);
            printf("[ļ      %s]\n", u_pcfgs->attachfile);
            printf("[ſ      %s]\n", u_pcfgs->seq_ctrl == 1 ? "ϸŲɼ" : "");
            printf("[ŷΧ      %0*d%c%0*d]\n",
                u_pcfgs->seq_length, u_pcfgs->seq_min, SM_SEQHYPHEN, u_pcfgs->seq_length, u_pcfgs->seq_max);
            printf("[ͬţ%s]\n", u_pcfgs->seq_sync == 1 ? "" : "");
            printf("[FTP ʱ  %d]\n", u_pcfgs->ftp_timeout);
            printf("[¼С      %d]\n", u_pcfgs->record_size);
            printf("['С'б  %d]\n", u_pcfgs->size_col);
            printf("[⿽      %d]\n", u_pcfgs->extracopy);
            printf("[Զ̱ݳԴΣ%d]\n", u_pcfgs->rmtbak_times);
            printf("[ʧܳԴ  %d]\n", u_pcfgs->retrytimes);
            printf("[ʧܳԼ  %d]\n", u_pcfgs->retryitv);
            printf("[FTP ϵ  %s]\n", u_pcfgs->ftp_resume == 1 ? "" : "");
            printf("[FTP ģʽ  %s]\n", u_pcfgs->ftp_passive == 1 ? "" : "");
            printf("[Ƿ      %s]\n", u_pcfgs->status == 1 ? "" : "");

            /*
             * printf("[Чʱ      %s]\n", u_pcfgs->enable_time);
             * printf("[ʧЧʱ      %s]\n", u_pcfgs->expire_time);
             */

            printf("------------------------------------------------------------------\n");

            printf("[ƽ̨λ  %d]\n", u_pruns->pslot);
            printf("[ֹ˾û    %s]\n", u_pruns->uname);
            printf("[ֹ˾ļ%s]\n", u_pruns->extra);
            printf("[ʣļĿ  %d]\n", u_pruns->leftfiles);
            printf("[ϴβɼļ  %s]\n", u_pruns->currfile);
            printf("[ϴλʱ  %s]\n", u_pruns->hdftime);

            tmstr[0] = 0;
            if( u_pruns->begtime ) z_get_dt(tmstr, 8, "t", u_pruns->begtime);
            printf("[ϴοʼʱ  %s]\n", tmstr);

            tmstr[0] = 0;
            if( u_pruns->endtime ) z_get_dt(tmstr, 8, "t", u_pruns->endtime);
            printf("[ϴνʱ  %s]\n", tmstr);

            tmstr[0] = 0;
            if( u_pruns->errtime ) z_get_dt(tmstr, 8, "t", u_pruns->errtime);
            printf("[ʱ      %s]\n", tmstr);
            printf("[Ϣ      %s(%s)]\n", u_pruns->errmsg, u_pruns->errmsg + (EMSG_LEN - NIDW_LEN) + 1);

            tmstr[0] = 0;
            if( u_pruns->noftime ) z_get_dt(tmstr, 8, "t", u_pruns->noftime);
            printf("[ļʱ    %s]\n", tmstr);

            /*
             * printf("[ɼԴ  %d]\n", u_pruns->trytimes);
             * printf("[¼Դ  %d]\n", u_pruns->conntimes);
             */

            printf("[0 ļĿ%d]\n", u_pruns->num0);
            printf("[ϴ      %d]\n", u_pruns->lastseq);
            printf("[ǰ      %d]\n", u_pruns->seq);

            printf("[ֹ˾澯%d]\n", u_pruns->e_report1);
            printf("[ʡĸ澯%d]\n", u_pruns->e_report2);
            printf("[ļ澯1%d]\n", u_pruns->e_nofrep1);
            printf("[ļ澯2%d]\n", u_pruns->e_nofrep2);
            printf("------------------------------------------------------------------\n");

            if( u_pcfgs->refresh == 1 ) printf("[*Ϣȴˢ ...]\n");
            if( u_pcfgs->seq_refresh == 1 ) printf("[*ļȴ %d ...]\n", u_pcfgs->seq_to_file);

            found = 1;
            break;
        }
    }

    if( found == 0 ) printf("󣺲ɼ '%s' \n\n", no);
    return;
}

/********************
 ʾɼĸ澯״̬
 ********************/
void f_warn_list(void)
{
    int    i, j, isbusy;
    char   szTime[20];

    time_t t1;
    uid_t  myuid;    /* ûuid */

    memcpy(&u_zpara, u_paras, ZPUB_LEN);    /* f_isbusy()Ҫ */

    u_pcfgs = u_cfgs;
    u_pruns = u_runs;

    myuid = geteuid();

    /* ʾÿû */
    printf("%2s %16s %s\n", "SN", "UID", "WARNTIME");

    for( i = 0, u_pwtms = u_wtms; i < MAXN_USER; i++, u_pwtms++ )
    {
        if( u_pwtms->iUid == 0 && i ) break;
        if( myuid && myuid != u_pwtms->iUid ) continue;

        if( u_pwtms->tWarnTime )
            z_get_dt(szTime, 19, "l", u_pwtms->tWarnTime);
        else
            szTime[0] = 0;
        printf("%2d %16u %s\n", i, u_pwtms->iUid, szTime);
    }

    for( i = 0; i < MAXN_Z; i++, u_pcfgs++, u_pruns++ )
    {
        if( u_pcfgs->no[0] == 0 ) continue;

        /* ״̬ */
        if( GC_getstat(NULL, u_pruns->pslot) == ST_RELEASED ) continue;

        if( myuid && (myuid != GC_getuid(NULL, u_pruns->pslot)) ) continue;

        printf("------------------------------------------------------------------\n");
        printf("ɼ㣺%s\n", u_pcfgs->no);

        if( u_pcfgs->warn_mode[WF_ALL] != '1' ) printf("\t\n");
        else
        {
            for( j = 1; u_pcfgs->warn_mode[j]; j++ )
            {
                switch( j )
                {
                case WF_ZERO:
                    if( u_pcfgs->warn_mode[j] == '1' ) printf("\tļ澯\n");
                    break;

                case WF_SEQBREAK:
                    if( u_pcfgs->warn_mode[j] == '1' ) printf("\tŲ澯\n");
                    break;

                /*
                 * case WF_LOGON:
                 *     if( u_pcfgs->warn_mode[j] == '1' ) printf("\t¼ʧܸ澯\n");
                 *     break;
                 *
                 * case WF_SIZEMIS:
                 *     if( u_pcfgs->warn_mode[j] == '1' ) printf("\tļСһ¸澯\n");
                 *     break;
                 */
                }
            }

            if( u_pcfgs->nofile_limit > 0 )
                printf("\tļ澯ʱ\t%d\n", u_pcfgs->nofile_limit);
            else
            {
                printf("\tļ澯ʱ\t");

                /* ȷæʱʱ */
                isbusy = f_isbusy(u_pcfgs->busytime);

                if( isbusy == 1 )
                    t1 = u_zpara.busynofilet;
                else
                    t1 = u_zpara.freenofilet;

                if( t1 > 0 )
                    printf("%ld\n", (long)t1);
                else
                    printf("Ч\n");
            }
        }
    }
}
