/************
 ɼmain
 ************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <pwd.h>
#include "zvdef.h"
#include "zvar.h"
#include "gcps.h"
#include "z.h"

/* λϢλ */
int f_cfg_slot(char *pno);

/* ȡϢ */
int f_cfg_read(char *cfgfile, ZCFG *t, char *pno);

/* ȡļʾϢ */
int f_cfg_read_ex(ZCFG *t, char *pno);

/* ʱȡǰ */
int f_init_seq(int *iseq);

/* ϴβɼʱ */
int f_set_endtime(void);

/* ȡӲ */
int f_entry_para(char *spno, char *pList, int nListSize);

/* װϢ */
int f_loadcfg(char *pList, int pno, char *pBelong);

/* ʼ */
void f_inittask(int *aseq, char *pBelong);

/* ˢϢ */
int f_refresh_cfg(int i);

/* Ϣ */
int f_refresh_seq(int *aseq, int i);

/* ״̬ʱĴ */
int f_notused(int i);

/* ɼʧܴ */
void f_faildo(int b, int i, int *itv, FILINFO *fi);

/* ò */
int f_cfgcheck(ZCFG *t, char *sip, char *suser, char *spass, char *seqscope);

static ZCFG  t_zcfg[MAXN_CARE];             /* Ϣ */
static int   t_retrytimes[MAXN_CARE];       /* Դ */

/************
 ɼ߼
 ************/
int f_entry(CPFUNC_PTR pcpfunc)
{
    int   i, b,
          mask,                             /* ļ */
          pno = 0,                          /*  */

          aseq[MAXN_CARE] = {0},            /* ǰļ */

          isbusy,                           /* Ƿæʱ */
          itv, sleep_itv;                   /* ˯ */

    char *p,
          spno[65],                         /* ̱ */
          szList[CL],                       /* ɼб */
          emsg[EMSG_LEN + 1],               /* ־Ϣ */
          value[16],
          szBelong[16];

    static FILINFO  fi[2];                  /* ļļϢ */

//GC_ftp_trace(1);
    if( (b = GC_daemon_init(u_pcfgfile, spno, &pno, NULL, &u_semid)) )
    {
        printf("󣺳ʼʧ=%d", b);
        return(1);
    }

    /* ļ */
    mask = FILE_UMASK;

    if( z_getkeyv(u_pcfgfile, "FILE_UMASK", value, sizeof(value) - 1) == 0 )
        mask = (int) strtol(value, (char **)NULL, 8);

    umask(mask);

    /* ֹ˾ļ */
    GC_getextra(u_zcfgfile);

    if( u_zcfgfile[0] == 0 )
    {
        printf("δָֹ˾ضļ\n");
        return(1);
    }

    if( z_getkeyv(u_zcfgfile, "DIRLOG", u_logdir, sizeof(u_logdir) - 1) )
    {
        printf("󣺷ֹ˾ضļ־Ŀ¼ DIRLOG !\n");
        return(1);
    }

    /* ־ļ */
    snprintf(u_logfile, sizeof(u_logfile), "%s/%s%s", u_logdir, LOGPREFIX, spno);

    /* ȡò */
    b = f_para_read();

    /* ־ */
    /* z_logsetday(1); */
    z_logsetsz(u_logmsize);
    z_logsetbox(u_logloops);
    z_loglogin(u_logfile, u_logloops);

    if( b < 0 )
    {
        z_logv(u_logfile, "ƽ̨ļ GCPSIPCKEY !");
        return(1);
    }

    z_logv(u_logfile, "ƽ̨ļ='%s'", u_pcfgfile);
    z_logv(u_logfile, "ֹ˾ضļ='%s'", u_zcfgfile);

    /* ȡӲ */
    if( f_entry_para(spno, szList, sizeof(szList)) < 0 ) return(1);

    /* ӹڴ */
    if( f_conn_zshm(-1, 1) == NULL )
    {
        z_logv(u_logfile, "Զڴʧ");
        return(1);
    }

    /* ֽ̱ţȡϢ */
    if( f_loadcfg(szList, pno, szBelong) < 0 ) return(1);

    /* ʼ */
    f_inittask(aseq, szBelong);

/* ---------------------------------------------------------- */
    /* ѭɼ */
    while( 1 )
    {
        /* ϽȫϢ */
        if( GC_semop(u_semid, SN_LOCATION, -1, 0) < 0 )
        {
            z_logv(u_logfile, "󣺼ʧ");
            return(1);
        }

        for( i = 0; i < u_carecount; i++ )
        {
            memcpy(t_zcfg + i, u_cfgs + u_careslot[i], ZCFG_LEN);
        }

        memcpy(&u_zpara, u_paras, ZPUB_LEN);

        /*  */
        if( GC_semop(u_semid, SN_LOCATION, 1, 0) < 0 )
        {
            z_logv(u_logfile, "󣺽ʧ");
            return(1);
        }

        for( i = 0, sleep_itv = -1, b = -1; i < u_carecount; i++ )
        {
            itv = -1;
            u_careno = i;

            /* ɹʱٴɼ */
            if( u_bBreakOnOK == 1 && b == R_SUCCESS )
            {
                z_logv(u_logfile, "break on OK");
                break;
            }

/* -------------------------------------------- */
            memset(&u_zcfg, 0, ZCFG_LEN);
            u_pruns = u_runs + u_careslot[i];

            if( t_zcfg[i].refresh == 0 )    /* תϢ */
            {
                memcpy(&u_zcfg, t_zcfg + i, ZCFG_LEN);
            }
            else                            /* ˢϢ */
            {
                /* ˢϢ */
                if( f_refresh_cfg(i) < 0 ) return(1);
            }

            z_logv(u_logfile, u_zcfg.no);
            strcpy(u_pNidWarn->szProcId, u_zcfg.no);

            /* ԪID */
            p = u_zcfg.desc;

            z_get_fieldv(&p, u_pNidWarn->szDeviceId, NULL, sizeof(u_pNidWarn->szDeviceId) - 1, "|");
            z_get_fieldv(&p, u_pNidWarn->szDeviceId, NULL, sizeof(u_pNidWarn->szDeviceId) - 1, "|");

            strcpy(u_pNidNormal->szDeviceId, u_pNidWarn->szDeviceId);
            strcpy(u_pNidNormal->szProcId, u_pNidWarn->szProcId);
/* ---------------------------------------------------------- */

            /* Ƿ */
            if( u_zcfg.status == 0 )
            {
                if( f_notused(i) < 0 ) return(1);
            }
            else
            {
                snprintf(u_fsnfile, sizeof(u_fsnfile), "%s/%s%s", u_fsndir, u_zcfg.no, FSNSUFFIX);

                /* ļ */
                if( t_zcfg[i].seq_refresh == 1 )
                {
                    if( f_refresh_seq(aseq, i) < 0 ) return(1);
                }
                else if( u_zcfg.seq_ctrl == 1 || u_zcfg.warn_mode[WF_SEQBREAK] == '1' )
                {
                    /* ʱȡǰ */
                    if( aseq[i] == -1 && f_init_seq(&(aseq[i])) < 0 )
                    {
                        snprintf(emsg, sizeof(emsg), "ļЧ'%s'", u_fsnfile);
                        f_seterr(emsg, "A002", "APP", 9);
                        return(-3);
                    }
                }

                /* ϴβɼʱ */
                if( f_set_endtime() < 0 )
                {
                    f_seterr("ʧ");
                    return(-1);
                }

                /* FTP ʱʱ */
                GC_ftp_timeout(u_zcfg.ftp_timeout);

                /* òɼ߼ */
                b = pcpfunc(&(aseq[i]), toupper(u_zcfg.optype), fi);

                /* ʧܴ */
                f_faildo(b, i, &itv, fi);
            }

/* ---------------------------------------------------------- */
            if( itv == -1 )
            {
                /* ȷæʱʱ */
                isbusy = f_isbusy(u_zcfg.busytime);

                if( isbusy == 0 ) itv = u_zcfg.freeitv;
                else itv = u_zcfg.busyitv;
            }

            if( sleep_itv == -1 || itv < sleep_itv ) sleep_itv = itv;
        }

        /* ʹСĲɼ */
        if( sleep_itv <= 0 )    /* ˳ */
        {
            GC_daemon_end();
            exit(0);
        }

        z_logv(u_logfile, "Sleeping %d ...", sleep_itv);
        sleep(sleep_itv);
    }
}

/************
 ɼʧܴ
 ************/
void f_faildo(int b, int i, int *itv, FILINFO *fi)
{
    char emsg[EMSG_LEN + 1];

    if( b == R_VOID_TYP )
    {
        sprintf(emsg, "󣺲Ч'%c'", u_zcfg.optype);
        f_seterr(emsg, "A003", "APP", 9);
    }
    else if( b == R_RESTART )       /*  */
    {
        sleep(u_zcfg.busyitv);
        exit(0);
    }
    else if( b == R_SUCCESS )       /* ɹ */
    {
        t_retrytimes[i] = 0;
    }
    else if( b < 0 )                /* ʧ */
    {
        t_retrytimes[i] ++;
        if( u_zcfg.retrytimes )
        {
            if( t_retrytimes[i] <= u_zcfg.retrytimes )
                *itv = u_zcfg.retryitv;
            else
                t_retrytimes[i] = 0;
        }
    }

    /* ɼʧܺýű */
    if( b != R_SUCCESS && u_zcfg.failshell[0] ) f_failshell(b, fi);
}

/************
 ȡӲ
 ************/
int f_entry_para(char *spno, char *pList, int nListSize)
{
    int  b, k;
    char szBuf[64], szValue[64];

    if( z_getkeyv(u_zcfgfile, "DIRFSN", u_fsndir, sizeof(u_fsndir) - 1) )
    {
        z_logv(u_logfile, "󣺷ֹ˾ضļļĿ¼ DIRFSN !");
        return(-1);
    }

    if( z_getkeyv(u_zcfgfile, "DIRCFG", u_cfgdir, sizeof(u_cfgdir) - 1) )
    {
        z_logv(u_logfile, "󣺷ֹ˾ضļļĿ¼ DIRCFG !");
        return(-1);
    }

    /* ȡϽĲɼб */
    if( z_getkeyv(u_zcfgfile, spno, pList, nListSize - 1) )
    {
        strcpy(pList, spno);    /* ûжʱٶϽɼ */
    }

    /* ֹ˾ĳɹbreak ־ */
    if( z_getkeyv(u_zcfgfile, "BREAK_ON_OK", szValue, sizeof(szValue) - 1) == 0 )
        u_bBreakOnOK = (int) strtol(szValue, (char **)NULL, 10);

    /* ̵break ־ */
    sprintf(szBuf, "BREAK_ON_OK_%s", spno);

    if( z_getkeyv(u_zcfgfile, szBuf, szValue, sizeof(szValue) - 1) == 0 )
        u_bBreakOnOK = (int) strtol(szValue, (char **)NULL, 10);

    return(0);
}

/************
 װϢ
 ************/
int f_loadcfg(char *pList, int pno, char *pBelong)
{
    int   b, k;

    char *p,
          vno[17],          /* ɼ */
          szBuf[64],
          szBelong[16];

    /* ȡû(ݷֹ˾ȫļ) */
    strcpy(szBuf, z_fnonly(u_zcfgfile));

    p = szBuf;
    z_get_fieldv(&p, szBelong, NULL, sizeof(szBelong) - 1, ".");
    strcpy(pBelong, szBelong);

    p = pList;
    do
    {
        if( u_carecount > MAXN_CARE - 1 )
        {
            z_logv(u_logfile, "ϽɼĿ%d", MAXN_CARE);
            return(-1);
        }

        b = z_get_fieldv(&p, vno, NULL, sizeof(vno) - 1, ",");

        /* ȡϢ */
        memset(&u_zcfg, 0, ZCFG_LEN);

        if( f_cfg_read_ex(&u_zcfg, vno) )
        {
            z_logv(u_logfile, "Ч˳");
            return(-1);
        }

        /*  */
        if( GC_semop(u_semid, SN_LOCATION, -1, 0) < 0 )
        {
            z_logv(u_logfile, "󣺼ʧ");
            return(-1);
        }

        /* λϢλ */
        k = f_cfg_slot(vno);

        /* װϢ */
        if( k >= 0 )
        {
            memcpy(u_cfgs + k, &u_zcfg, ZCFG_LEN);

            u_runs[k].pslot = pno;
            strcpy(u_runs[k].extra, u_zcfgfile);
            u_runs[k].lastseq = -1;

            strncpy(u_runs[k].uname, szBelong, sizeof(u_runs[k].uname) - 1);
            u_runs[k].uname[sizeof(u_runs[k].uname) - 1] = 0;
        }

        /*  */
        if( GC_semop(u_semid, SN_LOCATION, 1, 0) < 0 )
        {
            z_logv(u_logfile, "󣺽ʧ");
            return(-1);
        }

        if( k < 0 )
        {
            z_logv(u_logfile, "޿вλ");
            return(-1);
        }

        u_careslot[u_carecount++] = k;          /* ¼òλ */
    }
    while( b );

    return(0);
}

/**************************
 λϢλ
 ڲchar *pno   
 ֵ  >= 0  λ
           -1    λ
 **************************/
int f_cfg_slot(char *pno)
{
    int i,
        b = 0,
        slot[8];            /* λ־0-ԭλ 1- 2-ֹͣ - */

    slot[0] = slot[1] = slot[2] = -1;

    for( i = 0, u_pcfgs = u_cfgs; i < MAXN_Z; i++, u_pcfgs++ )
    {
        /*  */
        if( u_pcfgs->no[0] == 0 && slot[1] < 0 ) slot[1] = i;

        if( strcmp(u_pcfgs->no, pno) == 0 )     /* ƥ */
        {
            slot[0] = i;
            break;
        }
        else                                    /* ƥ */
        {
            if( slot[2] < 0 )
            {
                /* ֹͣ״̬ */
                b = GC_getstat(NULL, u_runs[i].pslot);

                if( b == ST_FAILED || b == ST_STOPPED || b == ST_RELEASED )
                    slot[2] = i;
            }
        }
    }

    if( slot[0] < 0 && slot[1] < 0 && slot[2] < 0 ) return(-1);

    if( slot[0] >= 0 ) b = slot[0];
    else if( slot[1] >= 0 ) b = slot[1];
    else if( slot[2] >= 0 ) b = slot[2];

    return(b);
}

/**********
 ʼ
 **********/
void f_inittask(int *aseq, char *pBelong)
{
    int i;

    /* ųʼ */
    for( i = 0; i < u_carecount; i++ ) aseq[i] = -1;

    /* 澯ݳʼ */
    for( i = 0; i < MAXN_CARE; i++ )
    {
        memcpy(u_lightwarn[i], u_lightwarnID, sizeof(u_lightwarnID));
    }

    /* ݽṹ */
    u_pNidNormal = &(u_nid_normal.uData.sNormal);
    u_pNidWarn = &(u_nid_warn.uData.sWarn);

    u_nid_normal.cType = NID_T_NORMAL;
    u_nid_warn.cType = NID_T_WARN;

    /* ɼID */
    gethostname(u_pNidWarn->szNodeId, sizeof(u_pNidWarn->szNodeId) - 1);

    /* ֹ˾û */
    strncpy(u_pNidWarn->szBelong, pBelong, sizeof(u_pNidWarn->szBelong) - 1);
    u_pNidWarn->szBelong[sizeof(u_pNidWarn->szBelong) - 1] = 0;
}

/************
 ˢϢ
 ************/
int f_refresh_cfg(int i)
{
    char *p;

    strcpy(u_pNidWarn->szProcId, t_zcfg[i].no);

    /* ԪID */
    p = t_zcfg[i].desc;

    z_get_fieldv(&p, u_pNidWarn->szDeviceId, NULL, sizeof(u_pNidWarn->szDeviceId) - 1, "|");
    z_get_fieldv(&p, u_pNidWarn->szDeviceId, NULL, sizeof(u_pNidWarn->szDeviceId) - 1, "|");

    z_logv(u_logfile, "Ϣ ...");

    if( f_cfg_read_ex(&u_zcfg, t_zcfg[i].no) )
    {
        f_seterr("ˢʧ", "A001", "APP", 9);
        return(-1);
    }

    /*  */
    if( GC_semop(u_semid, SN_LOCATION, -1, 0) < 0 )
    {
        f_seterr("󣺼ʧ");
        return(-1);
    }

    /* װϢ */
    memcpy(u_cfgs + u_careslot[i], &u_zcfg, ZCFG_LEN);

    /*  */
    if( GC_semop(u_semid, SN_LOCATION, 1, 0) < 0 )
    {
        f_seterr("󣺽ʧ");
        return(-1);
    }

    return(0);
}

/************
 Ϣ
 ************/
int f_refresh_seq(int *aseq, int i)
{
    /*  */
    if( GC_semop(u_semid, SN_LOCATION, -1, 0) < 0 )
    {
        f_seterr("󣺼ʧ");
        return(-1);
    }

    u_cfgs[ u_careslot[i] ].seq_refresh = 0;
    u_cfgs[ u_careslot[i] ].seq_to_file = 0;

    /*  */
    if( GC_semop(u_semid, SN_LOCATION, 1, 0) < 0 )
    {
        f_seterr("󣺽ʧ");
        return(-1);
    }

    z_logv(u_logfile, "ļ %d", t_zcfg[i].seq_to_file);

    aseq[i] = t_zcfg[i].seq_to_file;

    if( f_fsn_write(u_fsnfile, aseq[i]) < 0 )
    {
        f_seterr("дļʧ", "O001", "OS", 9);
        return(-1);
    }

    return(0);
}

/******************
 ״̬ʱĴ
 ******************/
int f_notused(int i)
{
    z_logv(u_logfile, "ʾ");

    /*  */
    if( GC_semop(u_semid, SN_LOCATION, -1, 0) < 0 )
    {
        f_seterr("󣺼ʧ");
        return(-1);
    }

    u_cfgs[ u_careslot[i] ].warn_mode[WF_ALL] = '0';    /* رո澯 */

    /*  */
    if( GC_semop(u_semid, SN_LOCATION, 1, 0) < 0 )
    {
        f_seterr("󣺽ʧ");
        return(-1);
    }

    return(0);
}

/**********************************
 ȡϢ
 ڲchar *cfgfile ļ
           ZCFG *t       Ϣṹ
           char *pno     ɼ
 ֵ  0   ɹ
           -1  ļʧ
 **********************************/
int f_cfg_read(char *cfgfile, ZCFG *t, char *pno)
{
    FILE *fp;

    int   r = 0, cfg_seg = 0;
    char  keystr[19], sip[34], suser[34], spass[66], seqscope[34];

    static char buf1[1024];

    /* ļ */
    if( (fp = fopen(cfgfile, "r")) == NULL ) return(-1);

    sprintf(keystr, "[%s]", pno);

    memset(sip, 0, sizeof(sip));                /* IP */
    memset(suser, 0, sizeof(suser));            /* û */
    memset(spass, 0, sizeof(spass));            /*  */
    memset(seqscope, 0, sizeof(seqscope));      /* ŷΧ */

    strcpy(t->no, pno);
    t->warn_mode[WF_ALL] = '1';                 /* ǿƴ򿪸澯 */

    while( ! feof(fp) )
    {
        memset(buf1, 0, sizeof(buf1));
        buf1[sizeof(buf1) - 2] = '\n';

        if( fgets(buf1, sizeof(buf1), fp) == NULL ) break;

        /* й */
        if( buf1[sizeof(buf1) - 2] && buf1[sizeof(buf1) - 2] != '\n' )
        {
            r = -1;
            break;
        }

        z_lrtrim(buf1);
        if( buf1[0] == 0 || buf1[0] == SM_REMARK ) continue;

        if( cfg_seg == 0 )
        {
            if( strcmp(buf1, keystr) == 0 )     /* ɼö */
            {
                cfg_seg = 1;
            }
            continue;
        }
        else if( buf1[0] == SM_INISEG ) break;  /* һ */

        if( strncmp(buf1, "DESCRIPTION", 11) == 0 )             /* ע */
            strncpy(t->desc, buf1 + 11 + 1, sizeof(t->desc) - 1);
        else if( strncmp(buf1, "OPERATION_TYPE", 14) == 0 )     /*  */
            t->optype = *(buf1 + 14 + 1);
        else if( strncmp(buf1, "GATHER_MODE", 11) == 0 )        /* ɼģʽ */
            strncpy(t->gather_mode, buf1 + 11 + 1, sizeof(t->gather_mode) - 1);
        else if( strncmp(buf1, "HOSTIP_PAIR", 11) == 0 )        /* IP */
            strncpy(sip, buf1 + 11 + 1, sizeof(sip) - 1);
        else if( strncmp(buf1, "USER_PAIR", 9) == 0 )           /* û */
            strncpy(suser, buf1 + 9 + 1, sizeof(suser) - 1);
        else if( strncmp(buf1, "PASSWORD_PAIR", 13) == 0 )      /*  */
            strncpy(spass, buf1 + 13 + 1, sizeof(spass) - 1);
        else if( strncmp(buf1, "ENCRYPTION", 10) == 0 )         /* ʽ */
            t->encryption = (int) strtol(buf1 + 10 + 1, (char **)NULL, 10);
        else if( strncmp(buf1, "SOURCE_PATTERN", 14) == 0 )     /* ģʽ */
            strncpy(t->src_fn_pattern, buf1 + 14 + 1, sizeof(t->src_fn_pattern) - 1);
        else if( strncmp(buf1, "SIZE_COL", 8) == 0 )            /* 'С'б */
            t->size_col = (int) strtol(buf1 + 8 + 1, (char **)NULL, 10);
        else if( strncmp(buf1, "SOURCE_NAME_FILTER", 18) == 0 ) /* ʽ */
            strncpy(t->src_regex, buf1 + 18 + 1, sizeof(t->src_regex) - 1);
        else if( strncmp(buf1, "SOURCE_MOVEDEL", 14) == 0 )     /* Դɾƶ־ */
            t->src_bakflag = (int) strtol(buf1 + 14 + 1, (char **)NULL, 10);
        else if( strncmp(buf1, "SOURCE_PATH", 11) == 0 )        /* Դ· */
            strncpy(t->src_path, buf1 + 11 + 1, sizeof(t->src_path) - 1);
        else if( strncmp(buf1, "SOURCE_BACKUP_PATH", 18) == 0 ) /* Դ· */
            strncpy(t->src_bpath, buf1 + 18 + 1, sizeof(t->src_bpath) - 1);
        else if( strncmp(buf1, "DEST_PATH", 9) == 0 )           /* Ŀ· */
            strncpy(t->dst_path, buf1 + 9 + 1, sizeof(t->dst_path) - 1);
        else if( strncmp(buf1, "DEST_NAME_FORMAT", 16) == 0 )   /* Ŀתģʽ */
            strncpy(t->dst_format, buf1 + 16 + 1, sizeof(t->dst_format) - 1);
        else if( strncmp(buf1, "BUSY_TIME", 9) == 0 )           /* æʱʱ */
            strncpy(t->busytime, buf1 + 9 + 1, sizeof(t->busytime) - 1);
        else if( strncmp(buf1, "BUSY_INTERVAL", 13) == 0 )      /* æʱɼ */
            t->busyitv = (int) strtol(buf1 + 13 + 1, (char **)NULL, 10);
        else if( strncmp(buf1, "FREE_INTERVAL", 13) == 0 )      /* ʱɼ */
            t->freeitv = (int) strtol(buf1 + 13 + 1, (char **)NULL, 10);
        else if( strncmp(buf1, "WARN_MODE", 9) == 0 )           /* 澯ģʽ */
            strncpy(t->warn_mode + 1, buf1 + 9 + 1, sizeof(t->warn_mode) - 1);
        else if( strncmp(buf1, "NOFILE_LIMIT", 12) == 0 )       /* ļ澯ʱ */
            t->nofile_limit = (int) strtol(buf1 + 12 + 1, (char **)NULL, 10);
        else if( strncmp(buf1, "FILE_ANALYZER", 13) == 0 )      /* ļ */
            strncpy(t->file_analyzer, buf1 + 13 + 1, sizeof(t->file_analyzer) - 1);
        else if( strncmp(buf1, "SEQUENCE_CONTROL", 16) == 0 )   /* ſ */
            t->seq_ctrl = (int) strtol(buf1 + 16 + 1, (char **)NULL, 10);
        else if( strncmp(buf1, "SEQUENCE_SCOPE", 14) == 0 )     /* ŷΧ */
            strncpy(seqscope, buf1 + 14 + 1, sizeof(seqscope) - 1);
        else if( strncmp(buf1, "SEQUENCE_SYNC", 13) == 0 )      /* Ƿͬ */
            t->seq_sync = (int) strtol(buf1 + 13 + 1, (char **)NULL, 10);
        else if( strncmp(buf1, "FTP_TIMEOUT", 11) == 0 )        /* FTP ʱʱ */
            t->ftp_timeout = (int) strtol(buf1 + 11 + 1, (char **)NULL, 10);
        else if( strncmp(buf1, "RECORD_SIZE", 11) == 0 )        /* ¼ĴС */
            t->record_size = (int) strtol(buf1 + 11 + 1, (char **)NULL, 10);
        else if( strncmp(buf1, "FTP_RESUME", 10) == 0 )         /* FTP ϵ־ */
            t->ftp_resume = (int) strtol(buf1 + 10 + 1, (char **)NULL, 10);
        else if( strncmp(buf1, "FTP_PASSIVE", 11) == 0 )        /* FTP ģʽ */
            t->ftp_passive = (int) strtol(buf1 + 11 + 1, (char **)NULL, 10);
        else if( strncmp(buf1, "EXTRACOPY", 9) == 0 )           /* ⿽ */
            t->extracopy = (int) strtol(buf1 + 9 + 1, (char **)NULL, 10);
        else if( strncmp(buf1, "RETRY_TIMES", 11) == 0 )        /* ʧܳԴ */
            t->retrytimes = (int) strtol(buf1 + 11 + 1, (char **)NULL, 10);
        else if( strncmp(buf1, "RETRY_INTERVAL", 14) == 0 )     /* ʧܳԼ */
            t->retryitv = (int) strtol(buf1 + 14 + 1, (char **)NULL, 10);
        else if( strncmp(buf1, "FTPPORT", 7) == 0 )             /* FTP ˿ */
            t->ftpport = (int) strtol(buf1 + 7 + 1, (char **)NULL, 10);
        else if( strncmp(buf1, "ATTACH_FILE", 11) == 0 )        /* ļ */
            strncpy(t->attachfile, buf1 + 11 + 1, sizeof(t->attachfile) - 1);
        else if( strncmp(buf1, "REMOTE_BAK_TIMES", 16) == 0 )   /* Զ̱ݳԴ */
            t->rmtbak_times = (int) strtol(buf1 + 16 + 1, (char **)NULL, 10);
        else if( strncmp(buf1, "OK_SHELL", 8) == 0 )            /* ɹõĽű */
            strncpy(t->okshell, buf1 + 8 + 1, sizeof(t->okshell) - 1);
        else if( strncmp(buf1, "FAIL_SHELL", 10) == 0 )         /* ʧܺõĽű */
            strncpy(t->failshell, buf1 + 10 + 1, sizeof(t->failshell) - 1);
        else if( strncmp(buf1, "PREPARE_SHELL", 13) == 0 )      /* ϴǰ׼ű */
            strncpy(t->preshell, buf1 + 13 + 1, sizeof(t->preshell) - 1);
        else if( strncmp(buf1, "SIZE_SHELL", 10) == 0 )         /* ȡļСĽű */
            strncpy(t->sizeshell, buf1 + 10 + 1, sizeof(t->sizeshell) - 1);
        else if( strncmp(buf1, "DATA_SHELL", 10) == 0 )         /* ű */
            strncpy(t->datashell, buf1 + 10 + 1, sizeof(t->datashell) - 1);
        else if( strncmp(buf1, "RENAME_SHELL", 12) == 0 )      /* ű */
            strncpy(t->mvshell, buf1 + 12 + 1, sizeof(t->mvshell) - 1);

        /*
         * else if( strncmp(buf1, "ENABLE_TIME", 11) == 0 )        ** Чʱ **
         *     strncpy(t->enable_time, buf1 + 11 + 1, 14);
         * else if( strncmp(buf1, "EXPIRE_TIME", 11) == 0 )        ** ʧЧʱ **
         *     strncpy(t->expire_time, buf1 + 11 + 1, 14);
         */

        else if( strncmp(buf1, "STATUS", 6) == 0 )              /* Ƿ */
            t->status = (int) strtol(buf1 + 6 + 1, (char **)NULL, 10);
    }
    fclose(fp);

    if( r < 0 ) return(-1);                     /* й */
    if( cfg_seg == 0 ) return(-17);

    return( f_cfgcheck(t, sip, suser, spass, seqscope) );
}

/************
 ò
 ************/
int f_cfgcheck(ZCFG *t, char *sip, char *suser, char *spass, char *seqscope)
{
    int    r, nread;
    char  *p, ch, s2[2], seqmin[17], seqmax[17];

    static char szPath[1024];

    if( sip[0] == 0 ) return(-4);

    p = sip;
    nread = 0;

    z_get_fieldv(&p, t->host[0], &nread, sizeof(t->host[0]) - 1, ",");
    z_get_fieldv(&p, t->host[1], &nread, sizeof(t->host[1]) - 1, ",");

    if( suser[0] == 0 ) return(-5);

    p = suser;
    nread = 0;

    z_get_fieldv(&p, t->user[0], &nread, sizeof(t->user[0]) - 1, ",");
    z_get_fieldv(&p, t->user[1], &nread, sizeof(t->user[1]) - 1, ",");

    if( spass[0] == 0 ) return(-6);
    if( t->encryption != 0 && t->encryption != 1 ) return(-21);

    p = spass;
    nread = 0;

    z_get_fieldv(&p, t->pass[0], &nread, sizeof(t->pass[0]) - 1, ",");
    z_get_fieldv(&p, t->pass[1], &nread, sizeof(t->pass[1]) - 1, ",");

    /* ޳Ŀ¼β'/'
     * if( t->src_path[ strlen(t->src_path) - 1 ] == '/' && t->src_path[1] )
     *     t->src_path[ strlen(t->src_path) - 1 ] = 0;

     * if( t->src_bpath[ strlen(t->src_bpath) - 1 ] == '/' && t->src_bpath[1] )
     *     t->src_bpath[ strlen(t->src_bpath) - 1 ] = 0;

     * if( t->dst_path[ strlen(t->dst_path) - 1 ] == '/' && t->dst_path[1] )
     *     t->dst_path[ strlen(t->dst_path) - 1 ] = 0;
     */

    if( t->src_path[0] == 0 ) return(-7);
    if( t->dst_path[0] == 0 ) return(-8);
    if( t->busyitv <= 0 ) return(-9);
    if( t->freeitv <= 0 ) t->freeitv = t->busyitv;

    /* ؼ */
    if( t->seq_ctrl || t->warn_mode[WF_SEQBREAK] == '1' )
    {
        p = t->src_fn_pattern;

        if( *p == 0 || strchr(p, '*') ) return(-31);

        p = seqscope;
        if( *p == 0 ) return(-34);

        nread = 0;
        memset(seqmin, 0, sizeof(seqmin));
        memset(seqmax, 0, sizeof(seqmax));

        s2[0] = SM_SEQHYPHEN; s2[1] = 0;
        z_get_fieldv(&p, seqmin, &nread, sizeof(seqmin) - 1, s2);
        z_get_fieldv(&p, seqmax, &nread, sizeof(seqmax) - 1, s2);

        if( seqmin[0] == 0 || z_adigit(seqmin) == 0 ||
            seqmax[0] == 0 || z_adigit(seqmax) == 0 )
        {
            return(-34);
        }

        t->seq_length = strlen(seqmin);
        r = strlen(seqmax);

        if( t->seq_length != r ) return(-32);   /* ֶֻ֧ */

        /* ͳռλĿ */
        p = t->src_fn_pattern;
        nread = 0;

        while( *p )
        {
            if( *(p++) == SM_SEQHOLDER ) nread++;
        }

        if( nread != t->seq_length ) return(-33);

        t->seq_min = (int) strtol(seqmin, (char **)NULL, 10);
        t->seq_max = (int) strtol(seqmax, (char **)NULL, 10);

        if( t->seq_min < 0 || t->seq_max < 0 || t->seq_min > t->seq_max ) return(-34);
    }

    /* ֤Դļɾ־ĺϷ */
    if( t->src_bakflag < BF_NONE || t->src_bakflag > BF_MOVE ) return(-10);

    /* "ȡ"֤Ŀ·ĺϷ */
    if( toupper(t->optype) == SM_FTPGET ||
        toupper(t->optype) == SM_FTPNOKIA ||
        toupper(t->optype) == SM_FTAM )
    {
        if( strchr(t->dst_path, SM_PATH_DATE) == NULL )         /* ڸʽ */
        {
            r = z_valid_dir(t->dst_path);

            if( r < 0 ) return(-11);
            else
            {
                ch = (char) r;
                if( (ch & 0x1) != 0x1 || (ch & 0x2) != 0x2 ) return(-12);
            }
        }
    }
    else if( toupper(t->optype) == SM_FTPPUT ||
        toupper(t->optype) == SM_SHELLPUT )
    {
        /* ""֤Դ·ĺϷ */
        r = z_valid_dir(t->src_path);

        if( r < 0 ) return(-13);
        else
        {
            ch = (char) r;
            if( (ch & 0x1) != 0x1 || (ch & 0x4) != 0x4 ) return(-14);

            if( t->src_bakflag == BF_DELETE || t->src_bakflag == BF_MOVE )
            {
                if( (ch & 0x2) != 0x2 ) return(-14);            /* "д"Ȩ */
            }
        }

        /* ƶʱ֤·ĺϷ */
        if( t->src_bakflag == BF_MOVE )
        {
            if( strchr(t->src_bpath, SM_PATH_DATE) == NULL )    /* ڸʽ */
            {
                r = z_valid_dir(t->src_bpath);

                if( r < 0 ) return(-15);
                else
                {
                    ch = (char) r;
                    if( (ch & 0x1) != 0x1 || (ch & 0x2) != 0x2 ) return(-16);
                }
            }
        }
    }

    /* űִȨ */
    if( t->attachfile[0] )
    {
        snprintf(szPath, sizeof(szPath), "%s/%s", u_plugdir, t->attachfile);
        if( access(szPath, R_OK | X_OK) < 0 ) return(-100);
    }

    if( t->okshell[0] )
    {
        snprintf(szPath, sizeof(szPath), "%s/%s", u_plugdir, t->okshell);
        if( access(szPath, R_OK | X_OK) < 0 ) return(-101);
    }

    if( t->failshell[0] )
    {
        snprintf(szPath, sizeof(szPath), "%s/%s", u_plugdir, t->failshell);
        if( access(szPath, R_OK | X_OK) < 0 ) return(-102);
    }

    if( t->preshell[0] )
    {
        snprintf(szPath, sizeof(szPath), "%s/%s", u_plugdir, t->preshell);
        if( access(szPath, R_OK | X_OK) < 0 ) return(-103);
    }

    if( t->sizeshell[0] )
    {
        snprintf(szPath, sizeof(szPath), "%s/%s", u_plugdir, t->sizeshell);
        if( access(szPath, R_OK | X_OK) < 0 ) return(-104);
    }

    if( t->datashell[0] )
    {
        snprintf(szPath, sizeof(szPath), "%s/%s", u_plugdir, t->datashell);
        if( access(szPath, R_OK | X_OK) < 0 ) return(-105);
    }

    if( t->mvshell[0] )
    {
        snprintf(szPath, sizeof(szPath), "%s/%s", u_plugdir, t->mvshell);
        if( access(szPath, R_OK | X_OK) < 0 ) return(-106);
    }

    if( t->optype == SM_SHELLPUT && t->datashell[0] == 0 ) return(-107);

    return(0);
}

/**************************************
 ȡļʾϢ
 ڲZCFG *t     Ϣṹ
           char *pno   ɼ
 ֵ  0-ɹ  0-ʧ
 **************************************/
int f_cfg_read_ex(ZCFG *t, char *pno)
{
    int  r;
    char cfgfile[CL];

    snprintf(cfgfile, sizeof(cfgfile), "%s/%s%s", u_cfgdir, pno, CFGSUFFIX);

    r = f_cfg_read(cfgfile, t, pno);

    if( t->ftp_timeout <= 0 ) t->ftp_timeout = u_paras->ftp_timeout;
    if( t->ftpport <= 0 ) t->ftpport = u_paras->ftpport;

    switch( r )
    {
    case 0:
        return(0);

    case -1:
        z_logv(u_logfile, "󣺲ɼļ '%s' ʧ", cfgfile);
        break;

    case -2:
        z_logv(u_logfile, "ȱٶ䶨");
        break;

    case -4:
        z_logv(u_logfile, "IP");
        break;

    case -5:
        z_logv(u_logfile, "û");
        break;

    case -6:
        z_logv(u_logfile, "");
        break;

    case -21:
        z_logv(u_logfile, "ʽ '%d' Ч", t->encryption);
        break;

    case -7:
        z_logv(u_logfile, "Դ·");
        break;

    case -8:
        z_logv(u_logfile, "Ŀ·");
        break;

    case -9:
        z_logv(u_logfile, "%d, %d ɼЧ", t->busyitv, t->freeitv);
        break;

    case -10:
        z_logv(u_logfile, "Դļɾƶ־ '%d' Ч", t->src_bakflag);
        break;

    case -11:
        z_logv(u_logfile, "Ŀ· '%s' Ч", t->dst_path);
        break;

    case -12:
        z_logv(u_logfile, "Ŀ· '%s' Ȩ޲", t->dst_path);
        break;

    case -13:
        z_logv(u_logfile, "Դ· '%s' Ч", t->src_path);
        break;

    case -14:
        z_logv(u_logfile, "Դ· '%s' Ȩ޲", t->src_path);
        break;

    case -15:
        z_logv(u_logfile, "󣺱· '%s' Ч", t->src_bpath);
        break;

    case -16:
        z_logv(u_logfile, "󣺱· '%s' Ȩ޲", t->src_bpath);
        break;

    case -17:
        z_logv(u_logfile, "ָĲɼ [%s] ", pno);
        break;

    case -31:
        z_logv(u_logfile, "ſʱԴģʽвʹ*ֻʹ%c%c", SM_HOLDER, SM_SEQHOLDER);
        break;

    case -32:
        z_logv(u_logfile, "СųȲһ");
        break;

    case -33:
        z_logv(u_logfile, "Դģʽռλ%c ĿųȲһ", SM_SEQHOLDER);
        break;

    case -34:
        z_logv(u_logfile, "ŷΧǷ");
        break;

    case -100:
        z_logv(u_logfile, "󣺸ļűִ");
        break;

    case -101:
        z_logv(u_logfile, "󣺳ɹűִ");
        break;

    case -102:
        z_logv(u_logfile, "ʧܽűִ");
        break;

    case -103:
        z_logv(u_logfile, "ϴǰ׼űִ");
        break;

    case -104:
        z_logv(u_logfile, "󣺻ȡļСĽűִ");
        break;

    case -105:
        z_logv(u_logfile, "󣺴űִ");
        break;

    case -106:
        z_logv(u_logfile, "űִ");
        break;

    case -107:
        z_logv(u_logfile, "SHELLűûж");
        break;

    default:
        z_logv(u_logfile, "Ϣȡʧ");
        break;
    }

    return(1);
}

/************************
 ʱȡǰ
 ************************/
int f_init_seq(int *iseq)
{
    int b = 0, f_err = 0;

    b = f_fsn_read(u_fsnfile, iseq);

    if( b < 0 )
    {
        f_err = -1;
    }
    else if( b == 0 )
    {
        if( *iseq < u_zcfg.seq_min || *iseq > u_zcfg.seq_max ) f_err = -1;
    }
    else if( b == 1 )       /* δ */
    {
        if( u_zcfg.seq_ctrl == 1 ) f_err = -1;
        else f_err = 1;
    }

    return(f_err);
}

/**************************
 ϴβɼʱ
 **************************/
int f_set_endtime(void)
{
    if( GC_semop(u_semid, SN_LOCATION, -1, 0) < 0 ) return(-1);

    if( u_pruns->endtime == 0 ) u_pruns->endtime = time( (time_t *) 0 );

    if( GC_semop(u_semid, SN_LOCATION, 1, 0) < 0 ) return(-1);

    return(0);
}
