/***********************************************************************
*
* ļ        SharedData.h
* ģĿģʱ洢ڡ߳
* ߼ڣ  wang_jin 2008-05-31
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#ifndef SharedData_H
#define SharedData_H


#include <stdio.h>
#ifdef _WIN32
#	include <windows.h>
#else
#	include <pthread.h>
#endif
#include "Common/Common.h"


#if defined(_WIN32)
	#if defined(SHAREDDATA_EXPORTS)
		#define SHAREDDATA_API __declspec(dllexport)
	#else
		#define SHAREDDATA_API __declspec(dllimport)	
	#endif
#endif

#if !defined(SHAREDDATA_API)
	#define SHAREDDATA_API
#endif


#ifdef WIN32
#	define THREADKEY unsigned long
#else
#	define THREADKEY pthread_t
#endif


typedef struct process_data
{
	char sProcName[32]; // 
	
	char sModulePath[ GD_MAX_PATH ];		// ·

}	ProcessData, *PProcessData;


typedef struct thread_data
{
    long nThreadId;		// ߳Id
    long nSerial;		// ҵ
    long nSubSerial;	// ҵ
    long nRecSerial;	// 
    long nIndent;		// 

    char sIp[16];		// Զ̵IP
    char sPort[16];		// Զ̵Port
}	ThreadData, *PThreadData;


#ifdef __cplusplus


class SHAREDDATA_API CSharedData
{
public:
	CSharedData();
	~CSharedData();

public:
	static void SetProcessData( PProcessData pData );
	static PProcessData GetProcessData();

public:
	static void SetThreadData( THREADKEY id, PThreadData pData );
	static PThreadData GetThreadData( THREADKEY id );

};

#else

SHAREDDATA_API void SetProcessData( void* pData );
SHAREDDATA_API void GetProcessData( void* pData );

#endif


#endif
