/********************
 FTP Э飬NOKIA ɼ
 ********************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>
#include <errno.h>
#include <sys/stat.h>
#include "zvar.h"
#include "gcps.h"
#include "z.h"

#define   SCOF          "TTSCOF00.IMG"      /* 洢ļ */
#define   TCOF          "TTTCOF00.IMG"      /* ļ */
#define   FHEAD         "CF"                /* ļǰ׺ */
#define   FTAIL         ".DAT"              /* ļƺ׺ */

#define   MINN_FSEQ     1                   /* ԣСļ */
#define   SIZE_RECORD   8176                /* ԣ¼ĴС */
#define   MAXN_BATCH    300                 /* ÿȡļĿ */

/* BCD  => ַ */
void n_bcd2s(char *t, char *s, int l);

/* ַ => BCD  */
void n_s2bcd(char *t, char *s);

/* ɼļ */
int n_getctl(int ftpfd, char *filesco, char *filetco, char *outbuf);

/* ļңȡɼļϢ */
int n_flist(char *file, int start_no, char *maxtmstr);

/* д봫ļԱش */
int n_wfctl(char *file, int n, char *maxtmstr);

typedef struct s_nokia
{
    int        no;
    char       stat;                        /* ļ״̬Ϣ(1ֽ) */
    char       timestr[15];                 /* ת, ʱʶ */
    char       storage;                     /* 洢״̬־(1ֽ) */
} NOKIA;

static NOKIA   t_flist[MAXN_BATCH];         /* ļб */

/*********************************
 ڲint *iseq  ϴļ
 ֵ  0    ɹ
           -1   ʧ
           -2   FTP ʧ
           -3   ʧ
 *********************************/
int f_nokia(int *iseq)
{
    int    i, j, b,
           f_err = 0,                       /* ʧܱ־ */
           fcount = 0,                      /* ɼļĿ */
           ftpfd = -1;                      /* ftp  */

    long   fsize;                           /* ļС */

    static int mid0num = 0;                 /* ļĿ */
    static int lastseq = -1;                /* һļ */

    char   maxtmstr[16],
           seqstr[17],                      /* ǰŵַʾ */
           rfname[CL],
           lfname[CL],                      /* ļ(·) */

           filesco[CL], filetco[CL],        /* ļ */
           midfile[CL], currfile[CL],       /* ļ */
           dtpath[CL],                      /* תڸʽ· */
          *pDstPath,

          *ppath,
           zout[CL],                        /* FTP Ϣļ */
           hdftime[21],                     /* ʱ */
           emsgtmp[EMSG_LEN + 1],           /* ʱ־Ϣ */
           emsg[EMSG_LEN + 1];              /* ־Ϣ */

    static char buf1[1024];
    struct stat statbuf;

    /* ֵ */
    snprintf(filesco, sizeof(filesco), "%s/%s.%s", u_logdir, SCOF, u_zcfg.no);
    snprintf(filetco, sizeof(filetco), "%s/%s.%s", u_logdir, TCOF, u_zcfg.no);
    snprintf(zout, sizeof(zout), "%s/%s%s%s", u_logdir, OUTPREFIX, u_zcfg.no, OUTSUFFIX);

    /* ӲɼԴ */
    if( (ftpfd = f_conn_server(NULL, NULL, zout, t_ftpbuf1)) < 0 ) return(R_LOGONFAIL);

    /*  */
    if( ftpfd > 64 )
    {
        z_logv(u_logfile, "ftpfd > 64");
        return(R_RESTART);
    }

    /* ɼļ */
    b = n_getctl(ftpfd, filesco, filetco, t_ftpbuf1);

    if( b )
    {
        close(ftpfd);

        if( b > 0 )
        {
            z_rtrim(t_ftpbuf1);
            z_logv(zout, t_ftpbuf1);
            return(-2);
        }
        else
            return(-3);
    }

    /* ļ */
    memset(maxtmstr, 0, sizeof(maxtmstr));

    b = (*iseq + 1) > u_zcfg.seq_max ? MINN_FSEQ : (*iseq + 1);
    if( b < MINN_FSEQ ) b = MINN_FSEQ;

z_logv(u_logfile, "start_no=%d", b);

    if( (fcount = n_flist(filesco, b, maxtmstr)) < 0 )
    {
        snprintf(emsg, sizeof(emsg), "ļ'%s'", filesco);
        f_seterr(emsg, "A200", "APP", 6);

        close(ftpfd);
        return(-3);
    }
    z_logv(u_logfile, maxtmstr);

    if( fcount == 0 )               /* ļ澯Ϣ */
    {
        f_set_ok(NULL, NULL, "");
        close(ftpfd);
        return(0);
    }

    for( i = 0; i < fcount; i++ )
    {
        f_err = 0;

        /* sprintf(fstr, "%s%0*d%s", FHEAD, u_zcfg.seq_length, t_flist[i].no, FTAIL); */

        sprintf(seqstr, "%0*d", u_zcfg.seq_length, t_flist[i].no);
        f_seq2name(seqstr, rfname);

        /* ȡļС */
        fsize = 0;

        if( (fsize = GC_ftp_size(ftpfd, rfname, t_ftpbuf1)) < 0 )
        {
            z_rtrim(t_ftpbuf1);
            z_logv(zout, t_ftpbuf1);
            f_seterr("ȡԶļСʧ", "A007", "APP", 6);

            f_err = -2;
            break;
        }

        if( u_zcfg.record_size > 0 && (fsize % u_zcfg.record_size) )
        {
            sprintf(emsg, "ļС%ld, ", fsize);
            f_seterr(emsg, "A201", "APP", 6);
            f_err = -3;
            break;
        }

        /* Ŀļ */
        if( (b = f_nametr(rfname, u_zcfg.dst_format, lfname)) < 0 )
        {
            sprintf(emsg, "'%s' Ŀתʧ=%d", u_zcfg.dst_format, b);
            f_seterr(emsg, "A010", "APP", 9);
            f_err = -3;
            break;
        }

        /* ڸʽĿ· */
        if( strchr(u_zcfg.dst_path, SM_PATH_DATE) )
        {
            if( f_dtpath_local(u_zcfg.dst_path, dtpath) < 0 )
            {
                f_seterr("Ŀ·ʧ", "A011", "APP", 9);
                f_err = -3;
                break;
            }

            pDstPath = dtpath;
            snprintf(currfile, sizeof(currfile), "%s/%s", dtpath, lfname);
            snprintf(midfile, sizeof(midfile), "%s/tmp.%s.tmp", dtpath, lfname);
        }
        else
        {
            pDstPath = u_zcfg.dst_path;
            snprintf(currfile, sizeof(currfile), "%s/%s", u_zcfg.dst_path, lfname);
            snprintf(midfile, sizeof(midfile), "%s/tmp.%s.tmp", u_zcfg.dst_path, lfname);
        }

        z_logv(u_logfile, "Remote=%s, %s, %d", rfname, t_flist[i].timestr, t_flist[i].storage);
        z_logv(u_logfile, "Local=%s", lfname);

        /* ⿽· */
        for( j = 0; j < u_zcfg.extracopy; j++ )
        {
            snprintf(buf1, sizeof(buf1), "%s/%s%d", pDstPath, COPYPREFIX, j + 1);

            if( stat(buf1, &statbuf) < 0 && mkdir(buf1, NEWDIRMODE) < 0 )
            {
                f_seterr("⿽·ʧ", "A011", "APP", 9);
                f_err= -3;
                break;
            }
        }
        if( f_err < 0 ) break;

        /* 洢״̬ */
        ppath = NULL;

        if( (t_flist[i].storage & 0x1) == 1 ) ppath = u_zcfg.src_path;
        else if( (t_flist[i].storage & 0x2) == 2 ) ppath = u_zcfg.src_bpath;

        /* Զ̹Ŀ¼ */
        if( GC_ftp_cd(ftpfd, ppath, t_ftpbuf1) < 0 )
        {
            z_rtrim(t_ftpbuf1);
            z_logv(zout, t_ftpbuf1);

            snprintf(emsg, sizeof(emsg), "Զ·'%s'", ppath);
            f_seterr(emsg, "A006", "APP", 9);

            f_err = -2;
            break;
        }

/* ----------------------------------------------------------------- */

        /* ϴβɼʼʱ */
        u_pruns->begtime = time( (time_t *) 0 );

        /* ɼļ */
        z_logv(u_logfile, "Getting ...");

        gettimeofday(&(u_pNidNormal->tStartTv), NULL);

        if( GC_ftp_get(ftpfd, rfname, midfile, t_ftpbuf1) < 0 )
        {
            z_rtrim(t_ftpbuf1);
            z_logv(zout, t_ftpbuf1);
            f_seterr("ɼļʧ", "A008", "APP", 6);

            f_err = -2;
            break;
        }
        z_logv(u_logfile, "done");

        gettimeofday(&(u_pNidNormal->tEndTv), NULL);

        /* ļ */
        memset(&statbuf, 0, sizeof(statbuf));

        if( stat(midfile, &statbuf) < 0 )
        {
            f_seterr("ȡļ״̬ʧ", "O004", "OS", 9);
            f_err = -3;
            break;
        }
        if( statbuf.st_size != fsize )
        {
            sprintf(emsg, "Զ%ld. %ld. Сһ", fsize, (long) (statbuf.st_size));

            if( statbuf.st_size < fsize )
                strcat(emsg, "ļϵͳռ");

            if( statbuf.st_size < fsize )
                f_seterr(emsg, "A009", "APP", 6);
            else
                z_logv(u_logfile, emsg);

            f_err = -3;
            break;
        }

        if( rename(midfile, currfile) < 0 )
        {
            z_logv(u_logfile, "'%s' -> '%s' ļʧ", midfile, currfile);
            f_seterr("ļʧ", "O003", "OS", 9);
            f_err = -3;
            break;
        }

        /* link⿽ */
        for( j = 0; j < u_zcfg.extracopy; j++ )
        {
            snprintf(buf1, sizeof(buf1), "%s/%s%d/%s", pDstPath, COPYPREFIX, j + 1, lfname);
            unlink(buf1);

            if( link(currfile, buf1) < 0 )
            {
                f_seterr("Ӷ⿽ļʧ", "A011", "APP", 9);
                f_err= -3;
                break;
            }
        }
        if( f_err < 0 ) break;

        /* ͨʱ */
        sprintf(hdftime, "%8.8s %2.2s:%2.2s:%2.2s",
            t_flist[i].timestr, t_flist[i].timestr + 8,
            t_flist[i].timestr + 10, t_flist[i].timestr + 12);

        /* 澯Ϣ */
        emsg[0] = 0;

        /* ļ */
        if( u_zcfg.seq_ctrl == 1 )
        {
            if( *iseq < u_zcfg.seq_max )
                (*iseq) ++;
            else
                *iseq = MINN_FSEQ;
        }
        else if( u_zcfg.warn_mode[WF_SEQBREAK] == '1' )
        {
            /* ޸ļ */
            *iseq = t_flist[i].no;

            /* Լ */
            if( lastseq >= 0 )
            {
                b = *iseq - lastseq;

                if( b <= 0 )
                {
                    b += (u_zcfg.seq_max - MINN_FSEQ + 1);
                }

                if( b != 1 )
                {
                    sprintf(emsg, "棺ϴ%d", lastseq);
                    z_logv(u_logfile, emsg);
                    f_setnid(emsg, "A017", "APP", 9);
                }
            }

            lastseq = *iseq;
        }

        /* ļ澯 */
        if( fsize )
        {
            mid0num = 0;
        }
        else
        {
            mid0num ++;

            if( u_zcfg.warn_mode[WF_ZERO] == '1' )
            {
                sprintf(emsgtmp, "棺ļСΪ0Ŀ%d", mid0num);
                z_logv(u_logfile, emsgtmp);
                f_setnid(emsgtmp, "A018", "APP", 9);
                if( emsg[0] == 0 ) strcpy(emsg, emsgtmp);
            }
        }

        /* Իӳٵĸ澯 */
        if( hdftime[0] )
        {
            f_delay_warn(hdftime, emsg[0] == 0 ? emsg : NULL);
        }

        /* ɹ״̬ */
        if( f_set_ok(lfname, hdftime, emsg) < 0 )
        {
            f_seterr("ʧ");
            f_err = -1;
            break;
        }

        /* ¼ܼ */
        strncpy(u_pNidNormal->szFileName, lfname, sizeof(u_pNidNormal->szFileName) - 1);
        u_pNidNormal->szFileName[sizeof(u_pNidNormal->szFileName) - 1] = 0;
        u_pNidNormal->iFileSize = fsize;
        strcpy(u_pNidWarn->szFileName, u_pNidNormal->szFileName);

        f_nidlog(&u_nid_normal);

        z_logv(u_logfile, "Size=%ld", fsize);
        z_logv(u_logfile, "Ok!");
    }

    if( f_err < 0 )
    {
        close(ftpfd);   /* ر */
        ftpfd = -1;
        return(f_err);
    }

    /* شļ */
    if( u_zcfg.src_bakflag != BF_NONE )
    {
        if( n_wfctl(filetco, fcount, maxtmstr) < 0 )
        {
            snprintf(emsg, sizeof(emsg), "дļ'%s'", filetco);
            f_seterr(emsg, "O008", "OS", 9);

            close(ftpfd);
            return(-3);
        }

        /* γ */
        for( i = 0; i < 2; i++ )
        {
            z_logv(u_logfile, "Putting TCO ...");

            if( GC_ftp_put(ftpfd, filetco, TCOF, t_ftpbuf1) < 0 )
            {
                z_rtrim(t_ftpbuf1);
                z_logv(zout, t_ftpbuf1);
                z_logv(u_logfile, "شļʧ");
            }
            else
            {
                z_logv(u_logfile, "done");
                break;
            }

            sleep(3);
        }

        if( i == 2 )
        {
            close(ftpfd);
            return(-2);
        }
    }

    close(ftpfd);

    /* дļ */
    if( u_zcfg.seq_ctrl == 1 || u_zcfg.warn_mode[WF_SEQBREAK] == '1' )
    {
        if( f_fsn_write(u_fsnfile, *iseq) < 0 )
        {
            f_seterr("дļʧ", "O001", "OS", 9);
            return(-3);
        }
    }

    /* FTP  */
    if( u_zcfg.seq_ctrl == 1 || u_zcfg.warn_mode[WF_SEQBREAK] == '1' )
    {
        if( u_zcfg.seq_sync && f_fsn_rz(t_ftpbuf1) < 0 )
        {
            z_rtrim(t_ftpbuf1);
            z_logv(zout, t_ftpbuf1);
            z_logv(u_logfile, "ϵͳļʧ");
        }
    }

    return(0);
}

/**************************
 ɼļ
 ֵ  0   ɹ
           -1  زʧ
           1   FTP ʧ
 **************************/
int n_getctl(int ftpfd, char *filesco, char *filetco, char *outbuf)
{
    long   fsize = 0;

    char   midfile[CL],                     /* ʱļ */
           emsg[EMSG_LEN + 1];              /* ־Ϣ */

    struct stat statbuf;

    /* Զ̹Ŀ¼ */
    if( GC_ftp_cd(ftpfd, u_zcfg.src_path, outbuf) < 0 )
    {
        snprintf(emsg, sizeof(emsg), "Զ·'%s'", u_zcfg.src_path);
        f_seterr(emsg, "A006", "APP", 9);
        return(1);
    }

    /* ȡļС */
    if( (fsize = GC_ftp_size(ftpfd, SCOF, outbuf)) < 0 )
    {
        f_seterr("ȡļСʧ", "A007", "APP", 9);
        return(1);
    }

    z_logv(u_logfile, "Getting SCO ...");
    snprintf(midfile, sizeof(midfile), "%s.tmp", filesco);

    if( GC_ftp_get(ftpfd, SCOF, midfile, outbuf) < 0 )
    {
        z_logv(u_logfile, "ɼļʧ");
        return(1);
    }
    z_logv(u_logfile, "done");

    /* ļ */
    memset(&statbuf, 0, sizeof(statbuf));

    if( stat(midfile, &statbuf) < 0 )
    {
        f_seterr("ȡļ״̬ʧ", "O004", "OS", 9);
        return(-1);
    }
    if( statbuf.st_size != fsize )
    {
        sprintf(emsg, "Զ%ld. %ld. Сһ", fsize, (long) (statbuf.st_size));

        if( statbuf.st_size < fsize )
            strcat(emsg, "ļϵͳռ");

        if( statbuf.st_size < fsize )
            f_seterr(emsg, "A009", "APP", 6);
        else
            z_logv(u_logfile, emsg);

        return(-1);
    }

    if( rename(midfile, filesco) < 0 )
    {
        z_logv(u_logfile, "'%s' -> '%s' ļʧ", midfile, filesco);
        f_seterr("ļʧ", "O003", "OS", 9);
        return(-1);
    }

    /* ȡļС */
    if( (fsize = GC_ftp_size(ftpfd, TCOF, outbuf)) < 0 )
    {
        f_seterr("ȡļСʧ", "A007", "APP", 9);
        return(1);
    }

    z_logv(u_logfile, "Getting TCO ...");
    snprintf(midfile, sizeof(midfile), "%s.tmp", filetco);

    if( GC_ftp_get(ftpfd, TCOF, midfile, outbuf) < 0 )
    {
        z_logv(u_logfile, "ɼļʧ");
        return(1);
    }
    z_logv(u_logfile, "done");

    /* ļ */
    memset(&statbuf, 0, sizeof(statbuf));

    if( stat(midfile, &statbuf) < 0 )
    {
        f_seterr("ȡļ״̬ʧ", "O004", "OS", 9);
        return(-1);
    }
    if( statbuf.st_size != fsize )
    {
        sprintf(emsg, "Զ%ld. %ld. Сһ", fsize, (long) (statbuf.st_size));

        if( statbuf.st_size < fsize )
            strcat(emsg, "ļϵͳռ");

        if( statbuf.st_size < fsize )
            f_seterr(emsg, "A009", "APP", 6);
        else
            z_logv(u_logfile, emsg);

        return(-1);
    }

    if( rename(midfile, filetco) < 0 )
    {
        z_logv(u_logfile, "'%s' -> '%s' ļʧ", midfile, filetco);
        f_seterr("ļʧ", "O003", "OS", 9);
        return(-1);
    }

    return(0);
}

/****************************************************
 ļңȡɼļϢ
 ֵ  -1  ļʧ
           >=0 ļĿ
 ****************************************************/
int n_flist(char *file, int start_no, char *maxtmstr)
{
    FILE *fp;

    int   fn = 0,       /* ļĿ */
          fno,          /* ļ */
          first = 1;    /* α */

    char  s[16], statc, storage;

    /* 򿪴洢ļ */
    if( (fp = fopen(file, "r")) == NULL ) return(-1);

    /* λ */
    if( fseek(fp, 9 * start_no, SEEK_SET) < 0 )
    {
        fclose(fp);
        return(-1);
    }

    /*  */
    fno = start_no;
    fn = 0;

    while( ! feof(fp) )
    {
        if( fn == MAXN_BATCH ) break;

        if( first == 0 && fno >= start_no ) break;  /* ٴλص */

        memset(s, 0, sizeof(s));

        if( fread(s, 1, 9, fp) != 9 )
        {
            if( ferror(fp) )
            {
                fclose(fp);
                return(-1);
            }

            if( first == 0 ) break;                 /* ٴεļβ */
            else                                    /*  */
            {
                first = 0;

                if( fseek(fp, 9, SEEK_SET) < 0 )    /*  */
                {
                    fclose(fp);
                    return(-1);
                }

                fno = MINN_FSEQ;
                continue;
            }
        }

        statc = *s;
        storage = *(s + 8);

/*      if( statc != 1 && (storage & 0x40) != 1 ) break; */

        if( statc == 1 )                            /* FULL״̬ */
        {
            t_flist[fn].no = fno;
            t_flist[fn].stat = statc;
            n_bcd2s(t_flist[fn].timestr, s + 1, 7); /* ʱʶ(7ֽ) */

            if( strcmp(t_flist[fn].timestr, maxtmstr) > 0 )
                strcpy(maxtmstr, t_flist[fn].timestr);

            t_flist[fn].storage = storage;
            fn++;
        }

        fno++;
    }
    fclose(fp);

    return(fn);
}

/**************
 BCD תַ
 **************/
void n_bcd2s(char *t, char *s, int l)
{
    int i;

    for( i = 0; i < l; i++ )
    {
        t[2 * i] = ((s[l - 1 - i] >> 4) & 0x0F) + 0x30;
        t[2 * i + 1] = ((s[l - 1 - i]) & 0x0F) + 0x30;
    }
    t[2 * i] = 0;

    return;
}

/**************
 ַתBCD 
 **************/
void n_s2bcd(char *t, char *s)
{
    int   i, l;

    l = strlen(s);

    for( i = 0; i < l; i += 2, t++ )
    {
        *t = ((s[l - i - 2] - 0x30) << 4) | (s[l - i - 1] - 0x30);
    }
    *t = 0;

    return;
}

/**************************
 д봫ļԱش
 **************************/
int n_wfctl(char *file, int n, char *maxtmstr)
{
    FILE *fp;

    int   i;
    char  dt[16], stamp[8];
    time_t b;

    memset(dt, 0, sizeof(dt));
    z_get_dt(dt, 14, "f", 0);

    /* 򿪴ļ */
    if( (fp = fopen(file, "r+")) == NULL ) return(-1);

    if( strcmp(maxtmstr, dt) > 0 )
    {
        if( (b = z_secs_dt(maxtmstr, NULL)) < 0 )
        {
            fclose(fp);
            return(b);
        }
        z_get_dt(dt, 14, "f", b + 1);
    }
    n_s2bcd(stamp, dt);

    for( i = 0; i < n; i++ )
    {
        fseek(fp, 7 * t_flist[i].no, SEEK_SET);
        fwrite(stamp, 1, 7, fp);
    }
    fclose(fp);

    return(i);
}

/* ݿļ */
/*
int n_fctlbak(int flag, char *fold1)
{
    char   currtime[16];
    static char cmd[1024], filebak[CL];

    memset(currtime, 0, sizeof(currtime));

    z_get_dt(currtime, 14, "f", 0);

    snprintf(filebak, sizeof(filebak), "%s.%d.%s", fold1, flag, currtime);
    snprintf(cmd, sizeof(cmd), "cp %s %s", fold1, filebak);
    system(cmd);

    return(0);
}
*/
