//---------------------------------------------------------------------------
#include <stdio.h>
#include <vcl.h>
#pragma hdrstop

#include "ConfigPlat.h"
#include "Config.h"
#include "Fpub.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TFrmPlatCfg *FrmPlatCfg;

//---------------------------------------------------------------------------
__fastcall TFrmPlatCfg::TFrmPlatCfg(TComponent* Owner) : TForm(Owner)
{
        m_serv_no = 0;                        // ɼ

        m_nProItv= 0;                         // ʡ˾澯
        m_nCityItv = 0;                       // ֹ˾澯
        m_nHDTimeLimit = 0;                   // ʱ澯ʱ
        m_nRZTimeout = 0;                     // ֲʱʱ

        m_nBusyNoFileT = m_nFreeNoFileT = -1; // æ޻澯ʱ

        // æʱʱ
        memset(m_szBusyBeg, 0, sizeof(m_szBusyBeg));
        memset(m_szBusyEnd, 0, sizeof(m_szBusyEnd));
}

//---------------------------------------------------------------------------
void __fastcall TFrmPlatCfg::FormShow(TObject *Sender)
{
        // ʼ׽
        if( m_skt.Init(PKT_MAXSIZE, PKT_HEADFMT) != 1 )
        {
                ErrDlg("ʼʧ");
                Application->Terminate();
        }

        BtnDownLoadClick(Sender);
}

//---------------------------------------------------------------------------
// ֤Ϣ
int __fastcall TFrmPlatCfg::VerifyText(void)
{
        int   nRead;
        char *p, szBuf[256];

        // ֤ʡ˾澯
        if( EditProItv->Text.Trim().Length() == 0 )
        {
                ErrDlg("ʡ˾澯");
                return 1;
        }
        try
        {
                m_nProItv = EditProItv->Text.Trim().ToInt();
        }
        catch (...)
        {
                ErrDlg("ʡ˾澯Ƿ");
                return 2;
        }
        if( m_nProItv <= 0 )
        {
                ErrDlg("ʡ˾澯Ƿ");
                return 3;
        }

        // ֹ֤˾澯
        if( EditCityItv->Text.Trim().Length() == 0 )
        {
                ErrDlg("ֹ˾澯");
                return 1;
        }
        try
        {
                m_nCityItv = EditCityItv->Text.Trim().ToInt();
        }
        catch (...)
        {
                ErrDlg("ֹ˾澯Ƿ");
                return 2;
        }
        if( m_nCityItv <= 0 )
        {
                ErrDlg("ֹ˾澯Ƿ");
                return 3;
        }

        // ֤æʱ޻澯ʱ
        if( EditBusyNoFileLimit->Text.Trim().Length() == 0 )
        {
                ErrDlg("æʱ޻澯ʱ޿");
                return 1;
        }
        try
        {
                m_nBusyNoFileT = EditBusyNoFileLimit->Text.Trim().ToInt();
        }
        catch (...)
        {
                ErrDlg("æʱ޻澯ʱ޷Ƿ");
                return 2;
        }
        if( m_nBusyNoFileT <= 0 )
        {
                ErrDlg("æʱ޻澯ʱ޷Ƿ");
                return 3;
        }

        // ʱ޻澯ʱ
        if( EditFreeNoFileLimit->Text.Trim().Length() > 0 )
        {
                try
                {
                        m_nFreeNoFileT = EditFreeNoFileLimit->Text.Trim().ToInt();
                }
                catch (...)
                {
                }
        }

        if( m_nFreeNoFileT <= 0 )
        {
                m_nFreeNoFileT = m_nBusyNoFileT;
                EditFreeNoFileLimit->Text = m_nFreeNoFileT;
        }

        // ֤æʱʱ
        strcpy(m_szBusyBeg, DTimeBegin->Time.FormatString("HH:mm").c_str());
        strcpy(m_szBusyEnd, DTimeEnd->Time.FormatString("HH:mm").c_str());

        // ֤IPַ
        if( EditIP->Text.Trim().Length() > 0 )
        {
                if( z_valid_ip(EditIP->Text.Trim().c_str()) != 4 )
                {
                        ErrDlg("IPǷ");
                        return 3;
                }

                // ֤û
                if( EditUser->Text.Trim().Length() == 0 )
                {
                        ErrDlg("ûΪ");
                        return 5;
                }

                // ֤
                if( EditPass->Text.Trim().Length() == 0 )
                {
                        ErrDlg("ֿΪ");
                        return 6;
                }

                // ִ֤䳬ʱʱ
                if( EditOperTimeout->Text.Trim().Length() > 0 )
                {
                        try
                        {
                                m_nRZTimeout = EditOperTimeout->Text.Trim().ToInt();
                        }
                        catch (...)
                        {
                        }
                }
                if( m_nRZTimeout <= 0 )
                {
                        m_nRZTimeout = TMO_FTP_RZ;
                        EditOperTimeout->Text = m_nRZTimeout;
                }
        }

        return(0);
}

//---------------------------------------------------------------------------
void __fastcall TFrmPlatCfg::BtnUpLoadClick(TObject *Sender)
{
        int   i, b;
        char *pBody, szVal[64];

        static char szBody[1024];

        if( VerifyText() ) return;

        // 䱨ͷ
        m_skt.SetHeadN(TC_CFGPLAT, 2);

        pBody = szBody;

        // Ÿ澯롱
        f_packTLV(&pBody, MemoSmsNumbers->Text.Trim().c_str(), TAG_PROSMSNUMBERS);

        // ʡ˾澯
        f_packTLV(&pBody, EditProItv->Text.Trim().c_str(), TAG_PROWARNITV);

        // ֹ˾澯
        f_packTLV(&pBody, EditCityItv->Text.Trim().c_str(), TAG_CITYWARNITV);

        // æʱ޻澯ʱޡ
        f_packTLV(&pBody, EditBusyNoFileLimit->Text.Trim().c_str(), TAG_BUSYNOFILET);

        // ʱ޻澯ʱޡ
        f_packTLV(&pBody, EditFreeNoFileLimit->Text.Trim().c_str(), TAG_FREENOFILET);

        // æʱʱΡ
        sprintf(szVal, "%s%c%s", m_szBusyBeg, SM_SEQHYPHEN, m_szBusyEnd);
        f_packTLV(&pBody, szVal, TAG_PLAT_BUSY_TIME);

        // ֡
        f_packTLV(&pBody, EditIP->Text.Trim().c_str(), TAG_HOSTIP1);
        f_packTLV(&pBody, EditUser->Text.Trim().c_str(), TAG_USER1);
        f_packTLV(&pBody, EditPass->Text.Trim().c_str(), TAG_PASSWORD1);

        sprintf(szVal, "%d", ChkBoxEncry->Checked == true ? 1 : 0);
        f_packTLV(&pBody, szVal, TAG_RZENCRYPTION);

        f_packTLV(&pBody, EditOperTimeout->Text.Trim().c_str(), TAG_RZFTP_TIMEOUT);

        *pBody = 0;

        // ӷ
        b = SktComm(m_skt, m_serv_no + 1, szBody, StatusBar1);

        switch( b )
        {
        case R_OK:
                MessageDlg("ϴɹ", mtInformation, TMsgDlgButtons() << mbOK, 0);
                break;

        case R_COMMFAIL:
                ErrDlg("ͨʧ");
                break;

        case R_DENY:
                ErrDlg("ʧ");
                break;
        }
}

//---------------------------------------------------------------------------
// 
void __fastcall TFrmPlatCfg::BtnDownLoadClick(TObject *Sender)
{
        int   i, b,
              nHour1, nMin1,
              nHour2, nMin2;

        char *p, szDeli[8], szBuf[64], szStr1[64], szStr2[64];

        // 䱨ͷ
        m_skt.SetHeadN(TC_RCFGPLAT, 2);

        int   iHLen = m_skt.GetHeadLen();
        char *pInfo = m_skt.GetReply();

        *pInfo = 0;
        *(pInfo + iHLen) = 0;

        // ӷ
        b = SktComm(m_skt, m_serv_no + 1, "", StatusBar1);

        switch( b )
        {
        case R_OK:
                break;

        case R_COMMFAIL:
                ErrDlg("ͨʧ");
                break;

        case R_DENY:
                ErrDlg("ʧ");
                break;
        }

        if( b != R_OK ) return;

        /* һÿTAG */
        if( f_unpackTLV(pInfo + iHLen, m_skt.GetPktLen() - iHLen) < 0 ) return;

        // Ԥ
        FillComponent(this);

        // ŷΧָ
        szDeli[0] = SM_SEQHYPHEN;
        szDeli[1] = 0;

        // 
        for( i = 0; i < MAXN_TAG; i++ )
        {
                if( g_TAGs[i].tag == 0 ) break;

                switch( g_TAGs[i].tag )
                {
                case TAG_PLAT_BUSY_TIME:        // æʱʱ

                        p = g_TAGs[i].pv;

                        GC_get_fieldv(&p, szStr1, NULL, sizeof(szStr1) - 1, szDeli);
                        GC_get_fieldv(&p, szStr2, NULL, sizeof(szStr2) - 1, szDeli);

                        // ʼСʱ
                        p = szStr1;
                        GC_get_fieldv(&p, szBuf, NULL, 2, ":");
                        nHour1 = atoi(szBuf);
                        GC_get_fieldv(&p, szBuf, NULL, 2, ":");
                        nMin1 = atoi(szBuf);

                        // ֹСʱ
                        p = szStr2;
                        GC_get_fieldv(&p, szBuf, NULL, 2, ":");
                        nHour2 = atoi(szBuf);
                        GC_get_fieldv(&p, szBuf, NULL, 2, ":");
                        nMin2 = atoi(szBuf);

                        try
                        {
                                DTimeBegin->Time = TDateTime(nHour1, nMin1, 0, 0);
                                DTimeEnd->Time = TDateTime(nHour2, nMin2, 0, 0);
                        }
                        catch(...)
                        {
                        }

                        break;
                }
        }
}
//---------------------------------------------------------------------------

