//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Filter.h"
#include "MonOper.h"            // ز

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TFrmFilter *FrmFilter;

//---------------------------------------------------------------------------
__fastcall TFrmFilter::TFrmFilter(TComponent* Owner) : TForm(Owner)
{
        int wid;

        // ʶ
        m_monwin_id = static_cast<TFrmMonOper *>(Owner)->m_win_id;
        wid = m_monwin_id;

        EditDesc->Text = MonOperForms[wid - 1]->m_filter_szDesc;
        EditNo->Text = MonOperForms[wid - 1]->m_filter_szNo;
        RadioGrpWarn->ItemIndex = MonOperForms[wid - 1]->m_filter_warn;
        RadioGrpStatus->ItemIndex = MonOperForms[wid - 1]->m_filter_status;
}

//---------------------------------------------------------------------------
// 
void __fastcall TFrmFilter::BtnClearClick(TObject *Sender)
{
        EditDesc->Text = "";
        EditNo->Text = "";
        RadioGrpWarn->ItemIndex = -1;
        RadioGrpStatus->ItemIndex = -1;
}
//---------------------------------------------------------------------------
// ȷ
void __fastcall TFrmFilter::BtnOkClick(TObject *Sender)
{
        int wid = m_monwin_id;

        strcpy(MonOperForms[wid - 1]->m_filter_szDesc, EditDesc->Text.Trim().c_str());
        strcpy(MonOperForms[wid - 1]->m_filter_szNo, EditNo->Text.Trim().c_str());
        MonOperForms[wid - 1]->m_filter_warn = RadioGrpWarn->ItemIndex;
        MonOperForms[wid - 1]->m_filter_status = RadioGrpStatus->ItemIndex;
}
//---------------------------------------------------------------------------

