//---------------------------------------------------------------------
#include <stdio.h>
#include <vcl.h>
#include <IniFiles.hpp>
#pragma hdrstop

#include "Fpub.h"
#include "Logon.h"

//--------------------------------------------------------------------- 
#pragma link "GIFImage"
#pragma resource "*.dfm"

TFrmLogon *FrmLogon = NULL;

static char szOldIP1[16] = {0};         // ԭʼϢԼñ
static char szOldIP2[16] = {0};
static int  nOldPort1    = 0;
static int  nOldPort2    = 0;
static int  nOldHostNo   = 0;

//---------------------------------------------------------------------
__fastcall TFrmLogon::TFrmLogon(TComponent* AOwner) : TForm(AOwner)
{
}
//---------------------------------------------------------------------------

void __fastcall TFrmLogon::FormShow(TObject *Sender)
{
        TIniFile *ini;

        ini = new TIniFile( ChangeFileExt(Application->ExeName, ".INI") );

        // ȡļʱʹȱʡֵ
        EditIP1->Text   = ini->ReadString("HOST", "IP1", DEF_IP1);
        EditIP2->Text   = ini->ReadString("HOST", "IP2", DEF_IP2);
        EditPort1->Text = ini->ReadInteger("HOST", "PORT1", DEF_PORT);
        EditPort2->Text = ini->ReadInteger("HOST", "PORT2", DEF_PORT);

        RadioGrpHosts->ItemIndex = ini->ReadInteger("HOSTSEQ", "HOSTSEQ", DEF_HOSTSEQ - 1);

        // ʼϢ
        strcpy(szOldIP1, EditIP1->Text.Trim().c_str());
        strcpy(szOldIP2, EditIP2->Text.Trim().c_str());
        nOldHostNo = RadioGrpHosts->ItemIndex;

        nOldPort1 = EditPort1->Text.ToInt();
        nOldPort2 = EditPort2->Text.ToInt();

        delete ini;

        // ʼ׽
        if( m_skt.Init(PKT_MAXSIZE, PKT_HEADFMT) != 1 )
        {
                ErrDlg("ʼʧ");
                Application->Terminate();
        }
}

//---------------------------------------------------------------------
// ¼֤
void __fastcall TFrmLogon::BtnOkClick(TObject *Sender)
{
        int    b, fTry = 1;
        char  *pBody, szBody[64], szBuf[128];

/* TEST
ModalResult = mrOk;
return;
*/

        // ֤Ϣ
        if( VerifyText() ) return;

        // ¼û
        strcpy(g_username, EditUser->Text.Trim().c_str());
        g_hostseq = RadioGrpHosts->ItemIndex;

        // ļ
        IniWrite();

        // 챨
        pBody = szBody;

        // 롱
        f_packTLV(&pBody, EditPass->Text.c_str(), TAG_PASSWORD2);

        *pBody = 0;

        // 䱨ͷ
        m_skt.SetHeadN(TC_LOGON, 2);

        // ¼֤
        b = SktComm(m_skt, g_hostseq + 1, szBody, StatusBar1, 1, 0, &fTry);

        if( fTry == 0 )
        {
                g_hostseq = ! g_hostseq;
                RadioGrpHosts->ItemIndex = g_hostseq;
        }

        switch( b )
        {
        case R_OK:
                m_skt.GetHeadN(g_userid, 5);            // ӦUID
                ModalResult = mrOk;
                break;

        case R_COMMFAIL:
                ErrDlg("ͨʧ");
                break;

        default:
                m_skt.GetHeadN(szBuf, 3);               // 

                if( szBuf[0] == E_LOGONDENY )
                {
                        sprintf(szBuf, "ϵͳû'%s'¼", g_username);
                        ErrDlg(szBuf);
                }
                else if( szBuf[0] == E_FILE )
                        ErrDlg("Ȩ");
                else
                        ErrDlg("¼ʧ");

                break;
        }

        return;
}

//---------------------------------------------------------------------------
// IP˿
void __fastcall TFrmLogon::BtnSetClick(TObject *Sender)
{
        EditIP1->Enabled = true;
        EditIP1->Color = clWindow;
        EditPort1->Enabled = true;
        EditPort1->Color = clWindow;

        EditIP2->Enabled = true;
        EditIP2->Color = clWindow;
        EditPort2->Enabled = true;
        EditPort2->Color = clWindow;
}

//---------------------------------------------------------------------------
// дļ
void __fastcall TFrmLogon::IniWrite(void)
{
        TIniFile *ini;

        // ûбֱӷ
        if( strcmp(EditIP1->Text.Trim().c_str(), szOldIP1) == 0 &&
            strcmp(EditIP2->Text.Trim().c_str(), szOldIP2) == 0 &&
            EditPort1->Text.ToInt() == nOldPort1 &&
            EditPort2->Text.ToInt() == nOldPort2 &&
            RadioGrpHosts->ItemIndex == nOldHostNo )
        {
            return;
        }

        ini = new TIniFile( ChangeFileExt(Application->ExeName, ".INI") );
        ini->WriteString("HOST", "IP1", EditIP1->Text);
        ini->WriteString("HOST", "PORT1", EditPort1->Text);
        ini->WriteString("HOST", "IP2", EditIP2->Text);
        ini->WriteString("HOST", "PORT2", EditPort2->Text);
        ini->WriteInteger("HOSTSEQ", "HOSTSEQ", RadioGrpHosts->ItemIndex);

        delete ini;
}

//---------------------------------------------------------------------------
// ֤Ϣ
int __fastcall TFrmLogon::VerifyText(void)
{
        // ֤IP
        if( EditIP1->Text.Trim().Length() == 0 )
        {
                ErrDlg("IP1");
                return 1;
        }
        else if( z_valid_ip(EditIP1->Text.Trim().c_str()) != 4 )
        {
                ErrDlg("IP1Ƿ");
                return 2;
        }
        strcpy(g_winids[0].serv_ip, EditIP1->Text.Trim().c_str());

        if( EditIP2->Text.Trim().Length() == 0 )
        {
                ErrDlg("IP2");
                return 3;
        }
        else if( z_valid_ip(EditIP2->Text.Trim().c_str()) != 4 )
        {
                ErrDlg("IP2Ƿ");
                return 4;
        }
        strcpy(g_winids[1].serv_ip, EditIP2->Text.Trim().c_str());

        // ֤PORT
        if( EditPort1->Text.Trim().Length() == 0 )
        {
                ErrDlg("˿1");
                return 5;
        }
        try
        {
                g_winids[0].serv_port = EditPort1->Text.Trim().ToInt();
        }
        catch (...)
        {
                ErrDlg("˿1Ƿ");
                return 6;
        }
        if( EditPort2->Text.Trim().Length() == 0 )
        {
                ErrDlg("˿2");
                return 7;
        }
        try
        {
                g_winids[1].serv_port = EditPort2->Text.Trim().ToInt();
        }
        catch (...)
        {
                ErrDlg("˿2Ƿ");
                return 8;
        }

        if( g_winids[0].serv_port <= 0 || g_winids[1].serv_port <= 0 )
        {
                ErrDlg("˿ڷǷ");
                return 9;
        }

        // ֤û
        if( EditUser->Text.Trim().Length() == 0 )
        {
                ErrDlg("û");
                return 10;
        }

        return(0);
}

//---------------------------------------------------------------------------
void __fastcall TFrmLogon::Image1Click(TObject *Sender)
{
        static int iCount = 0;
        String msg;

        if( iCount < 10 ) iCount ++;

        if( iCount < 3 ) msg = "Ϲ㣬æ";
        else if( iCount < 5 ) msg = "˵أû";
        else msg = "ˣ";

        MessageDlg(msg, mtInformation, TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------

