//---------------------------------------------------------------------------
#ifndef MonOperH
#define MonOperH

//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include "gcps.h"
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------

#define N_MONOPER        2              // شĿ

                                        // Ŷ
#define CS_NAME          1              // ûơ
#define CS_NO            3              // ɼš
#define CS_WARN          4              // 澯
#define CS_STATUS        5              // ״̬
#define CS_ERROR         11             // Ϣ
#define CS_SEQCTRL       12             // Ƿϸſơ

                                        // ״̬
#define ST_OK           ""          // 
#define ST_STOP         "Ϊֹ"      // Ϊֹ

//---------------------------------------------------------------------------
class TFrmMonOper : public TForm
{
__published:	// IDE-managed Components
        TTimer *Timer1;
        TListView *ListView1;
        TPopupMenu *PopupMenu1;
        TMenuItem *N1;
        TMenuItem *N2;
        TMenuItem *N3;
        TMenuItem *N4;
        TMenuItem *N5;
        TMenuItem *N6;
        TPanel *Panel1;
        TStatusBar *StatusBar1;
        TPanel *Panel2;
        TButton *BtnFirstPage;
        TButton *BtnPrevPage;
        TButton *BtnNextPage;
        TButton *BtnLastPage;
        TEdit *EditPageNo;
        TButton *BtnFilter;
        TButton *BtnRefresh;
        TToolBar *ToolBar1;
        TToolButton *ToolButton1;
        TToolButton *ToolButton2;
        TToolButton *ToolButton3;
        TToolButton *ToolButton4;
        TToolButton *ToolButton5;
        TToolButton *ToolButton6;

        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall ListView1CustomDrawItem(TCustomListView *Sender,
          TListItem *Item, TCustomDrawState State, bool &DefaultDraw);

        void __fastcall N1Click(TObject *Sender);
        void __fastcall N2Click(TObject *Sender);
        void __fastcall N3Click(TObject *Sender);
        void __fastcall N4Click(TObject *Sender);
        void __fastcall N5Click(TObject *Sender);
        void __fastcall BtnRefreshClick(TObject *Sender);
        void __fastcall BtnFirstPageClick(TObject *Sender);
        void __fastcall BtnPrevPageClick(TObject *Sender);
        void __fastcall BtnNextPageClick(TObject *Sender);
        void __fastcall BtnLastPageClick(TObject *Sender);
        void __fastcall BtnFilterClick(TObject *Sender);
        void __fastcall EditPageNoKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall PopupMenu1Popup(TObject *Sender);
        void __fastcall StatusBar1DrawPanel(TStatusBar *StatusBar,
          TStatusPanel *Panel, const TRect &Rect);
        void __fastcall N6Click(TObject *Sender);
        void __fastcall ListView1DblClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);

private:        // User declarations
        TRect ProgressBarRect;             // ĳߴ

public:         // User declarations
        TSocket m_skt;

        int     m_last_start_no;           // ϴʾʼ
        int     m_last_show_rows;          // ϴĻɼ
        int     m_start_no;                // ʾʼ
        int     m_show_rows;               // ǰĻɼ

        int     m_filter_rows;             // ϹĿ
        int     m_total_rows;              // ɼܼĿ
        int     m_last_select;             // ϴѡITEM

        int     m_listing;                 // Ƿˢ
        int     m_win_id;                  // ʶ

        char    m_filter_szDesc[65];       // 
        char    m_filter_szNo[65];         // š
        int     m_filter_warn;             // 澯
        int     m_filter_status;           // ״̬

        __fastcall TFrmMonOper(TComponent* Owner);

        int  __fastcall List(void);
        int  __fastcall List1(void);

        // һɼ㣬
        int __fastcall SimpleReq1(char *code, int aRead);

        // ־ѯ
        void __fastcall QryLog(int id);
};

//---------------------------------------------------------------------------
extern PACKAGE TFrmMonOper *MonOperForms[ N_MONOPER ];

// ʾ
void __fastcall ListShow(TFrmMonOper *pFrm, TSocket *pSkt);
//---------------------------------------------------------------------------

#endif
