//---------------------------------------------------------------------------
#ifndef GcpsH
#define GcpsH
//---------------------------------------------------------------------------
#include <winsock2.h>

#define  GC_SM_SEPPHEAD    ","                  /* ͷֶηָ */
#define  GC_SM_SEPPHMEM    ":"                  /* ͷԱָ */

                                                /* 뷽ʽ */
#define  GC_AL_RIGHTSP     '0'                  /* 룬Ҳո */
#define  GC_AL_LEFTSP      '1'                  /* Ҷ룬󲹿ո */
#define  GC_AL_LEFTZE      '2'                  /* Ҷ룬 0 */
#define  GC_AL_RIGHTNUL    '3'                  /* 룬Ҳ \0 */

#define  GC_MAXL_PKT        4194304             /* ĳ 4M */
#define  GC_MAXN_TAGS       8192                /* TAG ṹĿ */

#define  GC_TMO_CONNECT     10                  /* ӳʱʱ */
#define  GC_TMO_READ        60                  /* ȡʱʱ */
#define  GC_R_TIMEOUT       -10                 /* ֵͨųʱ */

#define  GC_ErrDlg(a) MessageDlg(a, mtError, TMsgDlgButtons()<<mbOK, 0)

typedef struct s_gc_phead                       /* ͷṹ */
{
        unsigned char   keyc;                   /* ֶ */
        unsigned char   dtype;                  /* ֶ */
        unsigned char   align;                  /* ֶζ뷽ʽ */
        int             len;                    /* ֶγȣַλֽ */
        char           *vp;                     /* ֶָ */
} GC_PHEAD;

/* TAG ṹ */
typedef struct s_gc_tags
{
        int             tag;                    /* TAGַ */
        char            key[64];                /* ؼ */
        int             vlen;                   /* ֵ */

        int             group;                  /* TAG  */
        int             wintag;                 /* Ӧؼtag */

        int             klen;                   /* ؼֳ */
        char           *pv;                     /* ֵָ */
} GC_TAGS;

class TTags
{
private:
        GC_TAGS        *m_pTAGs;                /* TAG  */
        int             m_nTAGs;                /* TAG Ŀ */
        int             m_nMaxTAGs;             /* TAG Ŀ */

public:
        // 
        TTags(void);

        // 
        ~TTags(void);

        /************************************
         ʼTAG ࣬ռ
         ֵ  -1ʧ   1ɹ
         ************************************/
        int Init(int nTag);

        /******************************
         TAG
         ֵ  -1ʧ   1ɹ
         ******************************/
        int addTAG(GC_TAGS *pTag);

        /**************************
         λTAG
         ֵ  -1ʧ   >=0±
         **************************/
        int seekTAG(int atag);

        /***********************
         TAG ֵ
         ֵ  -1ʧ  1ɹ
         ***********************/
        int setTAG(int atag, char *pV);

        // TLV
        int packTLV(char **pBody, char *pValue, int tag);

        /************************
         TLV ṹ
         ֵ  -1ʧ   1ɹ
         ************************/
        int unpackTLV(char *pBuf, int alen);
};

class TSocket
{
private:
        u_short         m_cport;                /* ͨŶ˿ */
        char            m_sip[16];              /* ַ */

        SOCKET          m_fd;                   /* ׽ */
        GC_PHEAD       *m_pharr;                /* ͷ */

        unsigned int    m_phflds;               /* ͷֶĿ */
        unsigned int    m_phlen;                /* ͷֶγȺ */
        unsigned int    m_pmaxlen;              /* 󳤶 */
        unsigned int    m_plen;                 /* ǰĳ */
        int             m_fplen;                /* ĳ */

        int             m_plen_rev;             /* ĳ */
        int             m_byte_order;           /* ֽ˳ */

        char           *m_cphead;               /* ַͷ */
        char           *m_reqinfo;              /* ݣͷ */
        char           *m_repinfo;              /* Ӧݣͷ */

        int             m_cntmout;              /* ͻӳʱʱ */
        int             m_rdtmout;              /* ͻ˶ʱ */
        int             m_wrtmout;              /* дʱ */

public:
        // 
        TSocket(void);

        // 
        ~TSocket(void);

        // ʼ
        int Init(int pmlen, char *phfmt);

        // ر׽
        void Close(void);

        // ȡͷĿ
        unsigned int GetNumOfHead(void);

        // ȡͷ
        unsigned int GetHeadLen(void);

        // ȡĳ
        unsigned int GetPktLen(void);

        // ȡӦָ
        char* GetReply(void);

        // ȡָ
        char* GetRequest(void);

        /**************************************
         ֽⱨͷʽṹռ
         ֵ   1  ɹ
                    0  ޱͷʽ
                   -1  ڴʧ
         **************************************/
        int ParseFmt(char *phfmt);

        /********************************************
         ͷʽ֤Ϊÿռ
         ֵ   1  ɹ
                    0  ޳ֶζ
                   -1  ͷ򳤶֮Ч
                   -2  ֶζ岻
                   -3  ģͬʱֶ
                   -4  ΣֻΪ124
                   -5  <1
                   -10 ڴʧ
         ********************************************/
        int VerifyFmt(void);

        /**********************************************
         ȡͷĳֶεֵ
         ڲ: int   phfno-- ͷֶţ 1ʼ
         ڲ: char *s    -- ֵ
         ֵ  : 1ɹ  -1ʧ
         **********************************************/
        int GetHeadN(char *s, int phfno);

        /**********************************************
         ñͷĳֶεֵ
         ڲ: char *s    -- õ
                   int   phfno-- ͷֶţ 1ʼ
         ֵ  : 1ɹ  -1ʧ
         **********************************************/
        int SetHeadN(char *s, int phfno);

        /*****************************************************
         óʱ
         ڲint tmo  -- ʱʱ(0 ʾȡ)
                   int flag -- 0 ͻӳʱ
                               1 ͻ˶ʱ
                               2 дʱ
         ֵ  ϴγʱʱ
         *****************************************************/
        int Timeout(int tmo, int flag);

        /*********************
         
         ֵ  -1  error
                   -10 timeout
                    1  ok
         *********************/
        int Connect(const char *host, const u_short port, const int sec=GC_TMO_CONNECT);

        /******************************************************
         ͨű
         ڲ: char *t       --  ͨű
                   char *s       --  
                   int   len     --  ݳ
         ֵ  :  1  Ok
                    0  Ч
                   -1  ĳ
         ******************************************************/
        int MakePkt(char *t, char *s, int len);

        /*******************************************
         ȡͷ
         ڲ: char *info   -- յıͷ
         ֵ  : >0    ʵʶݳ
                   -2    ĳȷǷ
                   -10   ʱ
                   <0    ʧ
         *******************************************/
        int ReadHead(char *info);

        /****************************************************
         ֽⱨͷݣΪͷṹֵ
         ڲ: unsigned char *info --ַ͵ıͷ
         ****************************************************/
        void HeadAnaly(char *info);

        // 
        int ReadN(void *vptr, const int n);

        // 
        int WriteN(const void *vptr, const int n);

        // ״̬flag0 1д
        int DetectFd(const int flag);

        /********************************************
         ıϢ
         ڲ: char *s     --  
         ֵ  : 1 ɹ  -1ʧ
         ע    : ô˺ǰӦ豨ͷֶθֵ
         ********************************************/
        int SendText(char *s);
};

// 
void GC_getWinErr(int *ierrno, char *msg, int len);

/****************************************
 ָȣƶַָ
 ڲchar  *s1   Ŀַ
           char **s2   ָԴַָ
           int    len  ָ
 ****************************************/
void GC_cp_move(char *s1, char **s2, int len);

// ӷַָָζȡֵ
int GC_get_fieldv(char **s, char *d, int *n, int l, char *b);

// жַǷȫΪַ
int GC_adigit(char *s);

// ֽ˳
int GC_rev_byte_order(char *out, char *in, int len);

//---------------------------------------------------------------------------
#endif
 