#-------------------------------------------------
#
# Project created by QtCreator 2017-11-16T20:23:37
#
#-------------------------------------------------

QT       += core gui network xml script phonon sql
CONFIG  += qaxcontainer resources_big

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

#QMAKE_LFLAGS += /MANIFESTUAC:\"level=\'requireAdministrator\' uiAccess=\'false\'\"

TARGET = dxpy
TEMPLATE = app

#添加相关库
INCLUDEPATH += $$PWD/vlc_win32/include/
INCLUDEPATH += $$PWD/vlc_win32/include/vlc/
LIBS += -L$$PWD/vlc_win32
LIBS += -llibvlc -llibvlccore

INCLUDEPATH += $$PWD/qjson/include
LIBS += -L$$PWD/qjson
LIBS += -llibqjson


SOURCES += \
    main.cpp \
    mainwindow.cpp \
    video.cpp \
    imagebutton.cpp \
    coursepage.cpp \
    wordpage.cpp \
    login.cpp \
    restapi.cpp \
    middle.cpp \
    tool.cpp \
    welcomepage.cpp \
    articlelistpage.cpp \
    articlepage.cpp \
    videopage.cpp \
    xzzspage.cpp \
    jbbhpage.cpp \
    jbbhsubpage.cpp \
    jbbhvideopage.cpp \
    sfktpage.cpp \
    sfkt2page.cpp \
    sfkt3page.cpp \
    sfktvideopage.cpp \
    szzbpage.cpp \
    itemwidget.cpp \
    szzbsubpage.cpp \
    ppbspage.cpp \
    ppbssubpage.cpp \
    sxzfpage.cpp \
    sxzf2page.cpp \
    sxzf3page.cpp \
    sxzfvideopage.cpp \
    querypage.cpp \
    querysubpage.cpp \
    sfxspage.cpp \
    sync.cpp \
    syncthread.cpp \
    mylabel.cpp \
    download.cpp \
    sztxpage.cpp \
    sztxsubpage.cpp \
    swjzpage.cpp \
    swjzimage.cpp \
    loading.cpp \
    common.cpp \
    flashpage.cpp \
    queryplaypage.cpp \
    whrpage.cpp \
    articlesubpage.cpp

HEADERS  += \
    mainwindow.h \
    video.h \
    imagebutton.h \
    coursepage.h \
    wordpage.h \
    login.h \
    restapi.h \
    middle.h \
    tool.h \
    welcomepage.h \
    articlelistpage.h \
    articlepage.h \
    videopage.h \
    xzzspage.h \
    jbbhpage.h \
    jbbhsubpage.h \
    jbbhvideopage.h \
    sfktpage.h \
    sfkt2page.h \
    sfkt3page.h \
    sfktvideopage.h \
    szzbpage.h \
    itemwidget.h \
    szzbsubpage.h \
    ppbspage.h \
    ppbssubpage.h \
    sxzfpage.h \
    sxzf2page.h \
    sxzf3page.h \
    sxzfvideopage.h \
    querypage.h \
    querysubpage.h \
    sfxspage.h \
    sync.h \
    syncthread.h \
    mylabel.h \
    download.h \
    sztxpage.h \
    sztxsubpage.h \
    swjzpage.h \
    swjzimage.h \
    qtooltipper.h \
    loading.h \
    common.h \
    flashpage.h \
    queryplaypage.h \
    whrpage.h \
    articlesubpage.h

RESOURCES += \
    images/images.qrc

RC_FILE = dxpy.rc

FORMS += \
    mainwindow.ui \
    itemwidget.ui \
    download.ui \
    swjzimage.ui \
    loading.ui
