/***********************************************************************
*
* ļ        XmlConfig.h
* ģĿģù
* ߼ڣ  wu_bin 2009-05-26
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#ifndef XmlConfig_H
#define XmlConfig_H

#pragma warning( disable : 4275)

#include "Common/Common.h"
#include "Common/GDString.h"
#include "FileOpt/FileOptDef.h"
#include "GDQue/SharedBuffer.h"
#include "GDQue/SharedMemory.h"
#include "TinyXml/tinyxml.h"

#include <string>
#include <map>

using namespace std;

typedef int (*CallbackFunc2)( const char* sItemPath, const char* sItemData, void* pvoid );

typedef struct GDConfig
{
	string sCfgFile;
	map< string, string > cfgMap;
}	GDConfig;

class CXmlConfig
{
public:
	CXmlConfig();
	~CXmlConfig();

	bool LoadConfig( const char* sCfgFile,bool bForce = false);
	bool UnloadConfig( const char* sCfgFile );

private:
	void InitXmlText( GDConfig * pConfig, TiXmlElement* pNode, const string& top );
	void LoadXmlFile( const char* szFileName );
	
public:
	const char* GetConfigString( const char* sCfgFile, const char* sItemPath );
	int GetConfigInteger( const char* sCfgFile, const char* sItemPath );
	void WalkConfig( const char* sCfgFile, CallbackFunc2 pFunc, void* pvoid );
public:
	long SetConfigBuffer( const char* sCfgFile );         //ļݵڴ
    long GetConfigBuffer( const char* sCfgFile );         //ȡڴ
private:
	map< string, GDConfig* > m_config;
	CSharedBuffer*   cfgBuffer;         //ļڴ              

};


#endif
