#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z.h"

#define   SIZE_RECORD   123

/* 1994.1.11970.1.1 = 24*86400*365 + 6*86400 - 8*3600  */
#define   SECONDS_BTW   757353600

/***********************************************
 : תʱ
     : tagin, tagoutֱָ롢
 ˵    4ֽ, λǰ
 ***********************************************/
int tag_dt(char *tagin, char *tagout)
{
    char *p;

    time_t itv;

    p = tagin;

    itv = *(p + 0);
    itv += *(p + 1) << 8;
    itv += *(p + 2) << 16;
    itv += *(p + 3) << 24;

    z_get_dt(tagout, 17, "%Y%m%d %T", itv + SECONDS_BTW);

    return(0);
}

int main(int argc, char **argv)
{
    FILE *fp;
    char  buf1[SIZE_RECORD + 1], ftime[21];

    if( argc != 2 ) return(0);

    if( (fp = fopen(argv[1], "r")) == (FILE *)NULL ) return(0);

    ftime[0] = 0;
    if( fseek(fp, -SIZE_RECORD, SEEK_END) == 0 )
    {
        if( fread(buf1, 1, SIZE_RECORD, fp) == SIZE_RECORD )
        {
            tag_dt(&buf1[50], ftime);
            printf(ftime);
        }
    }
    fclose(fp);

    return(0);
}
