/***********************************************************************
*
* ļ        FileExclude.cpp
* ģĿģжļǷų
* ߼ڣ  wang_jin 2008-05-09
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#pragma warning(disable:4786)


#include "FileExclude/FileExclude.h"
#include "FileRule.h"


CFileExclude::CFileExclude()
{
	m_pFileRule = new CFileRule();
	//assert(m_pFileRule);
}

CFileExclude::CFileExclude( const CFileExclude &param )
{
	m_pFileRule = new CFileRule();
	//assert(m_pFileRule);
	m_pFileRule->Clone( *param.m_pFileRule );
}

CFileExclude::~CFileExclude()
{
	if ( m_pFileRule )
	{
		delete m_pFileRule;
	}
}

bool CFileExclude::SetRules( const CMonitorInformation& moniInfo )
{
	return m_pFileRule->SetRules( moniInfo );
}

bool CFileExclude::GetRules( CMonitorInformation& moniInfo )
{
	return m_pFileRule->GetRules( moniInfo );
}

bool CFileExclude::IsInMonitorPath( const char* file )
{
	return m_pFileRule->IsSubPath( m_pFileRule->m_monitorPath.c_str(), file );
}

bool CFileExclude::IsExcludeFile( const char* file, int nFileType )
{
	return m_pFileRule->IsExcludeFile( file, nFileType );
}

bool CFileExclude::IsExcludeEvent( eventType type, const char* file )
{
	return m_pFileRule->IsExcludeEvent( type, file );
}
