/***********************************************************************
*
* ļ              FileFilter.cpp
* ģĿģ      ڻȡļ¼
* ߼ڣ        wang_jin 2008-05-01
* 汾                1.0
* ȨϢ            CVICSE Middleware
* ļ¼            
*
***********************************************************************/

#include "FileFilter/FileFilter.h"
#include "Filter.h"

using namespace std;


CFileFilter::CFileFilter():
	CMonitorInterface("FileFilter", FILTER),
	m_pFilter(new CFilter)
{
}


CFileFilter::~CFileFilter()
{
	if ( m_pFilter )
	{
		delete m_pFilter;
		m_pFilter = NULL;
	}
}


bool CFileFilter::Initialize( const char * sParams )
{
	return m_pFilter->Initialize( sParams );
}


bool CFileFilter::Uninitialize()
{
	return m_pFilter->Uninitialize();
}


bool CFileFilter::WatchDirectory( CMonitorInformation& moniInfo )
{
	return m_pFilter->WatchDirectory( moniInfo );
}


bool CFileFilter::UnwatchDirectory( const char * sDirId )
{
	return m_pFilter->UnwatchDirectory( sDirId );
}


bool CFileFilter::IsWatched( const char * sDirId )
{
	return m_pFilter->IsWatched( sDirId );
}


bool CFileFilter::IsWatchedByWebsiteId( const char * sWebsiteId )
{
	return m_pFilter->IsWatchedByWebsiteId(sWebsiteId);
}


bool CFileFilter::ReadEvent( EVENT_S& event )
{
	return m_pFilter->ReadEvent(event) ;
}
