/***********************************************************************
*
* ļ        Filter.h
* ģĿģӦ÷ǶͨѶ
* ߼ڣ  wang_jin 2008-05-04
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#pragma warning( disable: 4786 )

#ifndef Filter_H
#define Filter_H


#include "Base/MonitorInterface.h"
#include "Base/MonitorDef.h"
#include "GDQue/MessageQueue.h"
#include "GDQue/SharedBuffer.h"
#include <list>
#include <string>


class CFilter
{
public:
	CFilter();
	~CFilter();
    //һЩsParams,|ָǶе
	bool Initialize( const char * sParams );
	//Դͷ
	bool Uninitialize();
	
public:
    /*ڱбһĿ¼ȻͨCSharedBuffer֪ͨverifier¼Ŀ¼,
	ϢCMonitorInformationĿ¼ų*/ 
	bool WatchDirectory( CMonitorInformation& moniInfo );
    /*ֹͣأ
	ȴӱбĿ¼ͨCSharedBuffer֪ͨverifier¼Ŀ¼*/
	bool UnwatchDirectory( const char * sDirId );
	//IsWatchedᴥһļάбĲҲ
	bool IsWatched( const char * sDirId );
	bool IsWatchedByWebsiteId( const char * sWebsiteId );
	
public:
	bool StartFilter();
	bool StopFilter();
	bool SetFilter();
	
public:

    //ϢжһϢ,CMessageQueue,һ¼۸ļָϢ
	bool ReadEvent( EVENT_S& event );
	
private:
    /*ѹڴύverifierǴWatchDirectoryUnwatchDirectory
	ȡͨò*/
	bool SetSharedBufferToVerifier(list<CMonitorInformation>&);
	
private:
	//Ŀ¼
	static std::list<CMonitorInformation> m_monitorList;
	CSharedBuffer m_sharedBuffer;
	CMessageQueue m_messageQueue;
	static long m_nVersion;//GDQuģ鹲ڴİ汾Ϣ
};


#endif
