/***********************************************************************
*
* ļ        SharedMemory.h
* ģĿģʵֶ̬乲ڴ
* ߼ڣ  wang_jin 2008-06-27
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#include "GDQue/SharedMemory.h"
#include "MemoryManager.h"
#include "DataManager.h"


CSharedMemory::CSharedMemory()
:m_pDataMgr( new CSharedDataManager )
{
}

CSharedMemory::~CSharedMemory()
{
	if ( m_pDataMgr )
	{
		m_pDataMgr->ReleaseMemory();
		delete m_pDataMgr;
	}
}

long CSharedMemory::CreateMemory( long nKey, long nTotalSize, long nSize )
{
	return m_pDataMgr->CreateMemory( nKey, nTotalSize, nSize );
}

long CSharedMemory::ReleaseMemory()
{
	return m_pDataMgr->ReleaseMemory();
}

void* CSharedMemory::GetRoot()
{
	return m_pDataMgr->GetRoot();
}

void* CSharedMemory::New()					// ̬
{
	return m_pDataMgr->New();
}

void CSharedMemory::Delete( void* pBuf )	// ̬ͷ
{
	if ( pBuf )
	{
		m_pDataMgr->Delete( pBuf );
	}
}

bool CSharedMemory::IsOwner()
{
	return m_pDataMgr->IsOwner();
}

int CSharedMemory::GetOffset( void* pBuf )					// Чڴַתƫ
{
    if( pBuf )
    {
	    return m_pDataMgr->GetOffset( pBuf );
    }

    return 0;
}

void* CSharedMemory::GetRealAddress( int nOffset )				// ƫתЧڴַ
{
	if ( nOffset )
	{
		return m_pDataMgr->GetRealAddress( nOffset );
	}

	return NULL;
}

