/********
 ¼֤
 ********/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <pwd.h>
#include <unistd.h>
#include <arpa/inet.h>
#include "gcps.h"
#include "z.h"
#include "zagent.h"
#include "zvar.h"

int f_logon(void)
{
    int   b, nPort = FTPPORT;
    char *p, szPass[32], szTmp[64], szUid[16], szBeUid[16] = {0};

    static char    szBuf[8192];
    struct passwd *psd;
    struct in_addr addr;

    /*  */
    b = f_seekTAG(TAG_PASSWORD2);
    strcpy(szPass, u_TAGs[b].pv);

    z_logv(g_logfile, szPass);

    /* ȡ¼û */
    b = z_readini(CITYS_CFG, SEG_LOGONUSERS, u_pkthead.user, szTmp, sizeof(szTmp) - 1, 0);

    if( b == -1 || b == -2 )
    {
        GC_sendecode(E_LOGONDENY);
        return(-1);
    }
    else if( b )
    {
        GC_sendecode(E_FILE);
        return(-1);
    }

    /* ȡûļٶID */
    p = szTmp;
    z_get_fieldv(&p, szBeUid, NULL, sizeof(szBeUid) - 1, ",");
    z_get_fieldv(&p, szBeUid, NULL, sizeof(szBeUid) - 1, ",");
    z_get_fieldv(&p, szBeUid, NULL, sizeof(szBeUid) - 1, ",");

    /* ȡûϢ */
    psd = getpwnam(u_pkthead.user);

    if( psd == NULL )
    {
        z_logv(g_logfile, "û");
        GC_sendecode(E_LOGONDENY);
        return(-1);
    }
    sprintf(szUid, "%ld", (long)(psd->pw_uid));

    /* ûHOME */
    z_logv(g_logfile, psd->pw_dir);

    if( access(psd->pw_dir, R_OK) )
    {
        z_logv(g_logfile, "ûHOME");
        GC_sendecode(E_BELONG);
        return(-1);
    }

    /* ֤û */
    addr.s_addr = ntohl(INADDR_LOOPBACK);

    if( z_getkeyv(g_cfgfile, "FTPPORT", szBuf, sizeof(szBuf) - 1) == 0 ) nPort = atoi(szBuf);
    b = GC_ftp_login(inet_ntoa(addr), nPort, u_pkthead.user, szPass, NULL, szBuf);

    if( b >= 0 )
    {
        close(b);
        GC_setpheadn(szBeUid[0] ? szBeUid : szUid, 5);
        GC_setpheadn(g_okcode, 3);

        /* Ӧǰʱ */
        sprintf(szTmp, "%ld", (long)(time(0)));
        GC_sendtext(szTmp);
    }
    else
    {
        z_rtrim(szBuf);
        z_logv(g_logfile, "login=%d, %s", b, szBuf);
        GC_sendecode(E_LOGONFAIL);
    }

    return( b );
}
