#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z.h"

int main(int argc, char **argv)
{
    FILE *fp;

    int   i;
    char *p, ftime[15];

    static char buf1[1024];

    if( argc != 2 ) return(0);

    if( (fp = fopen(argv[1], "r")) == (FILE *)NULL ) return(0);

    ftime[0] = 0;
    while( ! feof(fp) )
    {
        if( fgets(buf1, sizeof(buf1), fp) == NULL ) break;

        for( i = 0, p = buf1; i < 16; i++ )
            z_get_fieldv(&p, ftime, NULL, sizeof(ftime) - 1, "|");
    }
    fclose(fp);

    printf("%8.8s %2.2s:%2.2s:%2.2s", ftime, ftime + 8, ftime + 10, ftime + 12);
    return(0);
}
