//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "BatchFilter.h"
#include "Config.h"
#include "Fpub.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TFrmBatchFilter *FrmBatchFilter;

//---------------------------------------------------------------------------
__fastcall TFrmBatchFilter::TFrmBatchFilter(TComponent* Owner) : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFrmBatchFilter::FormShow(TObject *Sender)
{
        int    k, j, N;
        String pClassName;

        TCheckBox   *pChkBox   = NULL;
        TEdit       *pEdit     = NULL;
        TCheckBox   *pChkBox1  = NULL;
        TRadioGroup *pRadiogrp = NULL;

        m_FrmUpdate = static_cast<TFrmBatchUpdate *>(Owner);

        EditDesc->Text = m_FrmUpdate->m_szDesc;
        EditHost->Text = m_FrmUpdate->m_szHost;
        EditDstPath->Text = m_FrmUpdate->m_szDstPath;
        EditFileAnalyzer->Text = m_FrmUpdate->m_szFileAnalyzer;

        // 
        RadioGrpOperType->ItemIndex = m_FrmUpdate->m_iOperType;

        // Ƿϸſ
        if( m_FrmUpdate->m_iSeqCtrl == 1 )
                ChkBoxSeqCtrl->Checked = true;
        else
                ChkBoxSeqCtrl->Checked = false;

        // ѡǷʹá
        N = sizeof(m_FrmUpdate->m_iCheck) / sizeof(int);
        for( int i = 1; i <= N; i++ )
        {
                pChkBox   = NULL;
                pEdit     = NULL;
                pChkBox1  = NULL;
                pRadiogrp = NULL;

                if( (k = SeekComponent(this, i)) >= 0 )
                {
                        pChkBox = static_cast<TCheckBox *>(this->Components[k]);
                        if( (j = SeekComponent(this, 100 + pChkBox->Tag)) >= 0 )
                        {
                                // ȷ
                                pClassName = Components[j]->ClassName();

                                if( pClassName == "TRadioGroup" ) pRadiogrp = static_cast<TRadioGroup *>(Components[j]);
                                if( pClassName == "TCheckBox" ) pChkBox1 = static_cast<TCheckBox *>(Components[j]);
                                if( pClassName == "TEdit" ) pEdit = static_cast<TEdit *>(Components[j]);
                        }

                        // Ӧ
                        if( m_FrmUpdate->m_iCheck[i - 1] == 1 )
                        {
                                pChkBox->Checked = true;
                                if( pEdit )
                                {
                                        pEdit->Enabled = true;
                                        pEdit->Color = clWindow;
                                }
                                else if( pChkBox1 )
                                {
                                        pChkBox1->Enabled = true;
                                }
                                else if( pRadiogrp )
                                {
                                        pRadiogrp->Enabled = true;
                                }
                        }
                        else
                        {
                                pChkBox->Checked = false;
                                if( pEdit )
                                {
                                        pEdit->Enabled = false;
                                        pEdit->Color = clGrayText;
                                }
                                else if( pChkBox1 )
                                {
                                        pChkBox1->Enabled = false;
                                }
                                else if( pRadiogrp )
                                {
                                        pRadiogrp->Enabled = false;
                                }
                        }
                }
        }
}

//---------------------------------------------------------------------------
void __fastcall TFrmBatchFilter::ChkPublicClick(TObject *Sender)
{
        int k;

        TCheckBox   *pChkBox   = NULL;
        TEdit       *pEdit     = NULL;
        TCheckBox   *pChkBox1  = NULL;
        TRadioGroup *pRadiogrp = NULL;

        pChkBox = static_cast<TCheckBox *>(Sender);
        if( pChkBox == NULL ) return;

        if( (k = SeekComponent(this, 100 + pChkBox->Tag)) < 0 ) return;

        // ȷ
        String pClassName = Components[k]->ClassName();

        if( pClassName == "TRadioGroup" ) pRadiogrp = static_cast<TRadioGroup *>(Components[k]);
        if( pClassName == "TCheckBox" ) pChkBox1 = static_cast<TCheckBox *>(Components[k]);
        if( pClassName == "TEdit" ) pEdit = static_cast<TEdit *>(Components[k]);

        if( pChkBox->Checked == true )
        {
                if( pEdit )
                {
                        pEdit->Enabled = true;
                        pEdit->Color = clWindow;
                }
                else if( pChkBox1 )
                {
                        pChkBox1->Enabled = true;
                }
                else if( pRadiogrp )
                {
                        pRadiogrp->Enabled = true;
                }
        }
        else
        {
                if( pEdit )
                {
                        pEdit->Enabled = false;
                        pEdit->Color = clGrayText;
                }
                else if( pChkBox1 )
                {
                        pChkBox1->Enabled = false;
                }
                else if( pRadiogrp )
                {
                        pRadiogrp->Enabled = false;
                }
        }
}

//---------------------------------------------------------------------------
// ù
void __fastcall TFrmBatchFilter::BtnSetClick(TObject *Sender)
{
        int i, k, N;

        TCheckBox *pChkBox;

        // ΪǷʹá鸳ֵ
        memset(m_FrmUpdate->m_iCheck, 0, sizeof(m_FrmUpdate->m_iCheck));

        N = sizeof(m_FrmUpdate->m_iCheck) / sizeof(int);
        for( i = 1; i < N; i++ )
        {
                if( (k = SeekComponent(this, i)) >= 0 )
                {
                        pChkBox = static_cast<TCheckBox *>(this->Components[k]);
                        if( pChkBox->Checked == true )
                                m_FrmUpdate->m_iCheck[i - 1] = 1;
                        else
                                m_FrmUpdate->m_iCheck[i - 1] = 0;
                }
        }

        strcpy(m_FrmUpdate->m_szDesc, EditDesc->Text.Trim().c_str());
        strcpy(m_FrmUpdate->m_szHost, EditHost->Text.Trim().c_str());
        strcpy(m_FrmUpdate->m_szDstPath, EditDstPath->Text.Trim().c_str());
        strcpy(m_FrmUpdate->m_szFileAnalyzer, EditFileAnalyzer->Text.Trim().c_str());

        // 
        m_FrmUpdate->m_iOperType = RadioGrpOperType->ItemIndex;

        // Ƿϸſ
        if( ChkBoxSeqCtrl->Checked == true )
                m_FrmUpdate->m_iSeqCtrl = 1;
        else
                m_FrmUpdate->m_iSeqCtrl = 0;

        ModalResult = mrOk;
        return;
}
//---------------------------------------------------------------------------

