#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z.h"

#define   SIZE_RECORD   252

/***********************************************
 : תʱ
     : tagin, tagoutֱָ롢
 ˵    4ֽ, λǰ
 ***********************************************/
int tag_dt(char *tagin, char *tagout)
{
    int   year, duration;
    char *p;

    time_t itv;

    p = tagin;

    year = *p;
    year += *(p + 1) << 8;

    if( year > 9999 ||
        p[2] > 99 || p[3] > 99 || p[4] > 99 || p[5] > 99 || p[6] > 99 )
    {
        return(0);
    }

    sprintf(tagout, "%04d%02d%02d%02d%02d%02d", year, p[2], p[3], p[4], p[5], p[6]);

    duration = *(p + 85);
    duration += *(p + 86) << 8;
    duration += *(p + 87) << 16;
    duration += *(p + 88) << 24;

    /* ݿʼʱ䡢ʱʱ */
    itv = z_next_dt(tagout, duration);

    z_get_dt(tagout, 17, "%Y%m%d %T", itv);

    return(0);
}

int main(int argc, char **argv)
{
    FILE *fp;
    char  buf1[SIZE_RECORD + 1], ftime[21];

    if( argc != 2 ) return(0);

    if( (fp = fopen(argv[1], "r")) == (FILE *)NULL ) return(0);

    ftime[0] = 0;
    if( fseek(fp, -SIZE_RECORD, SEEK_END) == 0 )
    {
        if( fread(buf1, 1, SIZE_RECORD, fp) == SIZE_RECORD )
        {
            tag_dt(&buf1[10], ftime);
            printf(ftime);
        }
    }
    fclose(fp);

    return(0);
}
