

#ifndef __SPICE_CLIENT_SMARTCARD_CHANNEL_H__
#define __SPICE_CLIENT_SMARTCARD_CHANNEL_H__

#if !defined(__SPICE_CLIENT_H_INSIDE__) && !defined(SPICE_COMPILATION)
#warning "Only <spice-client.h> can be included directly"
#endif

#include "spice-client.h"

G_BEGIN_DECLS

#define SPICE_TYPE_SMARTCARD_CHANNEL            (spice_smartcard_channel_get_type())
#define SPICE_SMARTCARD_CHANNEL(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), SPICE_TYPE_SMARTCARD_CHANNEL, SpiceSmartcardChannel))
#define SPICE_SMARTCARD_CHANNEL_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), SPICE_TYPE_SMARTCARD_CHANNEL, SpiceSmartcardChannelClass))
#define SPICE_IS_SMARTCARD_CHANNEL(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), SPICE_TYPE_SMARTCARD_CHANNEL))
#define SPICE_IS_SMARTCARD_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), SPICE_TYPE_SMARTCARD_CHANNEL))
#define SPICE_SMARTCARD_CHANNEL_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), SPICE_TYPE_SMARTCARD_CHANNEL, SpiceSmartcardChannelClass))

typedef struct _SpiceSmartcardChannel SpiceSmartcardChannel;
typedef struct _SpiceSmartcardChannelClass SpiceSmartcardChannelClass;
typedef struct _SpiceSmartcardChannelPrivate SpiceSmartcardChannelPrivate;


struct _SpiceSmartcardChannel {
    SpiceChannel parent;

    
    SpiceSmartcardChannelPrivate *priv;
    
};


struct _SpiceSmartcardChannelClass {
    SpiceChannelClass parent_class;

    

    
    
};

GType spice_smartcard_channel_get_type(void);

G_END_DECLS

#endif 

