/******************************************************************************
*
* ļFileOpt.cpp
* ģĿģļ/Ŀ¼洦
						ҵ޹صĹܲ㴦
						Ŀʵֱݿƽ̨
* ߼ڣwang_jin 2007-09-02
* 汾1.0
* ȨϢCVICSE Middleware
* ļ¼wang_jin 2008-05-11
*
******************************************************************************/
#pragma warning(disable:4251)

#ifdef WIN32
#	include <windows.h>
#	include<windowsx.h>   
#	include<iostream.h>  
#	include <shellapi.h>
#	include <imagehlp.h>
# include <direct.h>
#	pragma comment(lib,"imagehlp")
#else
#	include <unistd.h>
#	include <dirent.h>
#	include <sys/stat.h>
#	include <errno.h>
#	include <fcntl.h>
#	ifdef NOT_USE_STD_LIB
#		include <fstream.h>
#	else
#		include <fstream>
#	endif
	extern int errno;
#endif

#include <stdio.h>
#include <stdlib.h> // system()
#include <sys/stat.h>
#include <sys/types.h>
#include <assert.h>

#include "Common/AppError.h"
#include "Common/Common.h"
#include "Common/DateTime.h"
#include "Common/GDString.h"
#include "FileOpt/FileOpt.h"
#include "GDLog/GDLog.h"
#include "GDLog/GDTrace.h"

#ifdef WIN32
#define DIRSEP '\\'
#define R_DIRSEP '/'
#else
#define DIRSEP '/'
#define R_DIRSEP '\\'
#endif

#define BUFFER_SIZE 3

CFileOpt::CFileOpt()
{
}

CFileOpt::~CFileOpt()
{
}

//CreateDirectoryMakeSureDirectoryPathExists
void CFileOpt::MakeSureDirExist( const char* sDir ) throw( CExceptionError )
{
	assert( NULL != sDir && '\0' != sDir[0] );

	if ( !sDir || !*sDir )
	{
		CExceptionError ex;
		ex.m_nErrCode = CAppError::GD_APP_ERR_PARAM_ISNULL;
		ex.AddErrText("Ϊմ");
		ex.AddErrText("CFileOpt:MakeSureDirExist()");
		throw ex;
	}

	CGDTrace trace( LOG_L6, "CFileOpt:MakeSureDirExist(%s)", sDir ); 

	char sPath[GD_MAX_PATH] = {0};
	if ( CGDString::isEndOf(sDir, S_PATHLASH) )
	{
		strcpy( sPath, sDir );
	}
	else
	{
		sprintf( sPath, "%s%c", sDir, C_PATHLASH );
	}

#ifdef WIN32
	if ( ! MakeSureDirectoryPathExists( sPath ) )
	{
		CExceptionError ex;
		ex.m_nErrCode = GetLastError();
		ex.AddErrText( "%s", GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
		ex.AddErrText( "ϵͳ: MakeSureDirectoryPathExists(%s)[%d][%s]", sPath, ex.m_nErrCode, GetErrText(ex.m_nErrCode) );
		ex.AddErrText( "CFileOpt:MakeSureDirExist(%s)", sDir );
		throw ex;
	}
#else
	int nLen = strlen(sPath);
	for ( int i = 2; i < nLen; i++ ) // /͵һַ
	{
		if ( sPath[i] == C_PATHLASH )
		{
			sPath[i] = '\0';
			/*
			S_IRWXU is the bitwise OR of S_IRUSR, S_IWUSR and S_IXUSR.
			S_IRWXG is the bitwise OR of S_IRGRP, S_IWGRP and S_IXGRP.
			S_IRWXO is the bitwise OR of S_IROTH, S_IWOTH and S_IXOTH. 
			*/
			if ( ! IsExist( sPath ) && mkdir(sPath, S_IRWXO|S_IRWXG|S_IRWXU) == -1 )
			{
				CExceptionError ex;
				ex.m_nErrCode = GetLastError();
				if ( EEXIST != ex.m_nErrCode )
				{
					ex.AddErrText( "%s", GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
					ex.AddErrText( "ϵͳ: mkdir(%s)[%d][%s]", sPath, ex.m_nErrCode, GetErrText(ex.m_nErrCode) );
					ex.AddErrText( "CFileOpt:MakeSureDirExist(%s)", sDir );
					throw ex;
				}
			}
			sPath[i] = C_PATHLASH;
		}
	}
#endif
}

long CFileOpt::MoveFileOrFolder( const char* sSrcFile, const char* sDstFile ) throw( CExceptionError )
{
	string sParam;
	sParam = sParam
		+ "sSrcFile[" + sSrcFile
		+ "]sDstFile[" + sDstFile
		+ "]";
	
	CGDTrace trace( LOG_L6, "CFileOpt:MoveFileOrFolder(%s)", sParam.c_str() ); 

#ifdef WIN32
	char sSrcFormat[GD_MAX_PATH] = {0};
	char sDstFormat[GD_MAX_PATH] = {0};
	
	trimDirStr( sSrcFile, sSrcFormat, sizeof(sSrcFormat) );
	trimDirStr( sDstFile, sDstFormat, sizeof(sDstFormat) );
	
	int ret = 0;
	
	try
	{
		bool bFolder = false;
		if ( CFileOpt::IsExist( sDstFile, &bFolder ) && bFolder )
		{
			// Ŀ¼ƶϵͳMoveFileԭ
			// MoveFileĿ¼ʱĿĿ¼ܴڣ˲֧Ŀ¼ϲ
			SHFILEOPSTRUCT op;
			ZeroMemory(&op, sizeof(op)); 
			
			op.hwnd = NULL; 
			op.wFunc = FO_MOVE; 
			op.pFrom = sSrcFormat;
			op.pTo = sDstFormat;
			op.fFlags= FOF_SILENT | FOF_NOCONFIRMATION ; 
			
			int retryNum = 3;
			while( retryNum -- > 0 )
			{
				ret = SHFileOperation(&op);
				if( !ret )
				{
					return 0;
				}
				else
				{
					//ERROR_CANCELLED - 1223Ŀ¼в
					//ERROR_SHARING_VIOLATION - 32ļռ
					if( ret == ERROR_CANCELLED 
						|| ret == ERROR_SHARING_VIOLATION
						|| ret == ERROR_INVALID_HANDLE
						|| ret == ERROR_ALREADY_EXISTS 
						|| ret == ERROR_INVALID_PARAMETER
						|| ret == ERROR_DIR_NOT_EMPTY
						|| ret == ERROR_ACCESS_DENIED
						|| ret == 1026
						|| ret == 65542 )
					{
						CDateTime::Sleep(500);
						continue ;
					}
					
					break ;
				}
			}
			
			if( ret )
			{
				CExceptionError ex;
				ex.m_nErrCode = ret;
				ex.AddErrText( "%s", GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
				ex.AddErrText( "ϵͳ: SHFileOperation() [%d][%s]", ex.m_nErrCode, GetErrText(ex.m_nErrCode) );
				ex.AddErrText( "CFileOpt:MoveFileOrFolder(%s,%s)", sSrcFile, sDstFile );
				throw ex;
			}
			
		}
		else
		{
			BOOL bRet = ::MoveFileEx( sSrcFile, sDstFile, MOVEFILE_REPLACE_EXISTING );
			if( !bRet )
			{
				CExceptionError ex;
				ex.m_nErrCode = GetLastError();
				ex.AddErrText( "%s", GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
				ex.AddErrText( "ϵͳ: MoveFileEx(%s,%s) [%d][%s]", sSrcFile, sDstFile, ex.m_nErrCode, GetErrText(ex.m_nErrCode) );
				ex.AddErrText( "CFileOpt:MoveFileOrFolder(%s,%s)", sSrcFile, sDstFile );
				throw ex;
			}
		}
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "CFileOpt:MoveFileOrFolder(%s,%s)", sSrcFile, sDstFile );
		throw ex;
	}
#else
	
	//int ret = gd3_Move( sSrcFile, sDstFile );
	int ret = rename( sSrcFile, sDstFile );//ļĿ¼Ƴ
	if ( ret )
	{
		if ( ret == EXDEV ) // renameʧܣҪcopy
		{
			if( !gd3_CopyFile(sSrcFile, sDstFile) )
			{
				remove(sSrcFile);
				return 0;
			}
		}
		CExceptionError ex;
		ex.m_nErrCode = GetLastError();
		ex.AddErrText( "%s", GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
		ex.AddErrText( "ϵͳ: rename(%s,%s) [%d][%s]", sSrcFile, sDstFile, ex.m_nErrCode, GetErrText(ex.m_nErrCode) );
		ex.AddErrText( "CFileOpt:MoveFileOrFolder(%s,%s)", sSrcFile, sDstFile );
		throw ex;
	}
	#endif
	    
	return 0;
}

long CFileOpt::CombinFileOrFolder (const char* sSrcFile, const char* sDstFile, string& strResult)throw( CExceptionError )
{
	string sParam;
	sParam = sParam
		+ "sSrcFile[" + sSrcFile
		+ "]sDstFile[" + sDstFile
		+ "]";
	
	CGDTrace trace( LOG_L6, "CFileOpt:CombinFileOrFolder(%s)", sParam.c_str() ); 

	strResult = sDstFile;

    // ԴļĿ¼Ƿ
    bool bSrcDir = false;
    if( !IsExist(sSrcFile, &bSrcDir) )
    {
        CExceptionError ex;
        ex.m_nErrCode = ENOENT;
		ex.AddErrText( "%s", GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
        ex.AddErrText( "ϵͳ: IsExist([%s]) [%d][%s]", sSrcFile, ex.m_nErrCode, GetErrText(ex.m_nErrCode) );
        ex.AddErrText( "CFileOpt:CombinFileOrFolder(Դļ)" );
        throw ex;
    }

    // ĿļĿ¼Ƿ
    bool bDstDir = false;
    bool bDstExist = IsExist(sDstFile, &bDstDir);

	// ļĿ·
	if( !bSrcDir || !bDstExist )
	{
		strResult = sSrcFile;

		return 0;
	}
	
	int ret = 0;

	// Ŀ¼Ŀ·
	if( bSrcDir )
	{
		bool bFinished = false;

		char topPath[GD_MAX_PATH] = {0};
		char localPath[GD_MAX_PATH] = {0};
		char RemotePath[GD_MAX_PATH] = {0};

		strcpy(RemotePath, sDstFile);
		int RemoteLen = strlen(sDstFile);
		strcpy(localPath, sSrcFile);
		int localLen = strlen(sSrcFile);
#ifdef WIN32				
		WIN32_FIND_DATA FileData;
		HANDLE hSearch;

		if(sDstFile[RemoteLen-1] != '\\')
		{
			strcat(RemotePath, "\\");
		}

		if(sSrcFile[localLen-1] != '\\')
		{
			strcat(localPath, "\\");
		}
		sprintf(topPath, "%s*.*", localPath);

		hSearch = FindFirstFile((LPCTSTR)topPath, &FileData);
		if( hSearch == INVALID_HANDLE_VALUE )
		{
			bFinished = true; //Ŀ¼ûļ
		}

		while( !bFinished )
		{
			char strCur[GD_MAX_PATH] = {0};
            char strRmt[GD_MAX_PATH] = {0};
            sprintf(strCur, "%s%s", localPath, FileData.cFileName);
            if( FileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
            {
                sprintf(strRmt, "%s", RemotePath);
            }
            else
            {
                sprintf(strRmt, "%s%s", RemotePath, FileData.cFileName);
            }

			if( strcmp(FileData.cFileName, ".") 
				&& strcmp(FileData.cFileName, "..") )
			{
                // ڲ쳣жϷֵ
				MoveFileOrFolder(strCur, strRmt);
			}
			
			if ( !FindNextFile( hSearch, &FileData ) )
			{
				bFinished = true;
			}
		}
		
		FindClose(hSearch);

		rmdir(sSrcFile);

#else
		if(sDstFile[RemoteLen-1] != '/')
		{
			strcat(RemotePath, "/");
		}
		
		if(sSrcFile[localLen-1] != '/')
		{
			strcat(localPath, "/");
		}
		gd3_Move(sSrcFile,sDstFile);
	/*	strcpy( topPath, localPath );
		topPath[ strlen(topPath) - 1 ] = '\0';

		DIR *dp = opendir(topPath);
		if( !dp )
		{
			CGDLog::WriteErrLog("1061:CombinFileOrFolder: open dir error [%s][%s]", topPath, strerror(errno));
			
			ret = -1;
			if( errno )
			{
				ret = errno;
			}
			
			return ret;
		}
		
		// Now traverse the directory
		struct dirent *dirp = NULL;
		while( (dirp = readdir(dp)) != NULL )
		{
			char strCur[GD_MAX_PATH] = {0};
			char strRmt[GD_MAX_PATH] = {0};
			sprintf(strCur, "%s%s", localPath, dirp->d_name);
			if( dirp->d_type & FILE_ATTRIBUTE_DIRECTORY )
			{
				sprintf(strRmt, "%s", RemotePath);
				CGDLog::WriteErrLog("path is [%s]",strCur);
			}
			else
			{
				sprintf(strRmt, "%s%s", RemotePath, dirp->d_name);
				CGDLog::WriteErrLog("RemotePaht is [%s]",strRmt);
			}
			if ( strcmp(dirp->d_name, ".") && strcmp(dirp->d_name, "..") )
			{
				ret = gd3_Move( strCur, strRmt ); // ļĿ¼Ƴ
				if ( ret )
				{
					CExceptionError ex;
					ex.m_nErrCode = GetLastError();
					ex.AddErrText( "%s", GetErrText(ex.m_nErrCode) );              // wu_binǰ̨Ϣ
					ex.AddErrText( "ϵͳ: rename(%s,%s) [%d][%s]", strCur, strRmt, ex.m_nErrCode, GetErrText(ex.m_nErrCode) );
					ex.AddErrText( "CFileOpt:MoveFileOrFolder(%s,%s)", strCur, strRmt );
					throw ex;
				}
			}
		}
		closedir(dp);
		rmdir(sSrcFile);
	*/
#endif

	}

	return ret;
}


long CFileOpt::AddDeleteElement( const char* sSrcFile ) throw( CExceptionError )
{
	string sParam;
	sParam = sParam
		+ "sSrcFile[" + sSrcFile
		+ "]";
	
	CGDTrace trace( LOG_L6, "CFileOpt:AddDeleteElement(%s)", sParam.c_str() ); 

	long nRet = 0;

	nRet = ::remove( sSrcFile );
	if ( nRet )
	{
		CExceptionError ex;
		ex.m_nErrCode = GetLastError();
		ex.AddErrText( "%s", GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
		ex.AddErrText( "ϵͳ: remove(%s) [%d][%s]", sSrcFile, ex.m_nErrCode, GetErrText(ex.m_nErrCode) );
		ex.AddErrText( "CFileOpt:AddDeleteElement(%s)", sParam.c_str() );
		throw ex;
	}

	return nRet;
}

// GetFileAttributesPathIsDirectory
bool CFileOpt::IsDirectory( const char* strFilePath ) throw ( CExceptionError )
{
#ifdef WIN32
	DWORD dwFileAttr = GetFileAttributes(strFilePath);

	if ( 0xFFFFFFFF == dwFileAttr )
	{
		// ļڻûȨ޷
		CExceptionError ex;
		ex.m_nErrCode = GetLastError();
		ex.AddErrText( "%s", GetErrText(ex.m_nErrCode) );
		ex.AddErrText( "ϵͳ: GetFileAttributes(%s)[%d][%s]", strFilePath, ex.m_nErrCode, GetErrText(ex.m_nErrCode) );
		ex.AddErrText( "IsDirectory(%s)", strFilePath );
		throw ex;
	}

	if ( FILE_ATTRIBUTE_DIRECTORY & dwFileAttr )
	{
		return true;
	}

	return false;

#else

	struct SSTAT buf;
	int nRet = SSTAT(strFilePath, &buf);

	if ( nRet )
	{
		// ļڻûȨ޷
		CExceptionError ex;
		ex.m_nErrCode = GetLastError();
		ex.AddErrText( "%s", GetErrText(ex.m_nErrCode) );
		ex.AddErrText( "ϵͳ: SSTAT(%s)[%d][%s]", strFilePath, ex.m_nErrCode, GetErrText(ex.m_nErrCode) );
		ex.AddErrText( "IsDirectory(%s)", strFilePath );
		throw ex;
	}

	if ( S_ISDIR(buf.st_mode) )
	{
		return true;
	}

	return false;

#endif
}

#if !defined (INVALID_FILE_ATTRIBUTES) 
#	define INVALID_FILE_ATTRIBUTES ((DWORD)-1) 
#endif

bool CFileOpt::IsExist( const char* strFilePath, bool* pbFolder ) throw ( CExceptionError )
{
#ifdef WIN32 // Windows

	DWORD dwFileAttr = GetFileAttributes( strFilePath );

	if ( INVALID_FILE_ATTRIBUTES == dwFileAttr )
	{
		if ( ERROR_FILE_NOT_FOUND == GetLastError() || ERROR_PATH_NOT_FOUND == GetLastError() )
		{
			return false;
		}

		// ʴ׳쳣
		CExceptionError ex;
		ex.m_nErrCode = GetLastError();
		ex.AddErrText( "%s", GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
		ex.AddErrText( "ϵͳ: GetFileAttributes(%s)[%d][%s]", strFilePath, ex.m_nErrCode, GetErrText(ex.m_nErrCode) ); 
		ex.AddErrText( "CFileOpt:IsExist(%s)", strFilePath );
		throw ex;
	}

	if ( pbFolder )
	{
		*pbFolder = ( ( dwFileAttr & FILE_ATTRIBUTE_DIRECTORY ) == FILE_ATTRIBUTE_DIRECTORY );
	}

	return true;

#else // Linux/UNIX

	struct stat buf = {0};
	int nRet = lstat( strFilePath, &buf ); // lstatstatlstatӵϢָļϢ

	if ( 0 != nRet )
	{
		ErrCode err = GetLastError();
		switch ( err )
		{
		case ENOENT: // 
			return false;
		case ENOTDIR: // Ŀ¼(ͬ˷ by wang_jin at 2009-02-28)
			return false;
		}

		// ʴ׳쳣
		CExceptionError ex;
		ex.m_nErrCode = GetLastError();
		ex.AddErrText( "%s", GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
		ex.AddErrText( "ϵͳ: lstat(%s)[%d][%s]", strFilePath, ex.m_nErrCode, GetErrText(ex.m_nErrCode) ); 
		ex.AddErrText( "CFileOpt:IsExist(%s)", strFilePath );
		throw ex;
		/*
		case EBADF: // ļЧ(fstat)
		case EFAULT: // bufΪЧָ룬ָ޷ʵڴռ 
		case ELOOP: // ·ڹ(Ϊ16)
		case ENAMETOOLONG: // file_name·̫ 
		case ENOENT: // ָļڣ·ǿմ 
		case ENOMEM: // ڴ治
		case ENOTDIR: // ·ĲֲĿ¼
		*/
	}

	// Ŀ¼
	if( S_ISDIR(buf.st_mode) )
	{
		if ( pbFolder )
		{
			*pbFolder = true;
		}

		return true;
	}

	// ͨļ
	if( S_ISREG(buf.st_mode) )
	{
		if ( pbFolder )
		{
			*pbFolder = false;
		}
		
		return true;
	}

	// 
	if( S_ISLNK(buf.st_mode) )
	{
		if ( pbFolder )
		{
			*pbFolder = false;
		}
		
		return true;
	}

	// ʽļ(ܵ 豸 ӵ)
	CExceptionError ex;
	ex.m_nErrCode = 1973;
	// ʴ׳쳣
	ex.AddErrText( "ϵͳ: lstat[%s][%d][%s]", strFilePath, ex.m_nErrCode, "ǳļ" );
	ex.AddErrText( "CFileOpt:IsExist(%s)", strFilePath );
	throw ex;

#endif
}

bool CFileOpt::IsLink( const char* strFilePath, char* sRealPath ) throw ( CExceptionError )
{
#ifdef WIN32 // Windows
	return false;
#else // Linux / UNIX
	struct stat buf = {0};
	int nRet = lstat( strFilePath, &buf );
	
	// 
	if( 0 == nRet && S_ISLNK(buf.st_mode) )
	{
		int nSize = readlink( strFilePath, sRealPath, GD_MAX_PATH );
		if ( nSize > 0 )
		{
			return true;
		}
	}

	return false;
#endif
}

long CFileOpt::GetFileSize( const char* strFilePath )
{
	struct SSTAT buf;
	int nRet = 0;
	
	nRet = SSTAT( strFilePath, &buf );
	if( nRet )
	{
		return -1;
	}
	
	if( ( buf.st_mode & S_IFMT ) == S_IFDIR )
	{
		return -2;
	}
	
	return buf.st_size;
}

time_t CFileOpt::GetFileTime( const char* strFilePath, GDDateTime * pDateTime, char type )
{
	struct SSTAT buf;
	int nRet = 0;
	
	nRet = SSTAT( strFilePath, &buf );
	if( nRet )
	{
		return -1;
	}
// modify at 2009.11.25Ϊڷʱһʱ䣬ʱļҲҪȡӦʱ
//	if( ( buf.st_mode & S_IFMT ) == S_IFDIR )
//	{
//		return -2;
//	}
	
	if ( pDateTime )
	{
		time_t tTime = 0;
		switch ( type )
		{
		case 'c': // Create Time
			tTime = buf.st_ctime;
			break;
		case 'm': // Modify Time
			tTime = buf.st_mtime;
			break;
		case 'a': // Access Time
			tTime = buf.st_atime;
			break;
		}
#ifdef WIN32
		FILETIME fileTime;
		CDateTime::UnixTimeToFileTime( tTime, &fileTime );
		FILETIME localFileTime;
		FileTimeToLocalFileTime( &fileTime, &localFileTime );
		::FileTimeToSystemTime( &localFileTime, pDateTime );
#else
		pDateTime->tv_sec = tTime;
		pDateTime->tv_usec = 0;
#endif
	}

	return buf.st_mtime;
}

long CFileOpt::RemoveFile( const char* sFile ) throw( CExceptionError )
{
	CGDTrace trace( LOG_L6, "CFileOpt:DeleteFile(%s)", sFile ); 

	int nRet = 0;

#ifdef WIN32
	char sTmpFile[GD_MAX_PATH] = {0};
	strcpy( sTmpFile, sFile );
	SHFILEOPSTRUCT op = {0};
	op.pFrom= sTmpFile;
	op.fFlags = FOF_NOCONFIRMATION | FOF_NOERRORUI; 
	op.wFunc= FO_DELETE;
	nRet = SHFileOperation(&op); 
	if ( 0 != nRet )
	{
		CExceptionError ex;
		ex.m_nErrCode = GetLastError();
		ex.AddErrText( "%s", GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
		ex.AddErrText( "ϵͳ: SHFileOperation(DELETE,%s)[%d][%s]", sFile, ex.m_nErrCode, GetErrText(ex.m_nErrCode) ); 
		ex.AddErrText( "CFileOpt:DeleteFile(%s)", sFile ); 
		throw ex;
	}
#else
	nRet = remove( sFile );
	if ( nRet )
	{
		CExceptionError ex;
		ex.m_nErrCode = GetLastError();
		ex.AddErrText( "%s", GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
		ex.AddErrText( "ϵͳ: remove(%s)[%d][%s]", sFile, ex.m_nErrCode, GetErrText(ex.m_nErrCode) ); 
		ex.AddErrText( "CFileOpt:DeleteFile(%s)", sFile ); 
		throw ex;
	}
#endif

	return 0;
}

// һĿ¼(ֻһ)
long CFileOpt::MakeDir( const char* sDir ) throw( CExceptionError )
{
	CGDTrace trace( LOG_L6, "CFileOpt:MakeDir(%s)", sDir ); 

#ifdef WIN32
	if ( ::CreateDirectoryA( sDir, NULL ) == FALSE )
	{
		CExceptionError ex;
		ex.m_nErrCode = GetLastError();
		ex.AddErrText( "%s", GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
		ex.AddErrText( "ϵͳ: CreateDirectory(%s)[%d][%s]", sDir, ex.m_nErrCode, GetErrText(ex.m_nErrCode) ); 
		ex.AddErrText( "CFileOpt:MakeDir(%s)", sDir ); 
		throw ex;
	}
#else
	if ( mkdir( sDir, O_RDWR) == -1 ) // S_IRUSR|S_IWUSR|S_IXUSR
	{
		CExceptionError ex;
		ex.m_nErrCode = GetLastError();
		ex.AddErrText( "%s", GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
		ex.AddErrText( "ϵͳ: mkdir(%s)[%d][%s]", sDir, ex.m_nErrCode, GetErrText(ex.m_nErrCode) ); 
		ex.AddErrText( "CFileOpt:MakeDir(%s)", sDir ); 
		throw ex;
		/*
		EACCESȨܲ
		EEXISTpathnameʾĿ¼Ѵ
		EFAULTڴռ䲻ɷ
		ELOOP·Ĺд̫ķ
		ENAMETOOLONG·ĳ
		ENOENT·ݱʾĿ¼
		ENOMEMڴ治
		ENOSPCƻռ䲻
		ENOTDIR·ĲݲĿ¼
		EPERM ·ļϵͳֽ֧Ŀ¼
		EROFSļϵͳֻ 
		*/
	}

#ifdef OS_AIX
	chmod(sDir,S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH);
#else
	chmod(sDir, S_IREAD|S_IWRITE|S_IEXEC|S_IRGRP|S_IROTH|S_IXGRP|S_IXOTH);
#endif
#endif

	return 0;
}

// ɾһĿ¼(Ŀ¼ļ)
long CFileOpt::RemoveDir( const char* sDir )throw( CExceptionError )
{
	CGDTrace trace( LOG_L6, "CFileOpt:RemoveDir(%s).", sDir ); 

	int nRet = 0;

#ifdef WIN32
	char sTmpDir[GD_MAX_PATH] = {0};
	strcpy( sTmpDir, sDir );
	SHFILEOPSTRUCT Op = {0};
	Op.hwnd = NULL; 
	Op.wFunc = FO_DELETE; 
	Op.pFrom = sTmpDir; 
	Op.fFlags = FOF_NOCONFIRMATION | FOF_NOERRORUI; 
	nRet = SHFileOperation(&Op);
	if ( 0 != nRet )
	{
		CExceptionError ex;
		ex.m_nErrCode = GetLastError();
		ex.AddErrText( "%s", GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
		ex.AddErrText( "ϵͳ: SHFileOperation(DELETE,%s)", sDir, ex.m_nErrCode, GetErrText(ex.m_nErrCode) ); 
		ex.AddErrText( "CFileOpt:RemoveDir(%s)", sDir ); 
		throw ex;
	}
#else
	// ˴ΪʱʵΪݹ鴦
	char shell[256 + 10] = {0};
	sprintf( shell, "rm -rf \"%s\"", sDir );
	nRet = system( shell );
	if ( -1 == nRet )
	{
		CExceptionError ex;
		ex.m_nErrCode = GetLastError();
		ex.AddErrText( "%s", GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
		ex.AddErrText( "ϵͳ: system(rm,%s)[%d][%s]", sDir, ex.m_nErrCode, GetErrText(ex.m_nErrCode) ); 
		ex.AddErrText( "CFileOpt:RemoveDir(%s)", sDir ); 
		throw ex;
	}
#endif

	return 0;
}

//ļ
long CFileOpt::BackupFile( const char* sSrcFilePath, const char* sDstFilePath)
{
#ifdef WIN32
	if( IsExist( sSrcFilePath ))
	{
		LPCTSTR  lpsrcfile = sSrcFilePath;   
		LPCTSTR  lpdstfile = sDstFilePath;   		
		if( CopyFile( lpsrcfile,lpdstfile,1 ) )   
			return 0;   
		else     
			return 1; 
	}
	return 0;
#else
	if( IsExist( sSrcFilePath ))
	{
		int src_fd, dst_fd; 
		char buff[BUFFER_SIZE] = {0}; 
		int fr = 0;
		int fw = 0;
		char *ptr;
		
		src_fd = 0; dst_fd = 0; 
		src_fd = open ( sSrcFilePath, O_RDONLY ); 
		if (src_fd < 0) 
			return 1; 	
		dst_fd = open (sDstFilePath, O_RDWR | O_CREAT, S_IRUSR | S_IWUSR); 
		if (dst_fd < 0) 
			return 1; 
		
		while(fr = read( src_fd, &buff, 1 ))
		{
			/* һĴ */
			if(( fr == -1 ) && ( errno != EINTR )) 
				return 1;
			else if( fr > 0 )
			{
				ptr = buff;
				while( fw = write( dst_fd, ptr, fr) )
				{
					/* һ */
					if(( fw == -1 ) && ( errno != EINTR ))
						return 1;
					/* джֽ */
					else if( fw == fr ) 
						break;
					/* ֻдһ,д */
					else if( fw>0 )
					{
						ptr += fw;
						fr -= fw;
					}
				}
				/* дʱ */
				if(fw == -1)
					return 1;
			}
		}
		close(src_fd);
		close(dst_fd);
		return 0;
	}
	return 1;
#endif
}

// ȡϼĿ¼
long CFileOpt::GetParentDir(const char* strFilePath, char* sParentDir)
{
	assert( strFilePath && *strFilePath );

	int nLen = strlen( strFilePath );
	while ( strFilePath[nLen-2] != C_PATHLASH ) nLen--;
	strncpy( sParentDir, strFilePath, nLen - 2 );
	sParentDir[nLen - 2] = '\0';

	return 0;
}

// ȡϼĿ¼(δʹ)
string CFileOpt::GetParentDir(const char* srcfile)
{
	CGDTrace trace( LOG_L6, "CFileOptEx::GetParentDir(%s)", srcfile );
	string srcFile = srcfile;
	srcFile.substr( 0, srcFile.rfind(S_PATHLASH) );
	trace.SetRetText( srcFile.c_str() );
	return srcFile;
}

void CFileOpt::GetParentDir(const char* srcfile, string &str)
{
	CGDTrace trace( LOG_L6, "CFileOptEx::GetParentDir(%s), (%s)", srcfile, str.c_str() );
	str = srcfile;
	if ( str.at(str.size()-1) == C_PATHLASH ) str[str.size()-1] = '\0';
	str.substr( 0, str.rfind(C_PATHLASH) );
}

// ·תд
void CFileOpt::MakeUpper( char * pzStr )
{
	while ( pzStr && *pzStr )
	{
		*pzStr = ('a'<=*pzStr && *pzStr<='z')?(*pzStr+'a'-'A'):*pzStr; // תСд
		pzStr++;
	}
}

// ·תСд
void CFileOpt::MakeLower( char * pzStr )
{
	while ( pzStr && *pzStr )
	{
		*pzStr = ('A'<=*pzStr && *pzStr<='Z')?(*pzStr+'A'-'a'):*pzStr; // תСд
		pzStr++;
	}
}

// ·תд
void CFileOpt::MakeUpper( const char * pzStr, char * pzDst )
{
	while ( pzStr && *pzStr )
	{
		*pzDst = ('a'<=*pzStr && *pzStr<='z')?(*pzStr+'a'-'A'):*pzStr; // תСд
		pzStr++;
		pzDst++;
	}
	*pzDst = '\0';
}

// ·תСд
void CFileOpt::MakeLower( const char * pzStr, char * pzDst )
{
	while ( pzStr && *pzStr )
	{
		*pzDst = ('A'<=*pzStr && *pzStr<='Z')?(*pzStr+'A'-'a'):*pzStr; // תСд
		pzStr++;
		pzDst++;
	}
	*pzDst = '\0';
}

int CFileOpt::htrim(char *line)
{
	int i = 0;
	int left = 0, right = 0;
	int len = 0;
	
	if( !line || (len = strlen(line)) == 0 )
	{
		return -1;
	}
	
	// ȡ߿ʼһǿհַλ
	for( left = 0; (line[left]==' ' || line[left]=='\t' || line[left]== '\r' || line[left]=='\n'); left++);
	
	// ȫǿհַɵĴֱӷ0ȴ
	if( left == len ) 
	{ 
		line[0]='\0'; 
		return 0; 
	}
	
	// ȡұ߿ʼһǿհַλ
	for( right = len-1; (line[right]==' ' || line[right]=='\t' || line[right]== '\r' || line[right]=='\n'); right--);
	
	if( left != 0 )
	{
		// пհַ
		for( i = left; i <= right; i++ )
		{
			line[i - left] = line[i];
		}
	}
	line[right - left + 1] = '\0';
	
	return 0;
}

int CFileOpt::trimDirStr(const char* dir, char* outDir, int outDirSize)
{
	int inLen = strlen(dir);
	if( inLen >= outDirSize )
	{
		return -1;
	}
	
	strcpy(outDir, dir);
	htrim(outDir);
	
	int len = strlen(outDir);
	if( outDir[len-1] == DIRSEP )
	{
		// ɾβ'\\''/'
		outDir[len-1] = '\0';
	}
	
	return 0;
}

// Unix/Linux ļƶ(ֿ֧)
#ifndef WIN32

int CFileOpt::gd3_Move(const char* src, const char* tar)
{
	int status = 0;
	
	int ret = 0;
	
	bool bDir = false;
	if( !IsExist(src, &bDir) )
	{
		CGDLog::WriteErrLog("1059:gd3_MoveDir: file status exception [%s]", src);
		
        return -1;
	}
	
    //
    // ļ
    //
    if( !bDir )
    {
        ret = gd3_MoveFile(src, tar);
		
        return ret;
    }
	
    //
    // Ŀ¼
    //
	if( access(tar, 0) )
	{
		// Ŀ¼
		mode_t md = S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH | S_IXUSR | S_IXGRP | S_IXOTH;
		
		ret = mkdir(tar, md);
		if( ret )
		{
			CGDLog::WriteErrLog("1060:gd3_MoveDir: mkdir error[%s][%s]", tar, strerror(errno));
			
			if( errno )
			{
				ret = errno;
			}
			
			return ret;
		}
	}
	
    DIR *dp = opendir(src);
    if( !dp )
	{
        CGDLog::WriteErrLog("1061:gd3_MoveDir: open dir error [%s][%s]", src, strerror(errno));
		
		ret = -1;
		if( errno )
		{
			ret = errno;
		}
		
        return ret;
    }
	
    // Now traverse the directory
    struct dirent *dirp = NULL;
    while( (dirp = readdir(dp)) != NULL )
	{
		// If has error, Ignore
		
        // Ignore "." and ".." directory. 
        if( !strcmp(".", dirp->d_name) || !strcmp("..", dirp->d_name) )
		{
            continue;
        }
		
        // Get a FROM file's name
        char fromName[GD_MAX_PATH] = {0};
        snprintf(fromName, sizeof(fromName)-1, "%s/%s", src, dirp->d_name);
		
        // Get a TO file's name
        char toName[GD_MAX_PATH] = {0};
        snprintf(toName, sizeof(toName)-1, "%s/%s", tar, dirp->d_name);
		
		ret = gd3_Move(fromName, toName);
        if( ret )
		{
			CGDLog::WriteErrLog("1062:gd3_MoveDir: move [%s]-->[%s] failed", fromName, toName);
			
            status = ret;
		}
		
    } // End of while
	
    closedir(dp);
	
    if( rmdir(src) )
	{
        status = -1;
        CGDLog::WriteErrLog("1063:gd3_MoveDir: rmdir error [%s][%s]", src, strerror(errno));
		
		if( errno )
		{
			status = errno;
		}
    }
	
	return status;
}

int CFileOpt::gd3_MoveFile(const char* src, const char* tar)
{
	CGDTrace trace( LOG_L6, "CFileOpt:gd3_MoveFile(%s,%s)", src, tar );
	try
	{
		bool bFolder = false;
		if ( IsExist(tar, &bFolder) && bFolder )
		{
			// ĿΪĿ¼򷵻ʧ
			CGDLog::WriteErrLog("1064:gd3_MoveFile: move file failed. target[%s] is dir", tar);
			return -1;
		}
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "CFileOpt:gd3_MoveFile(%s,%s)", src, tar );
		CGDLog::WriteErrLog( "1065:CFileOpt:gd3_MoveFile(%s) IsExist throw ex", ex.GetErrText().c_str() );
		return -2;
	}
	
	int err = 0;
	int retryNum = 3;
	
	while( retryNum -- > 0 )
	{
		int ret = rename(src, tar);
		trace.GDTrace( LOG_L6, "%d=rename(%s,%s)", ret, src, tar );

		if( !ret )
		{
			return 0;
		}
		else 
		{
			err = errno;
			if( err == ENOENT )
			{
				//ENOENT - 2Ŀ¼в
				CGDLog::WriteErrLog("1066:gd3_MoveFile: move file [%s]-->[%s] failed, error = [%d] [%s]",
					src, tar, err, strerror(err));
				
				sleep(3);
				continue;
			}
			
			// renameӦԴַĿĵַͬһ
			// ʧܣerrno EXDEV : "Invalid cross-device link"
			if( err == EXDEV )
			{
				if( !gd3_CopyFile(src, tar) )
				{
					remove(src);
					
					return 0;
				}
			}
			
			break;
		}
	}
	
	CGDLog::WriteErrLog("1066:gd3_MoveFile: move file [%s] --> [%s] failed, err = [%d] [%s]",
		src, tar, err, strerror(err));
	
	if( !err )
	{
		err = -1;
	}
	
	return err;
}

int CFileOpt::gd3_CopyFile(const char* src, const char* tar)
{
	CGDTrace trace( LOG_L6, "CFileOpt:gd3_CopyFile(%s,%s)", src, tar );

	if( !strcmp(src, tar) ) 
	{
		return -1;
	}
	
	ifstream inf;
	fstream outf;
	
	inf.open(src);
	outf.open(tar, ios::out | ios::trunc);
	
	if(inf.fail())return false;
	if(outf.fail()) return false;
	
	outf << inf.rdbuf();
	
	inf.close();
	outf.close();
	
	return 0;
}

#endif

bool CFileOpt::IsFileInDir( const char * filepath, const char * parentDir )
{
	CGDTrace trace( LOG_L6, "CFileOpt:IsFileInDir(%s,%s)", filepath, parentDir );
	if (strcmp( filepath, parentDir ) == 0 ) // ǸĿ¼
		return trace.SetRetResult( true );
	
	int size = sizeof( parentDir );
	if (strncmp( filepath, parentDir, size ) == 0 ) // localFileNameǷڸĿ¼
		return trace.SetRetResult( true );
	
	return trace.SetRetResult( false );
}

/* ѧϰ԰
int stat(const char *restrict pathname,struct stat *restrict buf);
ִֵгɹ0ʧܷ-1errno
룺
EACCESS ȡļʱܾ
EBADFļЧ 
EFAULT bufΪЧָ룬ָ޷ڵ ڴ ռ
ELOOP򿪵ļй⣬Ϊ16
ENAMETOOLONG file_name·̫
ENOENTfile_nameָļڣ·ǿִ 
ENOMEM  ڴ治
ENOTDIR ·ĲĿ¼
*/
