/****************************
 в׳
 ****************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z.h"
#include "base.h"
#include "EntityString.h"
#include "DataSet.h"
#include "CICS_BkUniCall.h"

int SplitStr1(char **s, char *d, int *n, int l, char *b);

int main(int argc,char **argv)
{
    CIntRequest  req;
    CIntResponse resp;
    CBkUniCall   call(CICS_SYSTEM_ID);

    char telnum[21] = {0};
    char intid[33] = {0};
    char intcmd[33] = {0};
    char buf[128] = {0};
    char cfgfile[128] = {0};
    char ywname[128] = {0};
    char intmp[513] = {0};
    char sn[10] = {0};
    char region[6] = {0};
    char intag[128] = {0};
    char intagvalue[256] = {0};
    char *p = NULL;
    char ecode[33] = {0};
    char emsg[256] = {0};
    char instr[129] = {0};
    char outstr[8196] = {0};
    char outretcode[10] = {0};
    int jnum = 0;
    int timeout = 0;
    int r = 0;
    int i = 0;
    int j = 0;

    memset(instr, 0, sizeof(instr));

    if( argc < 2 ){
        perror("ļ\n");
        exit(0);
    }
    strcpy(cfgfile, argv[1]);

    if( z_getkeyv(cfgfile, "TESTNAME", ywname, 127) != 0 ){
        strcpy(ywname,"");
    }

    if( z_getkeyv(cfgfile, "TIMEOUT", buf, 5) != 0 ){
        timeout = 60;
    }
    else
    {
        timeout = atoi(buf);
    }

    if( z_getkeyv(cfgfile, "INTID", intid, 32) != 0 ){
        printf( "ļINTID!\n");
        return(-1);
    }
    if( z_getkeyv(cfgfile, "INTCMD", intcmd, 32) != 0 ){
        printf( "ļINTCMD!\n");
        return(-1);
    }
    if( z_getkeyv(cfgfile, "TELNUM", telnum, 20) != 0 ){
        //printf( "ļTELNUM!\n");
        //return(-1);
		strcpy(telnum,"");
    }
    if( z_getkeyv(cfgfile, "REGION", region, 5) != 0 ){
        //printf( "ļREGION!\n");
        //return(-1);
		strcpy(region,"");
    }
    if( z_getkeyv(cfgfile, "INSTR", instr, 128) != 0 ){
        printf( "ļINTSTR!\n");
        return(-1);
    }
    printf("INSTR[%s]\n",instr);
/* ------------------------------------------------- */
    z_lrtrim(intid);
    z_lrtrim(region);
    z_lrtrim(intid);
    z_lrtrim(telnum);
    z_lrtrim(intcmd);

    /* ·ɲ */
    strcpy(req.strIntID, intid);
    strcpy(req.strRegion, region);
    strcpy(req.strOperator, intid);
    strcpy(req.strTelnum, telnum);
    strcpy(req.strIntCmd, intcmd);
    req.transFlag = 1;

    req.m_inParams.Add(new CEntityString(instr));

	printf("========================================\n");
    printf( "\nҵƣ[%s]\n",ywname);
    printf( "INTID[%s]\nINTCMD[%s]\nTELNUM[%s]\nREGION[%s]\nTIMEOUT[%d]\n", intid, intcmd, telnum, region, timeout);

	printf("----------------------------------------\n");
    printf( "ʼ÷ ............. \n");
    /* ÷ */
    for( i = 0; i < 2; i++ )
    {
        try
        {
            call.Invoke(req, resp, timeout);
            break;
        }
        catch(ECustom &e)
        {
            z_logsetonly1(1);
            printf("쳣ϢΪ:%s\n", e.Message);
            if( strstr(e.Message, "񲻿") ) sleep(1);
            if( i == 0 && strstr(e.Message, "·") ) call.Refresh(0);
            else
            {
               	printf("========================================\n");
                return(-1);
            }
        }
    }

/* ----------------------------------------------------------------- */
    /* ȡӦϢ */
    if( (r = resp.m_outParams.GetSize()) == 0 )
    {
        printf( "ûзϢ\n");
        return(-1);
    }

	printf("----------------------------------------\n");
    printf( "ϣΪ:ض GetSize=%d \n", r);

    CEntityString *tmpoutstr = NULL;

    tmpoutstr = dynamic_cast <CEntityString *> (resp.m_outParams.Get(0));

    printf( "outstr=[%s] \n", tmpoutstr->c_str());

/* ------------------------------------------------- */

    printf( "\nRETCODE=[%s], RETMSG=[%s]\n", resp.retcode, resp.strInfo);
	printf("========================================\n");

    return(0);
}

int SplitStr1(char **s, char *d, int *n, int l, char *b)
{
    int i, bl, f;
    if( (bl = strlen(b)) < 1) return(-1);    /* Ч */
    for(i = 0, f = 0, *n = 0; *(*s); (*s)++, (*n)++ ) {
        if( strncmp((*s), b, bl) == 0 ) {
            f = 1;
            (*s) += bl;
            break;
        }
        if( i < l ) d[i++] = *(*s);
    }
    d[i] = 0;
    if( f == 1 ) return(1);
    return(0);
}
