/***********************************************************************
*
* ļ        RunLog.cpp
* ģĿģڼ¼־
* ߼ڣ  wang_jin 2008-05-08
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/
#pragma warning(disable:4251)

#include "GDLock/GDLock.h"
#include "GDLog/RunLog.h"

#include <time.h>
#include <stdarg.h>

CSocketClient CRunLog::m_sock;
bool CRunLog::m_bConnected;
CThreadMutex* CRunLog::m_mutex = NULL;

CRunLog::CRunLog()
{
	m_bConnected = false;
}

CRunLog::~CRunLog()
{
}

bool CRunLog::Init( const char* sIp, short nPort )
{
#ifdef WIN32
	WORD wVer = MAKEWORD( 1, 1 );
	WSADATA wsaData = {0};
	WSAStartup( wVer, &wsaData );
#endif
	if ( 0 == m_sock.Init( sIp, nPort ) )
	{
		m_bConnected = true;
	}
	return m_bConnected;
}

void CRunLog::WriteLog( int no, const char* fmt, ... )
{
	if ( NULL == m_mutex )
	{
		m_mutex = new CThreadMutex();
	}
	CThreadLock lock( *m_mutex );

	char sBuff[1024+10] = {0};
	va_list args;
	va_start( args, fmt );
	vsprintf( sBuff + 9, fmt, args );
	va_end( args );
	int nLen = strlen(sBuff+9);
	sprintf( sBuff, "%04x%04x", no, nLen );
	sBuff[8] = '-';

	if ( m_bConnected )
	{
		if ( m_sock.Send( sBuff, nLen + 9 ) )
		{
			m_bConnected = true;
		}
	}
}

void CRunLog::WriteLog2( int no, const char* fmt, va_list args )
{
	if ( NULL == m_mutex )
	{
		m_mutex = new CThreadMutex();
	}
	CThreadLock lock( *m_mutex );

	char sBuff[1024] = {0};
	vsprintf( sBuff + 9, fmt, args );

	int nLen = strlen(sBuff+9);
	sprintf( sBuff, "%04x%04x", no, nLen );
	sBuff[8] = '-';


	if ( m_bConnected )
	{
		if ( m_sock.Send( sBuff, nLen + 9 ) )
		{
			m_bConnected = true;
		}
	}
}
