/********
 Ÿ澯
 ********/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <errno.h>
#include <unistd.h>
#include "zvdef.h"
#include "zvar.h"
#include "gcps.h"
#include "z.h"

#define   W_ID_NOFILE   "A900"      // 澯ID-ļ

/* ʡ/ֹ˾澯 */
int f_err_warn(int level);

int main(int argc, char **argv)
{
    time_t tNow,                    /* ǰʱ */
           tNoLimit;                /* ļ澯 */

    int    i, r,
           p_no;                    /*  */

    char  *pDevId,
           spno[65];                /* ̱ */

    p_no = 0;
    r = GC_daemon_init(u_pcfgfile, spno, &p_no, NULL, &u_semid);
    if( r )
    {
        printf("󣺳ʼʧ%d", r);
        return(0);
    }

    /* ־ļ */
    if( z_getkeyv(u_pcfgfile, "DIRLOG", u_logdir, sizeof(u_logdir) - 1) )
        strcpy(u_logdir, ALOGDIR);

    snprintf(u_logfile, sizeof(u_logfile), "%s/%s%s", u_logdir, LOGPREFIX, spno);

    /* ȡò */
    r = f_para_read();

    z_logsetsz(u_logmsize);
    /* z_logsetday(1); */
    z_logsetbox(u_logloops);
    z_loglogin(u_logfile, u_logloops);

    if( r < 0 )
    {
        z_logv(u_logfile, "󣺶ȡòʧ");
        return(1);
    }

    /* ӹڴ */
    if( f_conn_zshm(-1, 1) == NULL )
    {
        z_logv(u_logfile, "ӹڴʧ");
        return(1);
    }

    z_logv(u_logfile, "Ok.");

    /* ݽṹ */
    u_pNidNormal = &(u_nid_normal.uData.sNormal);
    u_pNidWarn = &(u_nid_warn.uData.sWarn);

    u_nid_normal.cType = NID_T_NORMAL;
    u_nid_warn.cType = NID_T_WARN;

    /* ɼID */
    gethostname(u_pNidWarn->szNodeId, sizeof(u_pNidWarn->szNodeId) - 1);

    while( 1 )
    {
        sleep(PMON_TIMER);
        z_logv(u_logfile, ".");

        u_pcfgs = u_cfgs;
        u_pruns = u_runs;

        for( i = 0; i < MAXN_Z; i++, u_pcfgs++, u_pruns++ )
        {
            /*  */
            if( GC_semop(u_semid, SN_LOCATION, -1, 0) < 0 )
            {
                z_logv(u_logfile, "󣺼ʧ");
                return(1);
            }

            memcpy(&u_zpara, u_paras, ZPUB_LEN);
            memcpy(&u_zcfg, u_pcfgs, ZCFG_LEN);
            memcpy(&u_zrun, u_pruns, ZRUN_LEN);

            /*  */
            if( GC_semop(u_semid, SN_LOCATION, 1, 0) < 0 )
            {
                z_logv(u_logfile, "󣺽ʧ");
                return(1);
            }

            if( u_zcfg.no[0] == 0 || u_zcfg.warn_mode[WF_ALL] != '1' )
            {
                continue;
            }

            /* ״̬ */
            if( GC_getstat(NULL, u_pruns->pslot) == ST_RELEASED ) continue;

            /*   */
            strcpy(u_pNidWarn->szBelong, u_zrun.uname); /* ֹ˾û */
            strcpy(u_pNidWarn->szProcId, u_zcfg.no);    /* ɼ */

            /* ԪID */
            pDevId = u_zcfg.desc;

            z_get_fieldv(&pDevId, u_pNidWarn->szDeviceId, NULL, sizeof(u_pNidWarn->szDeviceId) - 1, "|");
            z_get_fieldv(&pDevId, u_pNidWarn->szDeviceId, NULL, sizeof(u_pNidWarn->szDeviceId) - 1, "|");

            /* ȷ"ļ"澯 */
            if( u_zcfg.nofile_limit > 0 )
            {
                /* ݸ澯ʱ޸澯 */
                tNoLimit = u_zcfg.nofile_limit;
            }
            else
            {
                /* æʱͳһ澯 */
                if( f_isbusy(u_zcfg.busytime) == 1 )
                    tNoLimit = u_zpara.busynofilet;
                else
                    tNoLimit = u_zpara.freenofilet;
            }

            if( u_zcfg.nofile_limit >= 0 )
            {
                /* ȡϵͳǰʱ */
                tNow = time( (time_t *) 0 );

                /* Ƿﵽļʱ */
                if( u_zrun.noftime == 0 && u_zrun.endtime )
                {
                    if( tNow - u_zrun.endtime > tNoLimit )
                    {
                        u_pruns->noftime = tNow;
                        u_zrun.noftime = tNow;
                    }
                }
            }

            /* йϸ澯 */
            if( u_zrun.errtime || u_zrun.noftime )
            {
                f_err_warn( 1 );                        /* ֹ˾Ÿ澯 */
                if( f_err_warn(0) > 0 )                 /* ʡ˾澯*/
                    f_err_warn(2);                      /* ֹ˾ */
            }
        }
    }
}

/**********************************
 ܣʡ/ ֹ˾澯
 ڲint   ʡ/ ֹ˾־
           0 - ʡ˾
           1 - ֹ˾Ÿ澯
           2 - ֹ˾Ÿ澯()
 **********************************/
int f_err_warn(int level)
{
    time_t tV, tNow;

    int    i,
           bWarn[2] = {0, 0};       /* Ƿ澯[/ļ] */

    int    iSlot;
    uid_t  iUid;

    char  *pMsg,
          *pWarnFile,               /* 澯ļ */
          *pKeyName,                /* ֵ */
          *pExeName,                /* 澯 */
           szWarnMsg[CL];           /* 澯Ϣ */

    static char szWarnCmd[1024],    /* 澯 */
                szContact[1024];    /* ϵ */

    pExeName = SMSEXE;

    /* ǰʱ */
    tNow = time( (time_t *) 0 );

    switch( level )
    {
    case 0:     /* ʡ˾澯 */

        if( u_zpara.prov_warnitv <= 0 ) return(0);

        /* 澯 */
        if( u_zrun.errtime > 0 )
        {
            tV = u_zpara.prov_warnitv * (u_zrun.e_report2 + 1);
            if( tNow - u_zrun.errtime >= tV ) bWarn[0] = 1;
        }

        /* ļ澯 */
        if( u_zrun.noftime > 0 )
        {
            tV = u_zpara.prov_warnitv * (u_zrun.e_nofrep2 + 1);
            if( tNow - u_zrun.noftime >= tV ) bWarn[1] = 1;
        }

        if( bWarn[0] == 0 && bWarn[1] == 0 ) return(0);

        /*  */
        if( GC_semop(u_semid, SN_LOCATION, -1, 0) < 0 ) return(0);

        if( bWarn[0] ) u_pruns->e_report2 = u_zrun.e_report2 + 1;
        if( bWarn[1] ) u_pruns->e_nofrep2 = u_zrun.e_nofrep2 + 1;

        /* rootûĸ澯ʱ䣬̶ʹõһλ */
        u_wtms[0].tWarnTime = time(0);

        if( GC_semop(u_semid, SN_LOCATION, 1, 0) < 0 ) return(0);

        pWarnFile = u_pcfgfile;
        pKeyName = "PROVINCE_SMS_NUMBERS";

        break;

    case 1:     /* ֹ˾澯 */

        if( u_zpara.city_warnitv <= 0 ) return(0);

        /* 澯 */
        if( u_zrun.errtime > 0 )
        {
            tV = u_zpara.city_warnitv * u_zrun.e_report1;
            if( tNow - u_zrun.errtime >= tV ) bWarn[0] = 1;
        }

        /* ļ澯 */
        if( u_zrun.noftime > 0 )
        {
            tV = u_zpara.city_warnitv * u_zrun.e_nofrep1;
            if( tNow - u_zrun.noftime >= tV ) bWarn[1] = 1;
        }

        if( bWarn[0] == 0 && bWarn[1] == 0 ) return(0);

        /* ûIDڸ澯ʱڴеĶӦλ */
        iUid = GC_getuid(NULL, u_zrun.pslot);
        iSlot = f_wtmslot(iUid, 1);

        /*  */
        if( GC_semop(u_semid, SN_LOCATION, -1, 0) < 0 ) return(0);

        if( bWarn[0] ) u_pruns->e_report1 = u_zrun.e_report1 + 1;
        if( bWarn[1] ) u_pruns->e_nofrep1 = u_zrun.e_nofrep1 + 1;

        /* ûĸ澯ʱ */
        if( iSlot >= 0 )
        {
            u_wtms[iSlot].iUid = iUid;
            u_wtms[iSlot].tWarnTime = time(0);
        }

        if( GC_semop(u_semid, SN_LOCATION, 1, 0) < 0 ) return(0);

        pWarnFile = u_pruns->extra;
        pKeyName = "CITY_SMS_NUMBERS";

        break;

    case 2:

        /* pwarnfile = u_pruns->extra;
         * pKeyName = "CITY_DIAL_NUMBERS";
         * pExeName = TELEXE;

         * break;
         */

    default:
        return(0);
    }

    /* ϵ */
    if( z_getkeyv(pWarnFile, pKeyName, szContact, sizeof(szContact) - 1) ) return(0);

    for( i = 0; i < 2; i++ )
    {
        if( bWarn[i] == 0 ) continue;

        if( i == 0 )
        {
            snprintf(szWarnMsg, sizeof(szWarnMsg), "ɼ㣺%sļ%s%s",
                u_zcfg.no, u_zrun.currfile, u_zrun.errmsg);
        }
        else
        {
            snprintf(szWarnMsg, sizeof(szWarnMsg), "ɼ㣺%sļ%sļ %ld",
                u_zcfg.no, u_zrun.currfile, (long)(tNow - u_zrun.endtime));
        }

        /* 澯 */
        snprintf(szWarnCmd, sizeof(szWarnCmd), "%s/%s %s %s 1>/dev/null 2>/dev/null",
            u_plugdir, pExeName, szContact, szWarnMsg);

        z_logv(u_logfile, szWarnCmd);
        system(szWarnCmd);

        /* ¼ܸ澯 */
        if( i == 0 )
        {
            pMsg = u_zrun.errmsg + (EMSG_LEN - NIDW_LEN) + 1;

            if( *pMsg && u_zrun.e_report1 > 0 )
            {
                strncpy(u_pNidWarn->szWarnId, pMsg, sizeof(u_pNidWarn->szWarnId) - 1);
                u_pNidWarn->szWarnId[sizeof(u_pNidWarn->szWarnId) - 1] = 0;
                pMsg += 8;

                strncpy(u_pNidWarn->szWarnType, pMsg, sizeof(u_pNidWarn->szWarnType) - 1);
                u_pNidWarn->szWarnType[sizeof(u_pNidWarn->szWarnType) - 1] = 0;
                pMsg += 8;

                strncpy(u_pNidWarn->szWarnMsg, u_zrun.errmsg, sizeof(u_pNidWarn->szWarnMsg) - 1);
                u_pNidWarn->szWarnMsg[sizeof(u_pNidWarn->szWarnMsg) - 1] = 0;

                u_pNidWarn->iWarnLevel = *pMsg - '0';

                f_nidlog(&u_nid_warn);
            }
        }
        else    /* ļ澯 */
        {
            strcpy(u_pNidWarn->szWarnId, W_ID_NOFILE);
            strcpy(u_pNidWarn->szWarnType, "APP");
            sprintf(u_pNidWarn->szWarnMsg, "ļ %ld", (long)(tNow - u_zrun.endtime));
            u_pNidWarn->iWarnLevel = 9;

            f_nidlog(&u_nid_warn);
        }
    }

    return(1);
}
