#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#ifdef WIN32
#include <windows.h>
#endif


#include "security.h"
#include "securitydb.h"
#ifdef GZ_UNICOM
#define GZ_PASS_LEN   18
#endif

/*ת*/
char f_convert(char c,int pos,int type)
{
	char source0[]="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ`!@#$%^&*()-=_+{}[],.<>?/\\|:;~";
	char retchar = c;
	int len = strlen(source0);
	int i,j;
	switch(type)
	{
	case 1:
		for(i=0;i<len;i++)
		{
			if(source0[i] == c)
			{
				j = (len-i+pos) % len;
				retchar = source0[j];
			}
		}
		break;
	case 2:
		for(i=0;i<len;i++)
		{
			if(source0[i] == c)
			{
				j = (len-i-pos) % len;
				retchar = source0[j];
			}
		}
		break;
	default:
		break;
	}
	return retchar;
}

/**/
void decrypt(char* pass)
{
	char tmpchar;
	int i,length = strlen(pass);
	for(i=0;i<length;i++)
		pass[i] = f_convert(pass[i],i,1);

	for(i=0;i<length/2;i++)
	{
		tmpchar = pass[i];
		pass[i] = pass[length-i-1];
		pass[length-i-1] = tmpchar;
	}
	pass[length]=0;
}

/**/
void encrypt2(char* pass)
{
	char tmpchar;
	int i,length=strlen(pass);
	for (i=0;i<length/2;i++)
	{
		tmpchar = pass[i];
		pass[i] = pass[length-i-1];
		pass[length-i-1]=tmpchar;
	}
	for (i=0;i<length;i++)
		pass[i]=f_convert(pass[i],i,1);
	pass[length]=0;
}


int GetDBUserAndPass( char* opname, char* oppass, char* dbstr,char* dbuser,char *dbpass)
{
	char DBConnectStr[100]={0};
	char mpass[100] ={0};
	sprintf(DBConnectStr,"%s/%s@%s","logon","hbmobile",dbstr);
	if (!J_DBConnect(DBConnectStr)) return 0;
	EncryptTo(oppass,mpass);


	if (_GetDBUserAndPass(opname,mpass,dbuser,dbpass) != 1) 
	{
		printf("_GetDBUserAndPass Error!\n");
		J_DBRelease();
		return 0;
	}
	decrypt(dbuser);
	decrypt(dbpass);

	J_DBRelease();
	return 1;
}



int ConvertDBStr( char *instr,char *outstr)
{
	/*1.õ,,ݿ*/
	int i=0;
	 char *ins=instr;
	char opname[100]={0},oppass[100]={0},db[100]={0};
	char dbuser[100],dbpass[100];

	while(*ins!='/'&&*ins!=0)
		{opname[i++]=*ins;ins++;};
	if (*ins!=0) ins++;opname[i]=0;i=0;
	
	while(*ins!='@'&&*ins!=0)
		{oppass[i++]=*ins;ins++;};
	if (*ins!=0)ins++;oppass[i]=0;i=0;
	
	while(*ins!='\0')
		{db[i++]=*ins;ins++;};
	if (*ins!=0) ins++;db[i]=0;i=0;

	/*2.ȡõ½ݿû*/
		if (!GetDBUserAndPass(opname,oppass,db,dbuser,dbpass))
		{
			return 0;
		}
		sprintf(outstr,"%s/%s@%s",dbuser,dbpass,db);
		return 1;
}



static char* ltrim(char* str)
{
	int i=0,len;
    if(str == NULL) return str;

    len =  strlen(str);
    for(i=0; i<len; i++)
    {
        if(str[i] != ' ')
        {
            memmove(str,&str[i],len-i);
            str[len-i] = 0;
            break;
        }
        else if(i == len-1)
        {
            str[0] = 0;
            break;
        }
    }
    return str;
}

static char* rtrim(char* str)
{
	int i=0,len;
    if(str == NULL) return str;

    len = strlen(str);
    for(i=len-1; i>=0; i--)
    {
        if(str[i]!= ' ')
        {
            str[i+1] = 0;
            break;
        }
    }
    return str;
}
/*жsǷΪַǷ1Ƿ0*/
static int isDigitString(const char *s)
{
	while (*s != '\0'){
		if(*s < '0' || *s > '9')
                {
                    return 0;
                }
		++s;
	}
	return 1;
}

/*
д
汾1.00
룺
	InString:Ҫַܵ
	OutStringַܺ

	1ɹ
	-1:ȫַ
	-2:ȲΪ6λ
*/
int EncryptTo(const char *InString, char *OutString)
{
        char base_64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	char	buf1[6],buf2[32];
	unsigned int b1,b2,b3,b4;
	int	i = 0 ;
	
	if(InString[0] == 0) {
            OutString[0] = 0;
	    return 1;
	}
	if (!isDigitString(InString)) return -1;
	if (strlen(InString)!=6) return -2;

        memset(OutString, 0x00, sizeof(buf2));
        /*memset(buf1, 0x00, sizeof(buf1));*/
        memset(buf2, 0x00, sizeof(buf2));
	InitString(buf1);
	strncpy(buf1,InString,6);
	ltrim(buf2);
    	rtrim(buf2);
	InitString(buf2);
	for(i=0;i<6;i+=3){
        	b1=buf1[i]>>2;
        	b2=((buf1[i]&3)<<4)|(buf1[i+1]>>4);
        	b3=((buf1[i+1]&0x0f)<<2)|(buf1[i+2]>>6);
        	b4=buf1[i+2]&0x3f;
        	buf2[i/3*4+0]=base_64[b1];
        	buf2[i/3*4+1]=base_64[b2];
        	buf2[i/3*4+2]=base_64[b3];
        	buf2[i/3*4+3]=base_64[b4];
    	}
    	buf2[8]='\0';

    	strncpy(OutString,buf2,8);

    	return 1;
}

/*
룺
	InString:Ҫַܵ
	OutStringַܺ

	1ɹ
	-2:ȲΪ8λ
*/

int DecryptFrom(const char *InString,char	*OutString)
{
        char base_64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	char	buf2[32],buf3[32];
	int 	reverse[256];
	unsigned char a1,a2,a3,b1,b2,b3,b4;
	int	i = 0;

	if (strlen(InString)!=8) return -2;

	for(i=0;i<256;i++) reverse[i]=-1;
    	for(i=0;i<64;i++) reverse[base_64[i]]=i;

        memset(OutString, 0x00, sizeof(OutString));
        memset(buf2, 0x00, sizeof(buf2));
        memset(buf3, 0x00, sizeof(buf3));
    	InitString(buf2);
    	strncpy(buf2,InString,strlen(InString));
        ltrim(buf2);
    	rtrim(buf2);

    	InitString(buf3);

	for(i=0;i<6;i+=3)
    	{
        	b1=reverse[buf2[i/3*4+0]];
        	b2=reverse[buf2[i/3*4+1]];
        	b3=reverse[buf2[i/3*4+2]];
        	b4=reverse[buf2[i/3*4+3]];
        	a1=(b1<<2)|(b2>>4);
        	a2=((b2&0x0f)<<4)|(b3>>2);
        	a3=((b3&0x3)<<6)|b4;
        	buf3[i+0]=a1;
        	buf3[i+1]=a2;
        	buf3[i+2]=a3;
    	}
    	buf3[6]='\0';

   	strncpy(OutString,buf3,6);
    	return 1;
}

