

#ifndef SPICE_GRAB_SEQUENCE_H
#define SPICE_GRAB_SEQUENCE_H

#if !defined(__SPICE_CLIENT_GTK_H_INSIDE__) && !defined(SPICE_COMPILATION)
#warning "Only <spice-client-gtk.h> can be included directly"
#endif

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define SPICE_TYPE_GRAB_SEQUENCE            (spice_grab_sequence_get_type ())


typedef struct _SpiceGrabSequence SpiceGrabSequence;

GType spice_grab_sequence_get_type(void);

SpiceGrabSequence *spice_grab_sequence_new(guint nkeysyms, guint *keysyms);
SpiceGrabSequence *spice_grab_sequence_new_from_string(const gchar *str);
SpiceGrabSequence *spice_grab_sequence_copy(SpiceGrabSequence *sequence);
void spice_grab_sequence_free(SpiceGrabSequence *sequence);
gchar *spice_grab_sequence_as_string(SpiceGrabSequence *sequence);


G_END_DECLS

#endif 



