

#ifndef __SPICE_VERSION_H__
#define __SPICE_VERSION_H__

#if !defined(__SPICE_CLIENT_H_INSIDE__) && !defined(SPICE_COMPILATION)
#warning "Only <spice-client.h> can be included directly"
#endif




#define SPICE_GTK_MAJOR_VERSION              (UNKNOWN-dirty)


#define SPICE_GTK_MINOR_VERSION              (UNKNOWN-dirty)


#define SPICE_GTK_MICRO_VERSION              (UNKNOWN)


#define SPICE_GTK_CHECK_VERSION(major, minor, micro)                    \
        (SPICE_GTK_MAJOR_VERSION > (major) ||                           \
         (SPICE_GTK_MAJOR_VERSION == (major) && SPICE_GTK_MINOR_VERSION > (minor)) || \
         (SPICE_GTK_MAJOR_VERSION == (major) && SPICE_GTK_MINOR_VERSION == (minor) && \
          SPICE_GTK_MICRO_VERSION >= (micro)))


#endif 

