/***********************************************************************
*
* ļ        SqlConfig.h
* ģĿģڹSQLļ
* ߼ڣ  liu_yfeng 2008-09-12
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#ifndef SqlConfig_H
#define SqlConfig_H


#include "GDChecker/GDSqlConfig.h"
#include <string>


class CSqlConfig : public CGDSqlConfig
{
public:
	CSqlConfig();
	~CSqlConfig();

public:
	virtual bool Start();
	virtual bool Stop();

	virtual bool StartWeb( const char* sWebAddress );
	virtual bool StopWeb( const char* sWebAddress );

	bool SetCycle( long nCycle );

	bool SetLog( bool bUse );
	bool SetLog( const char* sType, bool bUse, long nSize = 0, long nCount = 0 );

	bool AddExcludeRule( const char* sValue, const char* sDescription = NULL );
	bool AddIncludeRule( const char* sValue, const char* sDescription = NULL );

	bool UpdateExcludeRule( const char* sOldValue, const char* sValue, const char* sDescription = NULL );
	bool UpdateIncludeRule( const char* sOldValue, const char* sValue, const char* sDescription = NULL );

	bool DeleteExcludeRule( const char* sValue );
	bool DeleteIncludeRule( const char* sValue );

private:
	bool SetSqlState( const bool bUse );

private:
	std::string		m_SqlConfigPath;
};


// inline

inline bool CSqlConfig::Start()
{
	return SetSqlState( true );
}

inline bool CSqlConfig::Stop()
{
	return SetSqlState( false );
}


#endif


