/******************
 ų⣬
 ******************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "gcps.h"
#include "z.h"
#include "mo15.h"
#include "security.h"

EXEC SQL INCLUDE SQLCA;

typedef char sc9[9];
typedef char sc16[16];
typedef char sc17[17];
typedef char sc21[21];
typedef char sc33[33];
typedef char sc65[65];
typedef char sc513[513];
typedef char sc1025[1025];
typedef char sc2048[2048];
typedef char scport[PORT_MAXL + 1];

EXEC SQL BEGIN DECLARE SECTION;

    EXEC SQL TYPE sc9    IS STRING(9);
    EXEC SQL TYPE sc16   IS STRING(16);
    EXEC SQL TYPE sc17   IS STRING(17);
    EXEC SQL TYPE sc21   IS STRING(21);
    EXEC SQL TYPE sc33   IS STRING(33);
    EXEC SQL TYPE sc65   IS STRING(65);
    EXEC SQL TYPE sc513  IS STRING(513);
    EXEC SQL TYPE sc1025 IS STRING(1025);
    EXEC SQL TYPE sc2048 IS STRING(2048);
    EXEC SQL TYPE scport IS STRING(PORT_MAXL + 1);

EXEC SQL END DECLARE SECTION;

/**********************
 ݿ⣬׼
 **********************/
int u_dbpre(int pno, char *dblogon)
{
    char db_txt[128],           /* ݿ¼ */
         buf[128];

    int  r, b, f_encry = 1;

/* ------------------------------------------------------------------------- */
    /* Ƿ */
    memset(buf, 0, sizeof(buf));

    if( z_getkeyv(u_cfgfile, "ENCRYPTION", buf, 8) == 0 )
        f_encry = (int) strtol(buf, (char **)NULL, 10);

    memset(db_txt, 0, sizeof(db_txt));

    z_logv(u_logfile, "pno[%s]dblogno[%s]", pno, dblogon);
    if( f_encry ) {
        if( ConvertDBStr(dblogon, db_txt) == 0 ) {
            z_logv(u_logfile, "%sʧ", dblogon);
            return(-1);
        }
    }
    else strcpy(db_txt, dblogon);

    z_logv(u_logfile, "ݿ ...");

    if( (r = u_conndb(db_txt, &b)) < 0 ) {
        z_logv(u_logfile, "%s¼ʧܣRETURN=%dSQLCODE=%d", dblogon, r, b);
        return(-1);
    }
    z_logv(u_logfile, "Ok.");

    return(0);
}

/************
 ȡ 
 ************/
int u_read_rule(SMRULE *prule, char *all_region)
{
    EXEC SQL BEGIN DECLARE SECTION;

    sc33   ruleid;
    sc33   ruletype;
    sc33   opcode;
    sc9    paraseparator;
    sc65   parafixed;

    int    status, haspara, paraoffset,islog;
    short  ind_fixed = 0;

    char   sql_str[256];

    EXEC SQL END DECLARE SECTION;

    int    r = 0;

    strcpy(ruleid, prule->ruleid);

    /* ѯdefine  */
    memset(sql_str, 0, sizeof(sql_str));

    strcpy(sql_str, "SELECT ruletype, opcode, \
 haspara, paraoffset, NVL(paraseparator, ','), parafixed, status ,issendudplog \
 FROM sm_rule_define WHERE ruleid = :1 and status=1");

    /* ׼ѯ */
    EXEC SQL PREPARE define_id FROM :sql_str;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-PREPARE define_id: %s, %d-", sql_str, sqlca.sqlcode);
        return(-1);
    }

    /* ѯα */
    EXEC SQL DECLARE define_cur CURSOR FOR define_id;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-DECLARE define_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    /* define  */
    EXEC SQL OPEN define_cur USING :ruleid;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-OPEN define_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    /* FETCH ¼ */
    EXEC SQL FETCH define_cur INTO :ruletype, :opcode,
        :haspara, :paraoffset, :paraseparator, :parafixed :ind_fixed, :status,:islog;

    if( sqlca.sqlcode == NO_DATA ) r = 1;
    else if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-FETCH define_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    /* رս */
    EXEC SQL CLOSE define_cur;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-CLOSE define_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    if( r || status == 0 ) return(1);

    /*  */
    prule->haspara = haspara;

    prule->isfixed = (ind_fixed == -1 ? 0 : 1);
    prule->status = status;

    if( paraoffset < 0 ) paraoffset = 0;
    else if( paraoffset > 160 ) paraoffset = 160;

    prule->paraoffset = paraoffset;

    strcpy(prule->ruletype, ruletype);
    strcpy(prule->opcode, opcode);
    strcpy(prule->paraseparator, paraseparator);
    strcpy(prule->parafixed, parafixed);
    prule->issendudplog=islog;

    return(0);
}

/************
 ȡ
 ************/
int u_read_para(SMRULE *prule)
{
    EXEC SQL BEGIN DECLARE SECTION;

    sc33   ruleid;
    sc65   paraname;
    sc9    paratype;
    sc2048  paravalue;

    int    inout;
    char   sql_str[256];

    EXEC SQL END DECLARE SECTION;

    strcpy(ruleid, prule->ruleid);

    /* ѯpara  */
    memset(sql_str, 0, sizeof(sql_str));

    strcpy(sql_str, "SELECT paraname, NVL(paravalue, ' '), paratype, inout \
 FROM sm_rule_para WHERE ruleid = :1 ORDER BY paraname");

    /* ׼ѯ */
    EXEC SQL PREPARE para_id FROM :sql_str;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-PREPARE para_id: %s, %d-", sql_str, sqlca.sqlcode);
        return(-1);
    }

    /* ѯα */
    EXEC SQL DECLARE para_cur CURSOR FOR para_id;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-DECLARE para_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    /* para  */
    EXEC SQL OPEN para_cur USING :ruleid;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-OPEN para_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    while( 1 )
    {
        /* FETCH ¼ */
        EXEC SQL FETCH para_cur INTO :paraname, :paravalue, :paratype, :inout;

        if( sqlca.sqlcode == NO_DATA ) break;
        else if( sqlca.sqlcode ) {
            z_logv(u_logfile, "-FETCH para_cur: %d-", sqlca.sqlcode);
            return(-1);
        }

        u_settag(paraname, paravalue, paratype, inout);
    }

    /* رս */
    EXEC SQL CLOSE para_cur;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-CLOSE para_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    return(0);
}

/******************
 ȡ
 ******************/
int u_read_rsfmt(SMRULE *prule)
{
    EXEC SQL BEGIN DECLARE SECTION;

    sc33   ruleid;
    sc33   retcode;
    sc513  smformat;
    sc9    rstype;
    sc2048 rsformat;
    sc33   colmid;

    int    startrow;
    short  ind_rsfmt = 0;

    char   sql_str[256];

    EXEC SQL END DECLARE SECTION;

    int    r = 0;

    prule->f_result = 1;

    strcpy(retcode, prule->retcode);
    strcpy(ruleid, prule->ruleid);

    /* ѯresult  */
    memset(sql_str, 0, sizeof(sql_str));

    strcpy(sql_str,
 "SELECT smformat, startrow, rstype, rsformat, NVL(colmid, ' ') \
 FROM sm_rule_result WHERE ruleid IN(:1, 'DEFAULT') and retcode = :2");

/*z_logv(u_logfile, "ruleid[%s],retcode[%s]",ruleid,retcode);*/
    /* ׼ѯ */
    EXEC SQL PREPARE result_id FROM :sql_str;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-PREPARE result_id: %s, %d-", sql_str, sqlca.sqlcode);
        return(-1);
    }

    /* ѯα */
    EXEC SQL DECLARE result_cur CURSOR FOR result_id;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-DECLARE result_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    /* result  */
    EXEC SQL OPEN result_cur USING :ruleid, :retcode;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-OPEN result_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    /* FETCH ¼ */
    rsformat[0] = 0;

    EXEC SQL FETCH result_cur INTO
        :smformat, :startrow, :rstype, :rsformat :ind_rsfmt, :colmid;

    if( sqlca.sqlcode == NO_DATA ) r = 1;
    else if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-FETCH result_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    /* رս */
    EXEC SQL CLOSE result_cur;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-CLOSE result_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    if( r )
    {
        prule->f_result = 2;
        return(1);
    }

    z_atrim(colmid);

    /*  */
    prule->startrow = startrow;

    strcpy(prule->rstype, rstype);
    strcpy(prule->smformat, smformat);
    strcpy(prule->rsformat, rsformat);
    strcpy(prule->colmid, colmid);
/*z_logv(u_logfile, "rstype[%s],smformat[%s,rsformat[%s],colmid[%s],ruleid[%s],retcode[%s]",rstype, smformat, rsformat, colmid,ruleid,retcode);*/
    return(0);
}

/****************
 ȡĿ
 ****************/
int u_read_check(SMRULE *prule)
{
    EXEC SQL BEGIN DECLARE SECTION;

    sc33   ruleid;
    sc9    logictype;
    sc9    sn;
    sc1025  logictext;

    char   sql_str[128];

    EXEC SQL END DECLARE SECTION;

    int    b = 0;

    strcpy(ruleid, prule->ruleid);

    /* ѯcheck  */
    memset(sql_str, 0, sizeof(sql_str));

    strcpy(sql_str,
 "SELECT sn, logictype, logictext FROM sm_rule_check WHERE ruleid = :1 ORDER BY SN");

    /* ׼ѯ */
    EXEC SQL PREPARE check_id FROM :sql_str;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-PREPARE check_id: %s, %d-", sql_str, sqlca.sqlcode);
        return(-1);
    }

    /* ѯα */
    EXEC SQL DECLARE check_cur CURSOR FOR check_id;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-DECLARE check_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    /* para  */
    EXEC SQL OPEN check_cur USING :ruleid;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-OPEN check_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    while( 1 )
    {
        /* FETCH ¼ */
        EXEC SQL FETCH check_cur INTO :sn, :logictype, :logictext;

        if( sqlca.sqlcode == NO_DATA ) break;
        else if( sqlca.sqlcode )
        {
            z_logv(u_logfile, "-FETCH check_cur: %d-", sqlca.sqlcode);
            return(-1);
        }

        /*  */
        b = u_rule_check(prule, logictype, logictext);
        z_logv(u_logfile, "sn=%s, logictype=%s, b=%d", sn, logictype, b);

        if( b ) break;
    }

    /* رս */
    EXEC SQL CLOSE check_cur;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-CLOSE check_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    return(b);
}

/************
 Ӧ
 ************/
int u_to_send(SMREQ *req, char *pmsg, char *retcode1, char *retmsg1, char *ywformnum1)
{
    EXEC SQL BEGIN DECLARE SECTION;

    sc33   formnum;
    sc21   telnum;
    sc17   templno;
    sc33   relformnum;
    sc33   ywformnum;
    sc513  parav;
    sc33   retcode;
    sc513  retmsg;

    int    region;
    char   para, sql_str[256];
    char   gtemplate[17],gdispport[22];

    EXEC SQL END DECLARE SECTION;

    int    i, len = 0;
    char  *p, key[65], templ_prefix[17];

    if( pmsg == NULL || *pmsg == 0 ) return(0);

    /* ȡļеģǰ׺ 100866ͷж̶*/

    memset(gtemplate, 0, sizeof(gtemplate));
    memset(gdispport, 0, sizeof(gdispport));
    memset(retmsg, 0, sizeof(retmsg));
    memset(retcode, 0, sizeof(retcode));
    memset(ywformnum, 0, sizeof(ywformnum));
    u_gettag("GTEMPLATE", gtemplate, PARA_ALL);
    u_gettag("GDISPPORT", gdispport, PARA_ALL);

    strncpy(retcode,retcode1, 32);
    strncpy(retmsg,retmsg1, 512);
    strncpy(ywformnum,ywformnum1, 32);
    
    sprintf(key, "TEMPLATE_%s", req->PORT);

    if(strlen(gtemplate) !=0 )
    {
        strcpy(templ_prefix, gtemplate);
    }
    else
    {
        if( z_getkeyv(u_cfgfile, key, templ_prefix, 16) )
        {
            z_logv(u_logfile, "ģǰ׺ '%s' δ,˿[%s],ģ[%s]", key, req->PORT, templ_prefix);
            return(0);
        }
    }

    /* кŵ */
    memset(sql_str, 0, sizeof(sql_str));

    strcpy(sql_str, "SELECT TO_CHAR(seq_oid.NEXTVAL) FROM DUAL");

    /* ׼ѯ */
    EXEC SQL PREPARE seq_id FROM :sql_str;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-PREPARE seq_id: %s, %d-", sql_str, sqlca.sqlcode);
        return(-1);
    }

    /* ѯα */
    EXEC SQL DECLARE seq_cur CURSOR FOR seq_id;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-DECLARE seq_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    /* ȡк */
    EXEC SQL OPEN seq_cur;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-OPEN seq_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    EXEC SQL FETCH seq_cur INTO :formnum;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-FETCH seq_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    EXEC SQL CLOSE seq_cur;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-CLOSE seq_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    region = req->REGION;

    /* notify_para  */
    memset(sql_str, 0, sizeof(sql_str));

    sprintf(sql_str, "INSERT INTO %s(region, formnum, para_no, para) \
 VALUES(:1, :2, :3, :4)", u_sendtabpara);

    /* ׼ѯ */
    EXEC SQL PREPARE notify_para_id FROM :sql_str;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-PREPARE notify_para_id: %s, %d-", sql_str, sqlca.sqlcode);
        return(-1);
    }

    /* 4 ¼ */
    for( i = 0, p = pmsg; i < 4 && *p; i++, p += len )
    {
        len = z_chi_nohalf(p, 512);

        switch( i )
        {
        case 0:
            para = '1';
            sprintf(templno, "%s1", templ_prefix);
            break;
        case 1:
            para = '2';
            sprintf(templno, "%s2", templ_prefix);
            break;
        case 2:
            para = '3';
            sprintf(templno, "%s3", templ_prefix);
            break;
        case 3:
            para = '4';
            sprintf(templno, "%s4", templ_prefix);
            break;
        }

        strncpy(parav, p, len);
        parav[len] = 0;

        EXEC SQL EXECUTE notify_para_id USING :region, :formnum, :para, :parav;

        if( sqlca.sqlcode ) {
            z_logv(u_logfile, "-EXECUTE notify_para_id: %d-", sqlca.sqlcode);
            return(-1);
        }
    }

    /* notify */
    strcpy(telnum, req->TELNUM);
    strcpy(relformnum, req->FORMNUM);

    /* notify  */
    memset(sql_str, 0, sizeof(sql_str));

    sprintf(sql_str, "INSERT INTO %s(region, formnum, telnum, notifytype, sfrom, \
 template_no, relatedformnum, retcode, retmsg, ywformnum) VALUES(:1, :2, :3, '_DEAL', :5, :6, :7, :8, :9, :10)", u_sendtab);

    /* ׼ */
    EXEC SQL PREPARE notify_id FROM :sql_str;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-PREPARE notify_id: %s, %d-", sql_str, sqlca.sqlcode);
        return(-1);
    }

    EXEC SQL EXECUTE notify_id USING :region, :formnum, :telnum, :gdispport, :templno, :relformnum, :retcode, :retmsg, :ywformnum;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-EXECUTE notify_id: %d-", sqlca.sqlcode);
        return(-1);
    }

    EXEC SQL COMMIT;
    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-COMMIT: %d-", sqlca.sqlcode);
        return(-1);
    }

    return(0);
}

/**************
 м
 **************/
int u_in_mid(SMREQ *req, int rows, int cols, char (*mid)[65])
{
    EXEC SQL BEGIN DECLARE SECTION;

    sc16   telnum;
    scport port;
    sc65   midcol1, midcol2, midcol3, midcol4, midcol5, midcol6;

    int    region, seqno;
    char   sql_str[256];

    EXEC SQL END DECLARE SECTION;

    int    i, j;

    midcol1[0] = 0; midcol2[0] = 0; midcol3[0] = 0;
    midcol4[0] = 0; midcol5[0] = 0; midcol6[0] = 0;

    region = req->REGION;

    strcpy(telnum, req->TELNUM);
    strcpy(port, req->PORT);

    /* SM_QRY_MIDDLE ɾ */
    memset(sql_str, 0, sizeof(sql_str));

    strcpy(sql_str,
 "DELETE FROM sm_qry_middle WHERE region = :1 AND telnum = :2 AND port = :3");

    /* ׼ɾ */
    EXEC SQL PREPARE del_qry_mid_id FROM :sql_str;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-PREPARE del_qry_mid_id: %s, %d-", sql_str, sqlca.sqlcode);
        return(-1);
    }

    /* ɾsm_qry_middleʷ */
    EXEC SQL EXECUTE del_qry_mid_id USING :region, :telnum, :port;

    if( sqlca.sqlcode && sqlca.sqlcode != NO_DATA ) {
        z_logv(u_logfile, "-EXECUTE del_qry_mid_id: %d-", sqlca.sqlcode);
        return(-1);
    }

    /* SM_QRY_MIDDLE  */
    memset(sql_str, 0, sizeof(sql_str));

    strcpy(sql_str, "INSERT INTO sm_qry_middle \
 (region, telnum, port, seqno, midcol1, midcol2, midcol3, midcol4, midcol5, midcol6) \
 VALUES(:1, :2, :3, :4, :5, :6, :7, :8, :9, :10)");

    /* ׼ */
    EXEC SQL PREPARE in_qry_mid_id FROM :sql_str;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-PREPARE in_qry_mid_id: %s, %d-", sql_str, sqlca.sqlcode);
        return(-1);
    }

    /* sm_qry_middle */
    for( i = 0; i < rows; i++ )
    {
        seqno = i + 1;

        for( j = 0; j < cols; j++ )
        {
            switch( j )
            {
                case 0:
                    strcpy(midcol1, mid[0]);
                    break;

                case 1:
                    strcpy(midcol2, mid[0]);
                    break;

                case 2:
                    strcpy(midcol3, mid[0]);
                    break;

                case 3:
                    strcpy(midcol4, mid[0]);
                    break;

                case 4:
                    strcpy(midcol5, mid[0]);
                    break;

                case 5:
                    strcpy(midcol6, mid[0]);
                    break;
            }

            mid++;
        }
//z_logv(u_logfile, "region[%d],telnum[%s],port[%s],seqno[%d],midcol1[%s],midcol2[%s],midcol3[%s],midcol4[%s],midcol5[%s],midcol6[%s]",region,telnum,port,seqno,midcol1,midcol2,midcol3,midcol4,midcol5,midcol6);
        
        if(strlen(midcol1)==0 && strlen(midcol2)==0) break;
            
        EXEC SQL EXECUTE in_qry_mid_id USING :region, :telnum, :port, :seqno,
            :midcol1, :midcol2, :midcol3, :midcol4, :midcol5, :midcol6;

        if( sqlca.sqlcode ) {
            z_logv(u_logfile, "-EXECUTE in_qry_mid_id: %d-", sqlca.sqlcode);
            return(-1);
        }
    }

    EXEC SQL COMMIT;
    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-COMMIT: %d-", sqlca.sqlcode);
        return(-1);
    }

    return(0);
}

/**********************
 ѯмʷ¼
 **********************/
int u_read_mid(SMRULE *prule, SMREQ *req)
{
    EXEC SQL BEGIN DECLARE SECTION;

    sc16   telnum;
    scport port;
    sc65   midcol1, midcol2, midcol3, midcol4, midcol5, midcol6;

    int    region, seqno;
    short  ind_mid[6] = {0, 0, 0, 0, 0, 0};

    char   sql_str[256];

    EXEC SQL END DECLARE SECTION;

    int    r = 0;
    char   value[2049],tmpvalue[2049];

    midcol1[0] = 0; midcol2[0] = 0; midcol3[0] = 0;
    midcol4[0] = 0; midcol5[0] = 0; midcol6[0] = 0;

    value[0] = 0;
    tmpvalue[0] = 0;
printf("[%s, %s, %d]\n", NAME_REC_SEQ, value, PARA_ALL);
    u_gettag(NAME_REC_SEQ, tmpvalue, PARA_ALL);
//    u_var_replace(tmpvalue, value);
    u_rep_single_var(prule, NAME_REC_SEQ, value);
printf("[%s, %s, %s, %d]\n", NAME_REC_SEQ, tmpvalue, value, PARA_ALL);

    seqno = (int) strtol(value, (char **)NULL, 10);
//    seqno --;
    region = req->REGION;

    strcpy(telnum, req->TELNUM);
    strcpy(port, req->PORT);

printf("seqno=%d\n", seqno);
    /* SM_QRY_MIDDLE ѯ */
    memset(sql_str, 0, sizeof(sql_str));

    strcpy(sql_str,
 "SELECT midcol1, midcol2, midcol3, midcol4, midcol5, midcol6 FROM sm_qry_middle \
 WHERE region = :1 AND telnum = :2 AND port = :3 AND seqno = :4");

    /* ׼ѯ */
    EXEC SQL PREPARE qry_mid_id FROM :sql_str;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-PREPARE qry_mid_id: %s, %d-", sql_str, sqlca.sqlcode);
        return(-1);
    }

    /* ѯα */
    EXEC SQL DECLARE qry_mid_cur CURSOR FOR qry_mid_id;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-DECLARE qry_mid_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    /* qry_mid  */
    EXEC SQL OPEN qry_mid_cur USING :region, :telnum, :port, :seqno;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-OPEN qry_mid_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    /* FETCH ¼ */
    EXEC SQL FETCH qry_mid_cur INTO
        :midcol1 :ind_mid[0], :midcol2 :ind_mid[1], :midcol3 :ind_mid[2],
        :midcol4 :ind_mid[3], :midcol5 :ind_mid[4], :midcol6 :ind_mid[5];

    if( sqlca.sqlcode == NO_DATA ) r = 1;
    else if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-FETCH qry_mid_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    /* رս */
    EXEC SQL CLOSE qry_mid_cur;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-CLOSE qry_mid_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    u_settag("MIDCOL1", midcol1, NULL, PARA_TMP);
    u_settag("MIDCOL2", midcol2, NULL, PARA_TMP);
    u_settag("MIDCOL3", midcol3, NULL, PARA_TMP);
    u_settag("MIDCOL4", midcol4, NULL, PARA_TMP);
    u_settag("MIDCOL5", midcol5, NULL, PARA_TMP);
    u_settag("MIDCOL6", midcol6, NULL, PARA_TMP);

    if( r ) return(1);

    return(0);
}

/******************
 ¼ ORACLE ݿ
 ******************/
int u_conndb(char *dbinfo, int *b)
{
    EXEC SQL BEGIN DECLARE SECTION;
    char userid[128];
    EXEC SQL END DECLARE SECTION;

    *b = 0;

    /*  ORACLE ݿ */
    memset(userid, 0, sizeof(userid));
    strcpy(userid, dbinfo);

    EXEC SQL CONNECT :userid;
    if( sqlca.sqlcode ) {
        *b = sqlca.sqlcode;
        return(-1);
    }

    return(0);
}


/****************
 ȡĿ
 ****************/
int u_get_sysdate(char *datestr)
{
    EXEC SQL BEGIN DECLARE SECTION;

    sc21   systime;
    char   sql_str[128];

    EXEC SQL END DECLARE SECTION;





    /* ѯcheck  */
    memset(sql_str, 0, sizeof(sql_str));

    strcpy(sql_str,"SELECT tosysdate from dual");

    /* ׼ѯ */
    EXEC SQL PREPARE check_id FROM :sql_str;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-PREPARE check_id: %s, %d-", sql_str, sqlca.sqlcode);
        return(-1);
    }

    /* ѯα */
    EXEC SQL DECLARE check_curs CURSOR FOR check_id;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-DECLARE check_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    /* para  */
    EXEC SQL OPEN check_curs ;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-OPEN check_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    while( 1 )
    {
        /* FETCH ¼ */
        EXEC SQL FETCH check_curs INTO :systime;

        if( sqlca.sqlcode == NO_DATA ) break;
        else if( sqlca.sqlcode )
        {
            z_logv(u_logfile, "-FETCH check_cur: %d-", sqlca.sqlcode);
            return(-1);
        }

        /*  */
        
        strcpy(datestr,systime);
        
    }

    /* رս */
    EXEC SQL CLOSE check_curs;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-CLOSE check_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    return(0);
}

/****************
 ʱȡʱǰʱ,صǰʱ
 ****************/
int u_get_duration(char *datein,char *dateout)
{
    EXEC SQL BEGIN DECLARE SECTION;

    sc21   date1;
    sc21   date2;
    int    duration;
    char   sql_str[256];

    EXEC SQL END DECLARE SECTION;

    int    b = 0;
    memset(date1,0,sizeof(date1));
   memset(date2,0,sizeof(date2));
   strcpy(date1, datein); 

    /* ѯcheck  */
    memset(sql_str, 0, sizeof(sql_str));

    strcpy(sql_str,"select to_char(sysdate,'yyyy-mm-dd hh24:mi:ss'),(sysdate - to_date( :1 ,'yyyy-mm-dd hh24:mi:ss')) * 24 * 3600000 + round(to_char(current_timestamp, 'ff')/1000) from dual");
z_logv(u_logfile, "sql_str [%s]", sql_str);
    /* ׼ѯ */
    EXEC SQL PREPARE check_id FROM :sql_str;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-PREPARE check_id: %s, %d-", sql_str, sqlca.sqlcode);
        return(-1);
    }

    /* ѯα */
    EXEC SQL DECLARE check_curt CURSOR FOR check_id;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-DECLARE check_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    /* para  */
    EXEC SQL OPEN check_curt USING :date1;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-OPEN check_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    while( 1 )
    {
        /* FETCH ¼ */
        EXEC SQL FETCH check_curt INTO :date2,:duration;

        if( sqlca.sqlcode == NO_DATA ) break;
        else if( sqlca.sqlcode )
        {
            z_logv(u_logfile, "-FETCH check_cur: %d-", sqlca.sqlcode);
            return(-1);
        }
        
        strcpy(dateout,date2);
    }

    /* رս */
    EXEC SQL CLOSE check_curt;

    if( sqlca.sqlcode ) {
        z_logv(u_logfile, "-CLOSE check_cur: %d-", sqlca.sqlcode);
        return(-1);
    }

    return(duration);
}

