// DBViewerView.cpp : CDBViewerView ʵ
//

#include "stdafx.h"
#include "DBViewer.h"

#include "DBViewerDoc.h"
#include "DBViewerView.h"
#include ".\dbviewerview.h"
#include "MainFrm.h"
#include "LeftView.h"
//#include "FindRecordDlg.h"
#include "DBTree/DB.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CListCtrl* CDBViewerView::m_pListCtrl = NULL;
UINT CDBViewerView::m_nId = 0;
// CDBViewerView

IMPLEMENT_DYNCREATE(CDBViewerView, CFormView)

BEGIN_MESSAGE_MAP(CDBViewerView, CFormView)
//	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_DBRECORD_FIND, OnDbRecordFind)
	ON_WM_SIZE()
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_DBRECORD, OnLvnItemchangedListDbrecord)
END_MESSAGE_MAP()

// CDBViewerView /

CDBViewerView::CDBViewerView()
	: CFormView(CDBViewerView::IDD)
	, m_pFindDlg(NULL)
{
	// TODO: ڴ˴ӹ

}

CDBViewerView::~CDBViewerView()
{
}

void CDBViewerView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_DBRECORD, m_listDbRecord);
}

BOOL CDBViewerView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ڴ˴ͨ޸ CREATESTRUCT cs ޸Ĵ
	// ʽ

	return CFormView::PreCreateWindow(cs);
}

void CDBViewerView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

	m_listDbRecord.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES | LVS_EX_INFOTIP);

	m_listDbRecord.InsertColumn(0, _T(""),	LVCFMT_LEFT,	40,		0);
	m_listDbRecord.InsertColumn(1, _T("ˮӡ"),	LVCFMT_LEFT,	250,	0);
	m_listDbRecord.InsertColumn(2, _T("Ŀ¼"),LVCFMT_LEFT,50,	0);
	m_listDbRecord.InsertColumn(3, _T("ļ"),LVCFMT_LEFT,	400,	0);

	m_pListCtrl = &m_listDbRecord;
/*
	m_pFindDlg = new CFindRecordDlg;
	m_pFindDlg->Create(IDD_DIALOG_DBRECORDFIND, this);
	m_pFindDlg->ShowWindow(SW_HIDE);
	*/
}


// CDBViewerView 

#ifdef _DEBUG
void CDBViewerView::AssertValid() const
{
	CFormView::AssertValid();
}

void CDBViewerView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CDBViewerDoc* CDBViewerView::GetDocument() const // ǵ԰汾
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDBViewerDoc)));
	return (CDBViewerDoc*)m_pDocument;
}
#endif //_DEBUG


// CDBViewerView Ϣ

void CDBViewerView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	if (IsWindow(m_listDbRecord.GetSafeHwnd()))  
	{  
		m_listDbRecord.SetWindowPos(  
			this,   0,   0,  
			cx,   cy,    
			SWP_NOOWNERZORDER   |   SWP_NOZORDER   |   SWP_SHOWWINDOW   );  
	}
}

void CDBViewerView::ShowDbCall(const char* sPath, const char* sWm)
{
	CString strId;
	strId.Format("%d", m_nId);

	m_pListCtrl->InsertItem(m_nId, strId);
	m_pListCtrl->SetItemText(m_nId, 0, strId);
	m_pListCtrl->SetItemText(m_nId, 1, sWm);
	m_pListCtrl->SetItemText(m_nId, 2, (strlen(sWm) == 0) ? "" : "-");
	m_pListCtrl->SetItemText(m_nId, 3, sPath);

	m_nId++;
}

void CDBViewerView::ShowDb(const char* sPath)
{
	m_nId = 0;
	m_pListCtrl->DeleteAllItems();

	//db.ShowData(ShowDb);
	CLeftView* pView=(CLeftView*)((CMainFrame*)AfxGetMainWnd())->m_wndSplitter.GetPane(0, 0);
	pView->GetDirTreeCtrl()->m_pDb->ShowDirData(sPath, CDBViewerView::ShowDbCall);
}


void CDBViewerView::OnDbRecordFind()
{
//	m_pFindDlg->ShowWindow(SW_SHOW);
}

void CDBViewerView::FindItem(int nType, const CString& strText)
{
	int nTotal = m_listDbRecord.GetItemCount();
	int nSelect = 0;
	CString strRecord;
	int nCol = 0;

	if (nType == 0)
		nCol = 3; // ļ
	else
		nCol = 1; // ˮӡ


	for (int i = 0; i < nTotal; i++)
	{
		m_listDbRecord.SetItemState(i, NULL, NULL);
	}

	for (i = 0; i < nTotal; i++)
	{
		strRecord = m_listDbRecord.GetItemText(i, nCol);

		if (strRecord.Compare(strText) == 0) // ҵ
		{
			m_listDbRecord.SetFocus();
			m_listDbRecord.SetItemState(i, LVIS_SELECTED, LVIS_SELECTED);
			return;
		}
	}

	::AfxMessageBox("ûзļ¼!");
}

void CDBViewerView::OnLvnItemchangedListDbrecord(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	// TODO: ڴӿؼ֪ͨ
	*pResult = 0;
}
