/***********************************************************************
*
* ļ DirDiffer.cpp
* ģĿģ ļɨĿ¼
* ߼ڣ wu_bin 2009-08-1
* 汾 1.0
* ȨϢ CVICSE Middleware
* ļ¼ wang_jin 2009-9-4
*
***********************************************************************/

#pragma warning ( disable : 4251 4786 )

#include "Common/Common.h"
#include "Common/GDString.h"
#include "Common/GDTimer.h"
#include "Common/ParamList.h"
#include "GDLog/GDLog.h"
#include "GDLog/GDTrace.h"
#include "GDLog/LogFile.h"
#include "GDLog/ThreadData.h"

#include "DirDiffer.h"
#include "FileTreeComper.h"

#include <iostream>
#include <string>

using namespace std;

namespace InforGuard{
namespace FileScanner{


long CDirDiffer::m_nSeconds = 1;

CDirDiffer::CDirDiffer()
{
}

CDirDiffer::~CDirDiffer()
{
}

bool CDirDiffer::SetPolicy( const CMonitorInformation & moniInfo )
{
	m_sDirId = moniInfo.m_sDirId;
	m_sMonitorPath = moniInfo.m_monitorPath;
	return m_fileExclude.SetRules( moniInfo );
}

bool CDirDiffer::StartMonitor()
{
	CGDTrace trace( LOG_L6, "CDirDiffer::StartMonitor()" );
	long nRet = Start();
	if ( nRet == 0 )
	{
		return true;
	}
	return false;
}

bool CDirDiffer::StopMonitor()
{
	CGDTrace trace( LOG_L6, "CDirDiffer::StopMonitor()" );
	long nRet = Stop();
	if ( nRet == 0 )
	{
		return true;
	}
	return false;
}

long CDirDiffer::Run( void* param )
{
	CGDTrace trace( LOG_L6, "CDirDiffer::Run()" );
	// DirDiffer־
	CThreadData::SetCurrentThreadLogFile( "scan", true ); // ߳()־
    CGDLog::WriteThreadState("Diff thread started");          //wu_binд߳״̬

	while( InforGuard::GDThreadPool::TS_STOPING != m_status )
	{
		try
		{
			CGDLog::WriteThreadState("diff task start [%s]", m_sMonitorPath.c_str() );

			string sCompFilePath = GetInforGuardPath();
#ifdef WIN32
			sCompFilePath.append( "\\dbhome" );
#else
			sCompFilePath.append( "/dbhome" );
#endif
			CFileTreeComper ftc( m_sMonitorPath.c_str(), sCompFilePath.c_str(), &m_fileExclude ); // ҪصĿ¼ҪűȽļĿ¼
			int nRet = ftc.FileTreeCompare();
			CGDLog::WriteThreadState("diff task end [%s]", m_sMonitorPath.c_str() );
		}
		catch( ... )
		{
			// 쳣
			CGDLog::WriteErrLog( "1068:CDirDiffer:Run catch ..." );
		}
		for ( int i=0; i<m_nSeconds && InforGuard::GDThreadPool::TS_STOPING != m_status; i++ )
		{
			CDateTime::Sleep( 1000 );
		}		
	}
	CGDLog::WriteThreadState("diff thread exited");          //wu_binд߳״̬
	return 0;
}


}	// namespace FileDirDiffer
}	// namespace InforGuard
