/******************
 ļԶ
 ******************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <sys/stat.h>
#include <glob.h>
#include "gcps.h"
#include "z.h"
#include "zvar.h"

/* ļб */
int f_put_files(char *path, char *pattern, char *listfile);

/* лԶ· */
int f_rcd(int fd, char *zout);

/* ϴļļ */
int f_put1a(int fd, char *zout, FILINFO *fi, int typ);

/* ɾƶļ */
int f_mvORdel(FILINFO *fi);

/* ϴǰԤ */
int f_uppre(char *pLine, FILINFO *fi);

/*************************
 ֵ  0  ɹ
           -1 ʧ
           -2 FTP ʧ
           -3 ʧ
 *************************/
int f_put(int typ, FILINFO *fi)
{
    FILE  *fp;

    int    b,
           f_err = R_SUCCESS,
           ftpfd = -1;                      /* ftp  */

    char   oldestfile[CL],                  /* ͬļɵһ澯ʹ */
           latestfile[CL],                  /* ͬļµһ */

           filelist[CL],                    /* ļб */
           zout[CL];                        /* FTP Ϣļ */

    static char     emsg[EMSG_LEN + 1];     /* ־Ϣ */
    static char     szLine[1024];

    /* бļļ */
    snprintf(filelist, sizeof(filelist), "%s/%s%s", u_logdir, FILELIST, u_zcfg.no);
    snprintf(zout, sizeof(zout), "%s/%s%s%s", u_logdir, OUTPREFIX, u_zcfg.no, OUTSUFFIX);

    /* ļϢб */
    z_logv(u_logfile, "Listing ...");

    if( (b = f_put_files(u_zcfg.src_path, u_zcfg.src_fn_pattern, filelist)) < 0 )
    {
        sprintf(emsg, "ȡļбʧ=%d", b);
        f_seterr(emsg, "O007", "OS", 9);
        return(R_FILEFAIL);
    }
    z_logv(u_logfile, "done");

    if( u_pruns->leftfiles == 0 )           /* ļ澯Ϣ */
    {
        f_set_ok(NULL, NULL, "");
        return(R_SUCCESS);
    }

    /* бļ */
    if( (fp = fopen(filelist, "r")) == NULL )
    {
        snprintf(emsg, sizeof(emsg), "бļʧ'%s'", filelist);
        f_seterr(emsg, "O007", "OS", 9);
        return(R_FILEFAIL);
    }

    /* жϵļ */
    if( f_oldnew(fp, latestfile, oldestfile) < 0 )
    {
        fclose(fp);
        close(ftpfd);
        return(R_FILEFAIL);
    }

    /* ϸŲɼʱļеʱ */
    if( f_checknewer(latestfile, oldestfile) < 0 )
    {
        fclose(fp);
        close(ftpfd);
        return(R_FILEFAIL);
    }

    /* һÿļ */
    for( rewind(fp); ! feof(fp); u_pruns->leftfiles -- )
    {
        f_err = R_SUCCESS;

        /* ȡһļ */
        b = f_1file(fp, szLine, sizeof(szLine), latestfile);

        if( b == 0 ) break;
        else if( b == 1 ) continue;
        else if( b == -1 )
        {
            f_err = R_FILEFAIL;
            break;
        }

        /* ȡļ */
        if( f_uppre(szLine, fi) < 0 )
        {
            f_err = R_FILEFAIL;
            break;
        }

        /* лԶ· */
        if( typ == SM_FTPPUT && ftpfd < 0 )
        {
            if( (ftpfd = f_conn_server(NULL, NULL, zout, t_ftpbuf1)) < 0 )
            {
                z_rtrim(t_ftpbuf1);
                f_err = R_LOGONFAIL;
                break;
            }
            if( f_rcd(ftpfd, zout) < 0 )
            {
                f_err = R_FTPFAIL;
                break;
            }
        }

        /*  */
        if( ftpfd > 64 )
        {
            z_logv(u_logfile, "ftpfd > 64");
            return(R_RESTART);
        }

        /* ĿƵϢ */
        if( f_name1a(fi) < 0 )
        {
            f_err = R_FILEFAIL;
            break;
        }

        z_logv(u_logfile, "Local=%s", fi->fstr);
        z_logv(u_logfile, "Remote=%s", fi->dstfile);

        /* ļļ */
        if( f_put1a(ftpfd, zout, fi, typ) < 0 )
        {
            f_err = R_FTPFAIL;
            break;
        }

        /* ʱ */
        if( f_hdtime(fi, fi->localpath) < 0 )
        {
            f_err = R_FILEFAIL;
            break;
        }

        /* ɾƶ */
        if( f_mvORdel(fi) < 0 )
        {
            f_seterr("ɾƶʧ", "A014", "APP", 9);
            f_err = R_FILEFAIL;
            break;
        }

        /* ɹ״̬ */
        if( f_set_ok(fi->dstfile, fi->szCallTime, "") < 0 )
        {
            f_seterr("ʧ");
            f_err = R_LOCKFAIL;
            break;
        }

        /* óɹű */
        f_okshell(fi);

        /* ¼ܼ */
        u_pNidNormal->tStartTv = fi->tStartTv;
        u_pNidNormal->tEndTv = fi->tEndTv;
        u_pNidNormal->iFileSize = fi->fsize;
        strcpy(u_pNidNormal->szFileTime, fi->szCrtTime);
        strncpy(u_pNidNormal->szFileName, fi->dstfile, sizeof(u_pNidNormal->szFileName) - 1);
        u_pNidNormal->szFileName[sizeof(u_pNidNormal->szFileName) - 1] = 0;
        strcpy(u_pNidWarn->szFileName, u_pNidNormal->szFileName);

        f_nidlog(&u_nid_normal);

        z_logv(u_logfile, "Size=%ld", fi->fsize);
        z_logv(u_logfile, "Ok!");
    }
    fclose(fp);

    /* ر */
    if( ftpfd >= 0 ) close(ftpfd);
    ftpfd = -1;

    return(f_err);
}

/**************************************
 put ʱļб
 ڲchar *path      Դ·
           char *pattern   Դģʽ
           char *listfile  Ŀбļ
 **************************************/
int f_put_files(char *path, char *pattern, char *listfile)
{
    int    i;
    char   szTime[16];

    FILE  *fp;
    static char fullpath[1024];

    glob_t globbuf;
    struct stat stbuf;

    if( (fp = fopen(listfile, "w")) == NULL ) return(-1);

    /* ģʽƥб */
    globbuf.gl_offs = 0;

    if( pattern == NULL || *pattern == 0 )
        snprintf(fullpath, sizeof(fullpath), "%s/*", path);
    else
        snprintf(fullpath, sizeof(fullpath), "%s/%s", path, pattern);

    i = glob(fullpath, GLOB_DOOFFS, NULL, &globbuf);

    if( i && i != GLOB_NOMATCH )
    {
        globfree(&globbuf);
        return(-2);
    }

    /* дбļ */
    u_pruns->leftfiles = 0;

    for( i = 0; i < globbuf.gl_pathc; i++ )
    {
        if( stat(globbuf.gl_pathv[i], &stbuf) < 0 )
        {
            globfree(&globbuf);
            return(-3);
        }

        if( S_ISDIR(stbuf.st_mode) ) continue;

        /* ļơСʱ */
        z_get_dt(szTime, 14, "f", stbuf.st_ctime);
        fprintf(fp, "%s %ld %s\n", globbuf.gl_pathv[i], (long) (stbuf.st_size), szTime);

        u_pruns->leftfiles++;
    }
    fclose(fp);

    globfree(&globbuf);
    return(0);
}

/************
 ϴǰԤ
 ************/
int f_uppre(char *pLine, FILINFO *fi)
{
    FILE  *fp;
    char   cmdstr[CL];

    sscanf(pLine, "%s%ld%s", fi->localpath, &(fi->fsize), fi->szCrtTime);

    if( u_zcfg.preshell[0] )
    {
        snprintf(cmdstr, sizeof(cmdstr), "%s/%s %s", u_plugdir, u_zcfg.preshell, fi->localpath);

        fp = popen(cmdstr, "r");
        if( fp == NULL || fscanf(fp, "%s%d", fi->localpath, &(fi->fsize)) != 2 )
        {
            f_seterr("ϴǰԤʧ", "O011", "OS", 9);
            if( fp ) pclose(fp);
            return(-1);
        }

        pclose(fp);
    }
    strcpy(fi->fstr, z_fnonly(fi->localpath));

    return(0);
}

/*******************************
 лԶ·
 ڲint   fd     
           char *zout   ־ļ
 *******************************/
int f_rcd(int fd, char *zout)
{
    int    b = 0;
    char   dtpath[CL];          /* תڸʽ· */
    static char szTmp[1024];

    if( (b = f_dtpath_remote(fd, NULL, u_zcfg.dst_path, dtpath, t_ftpbuf1)) < 0 )
    {
        z_rtrim(t_ftpbuf1);
        z_logv(zout, t_ftpbuf1);

        sprintf(szTmp, "Ŀ·ʧ=%d", b);
        f_seterr(szTmp, "A011", "APP", 9);

        return(-1);
    }

    /* Զ̹Ŀ¼ */
    if( b == 0 || b == 1 )
    {
        if( GC_ftp_cd(fd, dtpath, t_ftpbuf1) < 0 )
        {
            z_rtrim(t_ftpbuf1);
            z_logv(zout, t_ftpbuf1);

            snprintf(szTmp, sizeof(szTmp), "Զ·'%s'", dtpath);
            f_seterr(szTmp, "A006", "APP", 9);

            return(-1);
        }
    }

    return(0);
}

/************************************
 ĿƵϢ
 ڲFILINFO *fi   ļϢ
 ************************************/
int f_name1a(FILINFO *fi)
{
    FILE  *fp;

    int    b, pl;
    char   cmdstr[CL], szTime[16] = {0};
    static char szTmp[1024];

    /* ļ */
    FILINFO *fT = fi + 1;

    fT->localpath[0] = 0;

    if( fi->szCrtTime[0] )
    {
        strncpy(szTime, fi->szCrtTime, 8);
        szTime[8] = 0;
    }

    /* Ŀļ */
    pl = strlen(NAMETRSH);

    if( strncmp(u_zcfg.dst_format, NAMETRSH, pl) == 0 )
    {
        snprintf(cmdstr, sizeof(cmdstr), "%s/%s %s %s",
            u_plugdir, u_zcfg.dst_format + pl, fi->fstr, u_zcfg.no);

        fp = popen(cmdstr, "r");
        if( fp == NULL || fscanf(fp, "%s", fi->dstfile) != 1 )
        {
            f_seterr("Ŀתʧ", "O009", "OS", 9);
            if( fp ) pclose(fp);
            return(-1);
        }

        pclose(fp);
    }
    else if( (b = f_nametr(fi->fstr, u_zcfg.dst_format, fi->dstfile, szTime[0] ? szTime : NULL)) < 0 )
    {
        sprintf(szTmp, "'%s' Ŀתʧ=%d", u_zcfg.dst_format, b);
        f_seterr(szTmp, "A010", "APP", 9);
        return(-1);
    }

    /* ڸʽ· */
    if( u_zcfg.optype == SM_FTPGET )
    {
        if( f_dtpath_local(u_zcfg.dst_path, fi->datedir) < 0 )
        {
            f_seterr("·ʧ", "A011", "APP", 9);
            return(-1);
        }

        /* ļȫ· */
        snprintf(fi->localpath, sizeof(fi->localpath), "%s/%s", fi->datedir, fi->dstfile);
    }

    /* ʱ */
    if( strchr(u_zcfg.gather_mode, SM_TIMESUFFIX) ) /* ʹðʱʱ׺ */
    {
        z_get_dt(szTime, 14, "f", 0);
        snprintf(fi->midfile, sizeof(fi->midfile), "%s.%s.tempfile", fi->dstfile, szTime);
        snprintf(fi->midpath, sizeof(fi->midpath), "%s/%s.%s.tempfile", fi->datedir, fi->dstfile, szTime);
    }
    else
    {
        snprintf(fi->midfile, sizeof(fi->midfile), "tmp.%s.tmp", fi->dstfile);
        snprintf(fi->midpath, sizeof(fi->midpath), "%s/tmp.%s.tmp", fi->datedir, fi->dstfile);
    }

    /* ɸļ */
    if( u_zcfg.attachfile[0] )
    {
        snprintf(cmdstr, sizeof(cmdstr), "%s/%s %s %s", u_plugdir, u_zcfg.attachfile, fi->localpath, fi->dstfile);

        fp = popen(cmdstr, "r");
        if( fp == NULL || fscanf(fp, "%ld%s%s", &(fT->fsize), fT->localpath, fT->dstfile) != 3 )
        {
            f_seterr("ļʧ", "O010", "OS", 9);
            if( fp ) pclose(fp);
            return(-1);
        }

        pclose(fp);
        strcpy(fT->fstr, fT->dstfile);
        snprintf(fT->midfile, sizeof(fT->midfile), "tmp.%s.tmp", fT->dstfile);
    }

    /* Ƿʹʱ */
    if( strchr(u_zcfg.gather_mode, SM_NOTMPNAME) )
    {
        fi->fTmpName = 0;
        fi->pPutName = fi->dstfile;
        fT->fTmpName = 0;
        fT->pPutName = fT->dstfile;
    }
    else
    {
        fi->fTmpName = 1;
        fi->pPutName = fi->midfile;
        fT->fTmpName = 1;
        fT->pPutName = fT->midfile;
    }

    return(0);
}

/****************
 ͨűϴļ
 ****************/
int f_datashell(char *local, char *rdir, char *rname, char *outbuf, int n)
{
    FILE  *fp;
    char   cmdstr[CL];
    unsigned char ptext[33];        /*  */

    if( u_zcfg.encryption == 1 )
        f_pass_decry(u_zcfg.pass[0], ptext);
    else
        strcpy((char *)ptext, u_zcfg.pass[0]);

    snprintf(cmdstr, sizeof(cmdstr), "%s/%s %s %s %s %s %d %s %s",
        u_plugdir, u_zcfg.datashell, u_zcfg.user[0], (char *)ptext, local,
        u_zcfg.host[0], u_zcfg.ftpport, rdir, rname);

    fp = popen(cmdstr, "r");

    if( fp == NULL ) return(-1);
    fread(outbuf, 1, n - 1, fp);

    if( pclose(fp) ) return(-1);
    else return(0);
}

/**********************
 ͨűԶļ
 **********************/
int f_mvshell(char *rdir, char *rtmp, char *rname, char *outbuf, int n)
{
    FILE  *fp;
    char   cmdstr[CL];

    if( u_zcfg.mvshell[0] == 0 ) return(0);

    snprintf(cmdstr, sizeof(cmdstr), "%s/%s %s %s %s", u_plugdir, u_zcfg.mvshell, rdir, rtmp, rname);
    fp = popen(cmdstr, "r");

    if( fp == NULL ) return(-1);
    fread(outbuf, 1, n - 1, fp);

    if( pclose(fp) ) return(-1);
    else return(0);
}

/************************************
 ϴļļ
 ڲint      fd   
           char    *zout ־ļ
           FILINFO *fi   ļϢ
 ************************************/
int f_put1a(int fd, char *zout, FILINFO *fi, int typ)
{
    int b = 0;
    FILINFO *p;

    for( p = fi; p->localpath[0]; p++ )
    {
        /* ϴδ俪ʼʱ */
        u_pruns->begtime = time( (time_t *) 0 );

        gettimeofday(&(p->tStartTv), NULL);

        /* ϴ */
        z_logv(u_logfile, "Putting %d ...", p - fi);

        if( typ == SM_FTPPUT ) b = GC_ftp_put(fd, p->localpath, p->pPutName, t_ftpbuf1);
        else b = f_datashell(p->localpath, u_zcfg.dst_path, p->pPutName, t_ftpbuf1, sizeof(t_ftpbuf1));

        if( b < 0 )
        {
            z_rtrim(t_ftpbuf1);
            z_logv(zout, t_ftpbuf1);
            f_seterr("ļʧ", "A008", "APP", 6);

            return(-1);
        }
        z_logv(u_logfile, "done");

        gettimeofday(&(p->tEndTv), NULL);

        /* ļСƥ֤ */
        if( f_sizematch(fd, p, zout) != R_SUCCESS ) return(-1);

        /* Զļ */
        if( p->fTmpName == 1 )
        {
            if( typ == SM_FTPPUT ) b = GC_ftp_move(fd, p->midfile, p->dstfile, t_ftpbuf1);
            else b = f_mvshell(u_zcfg.dst_path, p->midfile, p->dstfile, t_ftpbuf1, sizeof(t_ftpbuf1));

            if( b < 0 )
            {
                z_rtrim(t_ftpbuf1);
                z_logv(zout, t_ftpbuf1);
                f_seterr("Զļʧ", "A013", "APP", 6);

                return(-1);
            }
        }
    }

    return(0);
}

/********************************
 ɾƶļ
 ڲFILINFO *fi   ļϢ
 ********************************/
int f_mvORdel(FILINFO *fi)
{
    int  b = 0;
    char dtpath[CL];

    FILINFO *p;

    for( p = fi; b == 0 && p->localpath[0]; p++ )
    {
        switch( u_zcfg.src_bakflag )
        {
        case BF_DELETE:    /* ɾ */

            z_logv(u_logfile, "Unlinking ...");
            b = unlink(p->localpath);
            break;

        case BF_MOVE:      /* ƶ */

            if( (b = f_dtpath_local(u_zcfg.src_bpath, dtpath)) == 0 )
            {
                snprintf(p->midpath, sizeof(p->midpath), "%s/%s", dtpath, p->fstr);
                z_logv(u_logfile, "Renaming ...");
                b = rename(p->localpath, p->midpath);
            }
            break;
        }
    }

    return(b);
}
