//---------------------------------------------------------------------------
#ifndef ConfigH
#define ConfigH

//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include "gcps.h"

//---------------------------------------------------------------------------
class TFrmConfig : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar1;
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TTabSheet *TabSheet3;
        TTabSheet *TabSheet2;
        TLabel *Label1;
        TLabel *Label26;
        TLabel *Label30;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *Label5;
        TLabel *Label6;
        TLabel *Label7;
        TLabel *Label28;
        TLabel *Label29;
        TLabel *Label10;
        TLabel *Label11;
        TLabel *Label12;
        TLabel *Label8;
        TLabel *Label9;
        TLabel *Label13;
        TLabel *Label19;
        TLabel *Label14;
        TLabel *Label15;
        TLabel *Label16;
        TLabel *Label17;
        TLabel *Label22;
        TLabel *Label27;
        TLabel *Label23;
        TLabel *Label18;
        TLabel *Label24;
        TLabel *Label25;
        TEdit *EditNo;
        TLabel *Label20;
        TEdit *EditBelong;
        TEdit *EditDesc;
        TEdit *EditIP1;
        TEdit *EditIP2;
        TEdit *EditUser1;
        TEdit *EditUser2;
        TEdit *EditPass1;
        TEdit *EditPass2;
        TEdit *EditSrcPath;
        TEdit *EditSrcBakPath;
        TEdit *EditDstPath;
        TEdit *EditSrcPattern;
        TEdit *EditSrcNameFilter;
        TEdit *EditDstNameFormat;
        TEdit *EditFileAnalyzer;
        TEdit *EditBusyItv;
        TEdit *EditFreeItv;
        TEdit *EditRecordSize;
        TEdit *EditOperTimeout;
        TEdit *EditColSize;
        TEdit *EditNoFileLimit;
        TEdit *EditSeqMin;
        TEdit *EditSeqMax;
        TEdit *EditSeqCurr;
        TButton *BtnUpLoad;
        TButton *BtnStart;
        TButton *BtnDownLoad;
        TButton *BtnCheck;
        TButton *BtnTestRegex;
        TButton *BtnTestDstNameFormat;
        TRadioGroup *RadioGrpDelBak;
        TCheckBox *ChkBoxEnable;
        TCheckBox *ChkBoxEncry;
        TCheckBox *ChkBoxFtpPassive;
        TCheckBox *ChkBoxFtpResume;
        TCheckBox *ChkBoxZeroWarn;
        TCheckBox *ChkBoxSeqBreakWarn;
        TCheckBox *ChkBoxLatest;
        TCheckBox *ChkBoxBusyTime;
        TCheckBox *ChkBoxSeqCtrl;
        TGroupBox *GrpBoxWarnMode;
        TGroupBox *GrpBoxFtpMode;
        TGroupBox *GrpBoxSeq;
        TDateTimePicker *DTimeBegin;
        TDateTimePicker *DTimeEnd;
        TCheckBox *ChkBoxNoTmpName;
        TRadioGroup *RadioGrpOperType;
        TLabel *Label21;
        TEdit *EditExtraCopy;

        void __fastcall RadioGrpDelBakClick(TObject *Sender);
        void __fastcall ChkBoxSeqCtrlClick(TObject *Sender);
        void __fastcall BtnUpLoadClick(TObject *Sender);
        void __fastcall BtnStartClick(TObject *Sender);
        void __fastcall BtnDownLoadClick(TObject *Sender);
        void __fastcall BtnTestRegexClick(TObject *Sender);
        void __fastcall BtnTestDstNameFormatClick(TObject *Sender);
        void __fastcall BtnCheckClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall ChkBoxBusyTimeClick(TObject *Sender);

private:	// User declarations
public:		// User declarations
        TSocket m_skt;

        int     m_serv_no;                        // ɼ
        int     m_bChecked;                       // ǷѸ

        int     m_nColSize,                       // ļС
                m_nExtraCopy,                     // Ᵽ漸
                m_nRecordSize,                    // С
                m_nSeqLength,                     // ų
                m_nSeqMin, m_nSeqMax,             // ֹ
                m_nSeqCurr,                       // ǰ
                m_nNoFileLimit,                   // ޻澯ʱ
                m_nOperTimeout,                   // ʱʱ
                m_nBusyItv, m_nFreeItv;           // æвɼ

        char    m_szBusyBeg[16], m_szBusyEnd[16]; // æʱʱ

        __fastcall TFrmConfig(TComponent* Owner);
        int  __fastcall VerifyText(void);         // ֤Ϣ
        int  __fastcall SaveConfig(void);         // ϴϢ
        int  __fastcall LoadConfig(void);         // װϢ
};
//---------------------------------------------------------------------------
extern PACKAGE TFrmConfig *FrmConfig;

// 
int  __fastcall SeekComponent(TComponent* Owner, int tag);

// Ԥ
int __fastcall FillComponent(TComponent* Owner);
//---------------------------------------------------------------------------
#endif
