//---------------------------------------------------------------------------
#include <stdio.h>
#include <sys/types.h>
#include <vcl.h>
#include <IniFiles.hpp>
#pragma hdrstop

#include "Main.h"
#include "MonOper.h"            // ز
#include "About.h"              // About
#include "Logon.h"              // ¼
#include "Config.h"             // ô
#include "RegTest.h"            // ʽ
#include "ConfigCity.h"         // ֹ˾
#include "ConfigPlat.h"         // ƽ̨
#include "SeqAdjust.h"          // ŵ
#include "ShowLog.h"            // ־ѯ
#include "BatchUpdate.h"        // ޸
#include "Face.h"               // 
#include "Fpub.h"               // 

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TFrmMain *FrmMain;

TFont    *g_Font;               // 
TColor    g_Color;              // Ļɫ
String    g_WarnFile = "";      // 澯ļ

                                // ¼ỰϢ
char    g_username[32];         // û
char    g_userid[32];           // ûIDأ
int     g_hostseq;              // 

WINIDS  g_winids[2] =           // 
{
        {"g1a. ˹", DEF_IP1, DEF_PORT, 0},
        {"g1b. ˹", DEF_IP2, DEF_PORT, 0}
};

//---------------------------------------------------------------------------
__fastcall TFrmMain::TFrmMain(TComponent* Owner) : TForm(Owner)
{
        Caption = Caption + "    " + "ӭ" + "[" + g_username + "]";

        // rootû
        if( atoi(g_userid) == 0 )
        {
                G11->Enabled = true;    // /ɼ
                S13->Enabled = true;    // ޸
        }
}

//---------------------------------------------------------------------------
void __fastcall TFrmMain::FormShow(TObject *Sender)
{
        if( m_skt.Init(PKT_MAXSIZE, PKT_HEADFMT) != 1 )
        {
                ErrDlg("ʼʧ");
                Application->Terminate();
        }

        StaticText1->Hint =
                String("򿪡") + g_winids[0].win_caption + "("
                + g_winids[0].serv_ip + ")ļش";
        StaticText2->Hint =
                String("򿪡") + g_winids[1].win_caption + "("
                + g_winids[1].serv_ip + ")ļش";

        // ʾɫ
        // Application->HintColor = TColor(0xc0a000);
        // ӳͣʱΪ5
        Application->HintHidePause = 5000;
        // ʾʾʱ
        Application->HintPause = 100;
        // ʾݼϢ
        Application->HintShortCuts = True;
        // һʾֺƶһʾʱʾµʾ
        Application->HintShortPause = 0;

        // ȡļ
        g_Font = new TFont();
        g_Font->Assign(Font);
        g_Color = TColor(DEF_COLOR_MON);

        TIniFile *ini = new TIniFile( ChangeFileExt(Application->ExeName, ".INI") );

        // ơСɫ
        g_Font->Name = ini->ReadString("FONT", "NAME", DEF_FONT_NAME);
        g_Font->Size = ini->ReadInteger("FONT", "SIZE", DEF_FONT_SIZE);
        g_Font->Color = TColor( ini->ReadInteger("FONT", "COLOR", DEF_FONT_COLOR) );

        // شɫ
        g_Color = TColor( ini->ReadInteger("COLOR", "VALUE", DEF_COLOR_MON) );

        // 澯ļ
        g_WarnFile = ini->ReadString("Warn", "FILE", "");

        delete ini;
}

//---------------------------------------------------------------------------
// 򿪼زӴ
void MonFormOpen(int tag)
{
        if( MonOperForms[tag - 1] )     // Ѿ
        {
                MonOperForms[tag - 1]->SetFocus();
                MonOperForms[tag - 1]->BringToFront();
                return;
        }

        // µļش
        MonOperForms[tag - 1] = new TFrmMonOper(FrmMain);

        // 
        MonOperForms[tag - 1]->Caption = g_winids[tag - 1].win_caption;
        // MonOperForms[tag - 1]->Align = alClient;
        // MonOperForms[tag - 1]->Width = FrmMain->ClientWidth;

        MonOperForms[tag - 1]->m_win_id = tag;

        MonOperForms[tag - 1]->Font = g_Font;
        MonOperForms[tag - 1]->ListView1->Font = g_Font;
        MonOperForms[tag - 1]->ListView1->Color = g_Color;

        // ʾ
        MonOperForms[tag - 1]->Show();
}

//---------------------------------------------------------------------------
void __fastcall TFrmMain::StaticText1Click(TObject *Sender)
{
        MonFormOpen(1);
}

//---------------------------------------------------------------------------
void __fastcall TFrmMain::StaticText2Click(TObject *Sender)
{
        MonFormOpen(2);
}

//---------------------------------------------------------------------------
// 
void __fastcall TFrmMain::W11Click(TObject *Sender)
{
        Cascade();
}
//---------------------------------------------------------------------------
// ƽ
void __fastcall TFrmMain::W12Click(TObject *Sender)
{
        Tile();
}

//---------------------------------------------------------------------------
// ɼ/
void __fastcall TFrmMain::G11Click(TObject *Sender)
{
        FrmConfig = new TFrmConfig(this);
        FrmConfig->Tag = 0;
        FrmConfig->Font = g_Font;
        FrmConfig->ShowModal();

        delete FrmConfig;
        FrmConfig = NULL;
}

//---------------------------------------------------------------------------
// ֹ˾ȫϢ
void __fastcall TFrmMain::S11Click(TObject *Sender)
{
        FrmCityCfg = new TFrmCityCfg(this);
        FrmCityCfg->Font = g_Font;
        FrmCityCfg->ShowModal();

        delete FrmCityCfg;
        FrmCityCfg = NULL;
}

//---------------------------------------------------------------------------
// ڶԻ
void __fastcall TFrmMain::H11Click(TObject *Sender)
{
        FrmAbout = new TFrmAbout(this);
        FrmAbout->ShowModal();

        delete FrmAbout;
        FrmAbout = NULL;
}

//---------------------------------------------------------------------------
// ״̬ʾʾϢ
void ShowStatus(const char *msg, TStatusBar *pBar, int aItemNo)
{
        if( pBar == NULL ) return;

        pBar->Panels->Items[aItemNo]->Text = String(msg);
        pBar->Refresh();
}

//===========================================================================

/******************************************************
 SOCKETӣӦ
 ڲint         srvno   
           char       *pBody   
           TStatusBar *pBar    ״̬
           int         aRead   ǷӦ
           int         aItemNo ״̬
           int        *pTry    Ƿһ̨
 ******************************************************/
int SktComm(TSocket &skt, int srvno, char *pBody, TStatusBar *pBar, int aRead, int aItemNo, int *pTry)
{
        // 
        int SktComm1(TSocket &skt, int srvno, char *pBody, TStatusBar *pBar, int aRead, int aItemNo = 0);

        // ͨ
        int b = SktComm1(skt, srvno, pBody, pBar, aRead, aItemNo);

        // һ̨̨֧
        if( pTry && *pTry && b == R_RETRY )
        {
                *pTry = 0;
                b = SktComm1(skt, srvno == 1 ? 2 : 1, pBody, pBar, aRead, aItemNo);
        }

        int  iErrNo = 0;
        char szBuf[128];

        switch( b )
        {
        case R_OK:
                ShowStatus("OK", pBar, aItemNo);
                break;

        case R_DENY:
        case R_RETRY:
                ShowStatus("ʧ", pBar, aItemNo);

        case R_COMMFAIL:
        default:
                GC_getWinErr(&iErrNo, szBuf, sizeof(szBuf));

                if( iErrNo == 0 )
                        ShowStatus("ʧ", pBar, aItemNo);
                else
                        ShowStatus(szBuf, pBar, aItemNo);
                break;
        }

        return(b);
}

int SktComm1(TSocket &skt, int srvno, char *pBody, TStatusBar *pBar, int aRead, int aItemNo)
{
        char *pIP  = g_winids[srvno - 1].serv_ip;       // IP
        int   port = g_winids[srvno - 1].serv_port;     // ˿

        // 
        char  szBuf[64];

        sprintf(szBuf, " %s:%d ... ", pIP, port);
        ShowStatus(szBuf, pBar, aItemNo);

        // ӷ
        if( skt.Connect(pIP, port, TMO_CONN) != 1 )
        {
                skt.Close();
                return(R_COMMFAIL);
        }

        // 
        ShowStatus(" ... ", pBar, aItemNo);

        skt.SetHeadN(g_username, 4);
        skt.SetHeadN(g_userid, 5);

        if( skt.SendText(pBody) < 0 )
        {
                skt.Close();
                return(R_COMMFAIL);
        }

        if( aRead == 0 ) return(R_OK);

        // ȡӦϢ
        return( JustRead(skt, pBar, aItemNo) );
}

// ȡӦϢ
int JustRead(TSocket &skt, TStatusBar *pBar, int aItemNo, int aClose)
{
        int   b;
        char  szBuf[64];

        // ָȱʡĶʱʱ
        skt.Timeout(TMO_RDWR, 1);

        // ȡͷ
        int   iHeadLen = skt.GetHeadLen();      // ͷ
        char *pRepInfo = skt.GetReply();        // Ӧ𻺳

        ShowStatus("Ӧ ... ", pBar, aItemNo);

        if( skt.ReadHead(pRepInfo) != iHeadLen )
        {
                skt.Close();
                return(R_COMMFAIL);
        }

        int iPktLen = skt.GetPktLen();          // ĳ

        // ȡ
        if( skt.ReadN(pRepInfo + iHeadLen, iPktLen - iHeadLen) != (iPktLen - iHeadLen) )
        {
                skt.Close();
                return(R_COMMFAIL);
        }
        pRepInfo[iPktLen] = 0;

        skt.GetHeadN(szBuf, 3);               // 

        // ر׽
        if( aClose == 1 ) skt.Close();

        // Ӧ
        ShowStatus("Ӧ ...", pBar, aItemNo);

        if( szBuf[0] == E_BELONG )
        {
                b = R_RETRY;
        }
        else if( szBuf[0] == E_OK )
        {
                b = R_OK;
        }
        else
        {
                b = R_DENY;
        }

        return(b);
}

// ̽ӦϢʾ
int ReadProgress(TSocket &skt, TComponent *AOwner, TStatusBar *pBar, int aItemNo, int aTmo)
{
        int  b, tFlag = 0;
        char szBuf[64];

        TProgressBar *pProBar;

        try
        {
                pProBar = new TProgressBar(AOwner);

                // 趨λáС
                pProBar->Parent = pBar;             // ĸ
                pProBar->Top = 0;
                pProBar->Left = 0;
                pProBar->Width = pBar->Width;
                pProBar->Height = pBar->Height;

                pProBar->Visible = true;            // ʾ
                pProBar->Min = 0;                   // Сֵ
                pProBar->Max = aTmo;                // ֵ

                // ʱʱޣ1
                skt.Timeout(1, 1);

                // ʾ
                for( int i = 0; i < aTmo; i++ )
                {
                        pProBar->Position = i + 1;
                        if( (b = skt.DetectFd(0)) != R_TIMEOUT ) break;
                }
        }
        __finally
        {
                delete pProBar;                     // ͷŽԴ
        }
        tFlag = b;

        // ȡӦϢ
        if( b == 1 )            // ׽ֿɶ
        {
                b = JustRead(skt, pBar, aItemNo);
        }
        else                    // 
        {
                skt.Close();
        }

        switch( b )
        {
        case R_OK:
                ShowStatus("OK", pBar, aItemNo);
                break;

        default:
                sprintf(szBuf, "ʧ[%d][%d]", tFlag, b);
                ShowStatus(szBuf, pBar, aItemNo);
                break;
        }

        return(b);
}

//===========================================================================

//---------------------------------------------------------------------------
// ƽ̨
void __fastcall TFrmMain::N1Click(TObject *Sender)
{
        // 䱨ͷ
        m_skt.SetHeadN(TC_STARTPLAT, 2);

        // 
        char *pBody, szBody[64];
        pBody = szBody;

        // š
        int iSrvSeq = PopupMenu1->Tag;

        char  szVal[64];
        sprintf(szVal, "%d", iSrvSeq);

        f_packTLV(&pBody, szVal, TAG_BELONG);
        *pBody = 0;

        int   iHLen = m_skt.GetHeadLen();
        char *pInfo = m_skt.GetReply();

        *pInfo = 0;
        *(pInfo + iHLen) = 0;

        // 
        int b = SktComm(m_skt, iSrvSeq, szBody, StatusBar1, 0);

        if( b != R_OK )
        {
                ErrDlg("ͨʧ");
                return;
        }

        // ̽ӦϢʾ
        b = ReadProgress(m_skt, this, StatusBar1, 0, TMO_LONG);

        // л״ָ̬ʾ
        TShape *pShape = (iSrvSeq == 1 ? Shape1 : Shape2);

        if( b == R_OK && strstr(pInfo + iHLen, "") == NULL )
        {
                pShape->Brush->Color = clGreen;
                pShape->Tag = 1;
        }

        // ״̬ʾ
        FrmShowLog = new TFrmShowLog(this, pInfo + iHLen);
        FrmShowLog->Font = g_Font;
        FrmShowLog->Memo1->Font = g_Font;
        FrmShowLog->Caption = String(iSrvSeq) + "-ƽ̨";

        FrmShowLog->ShowModal();

        delete FrmShowLog;
        FrmShowLog = NULL;
}

//---------------------------------------------------------------------------
// ֹͣƽ̨
void __fastcall TFrmMain::N2Click(TObject *Sender)
{
        TModalResult r =
                MessageDlg("ֹͣƽ̨! Ƿ?",
                        mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0);

        if( r != mrYes ) return;

        // 䱨ͷ
        m_skt.SetHeadN(TC_STOPPLAT, 2);

        int   iHLen = m_skt.GetHeadLen();
        char *pInfo = m_skt.GetReply();

        *pInfo = 0;
        *(pInfo + iHLen) = 0;

        // 
        int iSrvSeq = PopupMenu1->Tag;
        int b = SktComm(m_skt, iSrvSeq, "", StatusBar1, 0);

        if( b != R_OK )
        {
                ErrDlg("ͨʧ");
                return;
        }

        // ̽ӦϢʾ
        b = ReadProgress(m_skt, this, StatusBar1);

        // л״ָ̬ʾ
        TShape *pShape = (iSrvSeq == 1 ? Shape1 : Shape2);

        if( b == R_OK && strstr(pInfo + iHLen, "") == NULL )
        {
                pShape->Brush->Color = clRed;
                pShape->Tag = 2;
        }

        // ״̬ʾ
        FrmShowLog = new TFrmShowLog(this, pInfo + iHLen);
        FrmShowLog->Font = g_Font;
        FrmShowLog->Memo1->Font = g_Font;
        FrmShowLog->Caption = String(iSrvSeq) + "-ƽֹ̨ͣ";

        FrmShowLog->ShowModal();

        delete FrmShowLog;
        FrmShowLog = NULL;
}

//---------------------------------------------------------------------------
// ״̬
void __fastcall TFrmMain::N3Click(TObject *Sender)
{
        int   iHLen = m_skt.GetHeadLen();
        char *pInfo = m_skt.GetReply();

        *pInfo = 0;
        *(pInfo + iHLen) = 0;

        // 䱨ͷ
        m_skt.SetHeadN(TC_STATPLAT, 2);

        // 
        int iSrvSeq = PopupMenu1->Tag;
        int b = SktComm(m_skt, iSrvSeq, "", StatusBar1);

        if( b != R_OK )
        {
                ErrDlg("ͨʧ");
                return;
        }

        // л״ָ̬ʾ
        TShape *pShape = (iSrvSeq == 1 ? Shape1 : Shape2);

        if( strstr(pInfo + iHLen, "ƽ̨δ") )
        {
                pShape->Brush->Color = clRed;
                pShape->Tag = 2;
        }
        else if( b == R_OK )
        {
                pShape->Brush->Color = clGreen;
                pShape->Tag = 1;
        }

        // ״̬ʾ
        FrmShowLog = new TFrmShowLog(this, pInfo + iHLen);
        FrmShowLog->Font = g_Font;
        FrmShowLog->Memo1->Font = g_Font;
        FrmShowLog->Caption = String(iSrvSeq) + "-ƽ̨״̬";

        FrmShowLog->ShowModal();

        delete FrmShowLog;
        FrmShowLog = NULL;
}

//---------------------------------------------------------------------------
// ־ѯ
void __fastcall TFrmMain::N4Click(TObject *Sender)
{
        // ־ʾ
        FrmShowLog = new TFrmShowLog(this);
        FrmShowLog->Font = g_Font;
        FrmShowLog->Memo1->Font = g_Font;

        FrmShowLog->Caption = String(PopupMenu1->Tag) + "-־ѯ";
        FrmShowLog->Tag = PopupMenu1->Tag;
        FrmShowLog->m_serv_no = PopupMenu1->Tag - 1;

        FrmShowLog->RadioGrpType->Visible = true;
        FrmShowLog->RadioGrpType->Enabled = true;
        FrmShowLog->RadioGrpType->ItemIndex = 0;

        FrmShowLog->EditBelong->Visible = false;
        FrmShowLog->EditBelong->Enabled = false;
        FrmShowLog->EditNo->Visible = false;
        FrmShowLog->EditNo->Enabled = false;
        FrmShowLog->ChkBoxFtpOut->Visible = false;
        FrmShowLog->ChkBoxFtpOut->Enabled = false;

        FrmShowLog->ShowModal();

        delete FrmShowLog;
        FrmShowLog = NULL;
}

//---------------------------------------------------------------------------
// ƽ̨
void __fastcall TFrmMain::N6Click(TObject *Sender)
{
        FrmPlatCfg = new TFrmPlatCfg(this);
        FrmPlatCfg->Font = g_Font;

        FrmPlatCfg->Caption = String(PopupMenu1->Tag) + "-";
        FrmPlatCfg->Tag = PopupMenu1->Tag;
        FrmPlatCfg->m_serv_no = PopupMenu1->Tag - 1;

        FrmPlatCfg->ShowModal();

        delete FrmPlatCfg;
        FrmPlatCfg = NULL;
}

//---------------------------------------------------------------------------
// ƽ̨Ҽ˵ʶ
void __fastcall TFrmMain::StaticText1ContextPopup(TObject *Sender,
      TPoint &MousePos, bool &Handled)
{
        PopupMenu1->Tag = 1;
}

//---------------------------------------------------------------------------
// ƽ̨Ҽ˵ʶ
void __fastcall TFrmMain::StaticText2ContextPopup(TObject *Sender,
      TPoint &MousePos, bool &Handled)
{
        PopupMenu1->Tag = 2;
}

//---------------------------------------------------------------------------
// ƽ̨˵
void __fastcall TFrmMain::PopupMenu1Popup(TObject *Sender)
{
        TShape *pShape;

        if( atoi(g_userid) )
        {
                N1->Enabled = false;
                N2->Enabled = false;
                N5->Enabled = false;
                return;
        }

        pShape = (PopupMenu1->Tag == 1 ? Shape1 : Shape2);

        switch( pShape->Tag )
        {
        case 0:         // ʼ
                N1->Enabled = false;
                N2->Enabled = false;
                break;

        case 1:         // ƽ̨
                N1->Enabled = false;
                N2->Enabled = true;
                break;

        case 2:         // ƽ̨δ
                N1->Enabled = true;
                N2->Enabled = false;
                break;
        }
}

//---------------------------------------------------------------------------
// ƶ
void __fastcall TFrmMain::Panel1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
        WORD SC_DragMove = 0xF012;

        ReleaseCapture();
        ((TWinControl*)Sender)->Perform(WM_SYSCOMMAND, SC_DragMove, 0);
}

//---------------------------------------------------------------------------
// ô
void __fastcall TFrmMain::S12Click(TObject *Sender)
{
        FrmFace = new TFrmFace(this);
        FrmFace->ShowModal();

        delete FrmFace;
        FrmFace = NULL;
}

//---------------------------------------------------------------------------
// ޸
void __fastcall TFrmMain::S13Click(TObject *Sender)
{
        FrmBatchUpdate = new TFrmBatchUpdate(this);
        FrmBatchUpdate->Font = g_Font;
        FrmBatchUpdate->ShowModal();

        delete FrmBatchUpdate;
        FrmBatchUpdate = NULL;
}
//---------------------------------------------------------------------------

