//---------------------------------------------------------------------------
#ifndef MainH
#define MainH

//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "gcps.h"
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include <Graphics.hpp>
#include <Dialogs.hpp>

//---------------------------------------------------------------------------
class TFrmMain : public TForm
{
__published:	// IDE-managed Components
        TMainMenu *MainMenu1;
        TMenuItem *W1;
        TMenuItem *H1;
        TMenuItem *W11;
        TMenuItem *W12;
        TMenuItem *H11;
        TMenuItem *S1;
        TMenuItem *S11;
        TPopupMenu *PopupMenu1;
        TMenuItem *N1;
        TMenuItem *N2;
        TStatusBar *StatusBar1;
        TMenuItem *N3;
        TMenuItem *N4;
        TMenuItem *N5;
        TImageList *ImageList1;
        TStaticText *StaticText1;
        TStaticText *StaticText2;
        TMenuItem *G1;
        TMenuItem *G11;
        TMenuItem *S12;
        TShape *Shape1;
        TShape *Shape2;
        TLabel *LblNum1;
        TLabel *LblNum2;
        TFontDialog *FontDialog1;
        TColorDialog *ColorDialog1;
        TMenuItem *S13;
        TPanel *Panel1;

        void __fastcall W11Click(TObject *Sender);
        void __fastcall W12Click(TObject *Sender);
        void __fastcall H11Click(TObject *Sender);
        // void __fastcall TreeViewChange(TObject *Sender, TTreeNode *Node);
        void __fastcall StaticText1Click(TObject *Sender);
        void __fastcall StaticText2Click(TObject *Sender);
        void __fastcall G11Click(TObject *Sender);
        void __fastcall S11Click(TObject *Sender);
        void __fastcall N1Click(TObject *Sender);
        void __fastcall N2Click(TObject *Sender);
        void __fastcall StaticText2ContextPopup(TObject *Sender,
          TPoint &MousePos, bool &Handled);
        void __fastcall StaticText1ContextPopup(TObject *Sender,
          TPoint &MousePos, bool &Handled);
        void __fastcall PopupMenu1Popup(TObject *Sender);
        void __fastcall N3Click(TObject *Sender);
        void __fastcall N4Click(TObject *Sender);
        void __fastcall N6Click(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall Panel1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall S12Click(TObject *Sender);
        void __fastcall S13Click(TObject *Sender);

private:	// User declarations
public:		// User declarations
        TSocket m_skt;

        __fastcall TFrmMain(TComponent* Owner);
        // TTreeView *TreeView1;                // ѷ
};

//---------------------------------------------------------------------------
extern PACKAGE TFrmMain *FrmMain;
//---------------------------------------------------------------------------

#endif
