//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "SeqAdjust.h"
#include "Config.h"
#include "Fpub.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TFrmSeqAdjust *FrmSeqAdjust;
//---------------------------------------------------------------------------
__fastcall TFrmSeqAdjust::TFrmSeqAdjust(TComponent* Owner) : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TFrmSeqAdjust::BtnOkClick(TObject *Sender)
{
        int   b,
              nNewSeq,
              nOldSeq,
              nSeqMin,
              nSeqMax;

        char *pBody, szBody[64];

        // ֤
        if( EditNewSeq->Text.Trim().Length() == 0 )
        {
                ErrDlg("ſ");
                return;
        }
        try
        {
                nOldSeq = EditOldSeq->Text.Trim().ToInt();
                nNewSeq = EditNewSeq->Text.Trim().ToInt();
                nSeqMin = EditSeqMin->Text.Trim().ToInt();
                nSeqMax = EditSeqMax->Text.Trim().ToInt();
        }
        catch (...)
        {
                ErrDlg("ŷǷ");
                return;
        }

        if( nNewSeq < nSeqMin || nNewSeq > nSeqMax )
        {
                ErrDlg("ŷΧǷ");
                return;
        }
        if( nOldSeq == nNewSeq )
        {
                ErrDlg("ͬѧһ");
                return;
        }

        // 
        m_skt.SetHeadN(TC_WSEQADJ, 2);

        pBody = szBody;

        // ɼš
        f_packTLV(&pBody, EditNo->Text.Trim().c_str(), TAG_NO);

        // ֹ˾
        f_packTLV(&pBody, EditBelong->Text.Trim().c_str(), TAG_BELONG);

        // š
        f_packTLV(&pBody, EditNewSeq->Text.Trim().c_str(), TAG_SEQCURR);

        *pBody = 0;

        // ݲɼĹ壬ӶӦķ
        b = SktComm(m_skt, m_serv_no + 1, szBody, StatusBar1);

        switch( b )
        {
        case R_OK:
                MessageDlg("֪ͨɼ̣ļ¸ɼڵԸ",
                        mtInformation, TMsgDlgButtons() << mbOK, 0);
                break;

        case R_COMMFAIL:
                ErrDlg("ͨʧ");
                break;

        case R_DENY:
                ErrDlg("ʧ");
                break;
        }

        ModalResult = mrOk;
}

//---------------------------------------------------------------------------
void __fastcall TFrmSeqAdjust::FormShow(TObject *Sender)
{
        // ʼ׽
        if( m_skt.Init(PKT_MAXSIZE, PKT_HEADFMT) != 1 )
        {
                ErrDlg("ʼʧ");
                Application->Terminate();
        }

        int   b;
        char *pBody, szBody[64];

        // ȡǰ
        m_skt.SetHeadN(TC_RSEQADJ, 2);

        pBody = szBody;

        // ɼš
        f_packTLV(&pBody, EditNo->Text.Trim().c_str(), TAG_NO);

        // ֹ˾
        f_packTLV(&pBody, EditBelong->Text.Trim().c_str(), TAG_BELONG);
        *pBody = 0;

        int   iHLen = m_skt.GetHeadLen();
        char *pInfo = m_skt.GetReply();

        *pInfo = 0;
        *(pInfo + iHLen) = 0;

        // ݲɼĹ壬ӶӦķ
        b = SktComm(m_skt, m_serv_no + 1, szBody, StatusBar1);

        switch( b )
        {
        case R_OK:
                break;

        case R_COMMFAIL:
                ErrDlg("ͨʧ");
                break;

        case R_DENY:
                ErrDlg("ʧ");
                break;
        }

        if( b != R_OK ) return;

        /* һÿTAG */
        if( f_unpackTLV(pInfo + iHLen, m_skt.GetPktLen() - iHLen) < 0 ) return;

        // Ԥ
        FillComponent(this);
}
//---------------------------------------------------------------------------

