//---------------------------------------------------------------------------
#include <stdio.h>
#include <vcl.h>
#pragma hdrstop

#include "ShowLog.h"
#include "Fpub.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TFrmShowLog *FrmShowLog;

//---------------------------------------------------------------------------
__fastcall TFrmShowLog::TFrmShowLog(TComponent* Owner, char *pV) : TForm(Owner)
{
        m_szBegDate[0] = 0;
        m_szEndDate[0] = 0;
        m_pInfo = pV;
}

//---------------------------------------------------------------------------
void __fastcall TFrmShowLog::FormShow(TObject *Sender)
{
        // ʼ׽
        if( m_skt.Init(PKT_MAXSIZE, PKT_HEADFMT) != 1 )
        {
                ErrDlg("ʼʧ");
                Application->Terminate();
        }

        int   b;
        char *pLine;

        static char szLine[1024];

        TDateTime DTnow, DTnow1;

        if( Tag )               // ѯ
        {
                DTnow = Now() + (0.5/24);
                DTnow1 = DTnow - (1.0/24);

                DDateEnd->Date = DTnow;
                DTimeEnd->Time = DTnow;

                DDateBegin->Date = DTnow1;
                DTimeBegin->Time = DTnow1;

                if( Tag == -1 ) // ѯСʱ֮ڵ־
                {
                        BtnQueryClick(Sender);
                }

                return;
        }

        // ʾӦϢ
        FrmShowLog->Panel1->Visible = false;

        Memo1->Visible = false;

        Memo1->Clear();
        pLine = m_pInfo;

        // в
        do {
                b = GC_get_fieldv(&pLine, szLine, NULL, sizeof(szLine) - 1, "\n");
                Memo1->Lines->Add(szLine);
        }
        while( b );

        Memo1->Visible = true;

        // ʾ־β
        PostMessage(Memo1->Handle, WM_KEYDOWN, VK_LEFT, 0);
        PostMessage(Memo1->Handle, WM_KEYDOWN, VK_RIGHT, 0);

        Memo1->SetFocus();
}

//---------------------------------------------------------------------------
void __fastcall TFrmShowLog::BtnQueryClick(TObject *Sender)
{
        int   b;
        char *pBody, *pLine, szVal[64], szBody[512];

        static char szLine[1024];

        strcpy(m_szBegDate, DDateBegin->Date.FormatString("yyyy*MM*dd").c_str());
        strcpy(m_szBegDate + 10, DTimeBegin->Time.FormatString(" HH:mm:ss").c_str());

        strcpy(m_szEndDate, DDateEnd->Date.FormatString("yyyy*MM*dd").c_str());
        strcpy(m_szEndDate + 10, DTimeEnd->Time.FormatString(" HH:mm:ss").c_str());

        m_szBegDate[4] = m_szBegDate[7] = '/';
        m_szEndDate[4] = m_szEndDate[7] = '/';

        if( strcmp(m_szBegDate, m_szEndDate) > 0 )
        {
                ErrDlg("ʱЧ");
                return;
        }

        // 䱨ͷ
        m_skt.SetHeadN(TC_LOGQRY, 2);

        pBody = szBody;

        // ֹ˾
        f_packTLV(&pBody, EditBelong->Text.Trim().c_str(), TAG_BELONG);

        // ɼš
        f_packTLV(&pBody, EditNo->Text.Trim().c_str(), TAG_NO);

        // ʼʱ䣬TAGá
        f_packTLV(&pBody, m_szBegDate, TAG_HOSTIP_PAIR);

        // ʱ䣬TAGá
        f_packTLV(&pBody, m_szEndDate, TAG_USER_PAIR);

        // TAGá
        f_packTLV(&pBody, EditInclude->Text.Trim().c_str(), TAG_SRC_PATH);

        // TAGá
        f_packTLV(&pBody, EditExclude->Text.Trim().c_str(), TAG_SRC_BACKUP_PATH);

        // ־ͣTAGá
        sprintf(szVal, "%d", RadioGrpType->ItemIndex);
        f_packTLV(&pBody, szVal, TAG_MONSTATOK);

        // ѯFTPTAGá
        sprintf(szVal, "%d", ChkBoxFtpOut->Checked == true ? 1 : 0);
        f_packTLV(&pBody, szVal, TAG_MONWARNNOT);
        *pBody = 0;

        int   iHLen = m_skt.GetHeadLen();
        char *pInfo = m_skt.GetReply();

        *pInfo = 0;
        *(pInfo + iHLen) = 0;

        b = SktComm(m_skt, m_serv_no + 1, szBody, StatusBar1);

        switch( b )
        {
        case R_COMMFAIL:
                ErrDlg("ͨʧ");
                return;
        }

        Memo1->Visible = false;

        Memo1->Clear();
        pLine = pInfo + iHLen;

        // в
        do {
                b = GC_get_fieldv(&pLine, szLine, NULL, sizeof(szLine) - 1, "\n");
                Memo1->Lines->Add(szLine);
        }
        while( b );

        Memo1->Visible = true;

        // ʾ־β
        PostMessage(Memo1->Handle, WM_KEYDOWN, VK_LEFT, 0);
        PostMessage(Memo1->Handle, WM_KEYDOWN, VK_RIGHT, 0);

        Memo1->SetFocus();
}
//---------------------------------------------------------------------------

